#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Control 0 Register"]
    pub adc14ctl0: ADC14CTL0,
    #[doc = "0x04 - Control 1 Register"]
    pub adc14ctl1: ADC14CTL1,
    #[doc = "0x08 - Window Comparator Low Threshold 0 Register"]
    pub adc14lo0: ADC14LO0,
    #[doc = "0x0c - Window Comparator High Threshold 0 Register"]
    pub adc14hi0: ADC14HI0,
    #[doc = "0x10 - Window Comparator Low Threshold 1 Register"]
    pub adc14lo1: ADC14LO1,
    #[doc = "0x14 - Window Comparator High Threshold 1 Register"]
    pub adc14hi1: ADC14HI1,
    #[doc = "0x18 - Conversion Memory Control Register"]
    pub adc14mctl: [ADC14MCTL; 32],
    #[doc = "0x98 - Conversion Memory Register"]
    pub adc14mem: [ADC14MEM; 32],
    _reserved0: [u8; 36usize],
    #[doc = "0x13c - Interrupt Enable 0 Register"]
    pub adc14ier0: ADC14IER0,
    #[doc = "0x140 - Interrupt Enable 1 Register"]
    pub adc14ier1: ADC14IER1,
    #[doc = "0x144 - Interrupt Flag 0 Register"]
    pub adc14ifgr0: ADC14IFGR0,
    #[doc = "0x148 - Interrupt Flag 1 Register"]
    pub adc14ifgr1: ADC14IFGR1,
    #[doc = "0x14c - Clear Interrupt Flag 0 Register"]
    pub adc14clrifgr0: ADC14CLRIFGR0,
    #[doc = "0x150 - Clear Interrupt Flag 1 Register"]
    pub adc14clrifgr1: ADC14CLRIFGR1,
    #[doc = "0x154 - Interrupt Vector Register"]
    pub adc14iv: ADC14IV,
}
#[doc = "Control 0 Register"]
pub struct ADC14CTL0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 0 Register"]
pub mod adc14ctl0;
#[doc = "Control 1 Register"]
pub struct ADC14CTL1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 1 Register"]
pub mod adc14ctl1;
#[doc = "Window Comparator Low Threshold 0 Register"]
pub struct ADC14LO0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Window Comparator Low Threshold 0 Register"]
pub mod adc14lo0;
#[doc = "Window Comparator High Threshold 0 Register"]
pub struct ADC14HI0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Window Comparator High Threshold 0 Register"]
pub mod adc14hi0;
#[doc = "Window Comparator Low Threshold 1 Register"]
pub struct ADC14LO1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Window Comparator Low Threshold 1 Register"]
pub mod adc14lo1;
#[doc = "Window Comparator High Threshold 1 Register"]
pub struct ADC14HI1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Window Comparator High Threshold 1 Register"]
pub mod adc14hi1;
#[doc = "Conversion Memory Control Register"]
pub struct ADC14MCTL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Conversion Memory Control Register"]
pub mod adc14mctl;
#[doc = "Conversion Memory Register"]
pub struct ADC14MEM {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Conversion Memory Register"]
pub mod adc14mem;
#[doc = "Interrupt Enable 0 Register"]
pub struct ADC14IER0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Enable 0 Register"]
pub mod adc14ier0;
#[doc = "Interrupt Enable 1 Register"]
pub struct ADC14IER1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Enable 1 Register"]
pub mod adc14ier1;
#[doc = "Interrupt Flag 0 Register"]
pub struct ADC14IFGR0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Flag 0 Register"]
pub mod adc14ifgr0;
#[doc = "Interrupt Flag 1 Register"]
pub struct ADC14IFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Flag 1 Register"]
pub mod adc14ifgr1;
#[doc = "Clear Interrupt Flag 0 Register"]
pub struct ADC14CLRIFGR0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clear Interrupt Flag 0 Register"]
pub mod adc14clrifgr0;
#[doc = "Clear Interrupt Flag 1 Register"]
pub struct ADC14CLRIFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clear Interrupt Flag 1 Register"]
pub mod adc14clrifgr1;
#[doc = "Interrupt Vector Register"]
pub struct ADC14IV {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Vector Register"]
pub mod adc14iv;
