#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::ADC14IV {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `ADC14IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC14IVR {
    #[doc = "No interrupt pending"]
    ADC14IV_0,
    #[doc = "Interrupt Source: ADC14MEMx overflow; Interrupt Flag: ADC14OVIFG; Interrupt Priority: Highest"]
    ADC14IV_2,
    #[doc = "Interrupt Source: Conversion time overflow; Interrupt Flag: ADC14TOVIFG"]
    ADC14IV_4,
    #[doc = "Interrupt Source: ADC14 window high interrupt flag; Interrupt Flag: ADC14HIIFG"]
    ADC14IV_6,
    #[doc = "Interrupt Source: ADC14 window low interrupt flag; Interrupt Flag: ADC14LOIFG"]
    ADC14IV_8,
    #[doc = "Interrupt Source: ADC14 in-window interrupt flag; Interrupt Flag: ADC14INIFG"]
    ADC14IV_10,
    #[doc = "Interrupt Source: ADC14MEM0 interrupt flag; Interrupt Flag: ADC14IFG0"]
    ADC14IV_12,
    #[doc = "Interrupt Source: ADC14MEM1 interrupt flag; Interrupt Flag: ADC14IFG1"]
    ADC14IV_14,
    #[doc = "Interrupt Source: ADC14MEM2 interrupt flag; Interrupt Flag: ADC14IFG2"]
    ADC14IV_16,
    #[doc = "Interrupt Source: ADC14MEM3 interrupt flag; Interrupt Flag: ADC14IFG3"]
    ADC14IV_18,
    #[doc = "Interrupt Source: ADC14MEM4 interrupt flag; Interrupt Flag: ADC14IFG4"]
    ADC14IV_20,
    #[doc = "Interrupt Source: ADC14MEM5 interrupt flag; Interrupt Flag: ADC14IFG5"]
    ADC14IV_22,
    #[doc = "Interrupt Source: ADC14MEM6 interrupt flag; Interrupt Flag: ADC14IFG6"]
    ADC14IV_24,
    #[doc = "Interrupt Source: ADC14MEM7 interrupt flag; Interrupt Flag: ADC14IFG7"]
    ADC14IV_26,
    #[doc = "Interrupt Source: ADC14MEM8 interrupt flag; Interrupt Flag: ADC14IFG8"]
    ADC14IV_28,
    #[doc = "Interrupt Source: ADC14MEM9 interrupt flag; Interrupt Flag: ADC14IFG9"]
    ADC14IV_30,
    #[doc = "Interrupt Source: ADC14MEM10 interrupt flag; Interrupt Flag: ADC14IFG10"]
    ADC14IV_32,
    #[doc = "Interrupt Source: ADC14MEM11 interrupt flag; Interrupt Flag: ADC14IFG11"]
    ADC14IV_34,
    #[doc = "Interrupt Source: ADC14MEM12 interrupt flag; Interrupt Flag: ADC14IFG12"]
    ADC14IV_36,
    #[doc = "Interrupt Source: ADC14MEM13 interrupt flag; Interrupt Flag: ADC14IFG13"]
    ADC14IV_38,
    #[doc = "Interrupt Source: ADC14MEM14 interrupt flag; Interrupt Flag: ADC14IFG14"]
    ADC14IV_40,
    #[doc = "Interrupt Source: ADC14MEM15 interrupt flag; Interrupt Flag: ADC14IFG15"]
    ADC14IV_42,
    #[doc = "Interrupt Source: ADC14MEM16 interrupt flag; Interrupt Flag: ADC14IFG16"]
    ADC14IV_44,
    #[doc = "Interrupt Source: ADC14MEM17 interrupt flag; Interrupt Flag: ADC14IFG17"]
    ADC14IV_46,
    #[doc = "Interrupt Source: ADC14MEM18 interrupt flag; Interrupt Flag: ADC14IFG18"]
    ADC14IV_48,
    #[doc = "Interrupt Source: ADC14MEM19 interrupt flag; Interrupt Flag: ADC14IFG19"]
    ADC14IV_50,
    #[doc = "Interrupt Source: ADC14MEM20 interrupt flag; Interrupt Flag: ADC14IFG20"]
    ADC14IV_52,
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    ADC14IV_54,
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    ADC14IV_56,
    #[doc = "Interrupt Source: ADC14MEM23 interrupt flag; Interrupt Flag: ADC14IFG23"]
    ADC14IV_58,
    #[doc = "Interrupt Source: ADC14MEM24 interrupt flag; Interrupt Flag: ADC14IFG24"]
    ADC14IV_60,
    #[doc = "Interrupt Source: ADC14MEM25 interrupt flag; Interrupt Flag: ADC14IFG25"]
    ADC14IV_62,
    #[doc = "Interrupt Source: ADC14MEM26 interrupt flag; Interrupt Flag: ADC14IFG26"]
    ADC14IV_64,
    #[doc = "Interrupt Source: ADC14MEM27 interrupt flag; Interrupt Flag: ADC14IFG27"]
    ADC14IV_66,
    #[doc = "Interrupt Source: ADC14MEM28 interrupt flag; Interrupt Flag: ADC14IFG28"]
    ADC14IV_68,
    #[doc = "Interrupt Source: ADC14MEM29 interrupt flag; Interrupt Flag: ADC14IFG29"]
    ADC14IV_70,
    #[doc = "Interrupt Source: ADC14MEM30 interrupt flag; Interrupt Flag: ADC14IFG30"]
    ADC14IV_72,
    #[doc = "Interrupt Source: ADC14MEM31 interrupt flag; Interrupt Flag: ADC14IFG31"]
    ADC14IV_74,
    #[doc = "Interrupt Source: ADC14RDYIFG interrupt flag; Interrupt Flag: ADC14RDYIFG; Interrupt Priority: Lowest"]
    ADC14IV_76,
    #[doc = r" Reserved"]
    _Reserved(u32),
}
impl ADC14IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        match *self {
            ADC14IVR::ADC14IV_0 => 0,
            ADC14IVR::ADC14IV_2 => 2,
            ADC14IVR::ADC14IV_4 => 4,
            ADC14IVR::ADC14IV_6 => 6,
            ADC14IVR::ADC14IV_8 => 8,
            ADC14IVR::ADC14IV_10 => 10,
            ADC14IVR::ADC14IV_12 => 12,
            ADC14IVR::ADC14IV_14 => 14,
            ADC14IVR::ADC14IV_16 => 16,
            ADC14IVR::ADC14IV_18 => 18,
            ADC14IVR::ADC14IV_20 => 20,
            ADC14IVR::ADC14IV_22 => 22,
            ADC14IVR::ADC14IV_24 => 24,
            ADC14IVR::ADC14IV_26 => 26,
            ADC14IVR::ADC14IV_28 => 28,
            ADC14IVR::ADC14IV_30 => 30,
            ADC14IVR::ADC14IV_32 => 32,
            ADC14IVR::ADC14IV_34 => 34,
            ADC14IVR::ADC14IV_36 => 36,
            ADC14IVR::ADC14IV_38 => 38,
            ADC14IVR::ADC14IV_40 => 40,
            ADC14IVR::ADC14IV_42 => 42,
            ADC14IVR::ADC14IV_44 => 44,
            ADC14IVR::ADC14IV_46 => 46,
            ADC14IVR::ADC14IV_48 => 48,
            ADC14IVR::ADC14IV_50 => 50,
            ADC14IVR::ADC14IV_52 => 52,
            ADC14IVR::ADC14IV_54 => 54,
            ADC14IVR::ADC14IV_56 => 56,
            ADC14IVR::ADC14IV_58 => 58,
            ADC14IVR::ADC14IV_60 => 60,
            ADC14IVR::ADC14IV_62 => 62,
            ADC14IVR::ADC14IV_64 => 64,
            ADC14IVR::ADC14IV_66 => 66,
            ADC14IVR::ADC14IV_68 => 68,
            ADC14IVR::ADC14IV_70 => 70,
            ADC14IVR::ADC14IV_72 => 72,
            ADC14IVR::ADC14IV_74 => 74,
            ADC14IVR::ADC14IV_76 => 76,
            ADC14IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u32) -> ADC14IVR {
        match value {
            0 => ADC14IVR::ADC14IV_0,
            2 => ADC14IVR::ADC14IV_2,
            4 => ADC14IVR::ADC14IV_4,
            6 => ADC14IVR::ADC14IV_6,
            8 => ADC14IVR::ADC14IV_8,
            10 => ADC14IVR::ADC14IV_10,
            12 => ADC14IVR::ADC14IV_12,
            14 => ADC14IVR::ADC14IV_14,
            16 => ADC14IVR::ADC14IV_16,
            18 => ADC14IVR::ADC14IV_18,
            20 => ADC14IVR::ADC14IV_20,
            22 => ADC14IVR::ADC14IV_22,
            24 => ADC14IVR::ADC14IV_24,
            26 => ADC14IVR::ADC14IV_26,
            28 => ADC14IVR::ADC14IV_28,
            30 => ADC14IVR::ADC14IV_30,
            32 => ADC14IVR::ADC14IV_32,
            34 => ADC14IVR::ADC14IV_34,
            36 => ADC14IVR::ADC14IV_36,
            38 => ADC14IVR::ADC14IV_38,
            40 => ADC14IVR::ADC14IV_40,
            42 => ADC14IVR::ADC14IV_42,
            44 => ADC14IVR::ADC14IV_44,
            46 => ADC14IVR::ADC14IV_46,
            48 => ADC14IVR::ADC14IV_48,
            50 => ADC14IVR::ADC14IV_50,
            52 => ADC14IVR::ADC14IV_52,
            54 => ADC14IVR::ADC14IV_54,
            56 => ADC14IVR::ADC14IV_56,
            58 => ADC14IVR::ADC14IV_58,
            60 => ADC14IVR::ADC14IV_60,
            62 => ADC14IVR::ADC14IV_62,
            64 => ADC14IVR::ADC14IV_64,
            66 => ADC14IVR::ADC14IV_66,
            68 => ADC14IVR::ADC14IV_68,
            70 => ADC14IVR::ADC14IV_70,
            72 => ADC14IVR::ADC14IV_72,
            74 => ADC14IVR::ADC14IV_74,
            76 => ADC14IVR::ADC14IV_76,
            i => ADC14IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `ADC14IV_0`"]
    #[inline]
    pub fn is_adc14iv_0(&self) -> bool {
        *self == ADC14IVR::ADC14IV_0
    }
    #[doc = "Checks if the value of the field is `ADC14IV_2`"]
    #[inline]
    pub fn is_adc14iv_2(&self) -> bool {
        *self == ADC14IVR::ADC14IV_2
    }
    #[doc = "Checks if the value of the field is `ADC14IV_4`"]
    #[inline]
    pub fn is_adc14iv_4(&self) -> bool {
        *self == ADC14IVR::ADC14IV_4
    }
    #[doc = "Checks if the value of the field is `ADC14IV_6`"]
    #[inline]
    pub fn is_adc14iv_6(&self) -> bool {
        *self == ADC14IVR::ADC14IV_6
    }
    #[doc = "Checks if the value of the field is `ADC14IV_8`"]
    #[inline]
    pub fn is_adc14iv_8(&self) -> bool {
        *self == ADC14IVR::ADC14IV_8
    }
    #[doc = "Checks if the value of the field is `ADC14IV_10`"]
    #[inline]
    pub fn is_adc14iv_10(&self) -> bool {
        *self == ADC14IVR::ADC14IV_10
    }
    #[doc = "Checks if the value of the field is `ADC14IV_12`"]
    #[inline]
    pub fn is_adc14iv_12(&self) -> bool {
        *self == ADC14IVR::ADC14IV_12
    }
    #[doc = "Checks if the value of the field is `ADC14IV_14`"]
    #[inline]
    pub fn is_adc14iv_14(&self) -> bool {
        *self == ADC14IVR::ADC14IV_14
    }
    #[doc = "Checks if the value of the field is `ADC14IV_16`"]
    #[inline]
    pub fn is_adc14iv_16(&self) -> bool {
        *self == ADC14IVR::ADC14IV_16
    }
    #[doc = "Checks if the value of the field is `ADC14IV_18`"]
    #[inline]
    pub fn is_adc14iv_18(&self) -> bool {
        *self == ADC14IVR::ADC14IV_18
    }
    #[doc = "Checks if the value of the field is `ADC14IV_20`"]
    #[inline]
    pub fn is_adc14iv_20(&self) -> bool {
        *self == ADC14IVR::ADC14IV_20
    }
    #[doc = "Checks if the value of the field is `ADC14IV_22`"]
    #[inline]
    pub fn is_adc14iv_22(&self) -> bool {
        *self == ADC14IVR::ADC14IV_22
    }
    #[doc = "Checks if the value of the field is `ADC14IV_24`"]
    #[inline]
    pub fn is_adc14iv_24(&self) -> bool {
        *self == ADC14IVR::ADC14IV_24
    }
    #[doc = "Checks if the value of the field is `ADC14IV_26`"]
    #[inline]
    pub fn is_adc14iv_26(&self) -> bool {
        *self == ADC14IVR::ADC14IV_26
    }
    #[doc = "Checks if the value of the field is `ADC14IV_28`"]
    #[inline]
    pub fn is_adc14iv_28(&self) -> bool {
        *self == ADC14IVR::ADC14IV_28
    }
    #[doc = "Checks if the value of the field is `ADC14IV_30`"]
    #[inline]
    pub fn is_adc14iv_30(&self) -> bool {
        *self == ADC14IVR::ADC14IV_30
    }
    #[doc = "Checks if the value of the field is `ADC14IV_32`"]
    #[inline]
    pub fn is_adc14iv_32(&self) -> bool {
        *self == ADC14IVR::ADC14IV_32
    }
    #[doc = "Checks if the value of the field is `ADC14IV_34`"]
    #[inline]
    pub fn is_adc14iv_34(&self) -> bool {
        *self == ADC14IVR::ADC14IV_34
    }
    #[doc = "Checks if the value of the field is `ADC14IV_36`"]
    #[inline]
    pub fn is_adc14iv_36(&self) -> bool {
        *self == ADC14IVR::ADC14IV_36
    }
    #[doc = "Checks if the value of the field is `ADC14IV_38`"]
    #[inline]
    pub fn is_adc14iv_38(&self) -> bool {
        *self == ADC14IVR::ADC14IV_38
    }
    #[doc = "Checks if the value of the field is `ADC14IV_40`"]
    #[inline]
    pub fn is_adc14iv_40(&self) -> bool {
        *self == ADC14IVR::ADC14IV_40
    }
    #[doc = "Checks if the value of the field is `ADC14IV_42`"]
    #[inline]
    pub fn is_adc14iv_42(&self) -> bool {
        *self == ADC14IVR::ADC14IV_42
    }
    #[doc = "Checks if the value of the field is `ADC14IV_44`"]
    #[inline]
    pub fn is_adc14iv_44(&self) -> bool {
        *self == ADC14IVR::ADC14IV_44
    }
    #[doc = "Checks if the value of the field is `ADC14IV_46`"]
    #[inline]
    pub fn is_adc14iv_46(&self) -> bool {
        *self == ADC14IVR::ADC14IV_46
    }
    #[doc = "Checks if the value of the field is `ADC14IV_48`"]
    #[inline]
    pub fn is_adc14iv_48(&self) -> bool {
        *self == ADC14IVR::ADC14IV_48
    }
    #[doc = "Checks if the value of the field is `ADC14IV_50`"]
    #[inline]
    pub fn is_adc14iv_50(&self) -> bool {
        *self == ADC14IVR::ADC14IV_50
    }
    #[doc = "Checks if the value of the field is `ADC14IV_52`"]
    #[inline]
    pub fn is_adc14iv_52(&self) -> bool {
        *self == ADC14IVR::ADC14IV_52
    }
    #[doc = "Checks if the value of the field is `ADC14IV_54`"]
    #[inline]
    pub fn is_adc14iv_54(&self) -> bool {
        *self == ADC14IVR::ADC14IV_54
    }
    #[doc = "Checks if the value of the field is `ADC14IV_56`"]
    #[inline]
    pub fn is_adc14iv_56(&self) -> bool {
        *self == ADC14IVR::ADC14IV_56
    }
    #[doc = "Checks if the value of the field is `ADC14IV_58`"]
    #[inline]
    pub fn is_adc14iv_58(&self) -> bool {
        *self == ADC14IVR::ADC14IV_58
    }
    #[doc = "Checks if the value of the field is `ADC14IV_60`"]
    #[inline]
    pub fn is_adc14iv_60(&self) -> bool {
        *self == ADC14IVR::ADC14IV_60
    }
    #[doc = "Checks if the value of the field is `ADC14IV_62`"]
    #[inline]
    pub fn is_adc14iv_62(&self) -> bool {
        *self == ADC14IVR::ADC14IV_62
    }
    #[doc = "Checks if the value of the field is `ADC14IV_64`"]
    #[inline]
    pub fn is_adc14iv_64(&self) -> bool {
        *self == ADC14IVR::ADC14IV_64
    }
    #[doc = "Checks if the value of the field is `ADC14IV_66`"]
    #[inline]
    pub fn is_adc14iv_66(&self) -> bool {
        *self == ADC14IVR::ADC14IV_66
    }
    #[doc = "Checks if the value of the field is `ADC14IV_68`"]
    #[inline]
    pub fn is_adc14iv_68(&self) -> bool {
        *self == ADC14IVR::ADC14IV_68
    }
    #[doc = "Checks if the value of the field is `ADC14IV_70`"]
    #[inline]
    pub fn is_adc14iv_70(&self) -> bool {
        *self == ADC14IVR::ADC14IV_70
    }
    #[doc = "Checks if the value of the field is `ADC14IV_72`"]
    #[inline]
    pub fn is_adc14iv_72(&self) -> bool {
        *self == ADC14IVR::ADC14IV_72
    }
    #[doc = "Checks if the value of the field is `ADC14IV_74`"]
    #[inline]
    pub fn is_adc14iv_74(&self) -> bool {
        *self == ADC14IVR::ADC14IV_74
    }
    #[doc = "Checks if the value of the field is `ADC14IV_76`"]
    #[inline]
    pub fn is_adc14iv_76(&self) -> bool {
        *self == ADC14IVR::ADC14IV_76
    }
}
#[doc = "Values that can be written to the field `ADC14IV`"]
pub enum ADC14IVW {
    #[doc = "No interrupt pending"]
    ADC14IV_0,
    #[doc = "Interrupt Source: ADC14MEMx overflow; Interrupt Flag: ADC14OVIFG; Interrupt Priority: Highest"]
    ADC14IV_2,
    #[doc = "Interrupt Source: Conversion time overflow; Interrupt Flag: ADC14TOVIFG"]
    ADC14IV_4,
    #[doc = "Interrupt Source: ADC14 window high interrupt flag; Interrupt Flag: ADC14HIIFG"]
    ADC14IV_6,
    #[doc = "Interrupt Source: ADC14 window low interrupt flag; Interrupt Flag: ADC14LOIFG"]
    ADC14IV_8,
    #[doc = "Interrupt Source: ADC14 in-window interrupt flag; Interrupt Flag: ADC14INIFG"]
    ADC14IV_10,
    #[doc = "Interrupt Source: ADC14MEM0 interrupt flag; Interrupt Flag: ADC14IFG0"]
    ADC14IV_12,
    #[doc = "Interrupt Source: ADC14MEM1 interrupt flag; Interrupt Flag: ADC14IFG1"]
    ADC14IV_14,
    #[doc = "Interrupt Source: ADC14MEM2 interrupt flag; Interrupt Flag: ADC14IFG2"]
    ADC14IV_16,
    #[doc = "Interrupt Source: ADC14MEM3 interrupt flag; Interrupt Flag: ADC14IFG3"]
    ADC14IV_18,
    #[doc = "Interrupt Source: ADC14MEM4 interrupt flag; Interrupt Flag: ADC14IFG4"]
    ADC14IV_20,
    #[doc = "Interrupt Source: ADC14MEM5 interrupt flag; Interrupt Flag: ADC14IFG5"]
    ADC14IV_22,
    #[doc = "Interrupt Source: ADC14MEM6 interrupt flag; Interrupt Flag: ADC14IFG6"]
    ADC14IV_24,
    #[doc = "Interrupt Source: ADC14MEM7 interrupt flag; Interrupt Flag: ADC14IFG7"]
    ADC14IV_26,
    #[doc = "Interrupt Source: ADC14MEM8 interrupt flag; Interrupt Flag: ADC14IFG8"]
    ADC14IV_28,
    #[doc = "Interrupt Source: ADC14MEM9 interrupt flag; Interrupt Flag: ADC14IFG9"]
    ADC14IV_30,
    #[doc = "Interrupt Source: ADC14MEM10 interrupt flag; Interrupt Flag: ADC14IFG10"]
    ADC14IV_32,
    #[doc = "Interrupt Source: ADC14MEM11 interrupt flag; Interrupt Flag: ADC14IFG11"]
    ADC14IV_34,
    #[doc = "Interrupt Source: ADC14MEM12 interrupt flag; Interrupt Flag: ADC14IFG12"]
    ADC14IV_36,
    #[doc = "Interrupt Source: ADC14MEM13 interrupt flag; Interrupt Flag: ADC14IFG13"]
    ADC14IV_38,
    #[doc = "Interrupt Source: ADC14MEM14 interrupt flag; Interrupt Flag: ADC14IFG14"]
    ADC14IV_40,
    #[doc = "Interrupt Source: ADC14MEM15 interrupt flag; Interrupt Flag: ADC14IFG15"]
    ADC14IV_42,
    #[doc = "Interrupt Source: ADC14MEM16 interrupt flag; Interrupt Flag: ADC14IFG16"]
    ADC14IV_44,
    #[doc = "Interrupt Source: ADC14MEM17 interrupt flag; Interrupt Flag: ADC14IFG17"]
    ADC14IV_46,
    #[doc = "Interrupt Source: ADC14MEM18 interrupt flag; Interrupt Flag: ADC14IFG18"]
    ADC14IV_48,
    #[doc = "Interrupt Source: ADC14MEM19 interrupt flag; Interrupt Flag: ADC14IFG19"]
    ADC14IV_50,
    #[doc = "Interrupt Source: ADC14MEM20 interrupt flag; Interrupt Flag: ADC14IFG20"]
    ADC14IV_52,
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    ADC14IV_54,
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    ADC14IV_56,
    #[doc = "Interrupt Source: ADC14MEM23 interrupt flag; Interrupt Flag: ADC14IFG23"]
    ADC14IV_58,
    #[doc = "Interrupt Source: ADC14MEM24 interrupt flag; Interrupt Flag: ADC14IFG24"]
    ADC14IV_60,
    #[doc = "Interrupt Source: ADC14MEM25 interrupt flag; Interrupt Flag: ADC14IFG25"]
    ADC14IV_62,
    #[doc = "Interrupt Source: ADC14MEM26 interrupt flag; Interrupt Flag: ADC14IFG26"]
    ADC14IV_64,
    #[doc = "Interrupt Source: ADC14MEM27 interrupt flag; Interrupt Flag: ADC14IFG27"]
    ADC14IV_66,
    #[doc = "Interrupt Source: ADC14MEM28 interrupt flag; Interrupt Flag: ADC14IFG28"]
    ADC14IV_68,
    #[doc = "Interrupt Source: ADC14MEM29 interrupt flag; Interrupt Flag: ADC14IFG29"]
    ADC14IV_70,
    #[doc = "Interrupt Source: ADC14MEM30 interrupt flag; Interrupt Flag: ADC14IFG30"]
    ADC14IV_72,
    #[doc = "Interrupt Source: ADC14MEM31 interrupt flag; Interrupt Flag: ADC14IFG31"]
    ADC14IV_74,
    #[doc = "Interrupt Source: ADC14RDYIFG interrupt flag; Interrupt Flag: ADC14RDYIFG; Interrupt Priority: Lowest"]
    ADC14IV_76,
}
impl ADC14IVW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u32 {
        match *self {
            ADC14IVW::ADC14IV_0 => 0,
            ADC14IVW::ADC14IV_2 => 2,
            ADC14IVW::ADC14IV_4 => 4,
            ADC14IVW::ADC14IV_6 => 6,
            ADC14IVW::ADC14IV_8 => 8,
            ADC14IVW::ADC14IV_10 => 10,
            ADC14IVW::ADC14IV_12 => 12,
            ADC14IVW::ADC14IV_14 => 14,
            ADC14IVW::ADC14IV_16 => 16,
            ADC14IVW::ADC14IV_18 => 18,
            ADC14IVW::ADC14IV_20 => 20,
            ADC14IVW::ADC14IV_22 => 22,
            ADC14IVW::ADC14IV_24 => 24,
            ADC14IVW::ADC14IV_26 => 26,
            ADC14IVW::ADC14IV_28 => 28,
            ADC14IVW::ADC14IV_30 => 30,
            ADC14IVW::ADC14IV_32 => 32,
            ADC14IVW::ADC14IV_34 => 34,
            ADC14IVW::ADC14IV_36 => 36,
            ADC14IVW::ADC14IV_38 => 38,
            ADC14IVW::ADC14IV_40 => 40,
            ADC14IVW::ADC14IV_42 => 42,
            ADC14IVW::ADC14IV_44 => 44,
            ADC14IVW::ADC14IV_46 => 46,
            ADC14IVW::ADC14IV_48 => 48,
            ADC14IVW::ADC14IV_50 => 50,
            ADC14IVW::ADC14IV_52 => 52,
            ADC14IVW::ADC14IV_54 => 54,
            ADC14IVW::ADC14IV_56 => 56,
            ADC14IVW::ADC14IV_58 => 58,
            ADC14IVW::ADC14IV_60 => 60,
            ADC14IVW::ADC14IV_62 => 62,
            ADC14IVW::ADC14IV_64 => 64,
            ADC14IVW::ADC14IV_66 => 66,
            ADC14IVW::ADC14IV_68 => 68,
            ADC14IVW::ADC14IV_70 => 70,
            ADC14IVW::ADC14IV_72 => 72,
            ADC14IVW::ADC14IV_74 => 74,
            ADC14IVW::ADC14IV_76 => 76,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ADC14IVW<'a> {
    w: &'a mut W,
}
impl<'a> _ADC14IVW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ADC14IVW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn adc14iv_0(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_0)
    }
    #[doc = "Interrupt Source: ADC14MEMx overflow; Interrupt Flag: ADC14OVIFG; Interrupt Priority: Highest"]
    #[inline]
    pub fn adc14iv_2(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_2)
    }
    #[doc = "Interrupt Source: Conversion time overflow; Interrupt Flag: ADC14TOVIFG"]
    #[inline]
    pub fn adc14iv_4(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_4)
    }
    #[doc = "Interrupt Source: ADC14 window high interrupt flag; Interrupt Flag: ADC14HIIFG"]
    #[inline]
    pub fn adc14iv_6(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_6)
    }
    #[doc = "Interrupt Source: ADC14 window low interrupt flag; Interrupt Flag: ADC14LOIFG"]
    #[inline]
    pub fn adc14iv_8(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_8)
    }
    #[doc = "Interrupt Source: ADC14 in-window interrupt flag; Interrupt Flag: ADC14INIFG"]
    #[inline]
    pub fn adc14iv_10(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_10)
    }
    #[doc = "Interrupt Source: ADC14MEM0 interrupt flag; Interrupt Flag: ADC14IFG0"]
    #[inline]
    pub fn adc14iv_12(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_12)
    }
    #[doc = "Interrupt Source: ADC14MEM1 interrupt flag; Interrupt Flag: ADC14IFG1"]
    #[inline]
    pub fn adc14iv_14(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_14)
    }
    #[doc = "Interrupt Source: ADC14MEM2 interrupt flag; Interrupt Flag: ADC14IFG2"]
    #[inline]
    pub fn adc14iv_16(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_16)
    }
    #[doc = "Interrupt Source: ADC14MEM3 interrupt flag; Interrupt Flag: ADC14IFG3"]
    #[inline]
    pub fn adc14iv_18(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_18)
    }
    #[doc = "Interrupt Source: ADC14MEM4 interrupt flag; Interrupt Flag: ADC14IFG4"]
    #[inline]
    pub fn adc14iv_20(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_20)
    }
    #[doc = "Interrupt Source: ADC14MEM5 interrupt flag; Interrupt Flag: ADC14IFG5"]
    #[inline]
    pub fn adc14iv_22(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_22)
    }
    #[doc = "Interrupt Source: ADC14MEM6 interrupt flag; Interrupt Flag: ADC14IFG6"]
    #[inline]
    pub fn adc14iv_24(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_24)
    }
    #[doc = "Interrupt Source: ADC14MEM7 interrupt flag; Interrupt Flag: ADC14IFG7"]
    #[inline]
    pub fn adc14iv_26(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_26)
    }
    #[doc = "Interrupt Source: ADC14MEM8 interrupt flag; Interrupt Flag: ADC14IFG8"]
    #[inline]
    pub fn adc14iv_28(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_28)
    }
    #[doc = "Interrupt Source: ADC14MEM9 interrupt flag; Interrupt Flag: ADC14IFG9"]
    #[inline]
    pub fn adc14iv_30(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_30)
    }
    #[doc = "Interrupt Source: ADC14MEM10 interrupt flag; Interrupt Flag: ADC14IFG10"]
    #[inline]
    pub fn adc14iv_32(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_32)
    }
    #[doc = "Interrupt Source: ADC14MEM11 interrupt flag; Interrupt Flag: ADC14IFG11"]
    #[inline]
    pub fn adc14iv_34(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_34)
    }
    #[doc = "Interrupt Source: ADC14MEM12 interrupt flag; Interrupt Flag: ADC14IFG12"]
    #[inline]
    pub fn adc14iv_36(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_36)
    }
    #[doc = "Interrupt Source: ADC14MEM13 interrupt flag; Interrupt Flag: ADC14IFG13"]
    #[inline]
    pub fn adc14iv_38(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_38)
    }
    #[doc = "Interrupt Source: ADC14MEM14 interrupt flag; Interrupt Flag: ADC14IFG14"]
    #[inline]
    pub fn adc14iv_40(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_40)
    }
    #[doc = "Interrupt Source: ADC14MEM15 interrupt flag; Interrupt Flag: ADC14IFG15"]
    #[inline]
    pub fn adc14iv_42(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_42)
    }
    #[doc = "Interrupt Source: ADC14MEM16 interrupt flag; Interrupt Flag: ADC14IFG16"]
    #[inline]
    pub fn adc14iv_44(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_44)
    }
    #[doc = "Interrupt Source: ADC14MEM17 interrupt flag; Interrupt Flag: ADC14IFG17"]
    #[inline]
    pub fn adc14iv_46(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_46)
    }
    #[doc = "Interrupt Source: ADC14MEM18 interrupt flag; Interrupt Flag: ADC14IFG18"]
    #[inline]
    pub fn adc14iv_48(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_48)
    }
    #[doc = "Interrupt Source: ADC14MEM19 interrupt flag; Interrupt Flag: ADC14IFG19"]
    #[inline]
    pub fn adc14iv_50(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_50)
    }
    #[doc = "Interrupt Source: ADC14MEM20 interrupt flag; Interrupt Flag: ADC14IFG20"]
    #[inline]
    pub fn adc14iv_52(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_52)
    }
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    #[inline]
    pub fn adc14iv_54(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_54)
    }
    #[doc = "Interrupt Source: ADC14MEM22 interrupt flag; Interrupt Flag: ADC14IFG22"]
    #[inline]
    pub fn adc14iv_56(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_56)
    }
    #[doc = "Interrupt Source: ADC14MEM23 interrupt flag; Interrupt Flag: ADC14IFG23"]
    #[inline]
    pub fn adc14iv_58(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_58)
    }
    #[doc = "Interrupt Source: ADC14MEM24 interrupt flag; Interrupt Flag: ADC14IFG24"]
    #[inline]
    pub fn adc14iv_60(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_60)
    }
    #[doc = "Interrupt Source: ADC14MEM25 interrupt flag; Interrupt Flag: ADC14IFG25"]
    #[inline]
    pub fn adc14iv_62(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_62)
    }
    #[doc = "Interrupt Source: ADC14MEM26 interrupt flag; Interrupt Flag: ADC14IFG26"]
    #[inline]
    pub fn adc14iv_64(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_64)
    }
    #[doc = "Interrupt Source: ADC14MEM27 interrupt flag; Interrupt Flag: ADC14IFG27"]
    #[inline]
    pub fn adc14iv_66(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_66)
    }
    #[doc = "Interrupt Source: ADC14MEM28 interrupt flag; Interrupt Flag: ADC14IFG28"]
    #[inline]
    pub fn adc14iv_68(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_68)
    }
    #[doc = "Interrupt Source: ADC14MEM29 interrupt flag; Interrupt Flag: ADC14IFG29"]
    #[inline]
    pub fn adc14iv_70(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_70)
    }
    #[doc = "Interrupt Source: ADC14MEM30 interrupt flag; Interrupt Flag: ADC14IFG30"]
    #[inline]
    pub fn adc14iv_72(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_72)
    }
    #[doc = "Interrupt Source: ADC14MEM31 interrupt flag; Interrupt Flag: ADC14IFG31"]
    #[inline]
    pub fn adc14iv_74(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_74)
    }
    #[doc = "Interrupt Source: ADC14RDYIFG interrupt flag; Interrupt Flag: ADC14RDYIFG; Interrupt Priority: Lowest"]
    #[inline]
    pub fn adc14iv_76(self) -> &'a mut W {
        self.variant(ADC14IVW::ADC14IV_76)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        const MASK: u32 = 4294967295;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:31 - ADC14 interrupt vector value"]
    #[inline]
    pub fn adc14iv(&self) -> ADC14IVR {
        ADC14IVR::_from({
            const MASK: u32 = 4294967295;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u32
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:31 - ADC14 interrupt vector value"]
    #[inline]
    pub fn adc14iv(&mut self) -> _ADC14IVW {
        _ADC14IVW { w: self }
    }
}
