#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - AES Accelerator Control Register 0"]
    pub aesactl0: AESACTL0,
    #[doc = "0x02 - AES Accelerator Control Register 1"]
    pub aesactl1: AESACTL1,
    #[doc = "0x04 - AES Accelerator Status Register"]
    pub aesastat: AESASTAT,
    #[doc = "0x06 - AES Accelerator Key Register"]
    pub aesakey: AESAKEY,
    #[doc = "0x08 - AES Accelerator Data In Register"]
    pub aesadin: AESADIN,
    #[doc = "0x0a - AES Accelerator Data Out Register"]
    pub aesadout: AESADOUT,
    #[doc = "0x0c - AES Accelerator XORed Data In Register"]
    pub aesaxdin: AESAXDIN,
    #[doc = "0x0e - AES Accelerator XORed Data In Register"]
    pub aesaxin: AESAXIN,
}
#[doc = "AES Accelerator Control Register 0"]
pub struct AESACTL0 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Control Register 0"]
pub mod aesactl0;
#[doc = "AES Accelerator Control Register 1"]
pub struct AESACTL1 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Control Register 1"]
pub mod aesactl1;
#[doc = "AES Accelerator Status Register"]
pub struct AESASTAT {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Status Register"]
pub mod aesastat;
#[doc = "AES Accelerator Key Register"]
pub struct AESAKEY {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Key Register"]
pub mod aesakey;
#[doc = "AES Accelerator Data In Register"]
pub struct AESADIN {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Data In Register"]
pub mod aesadin;
#[doc = "AES Accelerator Data Out Register"]
pub struct AESADOUT {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator Data Out Register"]
pub mod aesadout;
#[doc = "AES Accelerator XORed Data In Register"]
pub struct AESAXDIN {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator XORed Data In Register"]
pub mod aesaxdin;
#[doc = "AES Accelerator XORed Data In Register"]
pub struct AESAXIN {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "AES Accelerator XORed Data In Register"]
pub mod aesaxin;
