#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::CEXCTL3 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `CEPD0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD0R {
    #[doc = "The input buffer is enabled"]
    CEPD0_0,
    #[doc = "The input buffer is disabled"]
    CEPD0_1,
}
impl CEPD0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD0R::CEPD0_0 => false,
            CEPD0R::CEPD0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD0R {
        match value {
            false => CEPD0R::CEPD0_0,
            true => CEPD0R::CEPD0_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD0_0`"]
    #[inline]
    pub fn is_cepd0_0(&self) -> bool {
        *self == CEPD0R::CEPD0_0
    }
    #[doc = "Checks if the value of the field is `CEPD0_1`"]
    #[inline]
    pub fn is_cepd0_1(&self) -> bool {
        *self == CEPD0R::CEPD0_1
    }
}
#[doc = "Possible values of the field `CEPD1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD1R {
    #[doc = "The input buffer is enabled"]
    CEPD1_0,
    #[doc = "The input buffer is disabled"]
    CEPD1_1,
}
impl CEPD1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD1R::CEPD1_0 => false,
            CEPD1R::CEPD1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD1R {
        match value {
            false => CEPD1R::CEPD1_0,
            true => CEPD1R::CEPD1_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD1_0`"]
    #[inline]
    pub fn is_cepd1_0(&self) -> bool {
        *self == CEPD1R::CEPD1_0
    }
    #[doc = "Checks if the value of the field is `CEPD1_1`"]
    #[inline]
    pub fn is_cepd1_1(&self) -> bool {
        *self == CEPD1R::CEPD1_1
    }
}
#[doc = "Possible values of the field `CEPD2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD2R {
    #[doc = "The input buffer is enabled"]
    CEPD2_0,
    #[doc = "The input buffer is disabled"]
    CEPD2_1,
}
impl CEPD2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD2R::CEPD2_0 => false,
            CEPD2R::CEPD2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD2R {
        match value {
            false => CEPD2R::CEPD2_0,
            true => CEPD2R::CEPD2_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD2_0`"]
    #[inline]
    pub fn is_cepd2_0(&self) -> bool {
        *self == CEPD2R::CEPD2_0
    }
    #[doc = "Checks if the value of the field is `CEPD2_1`"]
    #[inline]
    pub fn is_cepd2_1(&self) -> bool {
        *self == CEPD2R::CEPD2_1
    }
}
#[doc = "Possible values of the field `CEPD3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD3R {
    #[doc = "The input buffer is enabled"]
    CEPD3_0,
    #[doc = "The input buffer is disabled"]
    CEPD3_1,
}
impl CEPD3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD3R::CEPD3_0 => false,
            CEPD3R::CEPD3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD3R {
        match value {
            false => CEPD3R::CEPD3_0,
            true => CEPD3R::CEPD3_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD3_0`"]
    #[inline]
    pub fn is_cepd3_0(&self) -> bool {
        *self == CEPD3R::CEPD3_0
    }
    #[doc = "Checks if the value of the field is `CEPD3_1`"]
    #[inline]
    pub fn is_cepd3_1(&self) -> bool {
        *self == CEPD3R::CEPD3_1
    }
}
#[doc = "Possible values of the field `CEPD4`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD4R {
    #[doc = "The input buffer is enabled"]
    CEPD4_0,
    #[doc = "The input buffer is disabled"]
    CEPD4_1,
}
impl CEPD4R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD4R::CEPD4_0 => false,
            CEPD4R::CEPD4_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD4R {
        match value {
            false => CEPD4R::CEPD4_0,
            true => CEPD4R::CEPD4_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD4_0`"]
    #[inline]
    pub fn is_cepd4_0(&self) -> bool {
        *self == CEPD4R::CEPD4_0
    }
    #[doc = "Checks if the value of the field is `CEPD4_1`"]
    #[inline]
    pub fn is_cepd4_1(&self) -> bool {
        *self == CEPD4R::CEPD4_1
    }
}
#[doc = "Possible values of the field `CEPD5`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD5R {
    #[doc = "The input buffer is enabled"]
    CEPD5_0,
    #[doc = "The input buffer is disabled"]
    CEPD5_1,
}
impl CEPD5R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD5R::CEPD5_0 => false,
            CEPD5R::CEPD5_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD5R {
        match value {
            false => CEPD5R::CEPD5_0,
            true => CEPD5R::CEPD5_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD5_0`"]
    #[inline]
    pub fn is_cepd5_0(&self) -> bool {
        *self == CEPD5R::CEPD5_0
    }
    #[doc = "Checks if the value of the field is `CEPD5_1`"]
    #[inline]
    pub fn is_cepd5_1(&self) -> bool {
        *self == CEPD5R::CEPD5_1
    }
}
#[doc = "Possible values of the field `CEPD6`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD6R {
    #[doc = "The input buffer is enabled"]
    CEPD6_0,
    #[doc = "The input buffer is disabled"]
    CEPD6_1,
}
impl CEPD6R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD6R::CEPD6_0 => false,
            CEPD6R::CEPD6_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD6R {
        match value {
            false => CEPD6R::CEPD6_0,
            true => CEPD6R::CEPD6_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD6_0`"]
    #[inline]
    pub fn is_cepd6_0(&self) -> bool {
        *self == CEPD6R::CEPD6_0
    }
    #[doc = "Checks if the value of the field is `CEPD6_1`"]
    #[inline]
    pub fn is_cepd6_1(&self) -> bool {
        *self == CEPD6R::CEPD6_1
    }
}
#[doc = "Possible values of the field `CEPD7`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD7R {
    #[doc = "The input buffer is enabled"]
    CEPD7_0,
    #[doc = "The input buffer is disabled"]
    CEPD7_1,
}
impl CEPD7R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD7R::CEPD7_0 => false,
            CEPD7R::CEPD7_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD7R {
        match value {
            false => CEPD7R::CEPD7_0,
            true => CEPD7R::CEPD7_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD7_0`"]
    #[inline]
    pub fn is_cepd7_0(&self) -> bool {
        *self == CEPD7R::CEPD7_0
    }
    #[doc = "Checks if the value of the field is `CEPD7_1`"]
    #[inline]
    pub fn is_cepd7_1(&self) -> bool {
        *self == CEPD7R::CEPD7_1
    }
}
#[doc = "Possible values of the field `CEPD8`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD8R {
    #[doc = "The input buffer is enabled"]
    CEPD8_0,
    #[doc = "The input buffer is disabled"]
    CEPD8_1,
}
impl CEPD8R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD8R::CEPD8_0 => false,
            CEPD8R::CEPD8_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD8R {
        match value {
            false => CEPD8R::CEPD8_0,
            true => CEPD8R::CEPD8_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD8_0`"]
    #[inline]
    pub fn is_cepd8_0(&self) -> bool {
        *self == CEPD8R::CEPD8_0
    }
    #[doc = "Checks if the value of the field is `CEPD8_1`"]
    #[inline]
    pub fn is_cepd8_1(&self) -> bool {
        *self == CEPD8R::CEPD8_1
    }
}
#[doc = "Possible values of the field `CEPD9`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD9R {
    #[doc = "The input buffer is enabled"]
    CEPD9_0,
    #[doc = "The input buffer is disabled"]
    CEPD9_1,
}
impl CEPD9R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD9R::CEPD9_0 => false,
            CEPD9R::CEPD9_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD9R {
        match value {
            false => CEPD9R::CEPD9_0,
            true => CEPD9R::CEPD9_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD9_0`"]
    #[inline]
    pub fn is_cepd9_0(&self) -> bool {
        *self == CEPD9R::CEPD9_0
    }
    #[doc = "Checks if the value of the field is `CEPD9_1`"]
    #[inline]
    pub fn is_cepd9_1(&self) -> bool {
        *self == CEPD9R::CEPD9_1
    }
}
#[doc = "Possible values of the field `CEPD10`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD10R {
    #[doc = "The input buffer is enabled"]
    CEPD10_0,
    #[doc = "The input buffer is disabled"]
    CEPD10_1,
}
impl CEPD10R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD10R::CEPD10_0 => false,
            CEPD10R::CEPD10_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD10R {
        match value {
            false => CEPD10R::CEPD10_0,
            true => CEPD10R::CEPD10_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD10_0`"]
    #[inline]
    pub fn is_cepd10_0(&self) -> bool {
        *self == CEPD10R::CEPD10_0
    }
    #[doc = "Checks if the value of the field is `CEPD10_1`"]
    #[inline]
    pub fn is_cepd10_1(&self) -> bool {
        *self == CEPD10R::CEPD10_1
    }
}
#[doc = "Possible values of the field `CEPD11`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD11R {
    #[doc = "The input buffer is enabled"]
    CEPD11_0,
    #[doc = "The input buffer is disabled"]
    CEPD11_1,
}
impl CEPD11R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD11R::CEPD11_0 => false,
            CEPD11R::CEPD11_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD11R {
        match value {
            false => CEPD11R::CEPD11_0,
            true => CEPD11R::CEPD11_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD11_0`"]
    #[inline]
    pub fn is_cepd11_0(&self) -> bool {
        *self == CEPD11R::CEPD11_0
    }
    #[doc = "Checks if the value of the field is `CEPD11_1`"]
    #[inline]
    pub fn is_cepd11_1(&self) -> bool {
        *self == CEPD11R::CEPD11_1
    }
}
#[doc = "Possible values of the field `CEPD12`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD12R {
    #[doc = "The input buffer is enabled"]
    CEPD12_0,
    #[doc = "The input buffer is disabled"]
    CEPD12_1,
}
impl CEPD12R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD12R::CEPD12_0 => false,
            CEPD12R::CEPD12_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD12R {
        match value {
            false => CEPD12R::CEPD12_0,
            true => CEPD12R::CEPD12_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD12_0`"]
    #[inline]
    pub fn is_cepd12_0(&self) -> bool {
        *self == CEPD12R::CEPD12_0
    }
    #[doc = "Checks if the value of the field is `CEPD12_1`"]
    #[inline]
    pub fn is_cepd12_1(&self) -> bool {
        *self == CEPD12R::CEPD12_1
    }
}
#[doc = "Possible values of the field `CEPD13`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD13R {
    #[doc = "The input buffer is enabled"]
    CEPD13_0,
    #[doc = "The input buffer is disabled"]
    CEPD13_1,
}
impl CEPD13R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD13R::CEPD13_0 => false,
            CEPD13R::CEPD13_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD13R {
        match value {
            false => CEPD13R::CEPD13_0,
            true => CEPD13R::CEPD13_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD13_0`"]
    #[inline]
    pub fn is_cepd13_0(&self) -> bool {
        *self == CEPD13R::CEPD13_0
    }
    #[doc = "Checks if the value of the field is `CEPD13_1`"]
    #[inline]
    pub fn is_cepd13_1(&self) -> bool {
        *self == CEPD13R::CEPD13_1
    }
}
#[doc = "Possible values of the field `CEPD14`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD14R {
    #[doc = "The input buffer is enabled"]
    CEPD14_0,
    #[doc = "The input buffer is disabled"]
    CEPD14_1,
}
impl CEPD14R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD14R::CEPD14_0 => false,
            CEPD14R::CEPD14_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD14R {
        match value {
            false => CEPD14R::CEPD14_0,
            true => CEPD14R::CEPD14_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD14_0`"]
    #[inline]
    pub fn is_cepd14_0(&self) -> bool {
        *self == CEPD14R::CEPD14_0
    }
    #[doc = "Checks if the value of the field is `CEPD14_1`"]
    #[inline]
    pub fn is_cepd14_1(&self) -> bool {
        *self == CEPD14R::CEPD14_1
    }
}
#[doc = "Possible values of the field `CEPD15`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEPD15R {
    #[doc = "The input buffer is enabled"]
    CEPD15_0,
    #[doc = "The input buffer is disabled"]
    CEPD15_1,
}
impl CEPD15R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CEPD15R::CEPD15_0 => false,
            CEPD15R::CEPD15_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CEPD15R {
        match value {
            false => CEPD15R::CEPD15_0,
            true => CEPD15R::CEPD15_1,
        }
    }
    #[doc = "Checks if the value of the field is `CEPD15_0`"]
    #[inline]
    pub fn is_cepd15_0(&self) -> bool {
        *self == CEPD15R::CEPD15_0
    }
    #[doc = "Checks if the value of the field is `CEPD15_1`"]
    #[inline]
    pub fn is_cepd15_1(&self) -> bool {
        *self == CEPD15R::CEPD15_1
    }
}
#[doc = "Values that can be written to the field `CEPD0`"]
pub enum CEPD0W {
    #[doc = "The input buffer is enabled"]
    CEPD0_0,
    #[doc = "The input buffer is disabled"]
    CEPD0_1,
}
impl CEPD0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD0W::CEPD0_0 => false,
            CEPD0W::CEPD0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD0W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd0_0(self) -> &'a mut W {
        self.variant(CEPD0W::CEPD0_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd0_1(self) -> &'a mut W {
        self.variant(CEPD0W::CEPD0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD1`"]
pub enum CEPD1W {
    #[doc = "The input buffer is enabled"]
    CEPD1_0,
    #[doc = "The input buffer is disabled"]
    CEPD1_1,
}
impl CEPD1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD1W::CEPD1_0 => false,
            CEPD1W::CEPD1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD1W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd1_0(self) -> &'a mut W {
        self.variant(CEPD1W::CEPD1_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd1_1(self) -> &'a mut W {
        self.variant(CEPD1W::CEPD1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD2`"]
pub enum CEPD2W {
    #[doc = "The input buffer is enabled"]
    CEPD2_0,
    #[doc = "The input buffer is disabled"]
    CEPD2_1,
}
impl CEPD2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD2W::CEPD2_0 => false,
            CEPD2W::CEPD2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD2W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd2_0(self) -> &'a mut W {
        self.variant(CEPD2W::CEPD2_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd2_1(self) -> &'a mut W {
        self.variant(CEPD2W::CEPD2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD3`"]
pub enum CEPD3W {
    #[doc = "The input buffer is enabled"]
    CEPD3_0,
    #[doc = "The input buffer is disabled"]
    CEPD3_1,
}
impl CEPD3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD3W::CEPD3_0 => false,
            CEPD3W::CEPD3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD3W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd3_0(self) -> &'a mut W {
        self.variant(CEPD3W::CEPD3_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd3_1(self) -> &'a mut W {
        self.variant(CEPD3W::CEPD3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD4`"]
pub enum CEPD4W {
    #[doc = "The input buffer is enabled"]
    CEPD4_0,
    #[doc = "The input buffer is disabled"]
    CEPD4_1,
}
impl CEPD4W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD4W::CEPD4_0 => false,
            CEPD4W::CEPD4_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD4W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD4W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD4W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd4_0(self) -> &'a mut W {
        self.variant(CEPD4W::CEPD4_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd4_1(self) -> &'a mut W {
        self.variant(CEPD4W::CEPD4_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD5`"]
pub enum CEPD5W {
    #[doc = "The input buffer is enabled"]
    CEPD5_0,
    #[doc = "The input buffer is disabled"]
    CEPD5_1,
}
impl CEPD5W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD5W::CEPD5_0 => false,
            CEPD5W::CEPD5_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD5W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD5W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd5_0(self) -> &'a mut W {
        self.variant(CEPD5W::CEPD5_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd5_1(self) -> &'a mut W {
        self.variant(CEPD5W::CEPD5_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD6`"]
pub enum CEPD6W {
    #[doc = "The input buffer is enabled"]
    CEPD6_0,
    #[doc = "The input buffer is disabled"]
    CEPD6_1,
}
impl CEPD6W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD6W::CEPD6_0 => false,
            CEPD6W::CEPD6_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD6W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD6W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD6W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd6_0(self) -> &'a mut W {
        self.variant(CEPD6W::CEPD6_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd6_1(self) -> &'a mut W {
        self.variant(CEPD6W::CEPD6_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD7`"]
pub enum CEPD7W {
    #[doc = "The input buffer is enabled"]
    CEPD7_0,
    #[doc = "The input buffer is disabled"]
    CEPD7_1,
}
impl CEPD7W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD7W::CEPD7_0 => false,
            CEPD7W::CEPD7_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD7W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD7W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD7W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd7_0(self) -> &'a mut W {
        self.variant(CEPD7W::CEPD7_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd7_1(self) -> &'a mut W {
        self.variant(CEPD7W::CEPD7_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD8`"]
pub enum CEPD8W {
    #[doc = "The input buffer is enabled"]
    CEPD8_0,
    #[doc = "The input buffer is disabled"]
    CEPD8_1,
}
impl CEPD8W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD8W::CEPD8_0 => false,
            CEPD8W::CEPD8_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD8W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD8W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD8W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd8_0(self) -> &'a mut W {
        self.variant(CEPD8W::CEPD8_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd8_1(self) -> &'a mut W {
        self.variant(CEPD8W::CEPD8_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD9`"]
pub enum CEPD9W {
    #[doc = "The input buffer is enabled"]
    CEPD9_0,
    #[doc = "The input buffer is disabled"]
    CEPD9_1,
}
impl CEPD9W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD9W::CEPD9_0 => false,
            CEPD9W::CEPD9_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD9W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD9W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD9W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd9_0(self) -> &'a mut W {
        self.variant(CEPD9W::CEPD9_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd9_1(self) -> &'a mut W {
        self.variant(CEPD9W::CEPD9_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD10`"]
pub enum CEPD10W {
    #[doc = "The input buffer is enabled"]
    CEPD10_0,
    #[doc = "The input buffer is disabled"]
    CEPD10_1,
}
impl CEPD10W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD10W::CEPD10_0 => false,
            CEPD10W::CEPD10_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD10W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD10W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd10_0(self) -> &'a mut W {
        self.variant(CEPD10W::CEPD10_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd10_1(self) -> &'a mut W {
        self.variant(CEPD10W::CEPD10_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD11`"]
pub enum CEPD11W {
    #[doc = "The input buffer is enabled"]
    CEPD11_0,
    #[doc = "The input buffer is disabled"]
    CEPD11_1,
}
impl CEPD11W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD11W::CEPD11_0 => false,
            CEPD11W::CEPD11_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD11W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD11W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD11W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd11_0(self) -> &'a mut W {
        self.variant(CEPD11W::CEPD11_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd11_1(self) -> &'a mut W {
        self.variant(CEPD11W::CEPD11_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD12`"]
pub enum CEPD12W {
    #[doc = "The input buffer is enabled"]
    CEPD12_0,
    #[doc = "The input buffer is disabled"]
    CEPD12_1,
}
impl CEPD12W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD12W::CEPD12_0 => false,
            CEPD12W::CEPD12_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD12W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD12W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD12W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd12_0(self) -> &'a mut W {
        self.variant(CEPD12W::CEPD12_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd12_1(self) -> &'a mut W {
        self.variant(CEPD12W::CEPD12_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD13`"]
pub enum CEPD13W {
    #[doc = "The input buffer is enabled"]
    CEPD13_0,
    #[doc = "The input buffer is disabled"]
    CEPD13_1,
}
impl CEPD13W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD13W::CEPD13_0 => false,
            CEPD13W::CEPD13_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD13W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD13W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD13W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd13_0(self) -> &'a mut W {
        self.variant(CEPD13W::CEPD13_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd13_1(self) -> &'a mut W {
        self.variant(CEPD13W::CEPD13_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD14`"]
pub enum CEPD14W {
    #[doc = "The input buffer is enabled"]
    CEPD14_0,
    #[doc = "The input buffer is disabled"]
    CEPD14_1,
}
impl CEPD14W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD14W::CEPD14_0 => false,
            CEPD14W::CEPD14_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD14W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD14W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD14W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd14_0(self) -> &'a mut W {
        self.variant(CEPD14W::CEPD14_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd14_1(self) -> &'a mut W {
        self.variant(CEPD14W::CEPD14_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CEPD15`"]
pub enum CEPD15W {
    #[doc = "The input buffer is enabled"]
    CEPD15_0,
    #[doc = "The input buffer is disabled"]
    CEPD15_1,
}
impl CEPD15W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CEPD15W::CEPD15_0 => false,
            CEPD15W::CEPD15_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CEPD15W<'a> {
    w: &'a mut W,
}
impl<'a> _CEPD15W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CEPD15W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The input buffer is enabled"]
    #[inline]
    pub fn cepd15_0(self) -> &'a mut W {
        self.variant(CEPD15W::CEPD15_0)
    }
    #[doc = "The input buffer is disabled"]
    #[inline]
    pub fn cepd15_1(self) -> &'a mut W {
        self.variant(CEPD15W::CEPD15_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Port disable"]
    #[inline]
    pub fn cepd0(&self) -> CEPD0R {
        CEPD0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Port disable"]
    #[inline]
    pub fn cepd1(&self) -> CEPD1R {
        CEPD1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Port disable"]
    #[inline]
    pub fn cepd2(&self) -> CEPD2R {
        CEPD2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Port disable"]
    #[inline]
    pub fn cepd3(&self) -> CEPD3R {
        CEPD3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Port disable"]
    #[inline]
    pub fn cepd4(&self) -> CEPD4R {
        CEPD4R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Port disable"]
    #[inline]
    pub fn cepd5(&self) -> CEPD5R {
        CEPD5R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Port disable"]
    #[inline]
    pub fn cepd6(&self) -> CEPD6R {
        CEPD6R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Port disable"]
    #[inline]
    pub fn cepd7(&self) -> CEPD7R {
        CEPD7R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 8 - Port disable"]
    #[inline]
    pub fn cepd8(&self) -> CEPD8R {
        CEPD8R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 9 - Port disable"]
    #[inline]
    pub fn cepd9(&self) -> CEPD9R {
        CEPD9R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 10 - Port disable"]
    #[inline]
    pub fn cepd10(&self) -> CEPD10R {
        CEPD10R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 11 - Port disable"]
    #[inline]
    pub fn cepd11(&self) -> CEPD11R {
        CEPD11R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 12 - Port disable"]
    #[inline]
    pub fn cepd12(&self) -> CEPD12R {
        CEPD12R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - Port disable"]
    #[inline]
    pub fn cepd13(&self) -> CEPD13R {
        CEPD13R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Port disable"]
    #[inline]
    pub fn cepd14(&self) -> CEPD14R {
        CEPD14R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 15 - Port disable"]
    #[inline]
    pub fn cepd15(&self) -> CEPD15R {
        CEPD15R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Port disable"]
    #[inline]
    pub fn cepd0(&mut self) -> _CEPD0W {
        _CEPD0W { w: self }
    }
    #[doc = "Bit 1 - Port disable"]
    #[inline]
    pub fn cepd1(&mut self) -> _CEPD1W {
        _CEPD1W { w: self }
    }
    #[doc = "Bit 2 - Port disable"]
    #[inline]
    pub fn cepd2(&mut self) -> _CEPD2W {
        _CEPD2W { w: self }
    }
    #[doc = "Bit 3 - Port disable"]
    #[inline]
    pub fn cepd3(&mut self) -> _CEPD3W {
        _CEPD3W { w: self }
    }
    #[doc = "Bit 4 - Port disable"]
    #[inline]
    pub fn cepd4(&mut self) -> _CEPD4W {
        _CEPD4W { w: self }
    }
    #[doc = "Bit 5 - Port disable"]
    #[inline]
    pub fn cepd5(&mut self) -> _CEPD5W {
        _CEPD5W { w: self }
    }
    #[doc = "Bit 6 - Port disable"]
    #[inline]
    pub fn cepd6(&mut self) -> _CEPD6W {
        _CEPD6W { w: self }
    }
    #[doc = "Bit 7 - Port disable"]
    #[inline]
    pub fn cepd7(&mut self) -> _CEPD7W {
        _CEPD7W { w: self }
    }
    #[doc = "Bit 8 - Port disable"]
    #[inline]
    pub fn cepd8(&mut self) -> _CEPD8W {
        _CEPD8W { w: self }
    }
    #[doc = "Bit 9 - Port disable"]
    #[inline]
    pub fn cepd9(&mut self) -> _CEPD9W {
        _CEPD9W { w: self }
    }
    #[doc = "Bit 10 - Port disable"]
    #[inline]
    pub fn cepd10(&mut self) -> _CEPD10W {
        _CEPD10W { w: self }
    }
    #[doc = "Bit 11 - Port disable"]
    #[inline]
    pub fn cepd11(&mut self) -> _CEPD11W {
        _CEPD11W { w: self }
    }
    #[doc = "Bit 12 - Port disable"]
    #[inline]
    pub fn cepd12(&mut self) -> _CEPD12W {
        _CEPD12W { w: self }
    }
    #[doc = "Bit 13 - Port disable"]
    #[inline]
    pub fn cepd13(&mut self) -> _CEPD13W {
        _CEPD13W { w: self }
    }
    #[doc = "Bit 14 - Port disable"]
    #[inline]
    pub fn cepd14(&mut self) -> _CEPD14W {
        _CEPD14W { w: self }
    }
    #[doc = "Bit 15 - Port disable"]
    #[inline]
    pub fn cepd15(&mut self) -> _CEPD15W {
        _CEPD15W { w: self }
    }
}
