#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Data Input for CRC32 Signature Computation"]
    pub crc32di: CRC32DI,
    _reserved0: [u8; 2usize],
    #[doc = "0x04 - Data In Reverse for CRC32 Computation"]
    pub crc32dirb: CRC32DIRB,
    _reserved1: [u8; 2usize],
    #[doc = "0x08 - CRC32 Initialization and Result, lower 16 bits"]
    pub crc32inires_lo: CRC32INIRES_LO,
    #[doc = "0x0a - CRC32 Initialization and Result, upper 16 bits"]
    pub crc32inires_hi: CRC32INIRES_HI,
    #[doc = "0x0c - CRC32 Result Reverse, lower 16 bits"]
    pub crc32resr_lo: CRC32RESR_LO,
    #[doc = "0x0e - CRC32 Result Reverse, Upper 16 bits"]
    pub crc32resr_hi: CRC32RESR_HI,
    #[doc = "0x10 - Data Input for CRC16 computation"]
    pub crc16di: CRC16DI,
    _reserved2: [u8; 2usize],
    #[doc = "0x14 - CRC16 Data In Reverse"]
    pub crc16dirb: CRC16DIRB,
    _reserved3: [u8; 2usize],
    #[doc = "0x18 - CRC16 Initialization and Result register"]
    pub crc16inires: CRC16INIRES,
    _reserved4: [u8; 4usize],
    #[doc = "0x1e - CRC16 Result Reverse"]
    pub crc16resr: CRC16RESR,
}
#[doc = "Data Input for CRC32 Signature Computation"]
pub struct CRC32DI {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Data Input for CRC32 Signature Computation"]
pub mod crc32di;
#[doc = "Data In Reverse for CRC32 Computation"]
pub struct CRC32DIRB {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Data In Reverse for CRC32 Computation"]
pub mod crc32dirb;
#[doc = "CRC32 Initialization and Result, lower 16 bits"]
pub struct CRC32INIRES_LO {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC32 Initialization and Result, lower 16 bits"]
pub mod crc32inires_lo;
#[doc = "CRC32 Initialization and Result, upper 16 bits"]
pub struct CRC32INIRES_HI {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC32 Initialization and Result, upper 16 bits"]
pub mod crc32inires_hi;
#[doc = "CRC32 Result Reverse, lower 16 bits"]
pub struct CRC32RESR_LO {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC32 Result Reverse, lower 16 bits"]
pub mod crc32resr_lo;
#[doc = "CRC32 Result Reverse, Upper 16 bits"]
pub struct CRC32RESR_HI {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC32 Result Reverse, Upper 16 bits"]
pub mod crc32resr_hi;
#[doc = "Data Input for CRC16 computation"]
pub struct CRC16DI {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Data Input for CRC16 computation"]
pub mod crc16di;
#[doc = "CRC16 Data In Reverse"]
pub struct CRC16DIRB {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC16 Data In Reverse"]
pub mod crc16dirb;
#[doc = "CRC16 Initialization and Result register"]
pub struct CRC16INIRES {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC16 Initialization and Result register"]
pub mod crc16inires;
#[doc = "CRC16 Result Reverse"]
pub struct CRC16RESR {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "CRC16 Result Reverse"]
pub mod crc16resr;
