#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Key Register"]
    pub cskey: CSKEY,
    #[doc = "0x04 - Control 0 Register"]
    pub csctl0: CSCTL0,
    #[doc = "0x08 - Control 1 Register"]
    pub csctl1: CSCTL1,
    #[doc = "0x0c - Control 2 Register"]
    pub csctl2: CSCTL2,
    #[doc = "0x10 - Control 3 Register"]
    pub csctl3: CSCTL3,
    _reserved0: [u8; 28usize],
    #[doc = "0x30 - Clock Enable Register"]
    pub csclken: CSCLKEN,
    #[doc = "0x34 - Status Register"]
    pub csstat: CSSTAT,
    _reserved1: [u8; 8usize],
    #[doc = "0x40 - Interrupt Enable Register"]
    pub csie: CSIE,
    _reserved2: [u8; 4usize],
    #[doc = "0x48 - Interrupt Flag Register"]
    pub csifg: CSIFG,
    _reserved3: [u8; 4usize],
    #[doc = "0x50 - Clear Interrupt Flag Register"]
    pub csclrifg: CSCLRIFG,
    _reserved4: [u8; 4usize],
    #[doc = "0x58 - Set Interrupt Flag Register"]
    pub cssetifg: CSSETIFG,
    _reserved5: [u8; 4usize],
    #[doc = "0x60 - DCO External Resistor Cailbration 0 Register"]
    pub csdcoercal0: CSDCOERCAL0,
    #[doc = "0x64 - DCO External Resistor Calibration 1 Register"]
    pub csdcoercal1: CSDCOERCAL1,
}
#[doc = "Key Register"]
pub struct CSKEY {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Key Register"]
pub mod cskey;
#[doc = "Control 0 Register"]
pub struct CSCTL0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 0 Register"]
pub mod csctl0;
#[doc = "Control 1 Register"]
pub struct CSCTL1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 1 Register"]
pub mod csctl1;
#[doc = "Control 2 Register"]
pub struct CSCTL2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 2 Register"]
pub mod csctl2;
#[doc = "Control 3 Register"]
pub struct CSCTL3 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 3 Register"]
pub mod csctl3;
#[doc = "Clock Enable Register"]
pub struct CSCLKEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clock Enable Register"]
pub mod csclken;
#[doc = "Status Register"]
pub struct CSSTAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Status Register"]
pub mod csstat;
#[doc = "Interrupt Enable Register"]
pub struct CSIE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Enable Register"]
pub mod csie;
#[doc = "Interrupt Flag Register"]
pub struct CSIFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Flag Register"]
pub mod csifg;
#[doc = "Clear Interrupt Flag Register"]
pub struct CSCLRIFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clear Interrupt Flag Register"]
pub mod csclrifg;
#[doc = "Set Interrupt Flag Register"]
pub struct CSSETIFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Set Interrupt Flag Register"]
pub mod cssetifg;
#[doc = "DCO External Resistor Cailbration 0 Register"]
pub struct CSDCOERCAL0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO External Resistor Cailbration 0 Register"]
pub mod csdcoercal0;
#[doc = "DCO External Resistor Calibration 1 Register"]
pub struct CSDCOERCAL1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO External Resistor Calibration 1 Register"]
pub mod csdcoercal1;
