#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P10IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P10IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P10IVR {
    #[doc = "No interrupt pending"]
    P10IV_0,
    #[doc = "Interrupt Source: Port 10.0 interrupt; Interrupt Flag: P10IFG0; Interrupt Priority: Highest"]
    P10IV_2,
    #[doc = "Interrupt Source: Port 10.1 interrupt; Interrupt Flag: P10IFG1"]
    P10IV_4,
    #[doc = "Interrupt Source: Port 10.2 interrupt; Interrupt Flag: P10IFG2"]
    P10IV_6,
    #[doc = "Interrupt Source: Port 10.3 interrupt; Interrupt Flag: P10IFG3"]
    P10IV_8,
    #[doc = "Interrupt Source: Port 10.4 interrupt; Interrupt Flag: P10IFG4"]
    P10IV_10,
    #[doc = "Interrupt Source: Port 10.5 interrupt; Interrupt Flag: P10IFG5"]
    P10IV_12,
    #[doc = "Interrupt Source: Port 10.6 interrupt; Interrupt Flag: P10IFG6"]
    P10IV_14,
    #[doc = "Interrupt Source: Port 10.7 interrupt; Interrupt Flag: P10IFG7; Interrupt Priority: Lowest"]
    P10IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P10IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P10IVR::P10IV_0 => 0,
            P10IVR::P10IV_2 => 2,
            P10IVR::P10IV_4 => 4,
            P10IVR::P10IV_6 => 6,
            P10IVR::P10IV_8 => 8,
            P10IVR::P10IV_10 => 10,
            P10IVR::P10IV_12 => 12,
            P10IVR::P10IV_14 => 14,
            P10IVR::P10IV_16 => 16,
            P10IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P10IVR {
        match value {
            0 => P10IVR::P10IV_0,
            2 => P10IVR::P10IV_2,
            4 => P10IVR::P10IV_4,
            6 => P10IVR::P10IV_6,
            8 => P10IVR::P10IV_8,
            10 => P10IVR::P10IV_10,
            12 => P10IVR::P10IV_12,
            14 => P10IVR::P10IV_14,
            16 => P10IVR::P10IV_16,
            i => P10IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P10IV_0`"]
    #[inline]
    pub fn is_p10iv_0(&self) -> bool {
        *self == P10IVR::P10IV_0
    }
    #[doc = "Checks if the value of the field is `P10IV_2`"]
    #[inline]
    pub fn is_p10iv_2(&self) -> bool {
        *self == P10IVR::P10IV_2
    }
    #[doc = "Checks if the value of the field is `P10IV_4`"]
    #[inline]
    pub fn is_p10iv_4(&self) -> bool {
        *self == P10IVR::P10IV_4
    }
    #[doc = "Checks if the value of the field is `P10IV_6`"]
    #[inline]
    pub fn is_p10iv_6(&self) -> bool {
        *self == P10IVR::P10IV_6
    }
    #[doc = "Checks if the value of the field is `P10IV_8`"]
    #[inline]
    pub fn is_p10iv_8(&self) -> bool {
        *self == P10IVR::P10IV_8
    }
    #[doc = "Checks if the value of the field is `P10IV_10`"]
    #[inline]
    pub fn is_p10iv_10(&self) -> bool {
        *self == P10IVR::P10IV_10
    }
    #[doc = "Checks if the value of the field is `P10IV_12`"]
    #[inline]
    pub fn is_p10iv_12(&self) -> bool {
        *self == P10IVR::P10IV_12
    }
    #[doc = "Checks if the value of the field is `P10IV_14`"]
    #[inline]
    pub fn is_p10iv_14(&self) -> bool {
        *self == P10IVR::P10IV_14
    }
    #[doc = "Checks if the value of the field is `P10IV_16`"]
    #[inline]
    pub fn is_p10iv_16(&self) -> bool {
        *self == P10IVR::P10IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 10 interrupt vector value"]
    #[inline]
    pub fn p10iv(&self) -> P10IVR {
        P10IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
