#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P3IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P3IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P3IVR {
    #[doc = "No interrupt pending"]
    P3IV_0,
    #[doc = "Interrupt Source: Port 3.0 interrupt; Interrupt Flag: P3IFG0; Interrupt Priority: Highest"]
    P3IV_2,
    #[doc = "Interrupt Source: Port 3.1 interrupt; Interrupt Flag: P3IFG1"]
    P3IV_4,
    #[doc = "Interrupt Source: Port 3.2 interrupt; Interrupt Flag: P3IFG2"]
    P3IV_6,
    #[doc = "Interrupt Source: Port 3.3 interrupt; Interrupt Flag: P3IFG3"]
    P3IV_8,
    #[doc = "Interrupt Source: Port 3.4 interrupt; Interrupt Flag: P3IFG4"]
    P3IV_10,
    #[doc = "Interrupt Source: Port 3.5 interrupt; Interrupt Flag: P3IFG5"]
    P3IV_12,
    #[doc = "Interrupt Source: Port 3.6 interrupt; Interrupt Flag: P3IFG6"]
    P3IV_14,
    #[doc = "Interrupt Source: Port 3.7 interrupt; Interrupt Flag: P3IFG7; Interrupt Priority: Lowest"]
    P3IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P3IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P3IVR::P3IV_0 => 0,
            P3IVR::P3IV_2 => 2,
            P3IVR::P3IV_4 => 4,
            P3IVR::P3IV_6 => 6,
            P3IVR::P3IV_8 => 8,
            P3IVR::P3IV_10 => 10,
            P3IVR::P3IV_12 => 12,
            P3IVR::P3IV_14 => 14,
            P3IVR::P3IV_16 => 16,
            P3IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P3IVR {
        match value {
            0 => P3IVR::P3IV_0,
            2 => P3IVR::P3IV_2,
            4 => P3IVR::P3IV_4,
            6 => P3IVR::P3IV_6,
            8 => P3IVR::P3IV_8,
            10 => P3IVR::P3IV_10,
            12 => P3IVR::P3IV_12,
            14 => P3IVR::P3IV_14,
            16 => P3IVR::P3IV_16,
            i => P3IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P3IV_0`"]
    #[inline]
    pub fn is_p3iv_0(&self) -> bool {
        *self == P3IVR::P3IV_0
    }
    #[doc = "Checks if the value of the field is `P3IV_2`"]
    #[inline]
    pub fn is_p3iv_2(&self) -> bool {
        *self == P3IVR::P3IV_2
    }
    #[doc = "Checks if the value of the field is `P3IV_4`"]
    #[inline]
    pub fn is_p3iv_4(&self) -> bool {
        *self == P3IVR::P3IV_4
    }
    #[doc = "Checks if the value of the field is `P3IV_6`"]
    #[inline]
    pub fn is_p3iv_6(&self) -> bool {
        *self == P3IVR::P3IV_6
    }
    #[doc = "Checks if the value of the field is `P3IV_8`"]
    #[inline]
    pub fn is_p3iv_8(&self) -> bool {
        *self == P3IVR::P3IV_8
    }
    #[doc = "Checks if the value of the field is `P3IV_10`"]
    #[inline]
    pub fn is_p3iv_10(&self) -> bool {
        *self == P3IVR::P3IV_10
    }
    #[doc = "Checks if the value of the field is `P3IV_12`"]
    #[inline]
    pub fn is_p3iv_12(&self) -> bool {
        *self == P3IVR::P3IV_12
    }
    #[doc = "Checks if the value of the field is `P3IV_14`"]
    #[inline]
    pub fn is_p3iv_14(&self) -> bool {
        *self == P3IVR::P3IV_14
    }
    #[doc = "Checks if the value of the field is `P3IV_16`"]
    #[inline]
    pub fn is_p3iv_16(&self) -> bool {
        *self == P3IVR::P3IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 3 interrupt vector value"]
    #[inline]
    pub fn p3iv(&self) -> P3IVR {
        P3IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
