#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P4IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P4IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P4IVR {
    #[doc = "No interrupt pending"]
    P4IV_0,
    #[doc = "Interrupt Source: Port 4.0 interrupt; Interrupt Flag: P4IFG0; Interrupt Priority: Highest"]
    P4IV_2,
    #[doc = "Interrupt Source: Port 4.1 interrupt; Interrupt Flag: P4IFG1"]
    P4IV_4,
    #[doc = "Interrupt Source: Port 4.2 interrupt; Interrupt Flag: P4IFG2"]
    P4IV_6,
    #[doc = "Interrupt Source: Port 4.3 interrupt; Interrupt Flag: P4IFG3"]
    P4IV_8,
    #[doc = "Interrupt Source: Port 4.4 interrupt; Interrupt Flag: P4IFG4"]
    P4IV_10,
    #[doc = "Interrupt Source: Port 4.5 interrupt; Interrupt Flag: P4IFG5"]
    P4IV_12,
    #[doc = "Interrupt Source: Port 4.6 interrupt; Interrupt Flag: P4IFG6"]
    P4IV_14,
    #[doc = "Interrupt Source: Port 4.7 interrupt; Interrupt Flag: P4IFG7; Interrupt Priority: Lowest"]
    P4IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P4IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P4IVR::P4IV_0 => 0,
            P4IVR::P4IV_2 => 2,
            P4IVR::P4IV_4 => 4,
            P4IVR::P4IV_6 => 6,
            P4IVR::P4IV_8 => 8,
            P4IVR::P4IV_10 => 10,
            P4IVR::P4IV_12 => 12,
            P4IVR::P4IV_14 => 14,
            P4IVR::P4IV_16 => 16,
            P4IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P4IVR {
        match value {
            0 => P4IVR::P4IV_0,
            2 => P4IVR::P4IV_2,
            4 => P4IVR::P4IV_4,
            6 => P4IVR::P4IV_6,
            8 => P4IVR::P4IV_8,
            10 => P4IVR::P4IV_10,
            12 => P4IVR::P4IV_12,
            14 => P4IVR::P4IV_14,
            16 => P4IVR::P4IV_16,
            i => P4IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P4IV_0`"]
    #[inline]
    pub fn is_p4iv_0(&self) -> bool {
        *self == P4IVR::P4IV_0
    }
    #[doc = "Checks if the value of the field is `P4IV_2`"]
    #[inline]
    pub fn is_p4iv_2(&self) -> bool {
        *self == P4IVR::P4IV_2
    }
    #[doc = "Checks if the value of the field is `P4IV_4`"]
    #[inline]
    pub fn is_p4iv_4(&self) -> bool {
        *self == P4IVR::P4IV_4
    }
    #[doc = "Checks if the value of the field is `P4IV_6`"]
    #[inline]
    pub fn is_p4iv_6(&self) -> bool {
        *self == P4IVR::P4IV_6
    }
    #[doc = "Checks if the value of the field is `P4IV_8`"]
    #[inline]
    pub fn is_p4iv_8(&self) -> bool {
        *self == P4IVR::P4IV_8
    }
    #[doc = "Checks if the value of the field is `P4IV_10`"]
    #[inline]
    pub fn is_p4iv_10(&self) -> bool {
        *self == P4IVR::P4IV_10
    }
    #[doc = "Checks if the value of the field is `P4IV_12`"]
    #[inline]
    pub fn is_p4iv_12(&self) -> bool {
        *self == P4IVR::P4IV_12
    }
    #[doc = "Checks if the value of the field is `P4IV_14`"]
    #[inline]
    pub fn is_p4iv_14(&self) -> bool {
        *self == P4IVR::P4IV_14
    }
    #[doc = "Checks if the value of the field is `P4IV_16`"]
    #[inline]
    pub fn is_p4iv_16(&self) -> bool {
        *self == P4IVR::P4IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 4 interrupt vector value"]
    #[inline]
    pub fn p4iv(&self) -> P4IVR {
        P4IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
