#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P5IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P5IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P5IVR {
    #[doc = "No interrupt pending"]
    P5IV_0,
    #[doc = "Interrupt Source: Port 5.0 interrupt; Interrupt Flag: P5IFG0; Interrupt Priority: Highest"]
    P5IV_2,
    #[doc = "Interrupt Source: Port 5.1 interrupt; Interrupt Flag: P5IFG1"]
    P5IV_4,
    #[doc = "Interrupt Source: Port 5.2 interrupt; Interrupt Flag: P5IFG2"]
    P5IV_6,
    #[doc = "Interrupt Source: Port 5.3 interrupt; Interrupt Flag: P5IFG3"]
    P5IV_8,
    #[doc = "Interrupt Source: Port 5.4 interrupt; Interrupt Flag: P5IFG4"]
    P5IV_10,
    #[doc = "Interrupt Source: Port 5.5 interrupt; Interrupt Flag: P5IFG5"]
    P5IV_12,
    #[doc = "Interrupt Source: Port 5.6 interrupt; Interrupt Flag: P5IFG6"]
    P5IV_14,
    #[doc = "Interrupt Source: Port 5.7 interrupt; Interrupt Flag: P5IFG7; Interrupt Priority: Lowest"]
    P5IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P5IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P5IVR::P5IV_0 => 0,
            P5IVR::P5IV_2 => 2,
            P5IVR::P5IV_4 => 4,
            P5IVR::P5IV_6 => 6,
            P5IVR::P5IV_8 => 8,
            P5IVR::P5IV_10 => 10,
            P5IVR::P5IV_12 => 12,
            P5IVR::P5IV_14 => 14,
            P5IVR::P5IV_16 => 16,
            P5IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P5IVR {
        match value {
            0 => P5IVR::P5IV_0,
            2 => P5IVR::P5IV_2,
            4 => P5IVR::P5IV_4,
            6 => P5IVR::P5IV_6,
            8 => P5IVR::P5IV_8,
            10 => P5IVR::P5IV_10,
            12 => P5IVR::P5IV_12,
            14 => P5IVR::P5IV_14,
            16 => P5IVR::P5IV_16,
            i => P5IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P5IV_0`"]
    #[inline]
    pub fn is_p5iv_0(&self) -> bool {
        *self == P5IVR::P5IV_0
    }
    #[doc = "Checks if the value of the field is `P5IV_2`"]
    #[inline]
    pub fn is_p5iv_2(&self) -> bool {
        *self == P5IVR::P5IV_2
    }
    #[doc = "Checks if the value of the field is `P5IV_4`"]
    #[inline]
    pub fn is_p5iv_4(&self) -> bool {
        *self == P5IVR::P5IV_4
    }
    #[doc = "Checks if the value of the field is `P5IV_6`"]
    #[inline]
    pub fn is_p5iv_6(&self) -> bool {
        *self == P5IVR::P5IV_6
    }
    #[doc = "Checks if the value of the field is `P5IV_8`"]
    #[inline]
    pub fn is_p5iv_8(&self) -> bool {
        *self == P5IVR::P5IV_8
    }
    #[doc = "Checks if the value of the field is `P5IV_10`"]
    #[inline]
    pub fn is_p5iv_10(&self) -> bool {
        *self == P5IVR::P5IV_10
    }
    #[doc = "Checks if the value of the field is `P5IV_12`"]
    #[inline]
    pub fn is_p5iv_12(&self) -> bool {
        *self == P5IVR::P5IV_12
    }
    #[doc = "Checks if the value of the field is `P5IV_14`"]
    #[inline]
    pub fn is_p5iv_14(&self) -> bool {
        *self == P5IVR::P5IV_14
    }
    #[doc = "Checks if the value of the field is `P5IV_16`"]
    #[inline]
    pub fn is_p5iv_16(&self) -> bool {
        *self == P5IVR::P5IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 5 interrupt vector value"]
    #[inline]
    pub fn p5iv(&self) -> P5IVR {
        P5IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
