#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P7IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P7IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P7IVR {
    #[doc = "No interrupt pending"]
    P7IV_0,
    #[doc = "Interrupt Source: Port 7.0 interrupt; Interrupt Flag: P7IFG0; Interrupt Priority: Highest"]
    P7IV_2,
    #[doc = "Interrupt Source: Port 7.1 interrupt; Interrupt Flag: P7IFG1"]
    P7IV_4,
    #[doc = "Interrupt Source: Port 7.2 interrupt; Interrupt Flag: P7IFG2"]
    P7IV_6,
    #[doc = "Interrupt Source: Port 7.3 interrupt; Interrupt Flag: P7IFG3"]
    P7IV_8,
    #[doc = "Interrupt Source: Port 7.4 interrupt; Interrupt Flag: P7IFG4"]
    P7IV_10,
    #[doc = "Interrupt Source: Port 7.5 interrupt; Interrupt Flag: P7IFG5"]
    P7IV_12,
    #[doc = "Interrupt Source: Port 7.6 interrupt; Interrupt Flag: P7IFG6"]
    P7IV_14,
    #[doc = "Interrupt Source: Port 7.7 interrupt; Interrupt Flag: P7IFG7; Interrupt Priority: Lowest"]
    P7IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P7IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P7IVR::P7IV_0 => 0,
            P7IVR::P7IV_2 => 2,
            P7IVR::P7IV_4 => 4,
            P7IVR::P7IV_6 => 6,
            P7IVR::P7IV_8 => 8,
            P7IVR::P7IV_10 => 10,
            P7IVR::P7IV_12 => 12,
            P7IVR::P7IV_14 => 14,
            P7IVR::P7IV_16 => 16,
            P7IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P7IVR {
        match value {
            0 => P7IVR::P7IV_0,
            2 => P7IVR::P7IV_2,
            4 => P7IVR::P7IV_4,
            6 => P7IVR::P7IV_6,
            8 => P7IVR::P7IV_8,
            10 => P7IVR::P7IV_10,
            12 => P7IVR::P7IV_12,
            14 => P7IVR::P7IV_14,
            16 => P7IVR::P7IV_16,
            i => P7IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P7IV_0`"]
    #[inline]
    pub fn is_p7iv_0(&self) -> bool {
        *self == P7IVR::P7IV_0
    }
    #[doc = "Checks if the value of the field is `P7IV_2`"]
    #[inline]
    pub fn is_p7iv_2(&self) -> bool {
        *self == P7IVR::P7IV_2
    }
    #[doc = "Checks if the value of the field is `P7IV_4`"]
    #[inline]
    pub fn is_p7iv_4(&self) -> bool {
        *self == P7IVR::P7IV_4
    }
    #[doc = "Checks if the value of the field is `P7IV_6`"]
    #[inline]
    pub fn is_p7iv_6(&self) -> bool {
        *self == P7IVR::P7IV_6
    }
    #[doc = "Checks if the value of the field is `P7IV_8`"]
    #[inline]
    pub fn is_p7iv_8(&self) -> bool {
        *self == P7IVR::P7IV_8
    }
    #[doc = "Checks if the value of the field is `P7IV_10`"]
    #[inline]
    pub fn is_p7iv_10(&self) -> bool {
        *self == P7IVR::P7IV_10
    }
    #[doc = "Checks if the value of the field is `P7IV_12`"]
    #[inline]
    pub fn is_p7iv_12(&self) -> bool {
        *self == P7IVR::P7IV_12
    }
    #[doc = "Checks if the value of the field is `P7IV_14`"]
    #[inline]
    pub fn is_p7iv_14(&self) -> bool {
        *self == P7IVR::P7IV_14
    }
    #[doc = "Checks if the value of the field is `P7IV_16`"]
    #[inline]
    pub fn is_p7iv_16(&self) -> bool {
        *self == P7IVR::P7IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 7 interrupt vector value"]
    #[inline]
    pub fn p7iv(&self) -> P7IVR {
        P7IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
