#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P8IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P8IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P8IVR {
    #[doc = "No interrupt pending"]
    P8IV_0,
    #[doc = "Interrupt Source: Port 8.0 interrupt; Interrupt Flag: P8IFG0; Interrupt Priority: Highest"]
    P8IV_2,
    #[doc = "Interrupt Source: Port 8.1 interrupt; Interrupt Flag: P8IFG1"]
    P8IV_4,
    #[doc = "Interrupt Source: Port 8.2 interrupt; Interrupt Flag: P8IFG2"]
    P8IV_6,
    #[doc = "Interrupt Source: Port 8.3 interrupt; Interrupt Flag: P8IFG3"]
    P8IV_8,
    #[doc = "Interrupt Source: Port 8.4 interrupt; Interrupt Flag: P8IFG4"]
    P8IV_10,
    #[doc = "Interrupt Source: Port 8.5 interrupt; Interrupt Flag: P8IFG5"]
    P8IV_12,
    #[doc = "Interrupt Source: Port 8.6 interrupt; Interrupt Flag: P8IFG6"]
    P8IV_14,
    #[doc = "Interrupt Source: Port 8.7 interrupt; Interrupt Flag: P8IFG7; Interrupt Priority: Lowest"]
    P8IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P8IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P8IVR::P8IV_0 => 0,
            P8IVR::P8IV_2 => 2,
            P8IVR::P8IV_4 => 4,
            P8IVR::P8IV_6 => 6,
            P8IVR::P8IV_8 => 8,
            P8IVR::P8IV_10 => 10,
            P8IVR::P8IV_12 => 12,
            P8IVR::P8IV_14 => 14,
            P8IVR::P8IV_16 => 16,
            P8IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P8IVR {
        match value {
            0 => P8IVR::P8IV_0,
            2 => P8IVR::P8IV_2,
            4 => P8IVR::P8IV_4,
            6 => P8IVR::P8IV_6,
            8 => P8IVR::P8IV_8,
            10 => P8IVR::P8IV_10,
            12 => P8IVR::P8IV_12,
            14 => P8IVR::P8IV_14,
            16 => P8IVR::P8IV_16,
            i => P8IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P8IV_0`"]
    #[inline]
    pub fn is_p8iv_0(&self) -> bool {
        *self == P8IVR::P8IV_0
    }
    #[doc = "Checks if the value of the field is `P8IV_2`"]
    #[inline]
    pub fn is_p8iv_2(&self) -> bool {
        *self == P8IVR::P8IV_2
    }
    #[doc = "Checks if the value of the field is `P8IV_4`"]
    #[inline]
    pub fn is_p8iv_4(&self) -> bool {
        *self == P8IVR::P8IV_4
    }
    #[doc = "Checks if the value of the field is `P8IV_6`"]
    #[inline]
    pub fn is_p8iv_6(&self) -> bool {
        *self == P8IVR::P8IV_6
    }
    #[doc = "Checks if the value of the field is `P8IV_8`"]
    #[inline]
    pub fn is_p8iv_8(&self) -> bool {
        *self == P8IVR::P8IV_8
    }
    #[doc = "Checks if the value of the field is `P8IV_10`"]
    #[inline]
    pub fn is_p8iv_10(&self) -> bool {
        *self == P8IVR::P8IV_10
    }
    #[doc = "Checks if the value of the field is `P8IV_12`"]
    #[inline]
    pub fn is_p8iv_12(&self) -> bool {
        *self == P8IVR::P8IV_12
    }
    #[doc = "Checks if the value of the field is `P8IV_14`"]
    #[inline]
    pub fn is_p8iv_14(&self) -> bool {
        *self == P8IVR::P8IV_14
    }
    #[doc = "Checks if the value of the field is `P8IV_16`"]
    #[inline]
    pub fn is_p8iv_16(&self) -> bool {
        *self == P8IVR::P8IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 8 interrupt vector value"]
    #[inline]
    pub fn p8iv(&self) -> P8IVR {
        P8IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
