#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::P9IV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `P9IV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum P9IVR {
    #[doc = "No interrupt pending"]
    P9IV_0,
    #[doc = "Interrupt Source: Port 9.0 interrupt; Interrupt Flag: P9IFG0; Interrupt Priority: Highest"]
    P9IV_2,
    #[doc = "Interrupt Source: Port 9.1 interrupt; Interrupt Flag: P9IFG1"]
    P9IV_4,
    #[doc = "Interrupt Source: Port 9.2 interrupt; Interrupt Flag: P9IFG2"]
    P9IV_6,
    #[doc = "Interrupt Source: Port 9.3 interrupt; Interrupt Flag: P9IFG3"]
    P9IV_8,
    #[doc = "Interrupt Source: Port 9.4 interrupt; Interrupt Flag: P9IFG4"]
    P9IV_10,
    #[doc = "Interrupt Source: Port 9.5 interrupt; Interrupt Flag: P9IFG5"]
    P9IV_12,
    #[doc = "Interrupt Source: Port 9.6 interrupt; Interrupt Flag: P9IFG6"]
    P9IV_14,
    #[doc = "Interrupt Source: Port 9.7 interrupt; Interrupt Flag: P9IFG7; Interrupt Priority: Lowest"]
    P9IV_16,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl P9IVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            P9IVR::P9IV_0 => 0,
            P9IVR::P9IV_2 => 2,
            P9IVR::P9IV_4 => 4,
            P9IVR::P9IV_6 => 6,
            P9IVR::P9IV_8 => 8,
            P9IVR::P9IV_10 => 10,
            P9IVR::P9IV_12 => 12,
            P9IVR::P9IV_14 => 14,
            P9IVR::P9IV_16 => 16,
            P9IVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> P9IVR {
        match value {
            0 => P9IVR::P9IV_0,
            2 => P9IVR::P9IV_2,
            4 => P9IVR::P9IV_4,
            6 => P9IVR::P9IV_6,
            8 => P9IVR::P9IV_8,
            10 => P9IVR::P9IV_10,
            12 => P9IVR::P9IV_12,
            14 => P9IVR::P9IV_14,
            16 => P9IVR::P9IV_16,
            i => P9IVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `P9IV_0`"]
    #[inline]
    pub fn is_p9iv_0(&self) -> bool {
        *self == P9IVR::P9IV_0
    }
    #[doc = "Checks if the value of the field is `P9IV_2`"]
    #[inline]
    pub fn is_p9iv_2(&self) -> bool {
        *self == P9IVR::P9IV_2
    }
    #[doc = "Checks if the value of the field is `P9IV_4`"]
    #[inline]
    pub fn is_p9iv_4(&self) -> bool {
        *self == P9IVR::P9IV_4
    }
    #[doc = "Checks if the value of the field is `P9IV_6`"]
    #[inline]
    pub fn is_p9iv_6(&self) -> bool {
        *self == P9IVR::P9IV_6
    }
    #[doc = "Checks if the value of the field is `P9IV_8`"]
    #[inline]
    pub fn is_p9iv_8(&self) -> bool {
        *self == P9IVR::P9IV_8
    }
    #[doc = "Checks if the value of the field is `P9IV_10`"]
    #[inline]
    pub fn is_p9iv_10(&self) -> bool {
        *self == P9IVR::P9IV_10
    }
    #[doc = "Checks if the value of the field is `P9IV_12`"]
    #[inline]
    pub fn is_p9iv_12(&self) -> bool {
        *self == P9IVR::P9IV_12
    }
    #[doc = "Checks if the value of the field is `P9IV_14`"]
    #[inline]
    pub fn is_p9iv_14(&self) -> bool {
        *self == P9IVR::P9IV_14
    }
    #[doc = "Checks if the value of the field is `P9IV_16`"]
    #[inline]
    pub fn is_p9iv_16(&self) -> bool {
        *self == P9IVR::P9IV_16
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:4 - Port 9 interrupt vector value"]
    #[inline]
    pub fn p9iv(&self) -> P9IVR {
        P9IVR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
