#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Device Configuration Status"]
    pub dma_device_cfg: DMA_DEVICE_CFG,
    #[doc = "0x04 - Software Channel Trigger Register"]
    pub dma_sw_chtrig: DMA_SW_CHTRIG,
    _reserved0: [u8; 8usize],
    #[doc = "0x10 - Channel n Source Configuration Register"]
    pub dma_ch_srccfg: [DMA_CH_SRCCFG; 32],
    _reserved1: [u8; 112usize],
    #[doc = "0x100 - Interrupt 1 Source Channel Configuration"]
    pub dma_int1_srccfg: DMA_INT1_SRCCFG,
    #[doc = "0x104 - Interrupt 2 Source Channel Configuration Register"]
    pub dma_int2_srccfg: DMA_INT2_SRCCFG,
    #[doc = "0x108 - Interrupt 3 Source Channel Configuration Register"]
    pub dma_int3_srccfg: DMA_INT3_SRCCFG,
    _reserved2: [u8; 4usize],
    #[doc = "0x110 - Interrupt 0 Source Channel Flag Register"]
    pub dma_int0_srcflg: DMA_INT0_SRCFLG,
    #[doc = "0x114 - Interrupt 0 Source Channel Clear Flag Register"]
    pub dma_int0_clrflg: DMA_INT0_CLRFLG,
    _reserved3: [u8; 3816usize],
    #[doc = "0x1000 - Status Register"]
    pub dma_stat: DMA_STAT,
    #[doc = "0x1004 - Configuration Register"]
    pub dma_cfg: DMA_CFG,
    #[doc = "0x1008 - Channel Control Data Base Pointer Register"]
    pub dma_ctlbase: DMA_CTLBASE,
    #[doc = "0x100c - Channel Alternate Control Data Base Pointer Register"]
    pub dma_altbase: DMA_ALTBASE,
    #[doc = "0x1010 - Channel Wait on Request Status Register"]
    pub dma_waitstat: DMA_WAITSTAT,
    #[doc = "0x1014 - Channel Software Request Register"]
    pub dma_swreq: DMA_SWREQ,
    #[doc = "0x1018 - Channel Useburst Set Register"]
    pub dma_useburstset: DMA_USEBURSTSET,
    #[doc = "0x101c - Channel Useburst Clear Register"]
    pub dma_useburstclr: DMA_USEBURSTCLR,
    #[doc = "0x1020 - Channel Request Mask Set Register"]
    pub dma_reqmaskset: DMA_REQMASKSET,
    #[doc = "0x1024 - Channel Request Mask Clear Register"]
    pub dma_reqmaskclr: DMA_REQMASKCLR,
    #[doc = "0x1028 - Channel Enable Set Register"]
    pub dma_enaset: DMA_ENASET,
    #[doc = "0x102c - Channel Enable Clear Register"]
    pub dma_enaclr: DMA_ENACLR,
    #[doc = "0x1030 - Channel Primary-Alternate Set Register"]
    pub dma_altset: DMA_ALTSET,
    #[doc = "0x1034 - Channel Primary-Alternate Clear Register"]
    pub dma_altclr: DMA_ALTCLR,
    #[doc = "0x1038 - Channel Priority Set Register"]
    pub dma_prioset: DMA_PRIOSET,
    #[doc = "0x103c - Channel Priority Clear Register"]
    pub dma_prioclr: DMA_PRIOCLR,
    _reserved4: [u8; 12usize],
    #[doc = "0x104c - Bus Error Clear Register"]
    pub dma_errclr: DMA_ERRCLR,
}
#[doc = "Device Configuration Status"]
pub struct DMA_DEVICE_CFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Device Configuration Status"]
pub mod dma_device_cfg;
#[doc = "Software Channel Trigger Register"]
pub struct DMA_SW_CHTRIG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Software Channel Trigger Register"]
pub mod dma_sw_chtrig;
#[doc = "Channel n Source Configuration Register"]
pub struct DMA_CH_SRCCFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel n Source Configuration Register"]
pub mod dma_ch_srccfg;
#[doc = "Interrupt 1 Source Channel Configuration"]
pub struct DMA_INT1_SRCCFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt 1 Source Channel Configuration"]
pub mod dma_int1_srccfg;
#[doc = "Interrupt 2 Source Channel Configuration Register"]
pub struct DMA_INT2_SRCCFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt 2 Source Channel Configuration Register"]
pub mod dma_int2_srccfg;
#[doc = "Interrupt 3 Source Channel Configuration Register"]
pub struct DMA_INT3_SRCCFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt 3 Source Channel Configuration Register"]
pub mod dma_int3_srccfg;
#[doc = "Interrupt 0 Source Channel Flag Register"]
pub struct DMA_INT0_SRCFLG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt 0 Source Channel Flag Register"]
pub mod dma_int0_srcflg;
#[doc = "Interrupt 0 Source Channel Clear Flag Register"]
pub struct DMA_INT0_CLRFLG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt 0 Source Channel Clear Flag Register"]
pub mod dma_int0_clrflg;
#[doc = "Status Register"]
pub struct DMA_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Status Register"]
pub mod dma_stat;
#[doc = "Configuration Register"]
pub struct DMA_CFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Configuration Register"]
pub mod dma_cfg;
#[doc = "Channel Control Data Base Pointer Register"]
pub struct DMA_CTLBASE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Control Data Base Pointer Register"]
pub mod dma_ctlbase;
#[doc = "Channel Alternate Control Data Base Pointer Register"]
pub struct DMA_ALTBASE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Alternate Control Data Base Pointer Register"]
pub mod dma_altbase;
#[doc = "Channel Wait on Request Status Register"]
pub struct DMA_WAITSTAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Wait on Request Status Register"]
pub mod dma_waitstat;
#[doc = "Channel Software Request Register"]
pub struct DMA_SWREQ {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Software Request Register"]
pub mod dma_swreq;
#[doc = "Channel Useburst Set Register"]
pub struct DMA_USEBURSTSET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Useburst Set Register"]
pub mod dma_useburstset;
#[doc = "Channel Useburst Clear Register"]
pub struct DMA_USEBURSTCLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Useburst Clear Register"]
pub mod dma_useburstclr;
#[doc = "Channel Request Mask Set Register"]
pub struct DMA_REQMASKSET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Request Mask Set Register"]
pub mod dma_reqmaskset;
#[doc = "Channel Request Mask Clear Register"]
pub struct DMA_REQMASKCLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Request Mask Clear Register"]
pub mod dma_reqmaskclr;
#[doc = "Channel Enable Set Register"]
pub struct DMA_ENASET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Enable Set Register"]
pub mod dma_enaset;
#[doc = "Channel Enable Clear Register"]
pub struct DMA_ENACLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Enable Clear Register"]
pub mod dma_enaclr;
#[doc = "Channel Primary-Alternate Set Register"]
pub struct DMA_ALTSET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Primary-Alternate Set Register"]
pub mod dma_altset;
#[doc = "Channel Primary-Alternate Clear Register"]
pub struct DMA_ALTCLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Primary-Alternate Clear Register"]
pub mod dma_altclr;
#[doc = "Channel Priority Set Register"]
pub struct DMA_PRIOSET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Priority Set Register"]
pub mod dma_prioset;
#[doc = "Channel Priority Clear Register"]
pub struct DMA_PRIOCLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Channel Priority Clear Register"]
pub mod dma_prioclr;
#[doc = "Bus Error Clear Register"]
pub struct DMA_ERRCLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Bus Error Clear Register"]
pub mod dma_errclr;
