#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DMA_CFG {
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
}
#[doc = "Values that can be written to the field `MASTEN`"]
pub enum MASTENW {
    #[doc = "Controller disabled"]
    MASTEN_0,
    #[doc = "Controller enabled"]
    MASTEN_1,
}
impl MASTENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            MASTENW::MASTEN_0 => false,
            MASTENW::MASTEN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _MASTENW<'a> {
    w: &'a mut W,
}
impl<'a> _MASTENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: MASTENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Controller disabled"]
    #[inline]
    pub fn masten_0(self) -> &'a mut W {
        self.variant(MASTENW::MASTEN_0)
    }
    #[doc = "Controller enabled"]
    #[inline]
    pub fn masten_1(self) -> &'a mut W {
        self.variant(MASTENW::MASTEN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CHPROTCTRLW<'a> {
    w: &'a mut W,
}
impl<'a> _CHPROTCTRLW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Enable status of the controller"]
    #[inline]
    pub fn masten(&mut self) -> _MASTENW {
        _MASTENW { w: self }
    }
    #[doc = "Bits 5:7 - Sets the AHB-Lite protection by controlling the HPROT\\[3:1\\] signal levels as follows: Bit \\[7\\] Controls HPROT\\[3\\] to indicate if a cacheable access is occurring. Bit \\[6\\] Controls HPROT\\[2\\] to indicate if a bufferable access is occurring. Bit \\[5\\] Controls HPROT\\[1\\] to indicate if a privileged access is occurring. Note: When bit \\[n\\] = 1 then the corresponding HPROT is HIGH. When bit \\[n\\] = 0 then the corresponding HPROT is LOW."]
    #[inline]
    pub fn chprotctrl(&mut self) -> _CHPROTCTRLW {
        _CHPROTCTRLW { w: self }
    }
}
