#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DMA_ERRCLR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `ERRCLR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ERRCLRR {
    #[doc = "dma_err is LOW"]
    ERRCLR_0_READ,
    #[doc = "dma_err is HIGH."]
    ERRCLR_1_READ,
}
impl ERRCLRR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            ERRCLRR::ERRCLR_0_READ => false,
            ERRCLRR::ERRCLR_1_READ => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> ERRCLRR {
        match value {
            false => ERRCLRR::ERRCLR_0_READ,
            true => ERRCLRR::ERRCLR_1_READ,
        }
    }
    #[doc = "Checks if the value of the field is `ERRCLR_0_READ`"]
    #[inline]
    pub fn is_errclr_0_read(&self) -> bool {
        *self == ERRCLRR::ERRCLR_0_READ
    }
    #[doc = "Checks if the value of the field is `ERRCLR_1_READ`"]
    #[inline]
    pub fn is_errclr_1_read(&self) -> bool {
        *self == ERRCLRR::ERRCLR_1_READ
    }
}
#[doc = "Values that can be written to the field `ERRCLR`"]
pub enum ERRCLRW {
    #[doc = "No effect, status of dma_err is unchanged."]
    ERRCLR_0_WRITE,
    #[doc = "Sets dma_err LOW."]
    ERRCLR_1_WRITE,
}
impl ERRCLRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            ERRCLRW::ERRCLR_0_WRITE => false,
            ERRCLRW::ERRCLR_1_WRITE => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ERRCLRW<'a> {
    w: &'a mut W,
}
impl<'a> _ERRCLRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ERRCLRW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No effect, status of dma_err is unchanged."]
    #[inline]
    pub fn errclr_0_write(self) -> &'a mut W {
        self.variant(ERRCLRW::ERRCLR_0_WRITE)
    }
    #[doc = "Sets dma_err LOW."]
    #[inline]
    pub fn errclr_1_write(self) -> &'a mut W {
        self.variant(ERRCLRW::ERRCLR_1_WRITE)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Returns the status of dma_err, or sets the signal LOW. For test purposes, use the ERRSET register to set dma_err HIGH. Note: If you deassert dma_err at the same time as an ERROR occurs on the AHB-Lite bus, then the ERROR condition takes precedence and dma_err remains asserted."]
    #[inline]
    pub fn errclr(&self) -> ERRCLRR {
        ERRCLRR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Returns the status of dma_err, or sets the signal LOW. For test purposes, use the ERRSET register to set dma_err HIGH. Note: If you deassert dma_err at the same time as an ERROR occurs on the AHB-Lite bus, then the ERROR condition takes precedence and dma_err remains asserted."]
    #[inline]
    pub fn errclr(&mut self) -> _ERRCLRW {
        _ERRCLRW { w: self }
    }
}
