#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::DMA_STAT {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `MASTEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MASTENR {
    #[doc = "Controller disabled"]
    MASTEN_0,
    #[doc = "Controller enabled"]
    MASTEN_1,
}
impl MASTENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            MASTENR::MASTEN_0 => false,
            MASTENR::MASTEN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> MASTENR {
        match value {
            false => MASTENR::MASTEN_0,
            true => MASTENR::MASTEN_1,
        }
    }
    #[doc = "Checks if the value of the field is `MASTEN_0`"]
    #[inline]
    pub fn is_masten_0(&self) -> bool {
        *self == MASTENR::MASTEN_0
    }
    #[doc = "Checks if the value of the field is `MASTEN_1`"]
    #[inline]
    pub fn is_masten_1(&self) -> bool {
        *self == MASTENR::MASTEN_1
    }
}
#[doc = "Possible values of the field `STATE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum STATER {
    #[doc = "idle"]
    STATE_0,
    #[doc = "reading channel controller data"]
    STATE_1,
    #[doc = "reading source data end pointer"]
    STATE_2,
    #[doc = "reading destination data end pointer"]
    STATE_3,
    #[doc = "reading source data"]
    STATE_4,
    #[doc = "writing destination data"]
    STATE_5,
    #[doc = "waiting for DMA request to clear"]
    STATE_6,
    #[doc = "writing channel controller data"]
    STATE_7,
    #[doc = "stalled"]
    STATE_8,
    #[doc = "done"]
    STATE_9,
    #[doc = "peripheral scatter-gather transition"]
    STATE_10,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl STATER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            STATER::STATE_0 => 0,
            STATER::STATE_1 => 1,
            STATER::STATE_2 => 2,
            STATER::STATE_3 => 3,
            STATER::STATE_4 => 4,
            STATER::STATE_5 => 5,
            STATER::STATE_6 => 6,
            STATER::STATE_7 => 7,
            STATER::STATE_8 => 8,
            STATER::STATE_9 => 9,
            STATER::STATE_10 => 10,
            STATER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> STATER {
        match value {
            0 => STATER::STATE_0,
            1 => STATER::STATE_1,
            2 => STATER::STATE_2,
            3 => STATER::STATE_3,
            4 => STATER::STATE_4,
            5 => STATER::STATE_5,
            6 => STATER::STATE_6,
            7 => STATER::STATE_7,
            8 => STATER::STATE_8,
            9 => STATER::STATE_9,
            10 => STATER::STATE_10,
            i => STATER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `STATE_0`"]
    #[inline]
    pub fn is_state_0(&self) -> bool {
        *self == STATER::STATE_0
    }
    #[doc = "Checks if the value of the field is `STATE_1`"]
    #[inline]
    pub fn is_state_1(&self) -> bool {
        *self == STATER::STATE_1
    }
    #[doc = "Checks if the value of the field is `STATE_2`"]
    #[inline]
    pub fn is_state_2(&self) -> bool {
        *self == STATER::STATE_2
    }
    #[doc = "Checks if the value of the field is `STATE_3`"]
    #[inline]
    pub fn is_state_3(&self) -> bool {
        *self == STATER::STATE_3
    }
    #[doc = "Checks if the value of the field is `STATE_4`"]
    #[inline]
    pub fn is_state_4(&self) -> bool {
        *self == STATER::STATE_4
    }
    #[doc = "Checks if the value of the field is `STATE_5`"]
    #[inline]
    pub fn is_state_5(&self) -> bool {
        *self == STATER::STATE_5
    }
    #[doc = "Checks if the value of the field is `STATE_6`"]
    #[inline]
    pub fn is_state_6(&self) -> bool {
        *self == STATER::STATE_6
    }
    #[doc = "Checks if the value of the field is `STATE_7`"]
    #[inline]
    pub fn is_state_7(&self) -> bool {
        *self == STATER::STATE_7
    }
    #[doc = "Checks if the value of the field is `STATE_8`"]
    #[inline]
    pub fn is_state_8(&self) -> bool {
        *self == STATER::STATE_8
    }
    #[doc = "Checks if the value of the field is `STATE_9`"]
    #[inline]
    pub fn is_state_9(&self) -> bool {
        *self == STATER::STATE_9
    }
    #[doc = "Checks if the value of the field is `STATE_10`"]
    #[inline]
    pub fn is_state_10(&self) -> bool {
        *self == STATER::STATE_10
    }
}
#[doc = "Possible values of the field `DMACHANS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMACHANSR {
    #[doc = "Controller configured to use 1 DMA channel"]
    DMACHANS_0,
    #[doc = "Controller configured to use 2 DMA channels"]
    DMACHANS_1,
    #[doc = "Controller configured to use 31 DMA channels"]
    DMACHANS_30,
    #[doc = "Controller configured to use 32 DMA channels"]
    DMACHANS_31,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl DMACHANSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            DMACHANSR::DMACHANS_0 => 0,
            DMACHANSR::DMACHANS_1 => 1,
            DMACHANSR::DMACHANS_30 => 30,
            DMACHANSR::DMACHANS_31 => 31,
            DMACHANSR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> DMACHANSR {
        match value {
            0 => DMACHANSR::DMACHANS_0,
            1 => DMACHANSR::DMACHANS_1,
            30 => DMACHANSR::DMACHANS_30,
            31 => DMACHANSR::DMACHANS_31,
            i => DMACHANSR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `DMACHANS_0`"]
    #[inline]
    pub fn is_dmachans_0(&self) -> bool {
        *self == DMACHANSR::DMACHANS_0
    }
    #[doc = "Checks if the value of the field is `DMACHANS_1`"]
    #[inline]
    pub fn is_dmachans_1(&self) -> bool {
        *self == DMACHANSR::DMACHANS_1
    }
    #[doc = "Checks if the value of the field is `DMACHANS_30`"]
    #[inline]
    pub fn is_dmachans_30(&self) -> bool {
        *self == DMACHANSR::DMACHANS_30
    }
    #[doc = "Checks if the value of the field is `DMACHANS_31`"]
    #[inline]
    pub fn is_dmachans_31(&self) -> bool {
        *self == DMACHANSR::DMACHANS_31
    }
}
#[doc = "Possible values of the field `TESTSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TESTSTATR {
    #[doc = "Controller does not include the integration test logic"]
    TESTSTAT_0,
    #[doc = "Controller includes the integration test logic"]
    TESTSTAT_1,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl TESTSTATR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            TESTSTATR::TESTSTAT_0 => 0,
            TESTSTATR::TESTSTAT_1 => 1,
            TESTSTATR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> TESTSTATR {
        match value {
            0 => TESTSTATR::TESTSTAT_0,
            1 => TESTSTATR::TESTSTAT_1,
            i => TESTSTATR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `TESTSTAT_0`"]
    #[inline]
    pub fn is_teststat_0(&self) -> bool {
        *self == TESTSTATR::TESTSTAT_0
    }
    #[doc = "Checks if the value of the field is `TESTSTAT_1`"]
    #[inline]
    pub fn is_teststat_1(&self) -> bool {
        *self == TESTSTATR::TESTSTAT_1
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Enable status of the controller"]
    #[inline]
    pub fn masten(&self) -> MASTENR {
        MASTENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 4:7 - Current state of the control state machine. State can be one of the following:"]
    #[inline]
    pub fn state(&self) -> STATER {
        STATER::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 16:20 - Number of available DMA channels minus one."]
    #[inline]
    pub fn dmachans(&self) -> DMACHANSR {
        DMACHANSR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 28:31 - To reduce the gate count the controller can be configured to exclude the integration test logic. The values 2h to Fh are Reserved."]
    #[inline]
    pub fn teststat(&self) -> TESTSTATR {
        TESTSTATR::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
