#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DMA_SWREQ {
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
}
#[doc = "Values that can be written to the field `CHNL_SW_REQ`"]
pub enum CHNL_SW_REQW {
    #[doc = "Does not create a DMA request for the channel"]
    CHNL_SW_REQ_0,
    #[doc = "Creates a DMA request for the channel"]
    CHNL_SW_REQ_1,
}
impl CHNL_SW_REQW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u32 {
        match *self {
            CHNL_SW_REQW::CHNL_SW_REQ_0 => 0,
            CHNL_SW_REQW::CHNL_SW_REQ_1 => 1,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CHNL_SW_REQW<'a> {
    w: &'a mut W,
}
impl<'a> _CHNL_SW_REQW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CHNL_SW_REQW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Does not create a DMA request for the channel"]
    #[inline]
    pub fn chnl_sw_req_0(self) -> &'a mut W {
        self.variant(CHNL_SW_REQW::CHNL_SW_REQ_0)
    }
    #[doc = "Creates a DMA request for the channel"]
    #[inline]
    pub fn chnl_sw_req_1(self) -> &'a mut W {
        self.variant(CHNL_SW_REQW::CHNL_SW_REQ_1)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        const MASK: u32 = 4294967295;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:31 - Set the appropriate bit to generate a software DMA request on the corresponding DMA channel. Writing to a bit where a DMA channel is not implemented does not create a DMA request for that channel."]
    #[inline]
    pub fn chnl_sw_req(&mut self) -> _CHNL_SW_REQW {
        _CHNL_SW_REQW { w: self }
    }
}
