#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DMA_USEBURSTCLR {
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
}
#[doc = "Values that can be written to the field `CLR`"]
pub enum CLRW {
    #[doc = "No effect.\r\r\nUse the DMA_USEBURST_SET Register to disable dma_sreq from generating requests."]
    CLR_0,
    #[doc = "Enables dma_sreq\\[C\\] to generate DMA requests.\r\r\nWriting to a bit where a DMA channel is not implemented has no effect."]
    CLR_1,
}
impl CLRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u32 {
        match *self {
            CLRW::CLR_0 => 0,
            CLRW::CLR_1 => 1,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CLRW<'a> {
    w: &'a mut W,
}
impl<'a> _CLRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CLRW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No effect. Use the DMA_USEBURST_SET Register to disable dma_sreq from generating requests."]
    #[inline]
    pub fn clr_0(self) -> &'a mut W {
        self.variant(CLRW::CLR_0)
    }
    #[doc = "Enables dma_sreq\\[C\\] to generate DMA requests. Writing to a bit where a DMA channel is not implemented has no effect."]
    #[inline]
    pub fn clr_1(self) -> &'a mut W {
        self.variant(CLRW::CLR_1)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        const MASK: u32 = 4294967295;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:31 - Set the appropriate bit to enable dma_sreq to generate requests."]
    #[inline]
    pub fn clr(&mut self) -> _CLRW {
        _CLRW { w: self }
    }
}
