#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DMA_USEBURSTSET {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SETR {
    #[doc = "DMA channel C responds to requests that it receives on dma_req\\[C\\] or dma_sreq\\[C\\].\r\r\nThe controller performs 2R, or single, bus transfers."]
    SET_0_READ,
    #[doc = "DMA channel C does not respond to requests that it receives on dma_sreq\\[C\\].\r\r\nThe controller only responds to dma_req\\[C\\] requests and performs 2R transfers."]
    SET_1_READ,
    #[doc = r" Reserved"]
    _Reserved(u32),
}
impl SETR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        match *self {
            SETR::SET_0_READ => 0,
            SETR::SET_1_READ => 1,
            SETR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u32) -> SETR {
        match value {
            0 => SETR::SET_0_READ,
            1 => SETR::SET_1_READ,
            i => SETR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `SET_0_READ`"]
    #[inline]
    pub fn is_set_0_read(&self) -> bool {
        *self == SETR::SET_0_READ
    }
    #[doc = "Checks if the value of the field is `SET_1_READ`"]
    #[inline]
    pub fn is_set_1_read(&self) -> bool {
        *self == SETR::SET_1_READ
    }
}
#[doc = "Values that can be written to the field `SET`"]
pub enum SETW {
    #[doc = "No effect. Use the DMA_USEBURST_CLR Register to set bit \\[C\\] to 0."]
    SET_0_WRITE,
    #[doc = "Disables dma_sreq\\[C\\] from generating DMA requests.\r\r\nThe controller performs 2R transfers.\r\r\nWriting to a bit where a DMA channel is not implemented has no effect."]
    SET_1_WRITE,
}
impl SETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u32 {
        match *self {
            SETW::SET_0_WRITE => 0,
            SETW::SET_1_WRITE => 1,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SETW<'a> {
    w: &'a mut W,
}
impl<'a> _SETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SETW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No effect. Use the DMA_USEBURST_CLR Register to set bit \\[C\\] to 0."]
    #[inline]
    pub fn set_0_write(self) -> &'a mut W {
        self.variant(SETW::SET_0_WRITE)
    }
    #[doc = "Disables dma_sreq\\[C\\] from generating DMA requests. The controller performs 2R transfers. Writing to a bit where a DMA channel is not implemented has no effect."]
    #[inline]
    pub fn set_1_write(self) -> &'a mut W {
        self.variant(SETW::SET_1_WRITE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        const MASK: u32 = 4294967295;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:31 - Returns the useburst status, or disables dma_sreq from generating DMA requests."]
    #[inline]
    pub fn set(&self) -> SETR {
        SETR::_from({
            const MASK: u32 = 4294967295;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u32
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:31 - Returns the useburst status, or disables dma_sreq from generating DMA requests."]
    #[inline]
    pub fn set(&mut self) -> _SETW {
        _SETW { w: self }
    }
}
