#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::DMA_WAITSTAT {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `WAITREQ`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITREQR {
    #[doc = "dma_waitonreq\\[C\\] is LOW."]
    WAITREQ_0,
    #[doc = "dma_waitonreq\\[C\\] is HIGH."]
    WAITREQ_1,
    #[doc = r" Reserved"]
    _Reserved(u32),
}
impl WAITREQR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        match *self {
            WAITREQR::WAITREQ_0 => 0,
            WAITREQR::WAITREQ_1 => 1,
            WAITREQR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u32) -> WAITREQR {
        match value {
            0 => WAITREQR::WAITREQ_0,
            1 => WAITREQR::WAITREQ_1,
            i => WAITREQR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `WAITREQ_0`"]
    #[inline]
    pub fn is_waitreq_0(&self) -> bool {
        *self == WAITREQR::WAITREQ_0
    }
    #[doc = "Checks if the value of the field is `WAITREQ_1`"]
    #[inline]
    pub fn is_waitreq_1(&self) -> bool {
        *self == WAITREQR::WAITREQ_1
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:31 - Channel wait on request status."]
    #[inline]
    pub fn waitreq(&self) -> WAITREQR {
        WAITREQR::_from({
            const MASK: u32 = 4294967295;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u32
        })
    }
}
