#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - eUSCI_Ax Control Word Register 0"]
    pub ucax_ctlw0: UCAXCTLW0,
    #[doc = "0x02 - eUSCI_Ax Control Word Register 1"]
    pub ucax_ctlw1: UCAXCTLW1,
    _reserved0: [u8; 2usize],
    #[doc = "0x06 - eUSCI_Ax Baud Rate Control Word Register"]
    pub ucax_brw: UCAXBRW,
    #[doc = "0x08 - eUSCI_Ax Modulation Control Word Register"]
    pub ucax_mctlw: UCAXMCTLW,
    #[doc = "0x0a - eUSCI_Ax Status Register"]
    pub ucax_statw: UCAXSTATW,
    #[doc = "0x0c - eUSCI_Ax Receive Buffer Register"]
    pub ucax_rxbuf: UCAXRXBUF,
    #[doc = "0x0e - eUSCI_Ax Transmit Buffer Register"]
    pub ucax_txbuf: UCAXTXBUF,
    #[doc = "0x10 - eUSCI_Ax Auto Baud Rate Control Register"]
    pub ucax_abctl: UCAXABCTL,
    #[doc = "0x12 - eUSCI_Ax IrDA Control Word Register"]
    pub ucax_irctl: UCAXIRCTL,
    _reserved1: [u8; 6usize],
    #[doc = "0x1a - eUSCI_Ax Interrupt Enable Register"]
    pub ucax_ie: UCAXIE,
    #[doc = "0x1c - eUSCI_Ax Interrupt Flag Register"]
    pub ucax_ifg: UCAXIFG,
    #[doc = "0x1e - eUSCI_Ax Interrupt Vector Register"]
    pub ucax_iv: UCAXIV,
}
#[doc = "eUSCI_Ax Control Word Register 0"]
pub struct UCAXCTLW0 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Control Word Register 0"]
pub mod ucax_ctlw0;
#[doc = "eUSCI_Ax Control Word Register 1"]
pub struct UCAXCTLW1 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Control Word Register 1"]
pub mod ucax_ctlw1;
#[doc = "eUSCI_Ax Baud Rate Control Word Register"]
pub struct UCAXBRW {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Baud Rate Control Word Register"]
pub mod ucax_brw;
#[doc = "eUSCI_Ax Modulation Control Word Register"]
pub struct UCAXMCTLW {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Modulation Control Word Register"]
pub mod ucax_mctlw;
#[doc = "eUSCI_Ax Status Register"]
pub struct UCAXSTATW {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Status Register"]
pub mod ucax_statw;
#[doc = "eUSCI_Ax Receive Buffer Register"]
pub struct UCAXRXBUF {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Receive Buffer Register"]
pub mod ucax_rxbuf;
#[doc = "eUSCI_Ax Transmit Buffer Register"]
pub struct UCAXTXBUF {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Transmit Buffer Register"]
pub mod ucax_txbuf;
#[doc = "eUSCI_Ax Auto Baud Rate Control Register"]
pub struct UCAXABCTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Auto Baud Rate Control Register"]
pub mod ucax_abctl;
#[doc = "eUSCI_Ax IrDA Control Word Register"]
pub struct UCAXIRCTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax IrDA Control Word Register"]
pub mod ucax_irctl;
#[doc = "eUSCI_Ax Interrupt Enable Register"]
pub struct UCAXIE {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Interrupt Enable Register"]
pub mod ucax_ie;
#[doc = "eUSCI_Ax Interrupt Flag Register"]
pub struct UCAXIFG {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Interrupt Flag Register"]
pub mod ucax_ifg;
#[doc = "eUSCI_Ax Interrupt Vector Register"]
pub struct UCAXIV {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "eUSCI_Ax Interrupt Vector Register"]
pub mod ucax_iv;
