#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXCTLW0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCSWRST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSWRSTR {
    #[doc = "Disabled. eUSCI_A reset released for operation"]
    UCSWRST_0,
    #[doc = "Enabled. eUSCI_A logic held in reset state"]
    UCSWRST_1,
}
impl UCSWRSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSWRSTR::UCSWRST_0 => false,
            UCSWRSTR::UCSWRST_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSWRSTR {
        match value {
            false => UCSWRSTR::UCSWRST_0,
            true => UCSWRSTR::UCSWRST_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSWRST_0`"]
    #[inline]
    pub fn is_ucswrst_0(&self) -> bool {
        *self == UCSWRSTR::UCSWRST_0
    }
    #[doc = "Checks if the value of the field is `UCSWRST_1`"]
    #[inline]
    pub fn is_ucswrst_1(&self) -> bool {
        *self == UCSWRSTR::UCSWRST_1
    }
}
#[doc = "Possible values of the field `UCTXBRK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXBRKR {
    #[doc = "Next frame transmitted is not a break"]
    UCTXBRK_0,
    #[doc = "Next frame transmitted is a break or a break/synch"]
    UCTXBRK_1,
}
impl UCTXBRKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXBRKR::UCTXBRK_0 => false,
            UCTXBRKR::UCTXBRK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXBRKR {
        match value {
            false => UCTXBRKR::UCTXBRK_0,
            true => UCTXBRKR::UCTXBRK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXBRK_0`"]
    #[inline]
    pub fn is_uctxbrk_0(&self) -> bool {
        *self == UCTXBRKR::UCTXBRK_0
    }
    #[doc = "Checks if the value of the field is `UCTXBRK_1`"]
    #[inline]
    pub fn is_uctxbrk_1(&self) -> bool {
        *self == UCTXBRKR::UCTXBRK_1
    }
}
#[doc = "Possible values of the field `UCTXADDR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXADDRR {
    #[doc = "Next frame transmitted is data"]
    UCTXADDR_0,
    #[doc = "Next frame transmitted is an address"]
    UCTXADDR_1,
}
impl UCTXADDRR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXADDRR::UCTXADDR_0 => false,
            UCTXADDRR::UCTXADDR_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXADDRR {
        match value {
            false => UCTXADDRR::UCTXADDR_0,
            true => UCTXADDRR::UCTXADDR_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXADDR_0`"]
    #[inline]
    pub fn is_uctxaddr_0(&self) -> bool {
        *self == UCTXADDRR::UCTXADDR_0
    }
    #[doc = "Checks if the value of the field is `UCTXADDR_1`"]
    #[inline]
    pub fn is_uctxaddr_1(&self) -> bool {
        *self == UCTXADDRR::UCTXADDR_1
    }
}
#[doc = "Possible values of the field `UCDORM`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCDORMR {
    #[doc = "Not dormant. All received characters set UCRXIFG."]
    UCDORM_0,
    #[doc = "Dormant. Only characters that are preceded by an idle-line or with address bit set UCRXIFG. In UART mode with automatic baud-rate detection, only the combination of a break and synch field sets UCRXIFG."]
    UCDORM_1,
}
impl UCDORMR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCDORMR::UCDORM_0 => false,
            UCDORMR::UCDORM_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCDORMR {
        match value {
            false => UCDORMR::UCDORM_0,
            true => UCDORMR::UCDORM_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCDORM_0`"]
    #[inline]
    pub fn is_ucdorm_0(&self) -> bool {
        *self == UCDORMR::UCDORM_0
    }
    #[doc = "Checks if the value of the field is `UCDORM_1`"]
    #[inline]
    pub fn is_ucdorm_1(&self) -> bool {
        *self == UCDORMR::UCDORM_1
    }
}
#[doc = "Possible values of the field `UCBRKIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBRKIER {
    #[doc = "Received break characters do not set UCRXIFG"]
    UCBRKIE_0,
    #[doc = "Received break characters set UCRXIFG"]
    UCBRKIE_1,
}
impl UCBRKIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBRKIER::UCBRKIE_0 => false,
            UCBRKIER::UCBRKIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBRKIER {
        match value {
            false => UCBRKIER::UCBRKIE_0,
            true => UCBRKIER::UCBRKIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBRKIE_0`"]
    #[inline]
    pub fn is_ucbrkie_0(&self) -> bool {
        *self == UCBRKIER::UCBRKIE_0
    }
    #[doc = "Checks if the value of the field is `UCBRKIE_1`"]
    #[inline]
    pub fn is_ucbrkie_1(&self) -> bool {
        *self == UCBRKIER::UCBRKIE_1
    }
}
#[doc = "Possible values of the field `UCRXEIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXEIER {
    #[doc = "Erroneous characters rejected and UCRXIFG is not set"]
    UCRXEIE_0,
    #[doc = "Erroneous characters received set UCRXIFG"]
    UCRXEIE_1,
}
impl UCRXEIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXEIER::UCRXEIE_0 => false,
            UCRXEIER::UCRXEIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXEIER {
        match value {
            false => UCRXEIER::UCRXEIE_0,
            true => UCRXEIER::UCRXEIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXEIE_0`"]
    #[inline]
    pub fn is_ucrxeie_0(&self) -> bool {
        *self == UCRXEIER::UCRXEIE_0
    }
    #[doc = "Checks if the value of the field is `UCRXEIE_1`"]
    #[inline]
    pub fn is_ucrxeie_1(&self) -> bool {
        *self == UCRXEIER::UCRXEIE_1
    }
}
#[doc = "Possible values of the field `UCSSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSSELR {
    #[doc = "UCLK"]
    UCSSEL_0,
    #[doc = "ACLK"]
    UCSSEL_1,
    #[doc = "SMCLK"]
    UCSSEL_2,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl UCSSELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCSSELR::UCSSEL_0 => 0,
            UCSSELR::UCSSEL_1 => 1,
            UCSSELR::UCSSEL_2 => 2,
            UCSSELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCSSELR {
        match value {
            0 => UCSSELR::UCSSEL_0,
            1 => UCSSELR::UCSSEL_1,
            2 => UCSSELR::UCSSEL_2,
            i => UCSSELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `UCSSEL_0`"]
    #[inline]
    pub fn is_ucssel_0(&self) -> bool {
        *self == UCSSELR::UCSSEL_0
    }
    #[doc = "Checks if the value of the field is `UCSSEL_1`"]
    #[inline]
    pub fn is_ucssel_1(&self) -> bool {
        *self == UCSSELR::UCSSEL_1
    }
    #[doc = "Checks if the value of the field is `UCSSEL_2`"]
    #[inline]
    pub fn is_ucssel_2(&self) -> bool {
        *self == UCSSELR::UCSSEL_2
    }
}
#[doc = "Possible values of the field `UCSYNC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSYNCR {
    #[doc = "Asynchronous mode"]
    UCSYNC_0,
    #[doc = "Synchronous mode"]
    UCSYNC_1,
}
impl UCSYNCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSYNCR::UCSYNC_0 => false,
            UCSYNCR::UCSYNC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSYNCR {
        match value {
            false => UCSYNCR::UCSYNC_0,
            true => UCSYNCR::UCSYNC_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSYNC_0`"]
    #[inline]
    pub fn is_ucsync_0(&self) -> bool {
        *self == UCSYNCR::UCSYNC_0
    }
    #[doc = "Checks if the value of the field is `UCSYNC_1`"]
    #[inline]
    pub fn is_ucsync_1(&self) -> bool {
        *self == UCSYNCR::UCSYNC_1
    }
}
#[doc = "Possible values of the field `UCMODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCMODER {
    #[doc = "UART mode"]
    UCMODE_0,
    #[doc = "Idle-line multiprocessor mode"]
    UCMODE_1,
    #[doc = "Address-bit multiprocessor mode"]
    UCMODE_2,
    #[doc = "UART mode with automatic baud-rate detection"]
    UCMODE_3,
}
impl UCMODER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCMODER::UCMODE_0 => 0,
            UCMODER::UCMODE_1 => 1,
            UCMODER::UCMODE_2 => 2,
            UCMODER::UCMODE_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCMODER {
        match value {
            0 => UCMODER::UCMODE_0,
            1 => UCMODER::UCMODE_1,
            2 => UCMODER::UCMODE_2,
            3 => UCMODER::UCMODE_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCMODE_0`"]
    #[inline]
    pub fn is_ucmode_0(&self) -> bool {
        *self == UCMODER::UCMODE_0
    }
    #[doc = "Checks if the value of the field is `UCMODE_1`"]
    #[inline]
    pub fn is_ucmode_1(&self) -> bool {
        *self == UCMODER::UCMODE_1
    }
    #[doc = "Checks if the value of the field is `UCMODE_2`"]
    #[inline]
    pub fn is_ucmode_2(&self) -> bool {
        *self == UCMODER::UCMODE_2
    }
    #[doc = "Checks if the value of the field is `UCMODE_3`"]
    #[inline]
    pub fn is_ucmode_3(&self) -> bool {
        *self == UCMODER::UCMODE_3
    }
}
#[doc = "Possible values of the field `UCSPB`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSPBR {
    #[doc = "One stop bit"]
    UCSPB_0,
    #[doc = "Two stop bits"]
    UCSPB_1,
}
impl UCSPBR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSPBR::UCSPB_0 => false,
            UCSPBR::UCSPB_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSPBR {
        match value {
            false => UCSPBR::UCSPB_0,
            true => UCSPBR::UCSPB_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSPB_0`"]
    #[inline]
    pub fn is_ucspb_0(&self) -> bool {
        *self == UCSPBR::UCSPB_0
    }
    #[doc = "Checks if the value of the field is `UCSPB_1`"]
    #[inline]
    pub fn is_ucspb_1(&self) -> bool {
        *self == UCSPBR::UCSPB_1
    }
}
#[doc = "Possible values of the field `UC7BIT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UC7BITR {
    #[doc = "8-bit data"]
    UC7BIT_0,
    #[doc = "7-bit data"]
    UC7BIT_1,
}
impl UC7BITR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UC7BITR::UC7BIT_0 => false,
            UC7BITR::UC7BIT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UC7BITR {
        match value {
            false => UC7BITR::UC7BIT_0,
            true => UC7BITR::UC7BIT_1,
        }
    }
    #[doc = "Checks if the value of the field is `UC7BIT_0`"]
    #[inline]
    pub fn is_uc7bit_0(&self) -> bool {
        *self == UC7BITR::UC7BIT_0
    }
    #[doc = "Checks if the value of the field is `UC7BIT_1`"]
    #[inline]
    pub fn is_uc7bit_1(&self) -> bool {
        *self == UC7BITR::UC7BIT_1
    }
}
#[doc = "Possible values of the field `UCMSB`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCMSBR {
    #[doc = "LSB first"]
    UCMSB_0,
    #[doc = "MSB first"]
    UCMSB_1,
}
impl UCMSBR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCMSBR::UCMSB_0 => false,
            UCMSBR::UCMSB_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCMSBR {
        match value {
            false => UCMSBR::UCMSB_0,
            true => UCMSBR::UCMSB_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCMSB_0`"]
    #[inline]
    pub fn is_ucmsb_0(&self) -> bool {
        *self == UCMSBR::UCMSB_0
    }
    #[doc = "Checks if the value of the field is `UCMSB_1`"]
    #[inline]
    pub fn is_ucmsb_1(&self) -> bool {
        *self == UCMSBR::UCMSB_1
    }
}
#[doc = "Possible values of the field `UCPAR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCPARR {
    #[doc = "Odd parity"]
    UCPAR_0,
    #[doc = "Even parity"]
    UCPAR_1,
}
impl UCPARR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCPARR::UCPAR_0 => false,
            UCPARR::UCPAR_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCPARR {
        match value {
            false => UCPARR::UCPAR_0,
            true => UCPARR::UCPAR_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCPAR_0`"]
    #[inline]
    pub fn is_ucpar_0(&self) -> bool {
        *self == UCPARR::UCPAR_0
    }
    #[doc = "Checks if the value of the field is `UCPAR_1`"]
    #[inline]
    pub fn is_ucpar_1(&self) -> bool {
        *self == UCPARR::UCPAR_1
    }
}
#[doc = "Possible values of the field `UCPEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCPENR {
    #[doc = "Parity disabled"]
    UCPEN_0,
    #[doc = "Parity enabled. Parity bit is generated (UCAxTXD) and expected (UCAxRXD). In address-bit multiprocessor mode, the address bit is included in the parity calculation."]
    UCPEN_1,
}
impl UCPENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCPENR::UCPEN_0 => false,
            UCPENR::UCPEN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCPENR {
        match value {
            false => UCPENR::UCPEN_0,
            true => UCPENR::UCPEN_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCPEN_0`"]
    #[inline]
    pub fn is_ucpen_0(&self) -> bool {
        *self == UCPENR::UCPEN_0
    }
    #[doc = "Checks if the value of the field is `UCPEN_1`"]
    #[inline]
    pub fn is_ucpen_1(&self) -> bool {
        *self == UCPENR::UCPEN_1
    }
}
#[doc = "Values that can be written to the field `UCSWRST`"]
pub enum UCSWRSTW {
    #[doc = "Disabled. eUSCI_A reset released for operation"]
    UCSWRST_0,
    #[doc = "Enabled. eUSCI_A logic held in reset state"]
    UCSWRST_1,
}
impl UCSWRSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSWRSTW::UCSWRST_0 => false,
            UCSWRSTW::UCSWRST_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSWRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSWRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSWRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled. eUSCI_A reset released for operation"]
    #[inline]
    pub fn ucswrst_0(self) -> &'a mut W {
        self.variant(UCSWRSTW::UCSWRST_0)
    }
    #[doc = "Enabled. eUSCI_A logic held in reset state"]
    #[inline]
    pub fn ucswrst_1(self) -> &'a mut W {
        self.variant(UCSWRSTW::UCSWRST_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXBRK`"]
pub enum UCTXBRKW {
    #[doc = "Next frame transmitted is not a break"]
    UCTXBRK_0,
    #[doc = "Next frame transmitted is a break or a break/synch"]
    UCTXBRK_1,
}
impl UCTXBRKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXBRKW::UCTXBRK_0 => false,
            UCTXBRKW::UCTXBRK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXBRKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXBRKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXBRKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Next frame transmitted is not a break"]
    #[inline]
    pub fn uctxbrk_0(self) -> &'a mut W {
        self.variant(UCTXBRKW::UCTXBRK_0)
    }
    #[doc = "Next frame transmitted is a break or a break/synch"]
    #[inline]
    pub fn uctxbrk_1(self) -> &'a mut W {
        self.variant(UCTXBRKW::UCTXBRK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXADDR`"]
pub enum UCTXADDRW {
    #[doc = "Next frame transmitted is data"]
    UCTXADDR_0,
    #[doc = "Next frame transmitted is an address"]
    UCTXADDR_1,
}
impl UCTXADDRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXADDRW::UCTXADDR_0 => false,
            UCTXADDRW::UCTXADDR_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXADDRW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXADDRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXADDRW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Next frame transmitted is data"]
    #[inline]
    pub fn uctxaddr_0(self) -> &'a mut W {
        self.variant(UCTXADDRW::UCTXADDR_0)
    }
    #[doc = "Next frame transmitted is an address"]
    #[inline]
    pub fn uctxaddr_1(self) -> &'a mut W {
        self.variant(UCTXADDRW::UCTXADDR_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCDORM`"]
pub enum UCDORMW {
    #[doc = "Not dormant. All received characters set UCRXIFG."]
    UCDORM_0,
    #[doc = "Dormant. Only characters that are preceded by an idle-line or with address bit set UCRXIFG. In UART mode with automatic baud-rate detection, only the combination of a break and synch field sets UCRXIFG."]
    UCDORM_1,
}
impl UCDORMW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCDORMW::UCDORM_0 => false,
            UCDORMW::UCDORM_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCDORMW<'a> {
    w: &'a mut W,
}
impl<'a> _UCDORMW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCDORMW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Not dormant. All received characters set UCRXIFG."]
    #[inline]
    pub fn ucdorm_0(self) -> &'a mut W {
        self.variant(UCDORMW::UCDORM_0)
    }
    #[doc = "Dormant. Only characters that are preceded by an idle-line or with address bit set UCRXIFG. In UART mode with automatic baud-rate detection, only the combination of a break and synch field sets UCRXIFG."]
    #[inline]
    pub fn ucdorm_1(self) -> &'a mut W {
        self.variant(UCDORMW::UCDORM_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBRKIE`"]
pub enum UCBRKIEW {
    #[doc = "Received break characters do not set UCRXIFG"]
    UCBRKIE_0,
    #[doc = "Received break characters set UCRXIFG"]
    UCBRKIE_1,
}
impl UCBRKIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBRKIEW::UCBRKIE_0 => false,
            UCBRKIEW::UCBRKIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBRKIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBRKIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBRKIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Received break characters do not set UCRXIFG"]
    #[inline]
    pub fn ucbrkie_0(self) -> &'a mut W {
        self.variant(UCBRKIEW::UCBRKIE_0)
    }
    #[doc = "Received break characters set UCRXIFG"]
    #[inline]
    pub fn ucbrkie_1(self) -> &'a mut W {
        self.variant(UCBRKIEW::UCBRKIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXEIE`"]
pub enum UCRXEIEW {
    #[doc = "Erroneous characters rejected and UCRXIFG is not set"]
    UCRXEIE_0,
    #[doc = "Erroneous characters received set UCRXIFG"]
    UCRXEIE_1,
}
impl UCRXEIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXEIEW::UCRXEIE_0 => false,
            UCRXEIEW::UCRXEIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXEIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXEIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXEIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Erroneous characters rejected and UCRXIFG is not set"]
    #[inline]
    pub fn ucrxeie_0(self) -> &'a mut W {
        self.variant(UCRXEIEW::UCRXEIE_0)
    }
    #[doc = "Erroneous characters received set UCRXIFG"]
    #[inline]
    pub fn ucrxeie_1(self) -> &'a mut W {
        self.variant(UCRXEIEW::UCRXEIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSSEL`"]
pub enum UCSSELW {
    #[doc = "UCLK"]
    UCSSEL_0,
    #[doc = "ACLK"]
    UCSSEL_1,
    #[doc = "SMCLK"]
    UCSSEL_2,
}
impl UCSSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCSSELW::UCSSEL_0 => 0,
            UCSSELW::UCSSEL_1 => 1,
            UCSSELW::UCSSEL_2 => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSSELW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSSELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "UCLK"]
    #[inline]
    pub fn ucssel_0(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_0)
    }
    #[doc = "ACLK"]
    #[inline]
    pub fn ucssel_1(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_1)
    }
    #[doc = "SMCLK"]
    #[inline]
    pub fn ucssel_2(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_2)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSYNC`"]
pub enum UCSYNCW {
    #[doc = "Asynchronous mode"]
    UCSYNC_0,
    #[doc = "Synchronous mode"]
    UCSYNC_1,
}
impl UCSYNCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSYNCW::UCSYNC_0 => false,
            UCSYNCW::UCSYNC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSYNCW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSYNCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSYNCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Asynchronous mode"]
    #[inline]
    pub fn ucsync_0(self) -> &'a mut W {
        self.variant(UCSYNCW::UCSYNC_0)
    }
    #[doc = "Synchronous mode"]
    #[inline]
    pub fn ucsync_1(self) -> &'a mut W {
        self.variant(UCSYNCW::UCSYNC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCMODE`"]
pub enum UCMODEW {
    #[doc = "UART mode"]
    UCMODE_0,
    #[doc = "Idle-line multiprocessor mode"]
    UCMODE_1,
    #[doc = "Address-bit multiprocessor mode"]
    UCMODE_2,
    #[doc = "UART mode with automatic baud-rate detection"]
    UCMODE_3,
}
impl UCMODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCMODEW::UCMODE_0 => 0,
            UCMODEW::UCMODE_1 => 1,
            UCMODEW::UCMODE_2 => 2,
            UCMODEW::UCMODE_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCMODEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCMODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCMODEW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "UART mode"]
    #[inline]
    pub fn ucmode_0(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_0)
    }
    #[doc = "Idle-line multiprocessor mode"]
    #[inline]
    pub fn ucmode_1(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_1)
    }
    #[doc = "Address-bit multiprocessor mode"]
    #[inline]
    pub fn ucmode_2(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_2)
    }
    #[doc = "UART mode with automatic baud-rate detection"]
    #[inline]
    pub fn ucmode_3(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSPB`"]
pub enum UCSPBW {
    #[doc = "One stop bit"]
    UCSPB_0,
    #[doc = "Two stop bits"]
    UCSPB_1,
}
impl UCSPBW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSPBW::UCSPB_0 => false,
            UCSPBW::UCSPB_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSPBW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSPBW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSPBW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "One stop bit"]
    #[inline]
    pub fn ucspb_0(self) -> &'a mut W {
        self.variant(UCSPBW::UCSPB_0)
    }
    #[doc = "Two stop bits"]
    #[inline]
    pub fn ucspb_1(self) -> &'a mut W {
        self.variant(UCSPBW::UCSPB_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UC7BIT`"]
pub enum UC7BITW {
    #[doc = "8-bit data"]
    UC7BIT_0,
    #[doc = "7-bit data"]
    UC7BIT_1,
}
impl UC7BITW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UC7BITW::UC7BIT_0 => false,
            UC7BITW::UC7BIT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UC7BITW<'a> {
    w: &'a mut W,
}
impl<'a> _UC7BITW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UC7BITW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "8-bit data"]
    #[inline]
    pub fn uc7bit_0(self) -> &'a mut W {
        self.variant(UC7BITW::UC7BIT_0)
    }
    #[doc = "7-bit data"]
    #[inline]
    pub fn uc7bit_1(self) -> &'a mut W {
        self.variant(UC7BITW::UC7BIT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCMSB`"]
pub enum UCMSBW {
    #[doc = "LSB first"]
    UCMSB_0,
    #[doc = "MSB first"]
    UCMSB_1,
}
impl UCMSBW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCMSBW::UCMSB_0 => false,
            UCMSBW::UCMSB_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCMSBW<'a> {
    w: &'a mut W,
}
impl<'a> _UCMSBW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCMSBW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "LSB first"]
    #[inline]
    pub fn ucmsb_0(self) -> &'a mut W {
        self.variant(UCMSBW::UCMSB_0)
    }
    #[doc = "MSB first"]
    #[inline]
    pub fn ucmsb_1(self) -> &'a mut W {
        self.variant(UCMSBW::UCMSB_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCPAR`"]
pub enum UCPARW {
    #[doc = "Odd parity"]
    UCPAR_0,
    #[doc = "Even parity"]
    UCPAR_1,
}
impl UCPARW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCPARW::UCPAR_0 => false,
            UCPARW::UCPAR_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCPARW<'a> {
    w: &'a mut W,
}
impl<'a> _UCPARW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCPARW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Odd parity"]
    #[inline]
    pub fn ucpar_0(self) -> &'a mut W {
        self.variant(UCPARW::UCPAR_0)
    }
    #[doc = "Even parity"]
    #[inline]
    pub fn ucpar_1(self) -> &'a mut W {
        self.variant(UCPARW::UCPAR_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCPEN`"]
pub enum UCPENW {
    #[doc = "Parity disabled"]
    UCPEN_0,
    #[doc = "Parity enabled. Parity bit is generated (UCAxTXD) and expected (UCAxRXD). In address-bit multiprocessor mode, the address bit is included in the parity calculation."]
    UCPEN_1,
}
impl UCPENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCPENW::UCPEN_0 => false,
            UCPENW::UCPEN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCPENW<'a> {
    w: &'a mut W,
}
impl<'a> _UCPENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCPENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Parity disabled"]
    #[inline]
    pub fn ucpen_0(self) -> &'a mut W {
        self.variant(UCPENW::UCPEN_0)
    }
    #[doc = "Parity enabled. Parity bit is generated (UCAxTXD) and expected (UCAxRXD). In address-bit multiprocessor mode, the address bit is included in the parity calculation."]
    #[inline]
    pub fn ucpen_1(self) -> &'a mut W {
        self.variant(UCPENW::UCPEN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Software reset enable"]
    #[inline]
    pub fn ucswrst(&self) -> UCSWRSTR {
        UCSWRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Transmit break"]
    #[inline]
    pub fn uctxbrk(&self) -> UCTXBRKR {
        UCTXBRKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Transmit address"]
    #[inline]
    pub fn uctxaddr(&self) -> UCTXADDRR {
        UCTXADDRR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Dormant"]
    #[inline]
    pub fn ucdorm(&self) -> UCDORMR {
        UCDORMR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Receive break character interrupt enable"]
    #[inline]
    pub fn ucbrkie(&self) -> UCBRKIER {
        UCBRKIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Receive erroneous-character interrupt enable"]
    #[inline]
    pub fn ucrxeie(&self) -> UCRXEIER {
        UCRXEIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 6:7 - eUSCI_A clock source select"]
    #[inline]
    pub fn ucssel(&self) -> UCSSELR {
        UCSSELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 8 - Synchronous mode enable"]
    #[inline]
    pub fn ucsync(&self) -> UCSYNCR {
        UCSYNCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 9:10 - eUSCI_A mode"]
    #[inline]
    pub fn ucmode(&self) -> UCMODER {
        UCMODER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 11 - Stop bit select"]
    #[inline]
    pub fn ucspb(&self) -> UCSPBR {
        UCSPBR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 12 - Character length"]
    #[inline]
    pub fn uc7bit(&self) -> UC7BITR {
        UC7BITR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - MSB first select"]
    #[inline]
    pub fn ucmsb(&self) -> UCMSBR {
        UCMSBR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Parity select"]
    #[inline]
    pub fn ucpar(&self) -> UCPARR {
        UCPARR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 15 - Parity enable"]
    #[inline]
    pub fn ucpen(&self) -> UCPENR {
        UCPENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 1 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Software reset enable"]
    #[inline]
    pub fn ucswrst(&mut self) -> _UCSWRSTW {
        _UCSWRSTW { w: self }
    }
    #[doc = "Bit 1 - Transmit break"]
    #[inline]
    pub fn uctxbrk(&mut self) -> _UCTXBRKW {
        _UCTXBRKW { w: self }
    }
    #[doc = "Bit 2 - Transmit address"]
    #[inline]
    pub fn uctxaddr(&mut self) -> _UCTXADDRW {
        _UCTXADDRW { w: self }
    }
    #[doc = "Bit 3 - Dormant"]
    #[inline]
    pub fn ucdorm(&mut self) -> _UCDORMW {
        _UCDORMW { w: self }
    }
    #[doc = "Bit 4 - Receive break character interrupt enable"]
    #[inline]
    pub fn ucbrkie(&mut self) -> _UCBRKIEW {
        _UCBRKIEW { w: self }
    }
    #[doc = "Bit 5 - Receive erroneous-character interrupt enable"]
    #[inline]
    pub fn ucrxeie(&mut self) -> _UCRXEIEW {
        _UCRXEIEW { w: self }
    }
    #[doc = "Bits 6:7 - eUSCI_A clock source select"]
    #[inline]
    pub fn ucssel(&mut self) -> _UCSSELW {
        _UCSSELW { w: self }
    }
    #[doc = "Bit 8 - Synchronous mode enable"]
    #[inline]
    pub fn ucsync(&mut self) -> _UCSYNCW {
        _UCSYNCW { w: self }
    }
    #[doc = "Bits 9:10 - eUSCI_A mode"]
    #[inline]
    pub fn ucmode(&mut self) -> _UCMODEW {
        _UCMODEW { w: self }
    }
    #[doc = "Bit 11 - Stop bit select"]
    #[inline]
    pub fn ucspb(&mut self) -> _UCSPBW {
        _UCSPBW { w: self }
    }
    #[doc = "Bit 12 - Character length"]
    #[inline]
    pub fn uc7bit(&mut self) -> _UC7BITW {
        _UC7BITW { w: self }
    }
    #[doc = "Bit 13 - MSB first select"]
    #[inline]
    pub fn ucmsb(&mut self) -> _UCMSBW {
        _UCMSBW { w: self }
    }
    #[doc = "Bit 14 - Parity select"]
    #[inline]
    pub fn ucpar(&mut self) -> _UCPARW {
        _UCPARW { w: self }
    }
    #[doc = "Bit 15 - Parity enable"]
    #[inline]
    pub fn ucpen(&mut self) -> _UCPENW {
        _UCPENW { w: self }
    }
}
