#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXIRCTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCIREN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIRENR {
    #[doc = "IrDA encoder/decoder disabled"]
    UCIREN_0,
    #[doc = "IrDA encoder/decoder enabled"]
    UCIREN_1,
}
impl UCIRENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCIRENR::UCIREN_0 => false,
            UCIRENR::UCIREN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCIRENR {
        match value {
            false => UCIRENR::UCIREN_0,
            true => UCIRENR::UCIREN_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCIREN_0`"]
    #[inline]
    pub fn is_uciren_0(&self) -> bool {
        *self == UCIRENR::UCIREN_0
    }
    #[doc = "Checks if the value of the field is `UCIREN_1`"]
    #[inline]
    pub fn is_uciren_1(&self) -> bool {
        *self == UCIRENR::UCIREN_1
    }
}
#[doc = "Possible values of the field `UCIRTXCLK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIRTXCLKR {
    #[doc = "BRCLK"]
    UCIRTXCLK_0,
    #[doc = "BITCLK16 when UCOS16 = 1. Otherwise, BRCLK."]
    UCIRTXCLK_1,
}
impl UCIRTXCLKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCIRTXCLKR::UCIRTXCLK_0 => false,
            UCIRTXCLKR::UCIRTXCLK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCIRTXCLKR {
        match value {
            false => UCIRTXCLKR::UCIRTXCLK_0,
            true => UCIRTXCLKR::UCIRTXCLK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCIRTXCLK_0`"]
    #[inline]
    pub fn is_ucirtxclk_0(&self) -> bool {
        *self == UCIRTXCLKR::UCIRTXCLK_0
    }
    #[doc = "Checks if the value of the field is `UCIRTXCLK_1`"]
    #[inline]
    pub fn is_ucirtxclk_1(&self) -> bool {
        *self == UCIRTXCLKR::UCIRTXCLK_1
    }
}
#[doc = r" Value of the field"]
pub struct UCIRTXPLR {
    bits: u8,
}
impl UCIRTXPLR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Possible values of the field `UCIRRXFE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIRRXFER {
    #[doc = "Receive filter disabled"]
    UCIRRXFE_0,
    #[doc = "Receive filter enabled"]
    UCIRRXFE_1,
}
impl UCIRRXFER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCIRRXFER::UCIRRXFE_0 => false,
            UCIRRXFER::UCIRRXFE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCIRRXFER {
        match value {
            false => UCIRRXFER::UCIRRXFE_0,
            true => UCIRRXFER::UCIRRXFE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCIRRXFE_0`"]
    #[inline]
    pub fn is_ucirrxfe_0(&self) -> bool {
        *self == UCIRRXFER::UCIRRXFE_0
    }
    #[doc = "Checks if the value of the field is `UCIRRXFE_1`"]
    #[inline]
    pub fn is_ucirrxfe_1(&self) -> bool {
        *self == UCIRRXFER::UCIRRXFE_1
    }
}
#[doc = "Possible values of the field `UCIRRXPL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIRRXPLR {
    #[doc = "IrDA transceiver delivers a high pulse when a light pulse is seen"]
    UCIRRXPL_0,
    #[doc = "IrDA transceiver delivers a low pulse when a light pulse is seen"]
    UCIRRXPL_1,
}
impl UCIRRXPLR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCIRRXPLR::UCIRRXPL_0 => false,
            UCIRRXPLR::UCIRRXPL_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCIRRXPLR {
        match value {
            false => UCIRRXPLR::UCIRRXPL_0,
            true => UCIRRXPLR::UCIRRXPL_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCIRRXPL_0`"]
    #[inline]
    pub fn is_ucirrxpl_0(&self) -> bool {
        *self == UCIRRXPLR::UCIRRXPL_0
    }
    #[doc = "Checks if the value of the field is `UCIRRXPL_1`"]
    #[inline]
    pub fn is_ucirrxpl_1(&self) -> bool {
        *self == UCIRRXPLR::UCIRRXPL_1
    }
}
#[doc = r" Value of the field"]
pub struct UCIRRXFLR {
    bits: u8,
}
impl UCIRRXFLR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `UCIREN`"]
pub enum UCIRENW {
    #[doc = "IrDA encoder/decoder disabled"]
    UCIREN_0,
    #[doc = "IrDA encoder/decoder enabled"]
    UCIREN_1,
}
impl UCIRENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCIRENW::UCIREN_0 => false,
            UCIRENW::UCIREN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCIRENW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCIRENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IrDA encoder/decoder disabled"]
    #[inline]
    pub fn uciren_0(self) -> &'a mut W {
        self.variant(UCIRENW::UCIREN_0)
    }
    #[doc = "IrDA encoder/decoder enabled"]
    #[inline]
    pub fn uciren_1(self) -> &'a mut W {
        self.variant(UCIRENW::UCIREN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCIRTXCLK`"]
pub enum UCIRTXCLKW {
    #[doc = "BRCLK"]
    UCIRTXCLK_0,
    #[doc = "BITCLK16 when UCOS16 = 1. Otherwise, BRCLK."]
    UCIRTXCLK_1,
}
impl UCIRTXCLKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCIRTXCLKW::UCIRTXCLK_0 => false,
            UCIRTXCLKW::UCIRTXCLK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCIRTXCLKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRTXCLKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCIRTXCLKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "BRCLK"]
    #[inline]
    pub fn ucirtxclk_0(self) -> &'a mut W {
        self.variant(UCIRTXCLKW::UCIRTXCLK_0)
    }
    #[doc = "BITCLK16 when UCOS16 = 1. Otherwise, BRCLK."]
    #[inline]
    pub fn ucirtxclk_1(self) -> &'a mut W {
        self.variant(UCIRTXCLKW::UCIRTXCLK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _UCIRTXPLW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRTXPLW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 63;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCIRRXFE`"]
pub enum UCIRRXFEW {
    #[doc = "Receive filter disabled"]
    UCIRRXFE_0,
    #[doc = "Receive filter enabled"]
    UCIRRXFE_1,
}
impl UCIRRXFEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCIRRXFEW::UCIRRXFE_0 => false,
            UCIRRXFEW::UCIRRXFE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCIRRXFEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRRXFEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCIRRXFEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Receive filter disabled"]
    #[inline]
    pub fn ucirrxfe_0(self) -> &'a mut W {
        self.variant(UCIRRXFEW::UCIRRXFE_0)
    }
    #[doc = "Receive filter enabled"]
    #[inline]
    pub fn ucirrxfe_1(self) -> &'a mut W {
        self.variant(UCIRRXFEW::UCIRRXFE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCIRRXPL`"]
pub enum UCIRRXPLW {
    #[doc = "IrDA transceiver delivers a high pulse when a light pulse is seen"]
    UCIRRXPL_0,
    #[doc = "IrDA transceiver delivers a low pulse when a light pulse is seen"]
    UCIRRXPL_1,
}
impl UCIRRXPLW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCIRRXPLW::UCIRRXPL_0 => false,
            UCIRRXPLW::UCIRRXPL_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCIRRXPLW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRRXPLW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCIRRXPLW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IrDA transceiver delivers a high pulse when a light pulse is seen"]
    #[inline]
    pub fn ucirrxpl_0(self) -> &'a mut W {
        self.variant(UCIRRXPLW::UCIRRXPL_0)
    }
    #[doc = "IrDA transceiver delivers a low pulse when a light pulse is seen"]
    #[inline]
    pub fn ucirrxpl_1(self) -> &'a mut W {
        self.variant(UCIRRXPLW::UCIRRXPL_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _UCIRRXFLW<'a> {
    w: &'a mut W,
}
impl<'a> _UCIRRXFLW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - IrDA encoder/decoder enable"]
    #[inline]
    pub fn uciren(&self) -> UCIRENR {
        UCIRENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - IrDA transmit pulse clock select"]
    #[inline]
    pub fn ucirtxclk(&self) -> UCIRTXCLKR {
        UCIRTXCLKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 2:7 - Transmit pulse length"]
    #[inline]
    pub fn ucirtxpl(&self) -> UCIRTXPLR {
        let bits = {
            const MASK: u8 = 63;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        UCIRTXPLR { bits }
    }
    #[doc = "Bit 8 - IrDA receive filter enabled"]
    #[inline]
    pub fn ucirrxfe(&self) -> UCIRRXFER {
        UCIRRXFER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 9 - IrDA receive input UCAxRXD polarity"]
    #[inline]
    pub fn ucirrxpl(&self) -> UCIRRXPLR {
        UCIRRXPLR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 10:13 - Receive filter length"]
    #[inline]
    pub fn ucirrxfl(&self) -> UCIRRXFLR {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        UCIRRXFLR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - IrDA encoder/decoder enable"]
    #[inline]
    pub fn uciren(&mut self) -> _UCIRENW {
        _UCIRENW { w: self }
    }
    #[doc = "Bit 1 - IrDA transmit pulse clock select"]
    #[inline]
    pub fn ucirtxclk(&mut self) -> _UCIRTXCLKW {
        _UCIRTXCLKW { w: self }
    }
    #[doc = "Bits 2:7 - Transmit pulse length"]
    #[inline]
    pub fn ucirtxpl(&mut self) -> _UCIRTXPLW {
        _UCIRTXPLW { w: self }
    }
    #[doc = "Bit 8 - IrDA receive filter enabled"]
    #[inline]
    pub fn ucirrxfe(&mut self) -> _UCIRRXFEW {
        _UCIRRXFEW { w: self }
    }
    #[doc = "Bit 9 - IrDA receive input UCAxRXD polarity"]
    #[inline]
    pub fn ucirrxpl(&mut self) -> _UCIRRXPLW {
        _UCIRRXPLW { w: self }
    }
    #[doc = "Bits 10:13 - Receive filter length"]
    #[inline]
    pub fn ucirrxfl(&mut self) -> _UCIRRXFLW {
        _UCIRRXFLW { w: self }
    }
}
