#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXMCTLW {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCOS16`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCOS16R {
    #[doc = "Disabled"]
    UCOS16_0,
    #[doc = "Enabled"]
    UCOS16_1,
}
impl UCOS16R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCOS16R::UCOS16_0 => false,
            UCOS16R::UCOS16_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCOS16R {
        match value {
            false => UCOS16R::UCOS16_0,
            true => UCOS16R::UCOS16_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCOS16_0`"]
    #[inline]
    pub fn is_ucos16_0(&self) -> bool {
        *self == UCOS16R::UCOS16_0
    }
    #[doc = "Checks if the value of the field is `UCOS16_1`"]
    #[inline]
    pub fn is_ucos16_1(&self) -> bool {
        *self == UCOS16R::UCOS16_1
    }
}
#[doc = r" Value of the field"]
pub struct UCBRFR {
    bits: u8,
}
impl UCBRFR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct UCBRSR {
    bits: u8,
}
impl UCBRSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `UCOS16`"]
pub enum UCOS16W {
    #[doc = "Disabled"]
    UCOS16_0,
    #[doc = "Enabled"]
    UCOS16_1,
}
impl UCOS16W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCOS16W::UCOS16_0 => false,
            UCOS16W::UCOS16_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCOS16W<'a> {
    w: &'a mut W,
}
impl<'a> _UCOS16W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCOS16W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn ucos16_0(self) -> &'a mut W {
        self.variant(UCOS16W::UCOS16_0)
    }
    #[doc = "Enabled"]
    #[inline]
    pub fn ucos16_1(self) -> &'a mut W {
        self.variant(UCOS16W::UCOS16_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _UCBRFW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBRFW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _UCBRSW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBRSW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 255;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Oversampling mode enabled"]
    #[inline]
    pub fn ucos16(&self) -> UCOS16R {
        UCOS16R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 4:7 - First modulation stage select"]
    #[inline]
    pub fn ucbrf(&self) -> UCBRFR {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        UCBRFR { bits }
    }
    #[doc = "Bits 8:15 - Second modulation stage select"]
    #[inline]
    pub fn ucbrs(&self) -> UCBRSR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        UCBRSR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Oversampling mode enabled"]
    #[inline]
    pub fn ucos16(&mut self) -> _UCOS16W {
        _UCOS16W { w: self }
    }
    #[doc = "Bits 4:7 - First modulation stage select"]
    #[inline]
    pub fn ucbrf(&mut self) -> _UCBRFW {
        _UCBRFW { w: self }
    }
    #[doc = "Bits 8:15 - Second modulation stage select"]
    #[inline]
    pub fn ucbrs(&mut self) -> _UCBRSW {
        _UCBRSW { w: self }
    }
}
