#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXSTATW {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCBUSY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBUSYR {
    #[doc = "eUSCI_A inactive"]
    UCBUSY_0,
    #[doc = "eUSCI_A transmitting or receiving"]
    UCBUSY_1,
}
impl UCBUSYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBUSYR::UCBUSY_0 => false,
            UCBUSYR::UCBUSY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBUSYR {
        match value {
            false => UCBUSYR::UCBUSY_0,
            true => UCBUSYR::UCBUSY_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBUSY_0`"]
    #[inline]
    pub fn is_ucbusy_0(&self) -> bool {
        *self == UCBUSYR::UCBUSY_0
    }
    #[doc = "Checks if the value of the field is `UCBUSY_1`"]
    #[inline]
    pub fn is_ucbusy_1(&self) -> bool {
        *self == UCBUSYR::UCBUSY_1
    }
}
#[doc = r" Value of the field"]
pub struct UCADDR_UCIDLER {
    bits: bool,
}
impl UCADDR_UCIDLER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `UCRXERR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXERRR {
    #[doc = "No receive errors detected"]
    UCRXERR_0,
    #[doc = "Receive error detected"]
    UCRXERR_1,
}
impl UCRXERRR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXERRR::UCRXERR_0 => false,
            UCRXERRR::UCRXERR_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXERRR {
        match value {
            false => UCRXERRR::UCRXERR_0,
            true => UCRXERRR::UCRXERR_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXERR_0`"]
    #[inline]
    pub fn is_ucrxerr_0(&self) -> bool {
        *self == UCRXERRR::UCRXERR_0
    }
    #[doc = "Checks if the value of the field is `UCRXERR_1`"]
    #[inline]
    pub fn is_ucrxerr_1(&self) -> bool {
        *self == UCRXERRR::UCRXERR_1
    }
}
#[doc = "Possible values of the field `UCBRK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBRKR {
    #[doc = "No break condition"]
    UCBRK_0,
    #[doc = "Break condition occurred"]
    UCBRK_1,
}
impl UCBRKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBRKR::UCBRK_0 => false,
            UCBRKR::UCBRK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBRKR {
        match value {
            false => UCBRKR::UCBRK_0,
            true => UCBRKR::UCBRK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBRK_0`"]
    #[inline]
    pub fn is_ucbrk_0(&self) -> bool {
        *self == UCBRKR::UCBRK_0
    }
    #[doc = "Checks if the value of the field is `UCBRK_1`"]
    #[inline]
    pub fn is_ucbrk_1(&self) -> bool {
        *self == UCBRKR::UCBRK_1
    }
}
#[doc = "Possible values of the field `UCPE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCPER {
    #[doc = "No error"]
    UCPE_0,
    #[doc = "Character received with parity error"]
    UCPE_1,
}
impl UCPER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCPER::UCPE_0 => false,
            UCPER::UCPE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCPER {
        match value {
            false => UCPER::UCPE_0,
            true => UCPER::UCPE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCPE_0`"]
    #[inline]
    pub fn is_ucpe_0(&self) -> bool {
        *self == UCPER::UCPE_0
    }
    #[doc = "Checks if the value of the field is `UCPE_1`"]
    #[inline]
    pub fn is_ucpe_1(&self) -> bool {
        *self == UCPER::UCPE_1
    }
}
#[doc = "Possible values of the field `UCOE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCOER {
    #[doc = "No error"]
    UCOE_0,
    #[doc = "Overrun error occurred"]
    UCOE_1,
}
impl UCOER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCOER::UCOE_0 => false,
            UCOER::UCOE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCOER {
        match value {
            false => UCOER::UCOE_0,
            true => UCOER::UCOE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCOE_0`"]
    #[inline]
    pub fn is_ucoe_0(&self) -> bool {
        *self == UCOER::UCOE_0
    }
    #[doc = "Checks if the value of the field is `UCOE_1`"]
    #[inline]
    pub fn is_ucoe_1(&self) -> bool {
        *self == UCOER::UCOE_1
    }
}
#[doc = "Possible values of the field `UCFE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCFER {
    #[doc = "No error"]
    UCFE_0,
    #[doc = "Character received with low stop bit"]
    UCFE_1,
}
impl UCFER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCFER::UCFE_0 => false,
            UCFER::UCFE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCFER {
        match value {
            false => UCFER::UCFE_0,
            true => UCFER::UCFE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCFE_0`"]
    #[inline]
    pub fn is_ucfe_0(&self) -> bool {
        *self == UCFER::UCFE_0
    }
    #[doc = "Checks if the value of the field is `UCFE_1`"]
    #[inline]
    pub fn is_ucfe_1(&self) -> bool {
        *self == UCFER::UCFE_1
    }
}
#[doc = "Possible values of the field `UCLISTEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCLISTENR {
    #[doc = "Disabled"]
    UCLISTEN_0,
    #[doc = "Enabled. UCAxTXD is internally fed back to the receiver"]
    UCLISTEN_1,
}
impl UCLISTENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCLISTENR::UCLISTEN_0 => false,
            UCLISTENR::UCLISTEN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCLISTENR {
        match value {
            false => UCLISTENR::UCLISTEN_0,
            true => UCLISTENR::UCLISTEN_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCLISTEN_0`"]
    #[inline]
    pub fn is_uclisten_0(&self) -> bool {
        *self == UCLISTENR::UCLISTEN_0
    }
    #[doc = "Checks if the value of the field is `UCLISTEN_1`"]
    #[inline]
    pub fn is_uclisten_1(&self) -> bool {
        *self == UCLISTENR::UCLISTEN_1
    }
}
#[doc = r" Proxy"]
pub struct _UCADDR_UCIDLEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCADDR_UCIDLEW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXERR`"]
pub enum UCRXERRW {
    #[doc = "No receive errors detected"]
    UCRXERR_0,
    #[doc = "Receive error detected"]
    UCRXERR_1,
}
impl UCRXERRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXERRW::UCRXERR_0 => false,
            UCRXERRW::UCRXERR_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXERRW<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXERRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXERRW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No receive errors detected"]
    #[inline]
    pub fn ucrxerr_0(self) -> &'a mut W {
        self.variant(UCRXERRW::UCRXERR_0)
    }
    #[doc = "Receive error detected"]
    #[inline]
    pub fn ucrxerr_1(self) -> &'a mut W {
        self.variant(UCRXERRW::UCRXERR_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBRK`"]
pub enum UCBRKW {
    #[doc = "No break condition"]
    UCBRK_0,
    #[doc = "Break condition occurred"]
    UCBRK_1,
}
impl UCBRKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBRKW::UCBRK_0 => false,
            UCBRKW::UCBRK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBRKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBRKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBRKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No break condition"]
    #[inline]
    pub fn ucbrk_0(self) -> &'a mut W {
        self.variant(UCBRKW::UCBRK_0)
    }
    #[doc = "Break condition occurred"]
    #[inline]
    pub fn ucbrk_1(self) -> &'a mut W {
        self.variant(UCBRKW::UCBRK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCPE`"]
pub enum UCPEW {
    #[doc = "No error"]
    UCPE_0,
    #[doc = "Character received with parity error"]
    UCPE_1,
}
impl UCPEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCPEW::UCPE_0 => false,
            UCPEW::UCPE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCPEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCPEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCPEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No error"]
    #[inline]
    pub fn ucpe_0(self) -> &'a mut W {
        self.variant(UCPEW::UCPE_0)
    }
    #[doc = "Character received with parity error"]
    #[inline]
    pub fn ucpe_1(self) -> &'a mut W {
        self.variant(UCPEW::UCPE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCOE`"]
pub enum UCOEW {
    #[doc = "No error"]
    UCOE_0,
    #[doc = "Overrun error occurred"]
    UCOE_1,
}
impl UCOEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCOEW::UCOE_0 => false,
            UCOEW::UCOE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCOEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCOEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCOEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No error"]
    #[inline]
    pub fn ucoe_0(self) -> &'a mut W {
        self.variant(UCOEW::UCOE_0)
    }
    #[doc = "Overrun error occurred"]
    #[inline]
    pub fn ucoe_1(self) -> &'a mut W {
        self.variant(UCOEW::UCOE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCFE`"]
pub enum UCFEW {
    #[doc = "No error"]
    UCFE_0,
    #[doc = "Character received with low stop bit"]
    UCFE_1,
}
impl UCFEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCFEW::UCFE_0 => false,
            UCFEW::UCFE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCFEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCFEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCFEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No error"]
    #[inline]
    pub fn ucfe_0(self) -> &'a mut W {
        self.variant(UCFEW::UCFE_0)
    }
    #[doc = "Character received with low stop bit"]
    #[inline]
    pub fn ucfe_1(self) -> &'a mut W {
        self.variant(UCFEW::UCFE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCLISTEN`"]
pub enum UCLISTENW {
    #[doc = "Disabled"]
    UCLISTEN_0,
    #[doc = "Enabled. UCAxTXD is internally fed back to the receiver"]
    UCLISTEN_1,
}
impl UCLISTENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCLISTENW::UCLISTEN_0 => false,
            UCLISTENW::UCLISTEN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCLISTENW<'a> {
    w: &'a mut W,
}
impl<'a> _UCLISTENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCLISTENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn uclisten_0(self) -> &'a mut W {
        self.variant(UCLISTENW::UCLISTEN_0)
    }
    #[doc = "Enabled. UCAxTXD is internally fed back to the receiver"]
    #[inline]
    pub fn uclisten_1(self) -> &'a mut W {
        self.variant(UCLISTENW::UCLISTEN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - eUSCI_A busy"]
    #[inline]
    pub fn ucbusy(&self) -> UCBUSYR {
        UCBUSYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Address received / Idle line detected"]
    #[inline]
    pub fn ucaddr_ucidle(&self) -> UCADDR_UCIDLER {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        };
        UCADDR_UCIDLER { bits }
    }
    #[doc = "Bit 2 - Receive error flag"]
    #[inline]
    pub fn ucrxerr(&self) -> UCRXERRR {
        UCRXERRR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Break detect flag"]
    #[inline]
    pub fn ucbrk(&self) -> UCBRKR {
        UCBRKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Parity error flag. When UCPEN = 0, UCPE is read as 0. UCPE is cleared when UCAxRXBUF is read."]
    #[inline]
    pub fn ucpe(&self) -> UCPER {
        UCPER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Overrun error flag"]
    #[inline]
    pub fn ucoe(&self) -> UCOER {
        UCOER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Framing error flag"]
    #[inline]
    pub fn ucfe(&self) -> UCFER {
        UCFER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Listen enable"]
    #[inline]
    pub fn uclisten(&self) -> UCLISTENR {
        UCLISTENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 1 - Address received / Idle line detected"]
    #[inline]
    pub fn ucaddr_ucidle(&mut self) -> _UCADDR_UCIDLEW {
        _UCADDR_UCIDLEW { w: self }
    }
    #[doc = "Bit 2 - Receive error flag"]
    #[inline]
    pub fn ucrxerr(&mut self) -> _UCRXERRW {
        _UCRXERRW { w: self }
    }
    #[doc = "Bit 3 - Break detect flag"]
    #[inline]
    pub fn ucbrk(&mut self) -> _UCBRKW {
        _UCBRKW { w: self }
    }
    #[doc = "Bit 4 - Parity error flag. When UCPEN = 0, UCPE is read as 0. UCPE is cleared when UCAxRXBUF is read."]
    #[inline]
    pub fn ucpe(&mut self) -> _UCPEW {
        _UCPEW { w: self }
    }
    #[doc = "Bit 5 - Overrun error flag"]
    #[inline]
    pub fn ucoe(&mut self) -> _UCOEW {
        _UCOEW { w: self }
    }
    #[doc = "Bit 6 - Framing error flag"]
    #[inline]
    pub fn ucfe(&mut self) -> _UCFEW {
        _UCFEW { w: self }
    }
    #[doc = "Bit 7 - Listen enable"]
    #[inline]
    pub fn uclisten(&mut self) -> _UCLISTENW {
        _UCLISTENW { w: self }
    }
}
