#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXABCTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCABDEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCABDENR {
    #[doc = "Baud-rate detection disabled. Length of break and synch field is not measured."]
    UCABDEN_0,
    #[doc = "Baud-rate detection enabled. Length of break and synch field is measured and baud-rate settings are changed accordingly."]
    UCABDEN_1,
}
impl UCABDENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCABDENR::UCABDEN_0 => false,
            UCABDENR::UCABDEN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCABDENR {
        match value {
            false => UCABDENR::UCABDEN_0,
            true => UCABDENR::UCABDEN_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCABDEN_0`"]
    #[inline]
    pub fn is_ucabden_0(&self) -> bool {
        *self == UCABDENR::UCABDEN_0
    }
    #[doc = "Checks if the value of the field is `UCABDEN_1`"]
    #[inline]
    pub fn is_ucabden_1(&self) -> bool {
        *self == UCABDENR::UCABDEN_1
    }
}
#[doc = "Possible values of the field `UCBTOE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBTOER {
    #[doc = "No error"]
    UCBTOE_0,
    #[doc = "Length of break field exceeded 22 bit times"]
    UCBTOE_1,
}
impl UCBTOER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBTOER::UCBTOE_0 => false,
            UCBTOER::UCBTOE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBTOER {
        match value {
            false => UCBTOER::UCBTOE_0,
            true => UCBTOER::UCBTOE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBTOE_0`"]
    #[inline]
    pub fn is_ucbtoe_0(&self) -> bool {
        *self == UCBTOER::UCBTOE_0
    }
    #[doc = "Checks if the value of the field is `UCBTOE_1`"]
    #[inline]
    pub fn is_ucbtoe_1(&self) -> bool {
        *self == UCBTOER::UCBTOE_1
    }
}
#[doc = "Possible values of the field `UCSTOE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTOER {
    #[doc = "No error"]
    UCSTOE_0,
    #[doc = "Length of synch field exceeded measurable time"]
    UCSTOE_1,
}
impl UCSTOER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTOER::UCSTOE_0 => false,
            UCSTOER::UCSTOE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTOER {
        match value {
            false => UCSTOER::UCSTOE_0,
            true => UCSTOER::UCSTOE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTOE_0`"]
    #[inline]
    pub fn is_ucstoe_0(&self) -> bool {
        *self == UCSTOER::UCSTOE_0
    }
    #[doc = "Checks if the value of the field is `UCSTOE_1`"]
    #[inline]
    pub fn is_ucstoe_1(&self) -> bool {
        *self == UCSTOER::UCSTOE_1
    }
}
#[doc = "Possible values of the field `UCDELIM`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCDELIMR {
    #[doc = "1 bit time"]
    UCDELIM_0,
    #[doc = "2 bit times"]
    UCDELIM_1,
    #[doc = "3 bit times"]
    UCDELIM_2,
    #[doc = "4 bit times"]
    UCDELIM_3,
}
impl UCDELIMR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCDELIMR::UCDELIM_0 => 0,
            UCDELIMR::UCDELIM_1 => 1,
            UCDELIMR::UCDELIM_2 => 2,
            UCDELIMR::UCDELIM_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCDELIMR {
        match value {
            0 => UCDELIMR::UCDELIM_0,
            1 => UCDELIMR::UCDELIM_1,
            2 => UCDELIMR::UCDELIM_2,
            3 => UCDELIMR::UCDELIM_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCDELIM_0`"]
    #[inline]
    pub fn is_ucdelim_0(&self) -> bool {
        *self == UCDELIMR::UCDELIM_0
    }
    #[doc = "Checks if the value of the field is `UCDELIM_1`"]
    #[inline]
    pub fn is_ucdelim_1(&self) -> bool {
        *self == UCDELIMR::UCDELIM_1
    }
    #[doc = "Checks if the value of the field is `UCDELIM_2`"]
    #[inline]
    pub fn is_ucdelim_2(&self) -> bool {
        *self == UCDELIMR::UCDELIM_2
    }
    #[doc = "Checks if the value of the field is `UCDELIM_3`"]
    #[inline]
    pub fn is_ucdelim_3(&self) -> bool {
        *self == UCDELIMR::UCDELIM_3
    }
}
#[doc = "Values that can be written to the field `UCABDEN`"]
pub enum UCABDENW {
    #[doc = "Baud-rate detection disabled. Length of break and synch field is not measured."]
    UCABDEN_0,
    #[doc = "Baud-rate detection enabled. Length of break and synch field is measured and baud-rate settings are changed accordingly."]
    UCABDEN_1,
}
impl UCABDENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCABDENW::UCABDEN_0 => false,
            UCABDENW::UCABDEN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCABDENW<'a> {
    w: &'a mut W,
}
impl<'a> _UCABDENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCABDENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Baud-rate detection disabled. Length of break and synch field is not measured."]
    #[inline]
    pub fn ucabden_0(self) -> &'a mut W {
        self.variant(UCABDENW::UCABDEN_0)
    }
    #[doc = "Baud-rate detection enabled. Length of break and synch field is measured and baud-rate settings are changed accordingly."]
    #[inline]
    pub fn ucabden_1(self) -> &'a mut W {
        self.variant(UCABDENW::UCABDEN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBTOE`"]
pub enum UCBTOEW {
    #[doc = "No error"]
    UCBTOE_0,
    #[doc = "Length of break field exceeded 22 bit times"]
    UCBTOE_1,
}
impl UCBTOEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBTOEW::UCBTOE_0 => false,
            UCBTOEW::UCBTOE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBTOEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBTOEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBTOEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No error"]
    #[inline]
    pub fn ucbtoe_0(self) -> &'a mut W {
        self.variant(UCBTOEW::UCBTOE_0)
    }
    #[doc = "Length of break field exceeded 22 bit times"]
    #[inline]
    pub fn ucbtoe_1(self) -> &'a mut W {
        self.variant(UCBTOEW::UCBTOE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTOE`"]
pub enum UCSTOEW {
    #[doc = "No error"]
    UCSTOE_0,
    #[doc = "Length of synch field exceeded measurable time"]
    UCSTOE_1,
}
impl UCSTOEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTOEW::UCSTOE_0 => false,
            UCSTOEW::UCSTOE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTOEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTOEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTOEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No error"]
    #[inline]
    pub fn ucstoe_0(self) -> &'a mut W {
        self.variant(UCSTOEW::UCSTOE_0)
    }
    #[doc = "Length of synch field exceeded measurable time"]
    #[inline]
    pub fn ucstoe_1(self) -> &'a mut W {
        self.variant(UCSTOEW::UCSTOE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCDELIM`"]
pub enum UCDELIMW {
    #[doc = "1 bit time"]
    UCDELIM_0,
    #[doc = "2 bit times"]
    UCDELIM_1,
    #[doc = "3 bit times"]
    UCDELIM_2,
    #[doc = "4 bit times"]
    UCDELIM_3,
}
impl UCDELIMW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCDELIMW::UCDELIM_0 => 0,
            UCDELIMW::UCDELIM_1 => 1,
            UCDELIMW::UCDELIM_2 => 2,
            UCDELIMW::UCDELIM_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCDELIMW<'a> {
    w: &'a mut W,
}
impl<'a> _UCDELIMW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCDELIMW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "1 bit time"]
    #[inline]
    pub fn ucdelim_0(self) -> &'a mut W {
        self.variant(UCDELIMW::UCDELIM_0)
    }
    #[doc = "2 bit times"]
    #[inline]
    pub fn ucdelim_1(self) -> &'a mut W {
        self.variant(UCDELIMW::UCDELIM_1)
    }
    #[doc = "3 bit times"]
    #[inline]
    pub fn ucdelim_2(self) -> &'a mut W {
        self.variant(UCDELIMW::UCDELIM_2)
    }
    #[doc = "4 bit times"]
    #[inline]
    pub fn ucdelim_3(self) -> &'a mut W {
        self.variant(UCDELIMW::UCDELIM_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Automatic baud-rate detect enable"]
    #[inline]
    pub fn ucabden(&self) -> UCABDENR {
        UCABDENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Break time out error"]
    #[inline]
    pub fn ucbtoe(&self) -> UCBTOER {
        UCBTOER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Synch field time out error"]
    #[inline]
    pub fn ucstoe(&self) -> UCSTOER {
        UCSTOER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 4:5 - Break/synch delimiter length"]
    #[inline]
    pub fn ucdelim(&self) -> UCDELIMR {
        UCDELIMR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Automatic baud-rate detect enable"]
    #[inline]
    pub fn ucabden(&mut self) -> _UCABDENW {
        _UCABDENW { w: self }
    }
    #[doc = "Bit 2 - Break time out error"]
    #[inline]
    pub fn ucbtoe(&mut self) -> _UCBTOEW {
        _UCBTOEW { w: self }
    }
    #[doc = "Bit 3 - Synch field time out error"]
    #[inline]
    pub fn ucstoe(&mut self) -> _UCSTOEW {
        _UCSTOEW { w: self }
    }
    #[doc = "Bits 4:5 - Break/synch delimiter length"]
    #[inline]
    pub fn ucdelim(&mut self) -> _UCDELIMW {
        _UCDELIMW { w: self }
    }
}
