#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::UCAXIV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `UCIV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIVR {
    #[doc = "No interrupt pending"]
    UCIV_0,
    #[doc = "Interrupt Source: Receive buffer full; Interrupt Flag: UCRXIFG; Interrupt Priority: Highest"]
    UCIV_2,
    #[doc = "Interrupt Source: Transmit buffer empty; Interrupt Flag: UCTXIFG"]
    UCIV_4,
    #[doc = "Interrupt Source: Start bit received; Interrupt Flag: UCSTTIFG"]
    UCIV_6,
    #[doc = "Interrupt Source: Transmit complete; Interrupt Flag: UCTXCPTIFG; Interrupt Priority: Lowest"]
    UCIV_8,
    #[doc = r" Reserved"]
    _Reserved(u16),
}
impl UCIVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        match *self {
            UCIVR::UCIV_0 => 0,
            UCIVR::UCIV_2 => 2,
            UCIVR::UCIV_4 => 4,
            UCIVR::UCIV_6 => 6,
            UCIVR::UCIV_8 => 8,
            UCIVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u16) -> UCIVR {
        match value {
            0 => UCIVR::UCIV_0,
            2 => UCIVR::UCIV_2,
            4 => UCIVR::UCIV_4,
            6 => UCIVR::UCIV_6,
            8 => UCIVR::UCIV_8,
            i => UCIVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `UCIV_0`"]
    #[inline]
    pub fn is_uciv_0(&self) -> bool {
        *self == UCIVR::UCIV_0
    }
    #[doc = "Checks if the value of the field is `UCIV_2`"]
    #[inline]
    pub fn is_uciv_2(&self) -> bool {
        *self == UCIVR::UCIV_2
    }
    #[doc = "Checks if the value of the field is `UCIV_4`"]
    #[inline]
    pub fn is_uciv_4(&self) -> bool {
        *self == UCIVR::UCIV_4
    }
    #[doc = "Checks if the value of the field is `UCIV_6`"]
    #[inline]
    pub fn is_uciv_6(&self) -> bool {
        *self == UCIVR::UCIV_6
    }
    #[doc = "Checks if the value of the field is `UCIV_8`"]
    #[inline]
    pub fn is_uciv_8(&self) -> bool {
        *self == UCIVR::UCIV_8
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:15 - eUSCI_A interrupt vector value"]
    #[inline]
    pub fn uciv(&self) -> UCIVR {
        UCIVR::_from({
            const MASK: u16 = 65535;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        })
    }
}
