#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXIFG {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCRXIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIFGR {
    #[doc = "No interrupt pending"]
    UCRXIFG_0,
    #[doc = "Interrupt pending"]
    UCRXIFG_1,
}
impl UCRXIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIFGR::UCRXIFG_0 => false,
            UCRXIFGR::UCRXIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIFGR {
        match value {
            false => UCRXIFGR::UCRXIFG_0,
            true => UCRXIFGR::UCRXIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIFG_0`"]
    #[inline]
    pub fn is_ucrxifg_0(&self) -> bool {
        *self == UCRXIFGR::UCRXIFG_0
    }
    #[doc = "Checks if the value of the field is `UCRXIFG_1`"]
    #[inline]
    pub fn is_ucrxifg_1(&self) -> bool {
        *self == UCRXIFGR::UCRXIFG_1
    }
}
#[doc = "Possible values of the field `UCTXIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIFGR {
    #[doc = "No interrupt pending"]
    UCTXIFG_0,
    #[doc = "Interrupt pending"]
    UCTXIFG_1,
}
impl UCTXIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIFGR::UCTXIFG_0 => false,
            UCTXIFGR::UCTXIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIFGR {
        match value {
            false => UCTXIFGR::UCTXIFG_0,
            true => UCTXIFGR::UCTXIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIFG_0`"]
    #[inline]
    pub fn is_uctxifg_0(&self) -> bool {
        *self == UCTXIFGR::UCTXIFG_0
    }
    #[doc = "Checks if the value of the field is `UCTXIFG_1`"]
    #[inline]
    pub fn is_uctxifg_1(&self) -> bool {
        *self == UCTXIFGR::UCTXIFG_1
    }
}
#[doc = "Possible values of the field `UCSTTIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTTIFGR {
    #[doc = "No interrupt pending"]
    UCSTTIFG_0,
    #[doc = "Interrupt pending"]
    UCSTTIFG_1,
}
impl UCSTTIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTTIFGR::UCSTTIFG_0 => false,
            UCSTTIFGR::UCSTTIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTTIFGR {
        match value {
            false => UCSTTIFGR::UCSTTIFG_0,
            true => UCSTTIFGR::UCSTTIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTTIFG_0`"]
    #[inline]
    pub fn is_ucsttifg_0(&self) -> bool {
        *self == UCSTTIFGR::UCSTTIFG_0
    }
    #[doc = "Checks if the value of the field is `UCSTTIFG_1`"]
    #[inline]
    pub fn is_ucsttifg_1(&self) -> bool {
        *self == UCSTTIFGR::UCSTTIFG_1
    }
}
#[doc = "Possible values of the field `UCTXCPTIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXCPTIFGR {
    #[doc = "No interrupt pending"]
    UCTXCPTIFG_0,
    #[doc = "Interrupt pending"]
    UCTXCPTIFG_1,
}
impl UCTXCPTIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXCPTIFGR::UCTXCPTIFG_0 => false,
            UCTXCPTIFGR::UCTXCPTIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXCPTIFGR {
        match value {
            false => UCTXCPTIFGR::UCTXCPTIFG_0,
            true => UCTXCPTIFGR::UCTXCPTIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXCPTIFG_0`"]
    #[inline]
    pub fn is_uctxcptifg_0(&self) -> bool {
        *self == UCTXCPTIFGR::UCTXCPTIFG_0
    }
    #[doc = "Checks if the value of the field is `UCTXCPTIFG_1`"]
    #[inline]
    pub fn is_uctxcptifg_1(&self) -> bool {
        *self == UCTXCPTIFGR::UCTXCPTIFG_1
    }
}
#[doc = "Values that can be written to the field `UCRXIFG`"]
pub enum UCRXIFGW {
    #[doc = "No interrupt pending"]
    UCRXIFG_0,
    #[doc = "Interrupt pending"]
    UCRXIFG_1,
}
impl UCRXIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIFGW::UCRXIFG_0 => false,
            UCRXIFGW::UCRXIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucrxifg_0(self) -> &'a mut W {
        self.variant(UCRXIFGW::UCRXIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucrxifg_1(self) -> &'a mut W {
        self.variant(UCRXIFGW::UCRXIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIFG`"]
pub enum UCTXIFGW {
    #[doc = "No interrupt pending"]
    UCTXIFG_0,
    #[doc = "Interrupt pending"]
    UCTXIFG_1,
}
impl UCTXIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIFGW::UCTXIFG_0 => false,
            UCTXIFGW::UCTXIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxifg_0(self) -> &'a mut W {
        self.variant(UCTXIFGW::UCTXIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxifg_1(self) -> &'a mut W {
        self.variant(UCTXIFGW::UCTXIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTTIFG`"]
pub enum UCSTTIFGW {
    #[doc = "No interrupt pending"]
    UCSTTIFG_0,
    #[doc = "Interrupt pending"]
    UCSTTIFG_1,
}
impl UCSTTIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTTIFGW::UCSTTIFG_0 => false,
            UCSTTIFGW::UCSTTIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTTIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTTIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTTIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucsttifg_0(self) -> &'a mut W {
        self.variant(UCSTTIFGW::UCSTTIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucsttifg_1(self) -> &'a mut W {
        self.variant(UCSTTIFGW::UCSTTIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXCPTIFG`"]
pub enum UCTXCPTIFGW {
    #[doc = "No interrupt pending"]
    UCTXCPTIFG_0,
    #[doc = "Interrupt pending"]
    UCTXCPTIFG_1,
}
impl UCTXCPTIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXCPTIFGW::UCTXCPTIFG_0 => false,
            UCTXCPTIFGW::UCTXCPTIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXCPTIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXCPTIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXCPTIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxcptifg_0(self) -> &'a mut W {
        self.variant(UCTXCPTIFGW::UCTXCPTIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxcptifg_1(self) -> &'a mut W {
        self.variant(UCTXCPTIFGW::UCTXCPTIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Receive interrupt flag"]
    #[inline]
    pub fn ucrxifg(&self) -> UCRXIFGR {
        UCRXIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Transmit interrupt flag"]
    #[inline]
    pub fn uctxifg(&self) -> UCTXIFGR {
        UCTXIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Start bit interrupt flag"]
    #[inline]
    pub fn ucsttifg(&self) -> UCSTTIFGR {
        UCSTTIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Transmit ready interrupt enable"]
    #[inline]
    pub fn uctxcptifg(&self) -> UCTXCPTIFGR {
        UCTXCPTIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 2 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Receive interrupt flag"]
    #[inline]
    pub fn ucrxifg(&mut self) -> _UCRXIFGW {
        _UCRXIFGW { w: self }
    }
    #[doc = "Bit 1 - Transmit interrupt flag"]
    #[inline]
    pub fn uctxifg(&mut self) -> _UCTXIFGW {
        _UCTXIFGW { w: self }
    }
    #[doc = "Bit 2 - Start bit interrupt flag"]
    #[inline]
    pub fn ucsttifg(&mut self) -> _UCSTTIFGW {
        _UCSTTIFGW { w: self }
    }
    #[doc = "Bit 3 - Transmit ready interrupt enable"]
    #[inline]
    pub fn uctxcptifg(&mut self) -> _UCTXCPTIFGW {
        _UCTXCPTIFGW { w: self }
    }
}
