#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCAXIE {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCRXIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIER {
    #[doc = "Interrupt disabled"]
    UCRXIE_0,
    #[doc = "Interrupt enabled"]
    UCRXIE_1,
}
impl UCRXIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIER::UCRXIE_0 => false,
            UCRXIER::UCRXIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIER {
        match value {
            false => UCRXIER::UCRXIE_0,
            true => UCRXIER::UCRXIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIE_0`"]
    #[inline]
    pub fn is_ucrxie_0(&self) -> bool {
        *self == UCRXIER::UCRXIE_0
    }
    #[doc = "Checks if the value of the field is `UCRXIE_1`"]
    #[inline]
    pub fn is_ucrxie_1(&self) -> bool {
        *self == UCRXIER::UCRXIE_1
    }
}
#[doc = "Possible values of the field `UCTXIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIER {
    #[doc = "Interrupt disabled"]
    UCTXIE_0,
    #[doc = "Interrupt enabled"]
    UCTXIE_1,
}
impl UCTXIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIER::UCTXIE_0 => false,
            UCTXIER::UCTXIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIER {
        match value {
            false => UCTXIER::UCTXIE_0,
            true => UCTXIER::UCTXIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIE_0`"]
    #[inline]
    pub fn is_uctxie_0(&self) -> bool {
        *self == UCTXIER::UCTXIE_0
    }
    #[doc = "Checks if the value of the field is `UCTXIE_1`"]
    #[inline]
    pub fn is_uctxie_1(&self) -> bool {
        *self == UCTXIER::UCTXIE_1
    }
}
#[doc = "Possible values of the field `UCSTTIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTTIER {
    #[doc = "Interrupt disabled"]
    UCSTTIE_0,
    #[doc = "Interrupt enabled"]
    UCSTTIE_1,
}
impl UCSTTIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTTIER::UCSTTIE_0 => false,
            UCSTTIER::UCSTTIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTTIER {
        match value {
            false => UCSTTIER::UCSTTIE_0,
            true => UCSTTIER::UCSTTIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTTIE_0`"]
    #[inline]
    pub fn is_ucsttie_0(&self) -> bool {
        *self == UCSTTIER::UCSTTIE_0
    }
    #[doc = "Checks if the value of the field is `UCSTTIE_1`"]
    #[inline]
    pub fn is_ucsttie_1(&self) -> bool {
        *self == UCSTTIER::UCSTTIE_1
    }
}
#[doc = "Possible values of the field `UCTXCPTIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXCPTIER {
    #[doc = "Interrupt disabled"]
    UCTXCPTIE_0,
    #[doc = "Interrupt enabled"]
    UCTXCPTIE_1,
}
impl UCTXCPTIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXCPTIER::UCTXCPTIE_0 => false,
            UCTXCPTIER::UCTXCPTIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXCPTIER {
        match value {
            false => UCTXCPTIER::UCTXCPTIE_0,
            true => UCTXCPTIER::UCTXCPTIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXCPTIE_0`"]
    #[inline]
    pub fn is_uctxcptie_0(&self) -> bool {
        *self == UCTXCPTIER::UCTXCPTIE_0
    }
    #[doc = "Checks if the value of the field is `UCTXCPTIE_1`"]
    #[inline]
    pub fn is_uctxcptie_1(&self) -> bool {
        *self == UCTXCPTIER::UCTXCPTIE_1
    }
}
#[doc = "Values that can be written to the field `UCRXIE`"]
pub enum UCRXIEW {
    #[doc = "Interrupt disabled"]
    UCRXIE_0,
    #[doc = "Interrupt enabled"]
    UCRXIE_1,
}
impl UCRXIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIEW::UCRXIE_0 => false,
            UCRXIEW::UCRXIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucrxie_0(self) -> &'a mut W {
        self.variant(UCRXIEW::UCRXIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucrxie_1(self) -> &'a mut W {
        self.variant(UCRXIEW::UCRXIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIE`"]
pub enum UCTXIEW {
    #[doc = "Interrupt disabled"]
    UCTXIE_0,
    #[doc = "Interrupt enabled"]
    UCTXIE_1,
}
impl UCTXIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIEW::UCTXIE_0 => false,
            UCTXIEW::UCTXIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxie_0(self) -> &'a mut W {
        self.variant(UCTXIEW::UCTXIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxie_1(self) -> &'a mut W {
        self.variant(UCTXIEW::UCTXIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTTIE`"]
pub enum UCSTTIEW {
    #[doc = "Interrupt disabled"]
    UCSTTIE_0,
    #[doc = "Interrupt enabled"]
    UCSTTIE_1,
}
impl UCSTTIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTTIEW::UCSTTIE_0 => false,
            UCSTTIEW::UCSTTIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTTIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTTIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTTIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucsttie_0(self) -> &'a mut W {
        self.variant(UCSTTIEW::UCSTTIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucsttie_1(self) -> &'a mut W {
        self.variant(UCSTTIEW::UCSTTIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXCPTIE`"]
pub enum UCTXCPTIEW {
    #[doc = "Interrupt disabled"]
    UCTXCPTIE_0,
    #[doc = "Interrupt enabled"]
    UCTXCPTIE_1,
}
impl UCTXCPTIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXCPTIEW::UCTXCPTIE_0 => false,
            UCTXCPTIEW::UCTXCPTIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXCPTIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXCPTIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXCPTIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxcptie_0(self) -> &'a mut W {
        self.variant(UCTXCPTIEW::UCTXCPTIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxcptie_1(self) -> &'a mut W {
        self.variant(UCTXCPTIEW::UCTXCPTIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Receive interrupt enable"]
    #[inline]
    pub fn ucrxie(&self) -> UCRXIER {
        UCRXIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Transmit interrupt enable"]
    #[inline]
    pub fn uctxie(&self) -> UCTXIER {
        UCTXIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Start bit interrupt enable"]
    #[inline]
    pub fn ucsttie(&self) -> UCSTTIER {
        UCSTTIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Transmit complete interrupt enable"]
    #[inline]
    pub fn uctxcptie(&self) -> UCTXCPTIER {
        UCTXCPTIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Receive interrupt enable"]
    #[inline]
    pub fn ucrxie(&mut self) -> _UCRXIEW {
        _UCRXIEW { w: self }
    }
    #[doc = "Bit 1 - Transmit interrupt enable"]
    #[inline]
    pub fn uctxie(&mut self) -> _UCTXIEW {
        _UCTXIEW { w: self }
    }
    #[doc = "Bit 2 - Start bit interrupt enable"]
    #[inline]
    pub fn ucsttie(&mut self) -> _UCSTTIEW {
        _UCSTTIEW { w: self }
    }
    #[doc = "Bit 3 - Transmit complete interrupt enable"]
    #[inline]
    pub fn uctxcptie(&mut self) -> _UCTXCPTIEW {
        _UCTXCPTIEW { w: self }
    }
}
