#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXCTLW0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCSWRST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSWRSTR {
    #[doc = "Disabled. eUSCI_B reset released for operation"]
    UCSWRST_0,
    #[doc = "Enabled. eUSCI_B logic held in reset state"]
    UCSWRST_1,
}
impl UCSWRSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSWRSTR::UCSWRST_0 => false,
            UCSWRSTR::UCSWRST_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSWRSTR {
        match value {
            false => UCSWRSTR::UCSWRST_0,
            true => UCSWRSTR::UCSWRST_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSWRST_0`"]
    #[inline]
    pub fn is_ucswrst_0(&self) -> bool {
        *self == UCSWRSTR::UCSWRST_0
    }
    #[doc = "Checks if the value of the field is `UCSWRST_1`"]
    #[inline]
    pub fn is_ucswrst_1(&self) -> bool {
        *self == UCSWRSTR::UCSWRST_1
    }
}
#[doc = "Possible values of the field `UCTXSTT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXSTTR {
    #[doc = "Do not generate START condition"]
    UCTXSTT_0,
    #[doc = "Generate START condition"]
    UCTXSTT_1,
}
impl UCTXSTTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXSTTR::UCTXSTT_0 => false,
            UCTXSTTR::UCTXSTT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXSTTR {
        match value {
            false => UCTXSTTR::UCTXSTT_0,
            true => UCTXSTTR::UCTXSTT_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXSTT_0`"]
    #[inline]
    pub fn is_uctxstt_0(&self) -> bool {
        *self == UCTXSTTR::UCTXSTT_0
    }
    #[doc = "Checks if the value of the field is `UCTXSTT_1`"]
    #[inline]
    pub fn is_uctxstt_1(&self) -> bool {
        *self == UCTXSTTR::UCTXSTT_1
    }
}
#[doc = "Possible values of the field `UCTXSTP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXSTPR {
    #[doc = "No STOP generated"]
    UCTXSTP_0,
    #[doc = "Generate STOP"]
    UCTXSTP_1,
}
impl UCTXSTPR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXSTPR::UCTXSTP_0 => false,
            UCTXSTPR::UCTXSTP_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXSTPR {
        match value {
            false => UCTXSTPR::UCTXSTP_0,
            true => UCTXSTPR::UCTXSTP_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXSTP_0`"]
    #[inline]
    pub fn is_uctxstp_0(&self) -> bool {
        *self == UCTXSTPR::UCTXSTP_0
    }
    #[doc = "Checks if the value of the field is `UCTXSTP_1`"]
    #[inline]
    pub fn is_uctxstp_1(&self) -> bool {
        *self == UCTXSTPR::UCTXSTP_1
    }
}
#[doc = "Possible values of the field `UCTXNACK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXNACKR {
    #[doc = "Acknowledge normally"]
    UCTXNACK_0,
    #[doc = "Generate NACK"]
    UCTXNACK_1,
}
impl UCTXNACKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXNACKR::UCTXNACK_0 => false,
            UCTXNACKR::UCTXNACK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXNACKR {
        match value {
            false => UCTXNACKR::UCTXNACK_0,
            true => UCTXNACKR::UCTXNACK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXNACK_0`"]
    #[inline]
    pub fn is_uctxnack_0(&self) -> bool {
        *self == UCTXNACKR::UCTXNACK_0
    }
    #[doc = "Checks if the value of the field is `UCTXNACK_1`"]
    #[inline]
    pub fn is_uctxnack_1(&self) -> bool {
        *self == UCTXNACKR::UCTXNACK_1
    }
}
#[doc = "Possible values of the field `UCTR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTRR {
    #[doc = "Receiver"]
    UCTR_0,
    #[doc = "Transmitter"]
    UCTR_1,
}
impl UCTRR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTRR::UCTR_0 => false,
            UCTRR::UCTR_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTRR {
        match value {
            false => UCTRR::UCTR_0,
            true => UCTRR::UCTR_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTR_0`"]
    #[inline]
    pub fn is_uctr_0(&self) -> bool {
        *self == UCTRR::UCTR_0
    }
    #[doc = "Checks if the value of the field is `UCTR_1`"]
    #[inline]
    pub fn is_uctr_1(&self) -> bool {
        *self == UCTRR::UCTR_1
    }
}
#[doc = "Possible values of the field `UCTXACK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXACKR {
    #[doc = "Do not acknowledge the slave address"]
    UCTXACK_0,
    #[doc = "Acknowledge the slave address"]
    UCTXACK_1,
}
impl UCTXACKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXACKR::UCTXACK_0 => false,
            UCTXACKR::UCTXACK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXACKR {
        match value {
            false => UCTXACKR::UCTXACK_0,
            true => UCTXACKR::UCTXACK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXACK_0`"]
    #[inline]
    pub fn is_uctxack_0(&self) -> bool {
        *self == UCTXACKR::UCTXACK_0
    }
    #[doc = "Checks if the value of the field is `UCTXACK_1`"]
    #[inline]
    pub fn is_uctxack_1(&self) -> bool {
        *self == UCTXACKR::UCTXACK_1
    }
}
#[doc = "Possible values of the field `UCSSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSSELR {
    #[doc = "UCLKI"]
    UCSSEL_0,
    #[doc = "ACLK"]
    UCSSEL_1,
    #[doc = "SMCLK"]
    UCSSEL_2,
    #[doc = "SMCLK"]
    UCSSEL_3,
}
impl UCSSELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCSSELR::UCSSEL_0 => 0,
            UCSSELR::UCSSEL_1 => 1,
            UCSSELR::UCSSEL_2 => 2,
            UCSSELR::UCSSEL_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCSSELR {
        match value {
            0 => UCSSELR::UCSSEL_0,
            1 => UCSSELR::UCSSEL_1,
            2 => UCSSELR::UCSSEL_2,
            3 => UCSSELR::UCSSEL_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCSSEL_0`"]
    #[inline]
    pub fn is_ucssel_0(&self) -> bool {
        *self == UCSSELR::UCSSEL_0
    }
    #[doc = "Checks if the value of the field is `UCSSEL_1`"]
    #[inline]
    pub fn is_ucssel_1(&self) -> bool {
        *self == UCSSELR::UCSSEL_1
    }
    #[doc = "Checks if the value of the field is `UCSSEL_2`"]
    #[inline]
    pub fn is_ucssel_2(&self) -> bool {
        *self == UCSSELR::UCSSEL_2
    }
    #[doc = "Checks if the value of the field is `UCSSEL_3`"]
    #[inline]
    pub fn is_ucssel_3(&self) -> bool {
        *self == UCSSELR::UCSSEL_3
    }
}
#[doc = "Possible values of the field `UCSYNC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSYNCR {
    #[doc = "Asynchronous mode"]
    UCSYNC_0,
    #[doc = "Synchronous mode"]
    UCSYNC_1,
}
impl UCSYNCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSYNCR::UCSYNC_0 => false,
            UCSYNCR::UCSYNC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSYNCR {
        match value {
            false => UCSYNCR::UCSYNC_0,
            true => UCSYNCR::UCSYNC_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSYNC_0`"]
    #[inline]
    pub fn is_ucsync_0(&self) -> bool {
        *self == UCSYNCR::UCSYNC_0
    }
    #[doc = "Checks if the value of the field is `UCSYNC_1`"]
    #[inline]
    pub fn is_ucsync_1(&self) -> bool {
        *self == UCSYNCR::UCSYNC_1
    }
}
#[doc = "Possible values of the field `UCMODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCMODER {
    #[doc = "3-pin SPI"]
    UCMODE_0,
    #[doc = "4-pin SPI (master or slave enabled if STE = 1)"]
    UCMODE_1,
    #[doc = "4-pin SPI (master or slave enabled if STE = 0)"]
    UCMODE_2,
    #[doc = "I2C mode"]
    UCMODE_3,
}
impl UCMODER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCMODER::UCMODE_0 => 0,
            UCMODER::UCMODE_1 => 1,
            UCMODER::UCMODE_2 => 2,
            UCMODER::UCMODE_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCMODER {
        match value {
            0 => UCMODER::UCMODE_0,
            1 => UCMODER::UCMODE_1,
            2 => UCMODER::UCMODE_2,
            3 => UCMODER::UCMODE_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCMODE_0`"]
    #[inline]
    pub fn is_ucmode_0(&self) -> bool {
        *self == UCMODER::UCMODE_0
    }
    #[doc = "Checks if the value of the field is `UCMODE_1`"]
    #[inline]
    pub fn is_ucmode_1(&self) -> bool {
        *self == UCMODER::UCMODE_1
    }
    #[doc = "Checks if the value of the field is `UCMODE_2`"]
    #[inline]
    pub fn is_ucmode_2(&self) -> bool {
        *self == UCMODER::UCMODE_2
    }
    #[doc = "Checks if the value of the field is `UCMODE_3`"]
    #[inline]
    pub fn is_ucmode_3(&self) -> bool {
        *self == UCMODER::UCMODE_3
    }
}
#[doc = "Possible values of the field `UCMST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCMSTR {
    #[doc = "Slave mode"]
    UCMST_0,
    #[doc = "Master mode"]
    UCMST_1,
}
impl UCMSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCMSTR::UCMST_0 => false,
            UCMSTR::UCMST_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCMSTR {
        match value {
            false => UCMSTR::UCMST_0,
            true => UCMSTR::UCMST_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCMST_0`"]
    #[inline]
    pub fn is_ucmst_0(&self) -> bool {
        *self == UCMSTR::UCMST_0
    }
    #[doc = "Checks if the value of the field is `UCMST_1`"]
    #[inline]
    pub fn is_ucmst_1(&self) -> bool {
        *self == UCMSTR::UCMST_1
    }
}
#[doc = "Possible values of the field `UCMM`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCMMR {
    #[doc = "Single master environment. There is no other master in the system. The address compare unit is disabled."]
    UCMM_0,
    #[doc = "Multi-master environment"]
    UCMM_1,
}
impl UCMMR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCMMR::UCMM_0 => false,
            UCMMR::UCMM_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCMMR {
        match value {
            false => UCMMR::UCMM_0,
            true => UCMMR::UCMM_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCMM_0`"]
    #[inline]
    pub fn is_ucmm_0(&self) -> bool {
        *self == UCMMR::UCMM_0
    }
    #[doc = "Checks if the value of the field is `UCMM_1`"]
    #[inline]
    pub fn is_ucmm_1(&self) -> bool {
        *self == UCMMR::UCMM_1
    }
}
#[doc = "Possible values of the field `UCSLA10`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSLA10R {
    #[doc = "Address slave with 7-bit address"]
    UCSLA10_0,
    #[doc = "Address slave with 10-bit address"]
    UCSLA10_1,
}
impl UCSLA10R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSLA10R::UCSLA10_0 => false,
            UCSLA10R::UCSLA10_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSLA10R {
        match value {
            false => UCSLA10R::UCSLA10_0,
            true => UCSLA10R::UCSLA10_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSLA10_0`"]
    #[inline]
    pub fn is_ucsla10_0(&self) -> bool {
        *self == UCSLA10R::UCSLA10_0
    }
    #[doc = "Checks if the value of the field is `UCSLA10_1`"]
    #[inline]
    pub fn is_ucsla10_1(&self) -> bool {
        *self == UCSLA10R::UCSLA10_1
    }
}
#[doc = "Possible values of the field `UCA10`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCA10R {
    #[doc = "Own address is a 7-bit address"]
    UCA10_0,
    #[doc = "Own address is a 10-bit address"]
    UCA10_1,
}
impl UCA10R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCA10R::UCA10_0 => false,
            UCA10R::UCA10_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCA10R {
        match value {
            false => UCA10R::UCA10_0,
            true => UCA10R::UCA10_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCA10_0`"]
    #[inline]
    pub fn is_uca10_0(&self) -> bool {
        *self == UCA10R::UCA10_0
    }
    #[doc = "Checks if the value of the field is `UCA10_1`"]
    #[inline]
    pub fn is_uca10_1(&self) -> bool {
        *self == UCA10R::UCA10_1
    }
}
#[doc = "Values that can be written to the field `UCSWRST`"]
pub enum UCSWRSTW {
    #[doc = "Disabled. eUSCI_B reset released for operation"]
    UCSWRST_0,
    #[doc = "Enabled. eUSCI_B logic held in reset state"]
    UCSWRST_1,
}
impl UCSWRSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSWRSTW::UCSWRST_0 => false,
            UCSWRSTW::UCSWRST_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSWRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSWRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSWRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled. eUSCI_B reset released for operation"]
    #[inline]
    pub fn ucswrst_0(self) -> &'a mut W {
        self.variant(UCSWRSTW::UCSWRST_0)
    }
    #[doc = "Enabled. eUSCI_B logic held in reset state"]
    #[inline]
    pub fn ucswrst_1(self) -> &'a mut W {
        self.variant(UCSWRSTW::UCSWRST_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXSTT`"]
pub enum UCTXSTTW {
    #[doc = "Do not generate START condition"]
    UCTXSTT_0,
    #[doc = "Generate START condition"]
    UCTXSTT_1,
}
impl UCTXSTTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXSTTW::UCTXSTT_0 => false,
            UCTXSTTW::UCTXSTT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXSTTW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXSTTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXSTTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Do not generate START condition"]
    #[inline]
    pub fn uctxstt_0(self) -> &'a mut W {
        self.variant(UCTXSTTW::UCTXSTT_0)
    }
    #[doc = "Generate START condition"]
    #[inline]
    pub fn uctxstt_1(self) -> &'a mut W {
        self.variant(UCTXSTTW::UCTXSTT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXSTP`"]
pub enum UCTXSTPW {
    #[doc = "No STOP generated"]
    UCTXSTP_0,
    #[doc = "Generate STOP"]
    UCTXSTP_1,
}
impl UCTXSTPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXSTPW::UCTXSTP_0 => false,
            UCTXSTPW::UCTXSTP_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXSTPW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXSTPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXSTPW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No STOP generated"]
    #[inline]
    pub fn uctxstp_0(self) -> &'a mut W {
        self.variant(UCTXSTPW::UCTXSTP_0)
    }
    #[doc = "Generate STOP"]
    #[inline]
    pub fn uctxstp_1(self) -> &'a mut W {
        self.variant(UCTXSTPW::UCTXSTP_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXNACK`"]
pub enum UCTXNACKW {
    #[doc = "Acknowledge normally"]
    UCTXNACK_0,
    #[doc = "Generate NACK"]
    UCTXNACK_1,
}
impl UCTXNACKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXNACKW::UCTXNACK_0 => false,
            UCTXNACKW::UCTXNACK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXNACKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXNACKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXNACKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Acknowledge normally"]
    #[inline]
    pub fn uctxnack_0(self) -> &'a mut W {
        self.variant(UCTXNACKW::UCTXNACK_0)
    }
    #[doc = "Generate NACK"]
    #[inline]
    pub fn uctxnack_1(self) -> &'a mut W {
        self.variant(UCTXNACKW::UCTXNACK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTR`"]
pub enum UCTRW {
    #[doc = "Receiver"]
    UCTR_0,
    #[doc = "Transmitter"]
    UCTR_1,
}
impl UCTRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTRW::UCTR_0 => false,
            UCTRW::UCTR_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTRW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTRW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Receiver"]
    #[inline]
    pub fn uctr_0(self) -> &'a mut W {
        self.variant(UCTRW::UCTR_0)
    }
    #[doc = "Transmitter"]
    #[inline]
    pub fn uctr_1(self) -> &'a mut W {
        self.variant(UCTRW::UCTR_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXACK`"]
pub enum UCTXACKW {
    #[doc = "Do not acknowledge the slave address"]
    UCTXACK_0,
    #[doc = "Acknowledge the slave address"]
    UCTXACK_1,
}
impl UCTXACKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXACKW::UCTXACK_0 => false,
            UCTXACKW::UCTXACK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXACKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXACKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXACKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Do not acknowledge the slave address"]
    #[inline]
    pub fn uctxack_0(self) -> &'a mut W {
        self.variant(UCTXACKW::UCTXACK_0)
    }
    #[doc = "Acknowledge the slave address"]
    #[inline]
    pub fn uctxack_1(self) -> &'a mut W {
        self.variant(UCTXACKW::UCTXACK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSSEL`"]
pub enum UCSSELW {
    #[doc = "UCLKI"]
    UCSSEL_0,
    #[doc = "ACLK"]
    UCSSEL_1,
    #[doc = "SMCLK"]
    UCSSEL_2,
    #[doc = "SMCLK"]
    UCSSEL_3,
}
impl UCSSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCSSELW::UCSSEL_0 => 0,
            UCSSELW::UCSSEL_1 => 1,
            UCSSELW::UCSSEL_2 => 2,
            UCSSELW::UCSSEL_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSSELW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSSELW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "UCLKI"]
    #[inline]
    pub fn ucssel_0(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_0)
    }
    #[doc = "ACLK"]
    #[inline]
    pub fn ucssel_1(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_1)
    }
    #[doc = "SMCLK"]
    #[inline]
    pub fn ucssel_2(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_2)
    }
    #[doc = "SMCLK"]
    #[inline]
    pub fn ucssel_3(self) -> &'a mut W {
        self.variant(UCSSELW::UCSSEL_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSYNC`"]
pub enum UCSYNCW {
    #[doc = "Asynchronous mode"]
    UCSYNC_0,
    #[doc = "Synchronous mode"]
    UCSYNC_1,
}
impl UCSYNCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSYNCW::UCSYNC_0 => false,
            UCSYNCW::UCSYNC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSYNCW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSYNCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSYNCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Asynchronous mode"]
    #[inline]
    pub fn ucsync_0(self) -> &'a mut W {
        self.variant(UCSYNCW::UCSYNC_0)
    }
    #[doc = "Synchronous mode"]
    #[inline]
    pub fn ucsync_1(self) -> &'a mut W {
        self.variant(UCSYNCW::UCSYNC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCMODE`"]
pub enum UCMODEW {
    #[doc = "3-pin SPI"]
    UCMODE_0,
    #[doc = "4-pin SPI (master or slave enabled if STE = 1)"]
    UCMODE_1,
    #[doc = "4-pin SPI (master or slave enabled if STE = 0)"]
    UCMODE_2,
    #[doc = "I2C mode"]
    UCMODE_3,
}
impl UCMODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCMODEW::UCMODE_0 => 0,
            UCMODEW::UCMODE_1 => 1,
            UCMODEW::UCMODE_2 => 2,
            UCMODEW::UCMODE_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCMODEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCMODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCMODEW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3-pin SPI"]
    #[inline]
    pub fn ucmode_0(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_0)
    }
    #[doc = "4-pin SPI (master or slave enabled if STE = 1)"]
    #[inline]
    pub fn ucmode_1(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_1)
    }
    #[doc = "4-pin SPI (master or slave enabled if STE = 0)"]
    #[inline]
    pub fn ucmode_2(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_2)
    }
    #[doc = "I2C mode"]
    #[inline]
    pub fn ucmode_3(self) -> &'a mut W {
        self.variant(UCMODEW::UCMODE_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCMST`"]
pub enum UCMSTW {
    #[doc = "Slave mode"]
    UCMST_0,
    #[doc = "Master mode"]
    UCMST_1,
}
impl UCMSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCMSTW::UCMST_0 => false,
            UCMSTW::UCMST_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCMSTW<'a> {
    w: &'a mut W,
}
impl<'a> _UCMSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCMSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Slave mode"]
    #[inline]
    pub fn ucmst_0(self) -> &'a mut W {
        self.variant(UCMSTW::UCMST_0)
    }
    #[doc = "Master mode"]
    #[inline]
    pub fn ucmst_1(self) -> &'a mut W {
        self.variant(UCMSTW::UCMST_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCMM`"]
pub enum UCMMW {
    #[doc = "Single master environment. There is no other master in the system. The address compare unit is disabled."]
    UCMM_0,
    #[doc = "Multi-master environment"]
    UCMM_1,
}
impl UCMMW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCMMW::UCMM_0 => false,
            UCMMW::UCMM_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCMMW<'a> {
    w: &'a mut W,
}
impl<'a> _UCMMW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCMMW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Single master environment. There is no other master in the system. The address compare unit is disabled."]
    #[inline]
    pub fn ucmm_0(self) -> &'a mut W {
        self.variant(UCMMW::UCMM_0)
    }
    #[doc = "Multi-master environment"]
    #[inline]
    pub fn ucmm_1(self) -> &'a mut W {
        self.variant(UCMMW::UCMM_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSLA10`"]
pub enum UCSLA10W {
    #[doc = "Address slave with 7-bit address"]
    UCSLA10_0,
    #[doc = "Address slave with 10-bit address"]
    UCSLA10_1,
}
impl UCSLA10W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSLA10W::UCSLA10_0 => false,
            UCSLA10W::UCSLA10_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSLA10W<'a> {
    w: &'a mut W,
}
impl<'a> _UCSLA10W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSLA10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Address slave with 7-bit address"]
    #[inline]
    pub fn ucsla10_0(self) -> &'a mut W {
        self.variant(UCSLA10W::UCSLA10_0)
    }
    #[doc = "Address slave with 10-bit address"]
    #[inline]
    pub fn ucsla10_1(self) -> &'a mut W {
        self.variant(UCSLA10W::UCSLA10_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCA10`"]
pub enum UCA10W {
    #[doc = "Own address is a 7-bit address"]
    UCA10_0,
    #[doc = "Own address is a 10-bit address"]
    UCA10_1,
}
impl UCA10W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCA10W::UCA10_0 => false,
            UCA10W::UCA10_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCA10W<'a> {
    w: &'a mut W,
}
impl<'a> _UCA10W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCA10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Own address is a 7-bit address"]
    #[inline]
    pub fn uca10_0(self) -> &'a mut W {
        self.variant(UCA10W::UCA10_0)
    }
    #[doc = "Own address is a 10-bit address"]
    #[inline]
    pub fn uca10_1(self) -> &'a mut W {
        self.variant(UCA10W::UCA10_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Software reset enable"]
    #[inline]
    pub fn ucswrst(&self) -> UCSWRSTR {
        UCSWRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Transmit START condition in master mode"]
    #[inline]
    pub fn uctxstt(&self) -> UCTXSTTR {
        UCTXSTTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Transmit STOP condition in master mode"]
    #[inline]
    pub fn uctxstp(&self) -> UCTXSTPR {
        UCTXSTPR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Transmit a NACK"]
    #[inline]
    pub fn uctxnack(&self) -> UCTXNACKR {
        UCTXNACKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Transmitter/receiver"]
    #[inline]
    pub fn uctr(&self) -> UCTRR {
        UCTRR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Transmit ACK condition in slave mode"]
    #[inline]
    pub fn uctxack(&self) -> UCTXACKR {
        UCTXACKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 6:7 - eUSCI_B clock source select"]
    #[inline]
    pub fn ucssel(&self) -> UCSSELR {
        UCSSELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 8 - Synchronous mode enable"]
    #[inline]
    pub fn ucsync(&self) -> UCSYNCR {
        UCSYNCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 9:10 - eUSCI_B mode"]
    #[inline]
    pub fn ucmode(&self) -> UCMODER {
        UCMODER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 11 - Master mode select"]
    #[inline]
    pub fn ucmst(&self) -> UCMSTR {
        UCMSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - Multi-master environment select"]
    #[inline]
    pub fn ucmm(&self) -> UCMMR {
        UCMMR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Slave addressing mode select"]
    #[inline]
    pub fn ucsla10(&self) -> UCSLA10R {
        UCSLA10R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 15 - Own addressing mode select"]
    #[inline]
    pub fn uca10(&self) -> UCA10R {
        UCA10R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 449 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Software reset enable"]
    #[inline]
    pub fn ucswrst(&mut self) -> _UCSWRSTW {
        _UCSWRSTW { w: self }
    }
    #[doc = "Bit 1 - Transmit START condition in master mode"]
    #[inline]
    pub fn uctxstt(&mut self) -> _UCTXSTTW {
        _UCTXSTTW { w: self }
    }
    #[doc = "Bit 2 - Transmit STOP condition in master mode"]
    #[inline]
    pub fn uctxstp(&mut self) -> _UCTXSTPW {
        _UCTXSTPW { w: self }
    }
    #[doc = "Bit 3 - Transmit a NACK"]
    #[inline]
    pub fn uctxnack(&mut self) -> _UCTXNACKW {
        _UCTXNACKW { w: self }
    }
    #[doc = "Bit 4 - Transmitter/receiver"]
    #[inline]
    pub fn uctr(&mut self) -> _UCTRW {
        _UCTRW { w: self }
    }
    #[doc = "Bit 5 - Transmit ACK condition in slave mode"]
    #[inline]
    pub fn uctxack(&mut self) -> _UCTXACKW {
        _UCTXACKW { w: self }
    }
    #[doc = "Bits 6:7 - eUSCI_B clock source select"]
    #[inline]
    pub fn ucssel(&mut self) -> _UCSSELW {
        _UCSSELW { w: self }
    }
    #[doc = "Bit 8 - Synchronous mode enable"]
    #[inline]
    pub fn ucsync(&mut self) -> _UCSYNCW {
        _UCSYNCW { w: self }
    }
    #[doc = "Bits 9:10 - eUSCI_B mode"]
    #[inline]
    pub fn ucmode(&mut self) -> _UCMODEW {
        _UCMODEW { w: self }
    }
    #[doc = "Bit 11 - Master mode select"]
    #[inline]
    pub fn ucmst(&mut self) -> _UCMSTW {
        _UCMSTW { w: self }
    }
    #[doc = "Bit 13 - Multi-master environment select"]
    #[inline]
    pub fn ucmm(&mut self) -> _UCMMW {
        _UCMMW { w: self }
    }
    #[doc = "Bit 14 - Slave addressing mode select"]
    #[inline]
    pub fn ucsla10(&mut self) -> _UCSLA10W {
        _UCSLA10W { w: self }
    }
    #[doc = "Bit 15 - Own addressing mode select"]
    #[inline]
    pub fn uca10(&mut self) -> _UCA10W {
        _UCA10W { w: self }
    }
}
