#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXI2COA3 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct I2COA3R {
    bits: u16,
}
impl I2COA3R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = "Possible values of the field `UCOAEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCOAENR {
    #[doc = "The slave address defined in I2COA3 is disabled"]
    UCOAEN_0,
    #[doc = "The slave address defined in I2COA3 is enabled"]
    UCOAEN_1,
}
impl UCOAENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCOAENR::UCOAEN_0 => false,
            UCOAENR::UCOAEN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCOAENR {
        match value {
            false => UCOAENR::UCOAEN_0,
            true => UCOAENR::UCOAEN_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCOAEN_0`"]
    #[inline]
    pub fn is_ucoaen_0(&self) -> bool {
        *self == UCOAENR::UCOAEN_0
    }
    #[doc = "Checks if the value of the field is `UCOAEN_1`"]
    #[inline]
    pub fn is_ucoaen_1(&self) -> bool {
        *self == UCOAENR::UCOAEN_1
    }
}
#[doc = r" Proxy"]
pub struct _I2COA3W<'a> {
    w: &'a mut W,
}
impl<'a> _I2COA3W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 1023;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCOAEN`"]
pub enum UCOAENW {
    #[doc = "The slave address defined in I2COA3 is disabled"]
    UCOAEN_0,
    #[doc = "The slave address defined in I2COA3 is enabled"]
    UCOAEN_1,
}
impl UCOAENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCOAENW::UCOAEN_0 => false,
            UCOAENW::UCOAEN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCOAENW<'a> {
    w: &'a mut W,
}
impl<'a> _UCOAENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCOAENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The slave address defined in I2COA3 is disabled"]
    #[inline]
    pub fn ucoaen_0(self) -> &'a mut W {
        self.variant(UCOAENW::UCOAEN_0)
    }
    #[doc = "The slave address defined in I2COA3 is enabled"]
    #[inline]
    pub fn ucoaen_1(self) -> &'a mut W {
        self.variant(UCOAENW::UCOAEN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:9 - I2C own address"]
    #[inline]
    pub fn i2coa3(&self) -> I2COA3R {
        let bits = {
            const MASK: u16 = 1023;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        };
        I2COA3R { bits }
    }
    #[doc = "Bit 10 - Own Address enable register"]
    #[inline]
    pub fn ucoaen(&self) -> UCOAENR {
        UCOAENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:9 - I2C own address"]
    #[inline]
    pub fn i2coa3(&mut self) -> _I2COA3W {
        _I2COA3W { w: self }
    }
    #[doc = "Bit 10 - Own Address enable register"]
    #[inline]
    pub fn ucoaen(&mut self) -> _UCOAENW {
        _UCOAENW { w: self }
    }
}
