#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXCTLW1 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCGLIT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCGLITR {
    #[doc = "50 ns"]
    UCGLIT_0,
    #[doc = "25 ns"]
    UCGLIT_1,
    #[doc = "12.5 ns"]
    UCGLIT_2,
    #[doc = "6.25 ns"]
    UCGLIT_3,
}
impl UCGLITR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCGLITR::UCGLIT_0 => 0,
            UCGLITR::UCGLIT_1 => 1,
            UCGLITR::UCGLIT_2 => 2,
            UCGLITR::UCGLIT_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCGLITR {
        match value {
            0 => UCGLITR::UCGLIT_0,
            1 => UCGLITR::UCGLIT_1,
            2 => UCGLITR::UCGLIT_2,
            3 => UCGLITR::UCGLIT_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCGLIT_0`"]
    #[inline]
    pub fn is_ucglit_0(&self) -> bool {
        *self == UCGLITR::UCGLIT_0
    }
    #[doc = "Checks if the value of the field is `UCGLIT_1`"]
    #[inline]
    pub fn is_ucglit_1(&self) -> bool {
        *self == UCGLITR::UCGLIT_1
    }
    #[doc = "Checks if the value of the field is `UCGLIT_2`"]
    #[inline]
    pub fn is_ucglit_2(&self) -> bool {
        *self == UCGLITR::UCGLIT_2
    }
    #[doc = "Checks if the value of the field is `UCGLIT_3`"]
    #[inline]
    pub fn is_ucglit_3(&self) -> bool {
        *self == UCGLITR::UCGLIT_3
    }
}
#[doc = "Possible values of the field `UCASTP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCASTPR {
    #[doc = "No automatic STOP generation. The STOP condition is generated after the user sets the UCTXSTP bit. The value in UCBxTBCNT is a don't care."]
    UCASTP_0,
    #[doc = "UCBCNTIFG is set with the byte counter reaches the threshold defined in UCBxTBCNT"]
    UCASTP_1,
    #[doc = "A STOP condition is generated automatically after the byte counter value reached UCBxTBCNT. UCBCNTIFG is set with the byte counter reaching the threshold"]
    UCASTP_2,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl UCASTPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCASTPR::UCASTP_0 => 0,
            UCASTPR::UCASTP_1 => 1,
            UCASTPR::UCASTP_2 => 2,
            UCASTPR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCASTPR {
        match value {
            0 => UCASTPR::UCASTP_0,
            1 => UCASTPR::UCASTP_1,
            2 => UCASTPR::UCASTP_2,
            i => UCASTPR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `UCASTP_0`"]
    #[inline]
    pub fn is_ucastp_0(&self) -> bool {
        *self == UCASTPR::UCASTP_0
    }
    #[doc = "Checks if the value of the field is `UCASTP_1`"]
    #[inline]
    pub fn is_ucastp_1(&self) -> bool {
        *self == UCASTPR::UCASTP_1
    }
    #[doc = "Checks if the value of the field is `UCASTP_2`"]
    #[inline]
    pub fn is_ucastp_2(&self) -> bool {
        *self == UCASTPR::UCASTP_2
    }
}
#[doc = "Possible values of the field `UCSWACK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSWACKR {
    #[doc = "The address acknowledge of the slave is controlled by the eUSCI_B module"]
    UCSWACK_0,
    #[doc = "The user needs to trigger the sending of the address ACK by issuing UCTXACK"]
    UCSWACK_1,
}
impl UCSWACKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSWACKR::UCSWACK_0 => false,
            UCSWACKR::UCSWACK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSWACKR {
        match value {
            false => UCSWACKR::UCSWACK_0,
            true => UCSWACKR::UCSWACK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSWACK_0`"]
    #[inline]
    pub fn is_ucswack_0(&self) -> bool {
        *self == UCSWACKR::UCSWACK_0
    }
    #[doc = "Checks if the value of the field is `UCSWACK_1`"]
    #[inline]
    pub fn is_ucswack_1(&self) -> bool {
        *self == UCSWACKR::UCSWACK_1
    }
}
#[doc = "Possible values of the field `UCSTPNACK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTPNACKR {
    #[doc = "Send a non-acknowledge before the STOP condition as a master receiver (conform to I2C standard)"]
    UCSTPNACK_0,
    #[doc = "All bytes are acknowledged by the eUSCI_B when configured as master receiver"]
    UCSTPNACK_1,
}
impl UCSTPNACKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTPNACKR::UCSTPNACK_0 => false,
            UCSTPNACKR::UCSTPNACK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTPNACKR {
        match value {
            false => UCSTPNACKR::UCSTPNACK_0,
            true => UCSTPNACKR::UCSTPNACK_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTPNACK_0`"]
    #[inline]
    pub fn is_ucstpnack_0(&self) -> bool {
        *self == UCSTPNACKR::UCSTPNACK_0
    }
    #[doc = "Checks if the value of the field is `UCSTPNACK_1`"]
    #[inline]
    pub fn is_ucstpnack_1(&self) -> bool {
        *self == UCSTPNACKR::UCSTPNACK_1
    }
}
#[doc = "Possible values of the field `UCCLTO`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCCLTOR {
    #[doc = "Disable clock low timeout counter"]
    UCCLTO_0,
    #[doc = "135 000 SYSCLK cycles (approximately 28 ms)"]
    UCCLTO_1,
    #[doc = "150 000 SYSCLK cycles (approximately 31 ms)"]
    UCCLTO_2,
    #[doc = "165 000 SYSCLK cycles (approximately 34 ms)"]
    UCCLTO_3,
}
impl UCCLTOR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            UCCLTOR::UCCLTO_0 => 0,
            UCCLTOR::UCCLTO_1 => 1,
            UCCLTOR::UCCLTO_2 => 2,
            UCCLTOR::UCCLTO_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> UCCLTOR {
        match value {
            0 => UCCLTOR::UCCLTO_0,
            1 => UCCLTOR::UCCLTO_1,
            2 => UCCLTOR::UCCLTO_2,
            3 => UCCLTOR::UCCLTO_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `UCCLTO_0`"]
    #[inline]
    pub fn is_ucclto_0(&self) -> bool {
        *self == UCCLTOR::UCCLTO_0
    }
    #[doc = "Checks if the value of the field is `UCCLTO_1`"]
    #[inline]
    pub fn is_ucclto_1(&self) -> bool {
        *self == UCCLTOR::UCCLTO_1
    }
    #[doc = "Checks if the value of the field is `UCCLTO_2`"]
    #[inline]
    pub fn is_ucclto_2(&self) -> bool {
        *self == UCCLTOR::UCCLTO_2
    }
    #[doc = "Checks if the value of the field is `UCCLTO_3`"]
    #[inline]
    pub fn is_ucclto_3(&self) -> bool {
        *self == UCCLTOR::UCCLTO_3
    }
}
#[doc = "Possible values of the field `UCETXINT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCETXINTR {
    #[doc = "UCTXIFGx is set after an address match with UCxI2COAx and the direction bit indicating slave transmit"]
    UCETXINT_0,
    #[doc = "UCTXIFG0 is set for each START condition"]
    UCETXINT_1,
}
impl UCETXINTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCETXINTR::UCETXINT_0 => false,
            UCETXINTR::UCETXINT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCETXINTR {
        match value {
            false => UCETXINTR::UCETXINT_0,
            true => UCETXINTR::UCETXINT_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCETXINT_0`"]
    #[inline]
    pub fn is_ucetxint_0(&self) -> bool {
        *self == UCETXINTR::UCETXINT_0
    }
    #[doc = "Checks if the value of the field is `UCETXINT_1`"]
    #[inline]
    pub fn is_ucetxint_1(&self) -> bool {
        *self == UCETXINTR::UCETXINT_1
    }
}
#[doc = "Values that can be written to the field `UCGLIT`"]
pub enum UCGLITW {
    #[doc = "50 ns"]
    UCGLIT_0,
    #[doc = "25 ns"]
    UCGLIT_1,
    #[doc = "12.5 ns"]
    UCGLIT_2,
    #[doc = "6.25 ns"]
    UCGLIT_3,
}
impl UCGLITW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCGLITW::UCGLIT_0 => 0,
            UCGLITW::UCGLIT_1 => 1,
            UCGLITW::UCGLIT_2 => 2,
            UCGLITW::UCGLIT_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCGLITW<'a> {
    w: &'a mut W,
}
impl<'a> _UCGLITW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCGLITW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "50 ns"]
    #[inline]
    pub fn ucglit_0(self) -> &'a mut W {
        self.variant(UCGLITW::UCGLIT_0)
    }
    #[doc = "25 ns"]
    #[inline]
    pub fn ucglit_1(self) -> &'a mut W {
        self.variant(UCGLITW::UCGLIT_1)
    }
    #[doc = "12.5 ns"]
    #[inline]
    pub fn ucglit_2(self) -> &'a mut W {
        self.variant(UCGLITW::UCGLIT_2)
    }
    #[doc = "6.25 ns"]
    #[inline]
    pub fn ucglit_3(self) -> &'a mut W {
        self.variant(UCGLITW::UCGLIT_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCASTP`"]
pub enum UCASTPW {
    #[doc = "No automatic STOP generation. The STOP condition is generated after the user sets the UCTXSTP bit. The value in UCBxTBCNT is a don't care."]
    UCASTP_0,
    #[doc = "UCBCNTIFG is set with the byte counter reaches the threshold defined in UCBxTBCNT"]
    UCASTP_1,
    #[doc = "A STOP condition is generated automatically after the byte counter value reached UCBxTBCNT. UCBCNTIFG is set with the byte counter reaching the threshold"]
    UCASTP_2,
}
impl UCASTPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCASTPW::UCASTP_0 => 0,
            UCASTPW::UCASTP_1 => 1,
            UCASTPW::UCASTP_2 => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCASTPW<'a> {
    w: &'a mut W,
}
impl<'a> _UCASTPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCASTPW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No automatic STOP generation. The STOP condition is generated after the user sets the UCTXSTP bit. The value in UCBxTBCNT is a don't care."]
    #[inline]
    pub fn ucastp_0(self) -> &'a mut W {
        self.variant(UCASTPW::UCASTP_0)
    }
    #[doc = "UCBCNTIFG is set with the byte counter reaches the threshold defined in UCBxTBCNT"]
    #[inline]
    pub fn ucastp_1(self) -> &'a mut W {
        self.variant(UCASTPW::UCASTP_1)
    }
    #[doc = "A STOP condition is generated automatically after the byte counter value reached UCBxTBCNT. UCBCNTIFG is set with the byte counter reaching the threshold"]
    #[inline]
    pub fn ucastp_2(self) -> &'a mut W {
        self.variant(UCASTPW::UCASTP_2)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSWACK`"]
pub enum UCSWACKW {
    #[doc = "The address acknowledge of the slave is controlled by the eUSCI_B module"]
    UCSWACK_0,
    #[doc = "The user needs to trigger the sending of the address ACK by issuing UCTXACK"]
    UCSWACK_1,
}
impl UCSWACKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSWACKW::UCSWACK_0 => false,
            UCSWACKW::UCSWACK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSWACKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSWACKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSWACKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The address acknowledge of the slave is controlled by the eUSCI_B module"]
    #[inline]
    pub fn ucswack_0(self) -> &'a mut W {
        self.variant(UCSWACKW::UCSWACK_0)
    }
    #[doc = "The user needs to trigger the sending of the address ACK by issuing UCTXACK"]
    #[inline]
    pub fn ucswack_1(self) -> &'a mut W {
        self.variant(UCSWACKW::UCSWACK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTPNACK`"]
pub enum UCSTPNACKW {
    #[doc = "Send a non-acknowledge before the STOP condition as a master receiver (conform to I2C standard)"]
    UCSTPNACK_0,
    #[doc = "All bytes are acknowledged by the eUSCI_B when configured as master receiver"]
    UCSTPNACK_1,
}
impl UCSTPNACKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTPNACKW::UCSTPNACK_0 => false,
            UCSTPNACKW::UCSTPNACK_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTPNACKW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTPNACKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTPNACKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Send a non-acknowledge before the STOP condition as a master receiver (conform to I2C standard)"]
    #[inline]
    pub fn ucstpnack_0(self) -> &'a mut W {
        self.variant(UCSTPNACKW::UCSTPNACK_0)
    }
    #[doc = "All bytes are acknowledged by the eUSCI_B when configured as master receiver"]
    #[inline]
    pub fn ucstpnack_1(self) -> &'a mut W {
        self.variant(UCSTPNACKW::UCSTPNACK_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCCLTO`"]
pub enum UCCLTOW {
    #[doc = "Disable clock low timeout counter"]
    UCCLTO_0,
    #[doc = "135 000 SYSCLK cycles (approximately 28 ms)"]
    UCCLTO_1,
    #[doc = "150 000 SYSCLK cycles (approximately 31 ms)"]
    UCCLTO_2,
    #[doc = "165 000 SYSCLK cycles (approximately 34 ms)"]
    UCCLTO_3,
}
impl UCCLTOW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            UCCLTOW::UCCLTO_0 => 0,
            UCCLTOW::UCCLTO_1 => 1,
            UCCLTOW::UCCLTO_2 => 2,
            UCCLTOW::UCCLTO_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCCLTOW<'a> {
    w: &'a mut W,
}
impl<'a> _UCCLTOW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCCLTOW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "Disable clock low timeout counter"]
    #[inline]
    pub fn ucclto_0(self) -> &'a mut W {
        self.variant(UCCLTOW::UCCLTO_0)
    }
    #[doc = "135 000 SYSCLK cycles (approximately 28 ms)"]
    #[inline]
    pub fn ucclto_1(self) -> &'a mut W {
        self.variant(UCCLTOW::UCCLTO_1)
    }
    #[doc = "150 000 SYSCLK cycles (approximately 31 ms)"]
    #[inline]
    pub fn ucclto_2(self) -> &'a mut W {
        self.variant(UCCLTOW::UCCLTO_2)
    }
    #[doc = "165 000 SYSCLK cycles (approximately 34 ms)"]
    #[inline]
    pub fn ucclto_3(self) -> &'a mut W {
        self.variant(UCCLTOW::UCCLTO_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCETXINT`"]
pub enum UCETXINTW {
    #[doc = "UCTXIFGx is set after an address match with UCxI2COAx and the direction bit indicating slave transmit"]
    UCETXINT_0,
    #[doc = "UCTXIFG0 is set for each START condition"]
    UCETXINT_1,
}
impl UCETXINTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCETXINTW::UCETXINT_0 => false,
            UCETXINTW::UCETXINT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCETXINTW<'a> {
    w: &'a mut W,
}
impl<'a> _UCETXINTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCETXINTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "UCTXIFGx is set after an address match with UCxI2COAx and the direction bit indicating slave transmit"]
    #[inline]
    pub fn ucetxint_0(self) -> &'a mut W {
        self.variant(UCETXINTW::UCETXINT_0)
    }
    #[doc = "UCTXIFG0 is set for each START condition"]
    #[inline]
    pub fn ucetxint_1(self) -> &'a mut W {
        self.variant(UCETXINTW::UCETXINT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:1 - Deglitch time"]
    #[inline]
    pub fn ucglit(&self) -> UCGLITR {
        UCGLITR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bits 2:3 - Automatic STOP condition generation"]
    #[inline]
    pub fn ucastp(&self) -> UCASTPR {
        UCASTPR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 4 - SW or HW ACK control"]
    #[inline]
    pub fn ucswack(&self) -> UCSWACKR {
        UCSWACKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - ACK all master bytes"]
    #[inline]
    pub fn ucstpnack(&self) -> UCSTPNACKR {
        UCSTPNACKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 6:7 - Clock low timeout select"]
    #[inline]
    pub fn ucclto(&self) -> UCCLTOR {
        UCCLTOR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 8 - Early UCTXIFG0"]
    #[inline]
    pub fn ucetxint(&self) -> UCETXINTR {
        UCETXINTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 3 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:1 - Deglitch time"]
    #[inline]
    pub fn ucglit(&mut self) -> _UCGLITW {
        _UCGLITW { w: self }
    }
    #[doc = "Bits 2:3 - Automatic STOP condition generation"]
    #[inline]
    pub fn ucastp(&mut self) -> _UCASTPW {
        _UCASTPW { w: self }
    }
    #[doc = "Bit 4 - SW or HW ACK control"]
    #[inline]
    pub fn ucswack(&mut self) -> _UCSWACKW {
        _UCSWACKW { w: self }
    }
    #[doc = "Bit 5 - ACK all master bytes"]
    #[inline]
    pub fn ucstpnack(&mut self) -> _UCSTPNACKW {
        _UCSTPNACKW { w: self }
    }
    #[doc = "Bits 6:7 - Clock low timeout select"]
    #[inline]
    pub fn ucclto(&mut self) -> _UCCLTOW {
        _UCCLTOW { w: self }
    }
    #[doc = "Bit 8 - Early UCTXIFG0"]
    #[inline]
    pub fn ucetxint(&mut self) -> _UCETXINTW {
        _UCETXINTW { w: self }
    }
}
