#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXIFG {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCRXIFG0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIFG0R {
    #[doc = "No interrupt pending"]
    UCRXIFG0_0,
    #[doc = "Interrupt pending"]
    UCRXIFG0_1,
}
impl UCRXIFG0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIFG0R::UCRXIFG0_0 => false,
            UCRXIFG0R::UCRXIFG0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIFG0R {
        match value {
            false => UCRXIFG0R::UCRXIFG0_0,
            true => UCRXIFG0R::UCRXIFG0_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIFG0_0`"]
    #[inline]
    pub fn is_ucrxifg0_0(&self) -> bool {
        *self == UCRXIFG0R::UCRXIFG0_0
    }
    #[doc = "Checks if the value of the field is `UCRXIFG0_1`"]
    #[inline]
    pub fn is_ucrxifg0_1(&self) -> bool {
        *self == UCRXIFG0R::UCRXIFG0_1
    }
}
#[doc = "Possible values of the field `UCTXIFG0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIFG0R {
    #[doc = "No interrupt pending"]
    UCTXIFG0_0,
    #[doc = "Interrupt pending"]
    UCTXIFG0_1,
}
impl UCTXIFG0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIFG0R::UCTXIFG0_0 => false,
            UCTXIFG0R::UCTXIFG0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIFG0R {
        match value {
            false => UCTXIFG0R::UCTXIFG0_0,
            true => UCTXIFG0R::UCTXIFG0_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIFG0_0`"]
    #[inline]
    pub fn is_uctxifg0_0(&self) -> bool {
        *self == UCTXIFG0R::UCTXIFG0_0
    }
    #[doc = "Checks if the value of the field is `UCTXIFG0_1`"]
    #[inline]
    pub fn is_uctxifg0_1(&self) -> bool {
        *self == UCTXIFG0R::UCTXIFG0_1
    }
}
#[doc = "Possible values of the field `UCSTTIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTTIFGR {
    #[doc = "No interrupt pending"]
    UCSTTIFG_0,
    #[doc = "Interrupt pending"]
    UCSTTIFG_1,
}
impl UCSTTIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTTIFGR::UCSTTIFG_0 => false,
            UCSTTIFGR::UCSTTIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTTIFGR {
        match value {
            false => UCSTTIFGR::UCSTTIFG_0,
            true => UCSTTIFGR::UCSTTIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTTIFG_0`"]
    #[inline]
    pub fn is_ucsttifg_0(&self) -> bool {
        *self == UCSTTIFGR::UCSTTIFG_0
    }
    #[doc = "Checks if the value of the field is `UCSTTIFG_1`"]
    #[inline]
    pub fn is_ucsttifg_1(&self) -> bool {
        *self == UCSTTIFGR::UCSTTIFG_1
    }
}
#[doc = "Possible values of the field `UCSTPIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTPIFGR {
    #[doc = "No interrupt pending"]
    UCSTPIFG_0,
    #[doc = "Interrupt pending"]
    UCSTPIFG_1,
}
impl UCSTPIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTPIFGR::UCSTPIFG_0 => false,
            UCSTPIFGR::UCSTPIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTPIFGR {
        match value {
            false => UCSTPIFGR::UCSTPIFG_0,
            true => UCSTPIFGR::UCSTPIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTPIFG_0`"]
    #[inline]
    pub fn is_ucstpifg_0(&self) -> bool {
        *self == UCSTPIFGR::UCSTPIFG_0
    }
    #[doc = "Checks if the value of the field is `UCSTPIFG_1`"]
    #[inline]
    pub fn is_ucstpifg_1(&self) -> bool {
        *self == UCSTPIFGR::UCSTPIFG_1
    }
}
#[doc = "Possible values of the field `UCALIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCALIFGR {
    #[doc = "No interrupt pending"]
    UCALIFG_0,
    #[doc = "Interrupt pending"]
    UCALIFG_1,
}
impl UCALIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCALIFGR::UCALIFG_0 => false,
            UCALIFGR::UCALIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCALIFGR {
        match value {
            false => UCALIFGR::UCALIFG_0,
            true => UCALIFGR::UCALIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCALIFG_0`"]
    #[inline]
    pub fn is_ucalifg_0(&self) -> bool {
        *self == UCALIFGR::UCALIFG_0
    }
    #[doc = "Checks if the value of the field is `UCALIFG_1`"]
    #[inline]
    pub fn is_ucalifg_1(&self) -> bool {
        *self == UCALIFGR::UCALIFG_1
    }
}
#[doc = "Possible values of the field `UCNACKIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCNACKIFGR {
    #[doc = "No interrupt pending"]
    UCNACKIFG_0,
    #[doc = "Interrupt pending"]
    UCNACKIFG_1,
}
impl UCNACKIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCNACKIFGR::UCNACKIFG_0 => false,
            UCNACKIFGR::UCNACKIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCNACKIFGR {
        match value {
            false => UCNACKIFGR::UCNACKIFG_0,
            true => UCNACKIFGR::UCNACKIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCNACKIFG_0`"]
    #[inline]
    pub fn is_ucnackifg_0(&self) -> bool {
        *self == UCNACKIFGR::UCNACKIFG_0
    }
    #[doc = "Checks if the value of the field is `UCNACKIFG_1`"]
    #[inline]
    pub fn is_ucnackifg_1(&self) -> bool {
        *self == UCNACKIFGR::UCNACKIFG_1
    }
}
#[doc = "Possible values of the field `UCBCNTIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBCNTIFGR {
    #[doc = "No interrupt pending"]
    UCBCNTIFG_0,
    #[doc = "Interrupt pending"]
    UCBCNTIFG_1,
}
impl UCBCNTIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBCNTIFGR::UCBCNTIFG_0 => false,
            UCBCNTIFGR::UCBCNTIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBCNTIFGR {
        match value {
            false => UCBCNTIFGR::UCBCNTIFG_0,
            true => UCBCNTIFGR::UCBCNTIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBCNTIFG_0`"]
    #[inline]
    pub fn is_ucbcntifg_0(&self) -> bool {
        *self == UCBCNTIFGR::UCBCNTIFG_0
    }
    #[doc = "Checks if the value of the field is `UCBCNTIFG_1`"]
    #[inline]
    pub fn is_ucbcntifg_1(&self) -> bool {
        *self == UCBCNTIFGR::UCBCNTIFG_1
    }
}
#[doc = "Possible values of the field `UCCLTOIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCCLTOIFGR {
    #[doc = "No interrupt pending"]
    UCCLTOIFG_0,
    #[doc = "Interrupt pending"]
    UCCLTOIFG_1,
}
impl UCCLTOIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCCLTOIFGR::UCCLTOIFG_0 => false,
            UCCLTOIFGR::UCCLTOIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCCLTOIFGR {
        match value {
            false => UCCLTOIFGR::UCCLTOIFG_0,
            true => UCCLTOIFGR::UCCLTOIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCCLTOIFG_0`"]
    #[inline]
    pub fn is_uccltoifg_0(&self) -> bool {
        *self == UCCLTOIFGR::UCCLTOIFG_0
    }
    #[doc = "Checks if the value of the field is `UCCLTOIFG_1`"]
    #[inline]
    pub fn is_uccltoifg_1(&self) -> bool {
        *self == UCCLTOIFGR::UCCLTOIFG_1
    }
}
#[doc = "Possible values of the field `UCRXIFG1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIFG1R {
    #[doc = "No interrupt pending"]
    UCRXIFG1_0,
    #[doc = "Interrupt pending"]
    UCRXIFG1_1,
}
impl UCRXIFG1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIFG1R::UCRXIFG1_0 => false,
            UCRXIFG1R::UCRXIFG1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIFG1R {
        match value {
            false => UCRXIFG1R::UCRXIFG1_0,
            true => UCRXIFG1R::UCRXIFG1_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIFG1_0`"]
    #[inline]
    pub fn is_ucrxifg1_0(&self) -> bool {
        *self == UCRXIFG1R::UCRXIFG1_0
    }
    #[doc = "Checks if the value of the field is `UCRXIFG1_1`"]
    #[inline]
    pub fn is_ucrxifg1_1(&self) -> bool {
        *self == UCRXIFG1R::UCRXIFG1_1
    }
}
#[doc = "Possible values of the field `UCTXIFG1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIFG1R {
    #[doc = "No interrupt pending"]
    UCTXIFG1_0,
    #[doc = "Interrupt pending"]
    UCTXIFG1_1,
}
impl UCTXIFG1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIFG1R::UCTXIFG1_0 => false,
            UCTXIFG1R::UCTXIFG1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIFG1R {
        match value {
            false => UCTXIFG1R::UCTXIFG1_0,
            true => UCTXIFG1R::UCTXIFG1_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIFG1_0`"]
    #[inline]
    pub fn is_uctxifg1_0(&self) -> bool {
        *self == UCTXIFG1R::UCTXIFG1_0
    }
    #[doc = "Checks if the value of the field is `UCTXIFG1_1`"]
    #[inline]
    pub fn is_uctxifg1_1(&self) -> bool {
        *self == UCTXIFG1R::UCTXIFG1_1
    }
}
#[doc = "Possible values of the field `UCRXIFG2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIFG2R {
    #[doc = "No interrupt pending"]
    UCRXIFG2_0,
    #[doc = "Interrupt pending"]
    UCRXIFG2_1,
}
impl UCRXIFG2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIFG2R::UCRXIFG2_0 => false,
            UCRXIFG2R::UCRXIFG2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIFG2R {
        match value {
            false => UCRXIFG2R::UCRXIFG2_0,
            true => UCRXIFG2R::UCRXIFG2_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIFG2_0`"]
    #[inline]
    pub fn is_ucrxifg2_0(&self) -> bool {
        *self == UCRXIFG2R::UCRXIFG2_0
    }
    #[doc = "Checks if the value of the field is `UCRXIFG2_1`"]
    #[inline]
    pub fn is_ucrxifg2_1(&self) -> bool {
        *self == UCRXIFG2R::UCRXIFG2_1
    }
}
#[doc = "Possible values of the field `UCTXIFG2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIFG2R {
    #[doc = "No interrupt pending"]
    UCTXIFG2_0,
    #[doc = "Interrupt pending"]
    UCTXIFG2_1,
}
impl UCTXIFG2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIFG2R::UCTXIFG2_0 => false,
            UCTXIFG2R::UCTXIFG2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIFG2R {
        match value {
            false => UCTXIFG2R::UCTXIFG2_0,
            true => UCTXIFG2R::UCTXIFG2_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIFG2_0`"]
    #[inline]
    pub fn is_uctxifg2_0(&self) -> bool {
        *self == UCTXIFG2R::UCTXIFG2_0
    }
    #[doc = "Checks if the value of the field is `UCTXIFG2_1`"]
    #[inline]
    pub fn is_uctxifg2_1(&self) -> bool {
        *self == UCTXIFG2R::UCTXIFG2_1
    }
}
#[doc = "Possible values of the field `UCRXIFG3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIFG3R {
    #[doc = "No interrupt pending"]
    UCRXIFG3_0,
    #[doc = "Interrupt pending"]
    UCRXIFG3_1,
}
impl UCRXIFG3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIFG3R::UCRXIFG3_0 => false,
            UCRXIFG3R::UCRXIFG3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIFG3R {
        match value {
            false => UCRXIFG3R::UCRXIFG3_0,
            true => UCRXIFG3R::UCRXIFG3_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIFG3_0`"]
    #[inline]
    pub fn is_ucrxifg3_0(&self) -> bool {
        *self == UCRXIFG3R::UCRXIFG3_0
    }
    #[doc = "Checks if the value of the field is `UCRXIFG3_1`"]
    #[inline]
    pub fn is_ucrxifg3_1(&self) -> bool {
        *self == UCRXIFG3R::UCRXIFG3_1
    }
}
#[doc = "Possible values of the field `UCTXIFG3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIFG3R {
    #[doc = "No interrupt pending"]
    UCTXIFG3_0,
    #[doc = "Interrupt pending"]
    UCTXIFG3_1,
}
impl UCTXIFG3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIFG3R::UCTXIFG3_0 => false,
            UCTXIFG3R::UCTXIFG3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIFG3R {
        match value {
            false => UCTXIFG3R::UCTXIFG3_0,
            true => UCTXIFG3R::UCTXIFG3_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIFG3_0`"]
    #[inline]
    pub fn is_uctxifg3_0(&self) -> bool {
        *self == UCTXIFG3R::UCTXIFG3_0
    }
    #[doc = "Checks if the value of the field is `UCTXIFG3_1`"]
    #[inline]
    pub fn is_uctxifg3_1(&self) -> bool {
        *self == UCTXIFG3R::UCTXIFG3_1
    }
}
#[doc = "Possible values of the field `UCBIT9IFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBIT9IFGR {
    #[doc = "No interrupt pending"]
    UCBIT9IFG_0,
    #[doc = "Interrupt pending"]
    UCBIT9IFG_1,
}
impl UCBIT9IFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBIT9IFGR::UCBIT9IFG_0 => false,
            UCBIT9IFGR::UCBIT9IFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBIT9IFGR {
        match value {
            false => UCBIT9IFGR::UCBIT9IFG_0,
            true => UCBIT9IFGR::UCBIT9IFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBIT9IFG_0`"]
    #[inline]
    pub fn is_ucbit9ifg_0(&self) -> bool {
        *self == UCBIT9IFGR::UCBIT9IFG_0
    }
    #[doc = "Checks if the value of the field is `UCBIT9IFG_1`"]
    #[inline]
    pub fn is_ucbit9ifg_1(&self) -> bool {
        *self == UCBIT9IFGR::UCBIT9IFG_1
    }
}
#[doc = "Values that can be written to the field `UCRXIFG0`"]
pub enum UCRXIFG0W {
    #[doc = "No interrupt pending"]
    UCRXIFG0_0,
    #[doc = "Interrupt pending"]
    UCRXIFG0_1,
}
impl UCRXIFG0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIFG0W::UCRXIFG0_0 => false,
            UCRXIFG0W::UCRXIFG0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIFG0W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIFG0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIFG0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucrxifg0_0(self) -> &'a mut W {
        self.variant(UCRXIFG0W::UCRXIFG0_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucrxifg0_1(self) -> &'a mut W {
        self.variant(UCRXIFG0W::UCRXIFG0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIFG0`"]
pub enum UCTXIFG0W {
    #[doc = "No interrupt pending"]
    UCTXIFG0_0,
    #[doc = "Interrupt pending"]
    UCTXIFG0_1,
}
impl UCTXIFG0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIFG0W::UCTXIFG0_0 => false,
            UCTXIFG0W::UCTXIFG0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIFG0W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIFG0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIFG0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxifg0_0(self) -> &'a mut W {
        self.variant(UCTXIFG0W::UCTXIFG0_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxifg0_1(self) -> &'a mut W {
        self.variant(UCTXIFG0W::UCTXIFG0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTTIFG`"]
pub enum UCSTTIFGW {
    #[doc = "No interrupt pending"]
    UCSTTIFG_0,
    #[doc = "Interrupt pending"]
    UCSTTIFG_1,
}
impl UCSTTIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTTIFGW::UCSTTIFG_0 => false,
            UCSTTIFGW::UCSTTIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTTIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTTIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTTIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucsttifg_0(self) -> &'a mut W {
        self.variant(UCSTTIFGW::UCSTTIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucsttifg_1(self) -> &'a mut W {
        self.variant(UCSTTIFGW::UCSTTIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTPIFG`"]
pub enum UCSTPIFGW {
    #[doc = "No interrupt pending"]
    UCSTPIFG_0,
    #[doc = "Interrupt pending"]
    UCSTPIFG_1,
}
impl UCSTPIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTPIFGW::UCSTPIFG_0 => false,
            UCSTPIFGW::UCSTPIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTPIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTPIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTPIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucstpifg_0(self) -> &'a mut W {
        self.variant(UCSTPIFGW::UCSTPIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucstpifg_1(self) -> &'a mut W {
        self.variant(UCSTPIFGW::UCSTPIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCALIFG`"]
pub enum UCALIFGW {
    #[doc = "No interrupt pending"]
    UCALIFG_0,
    #[doc = "Interrupt pending"]
    UCALIFG_1,
}
impl UCALIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCALIFGW::UCALIFG_0 => false,
            UCALIFGW::UCALIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCALIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCALIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCALIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucalifg_0(self) -> &'a mut W {
        self.variant(UCALIFGW::UCALIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucalifg_1(self) -> &'a mut W {
        self.variant(UCALIFGW::UCALIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCNACKIFG`"]
pub enum UCNACKIFGW {
    #[doc = "No interrupt pending"]
    UCNACKIFG_0,
    #[doc = "Interrupt pending"]
    UCNACKIFG_1,
}
impl UCNACKIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCNACKIFGW::UCNACKIFG_0 => false,
            UCNACKIFGW::UCNACKIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCNACKIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCNACKIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCNACKIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucnackifg_0(self) -> &'a mut W {
        self.variant(UCNACKIFGW::UCNACKIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucnackifg_1(self) -> &'a mut W {
        self.variant(UCNACKIFGW::UCNACKIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBCNTIFG`"]
pub enum UCBCNTIFGW {
    #[doc = "No interrupt pending"]
    UCBCNTIFG_0,
    #[doc = "Interrupt pending"]
    UCBCNTIFG_1,
}
impl UCBCNTIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBCNTIFGW::UCBCNTIFG_0 => false,
            UCBCNTIFGW::UCBCNTIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBCNTIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBCNTIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBCNTIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucbcntifg_0(self) -> &'a mut W {
        self.variant(UCBCNTIFGW::UCBCNTIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucbcntifg_1(self) -> &'a mut W {
        self.variant(UCBCNTIFGW::UCBCNTIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCCLTOIFG`"]
pub enum UCCLTOIFGW {
    #[doc = "No interrupt pending"]
    UCCLTOIFG_0,
    #[doc = "Interrupt pending"]
    UCCLTOIFG_1,
}
impl UCCLTOIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCCLTOIFGW::UCCLTOIFG_0 => false,
            UCCLTOIFGW::UCCLTOIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCCLTOIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCCLTOIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCCLTOIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uccltoifg_0(self) -> &'a mut W {
        self.variant(UCCLTOIFGW::UCCLTOIFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uccltoifg_1(self) -> &'a mut W {
        self.variant(UCCLTOIFGW::UCCLTOIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIFG1`"]
pub enum UCRXIFG1W {
    #[doc = "No interrupt pending"]
    UCRXIFG1_0,
    #[doc = "Interrupt pending"]
    UCRXIFG1_1,
}
impl UCRXIFG1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIFG1W::UCRXIFG1_0 => false,
            UCRXIFG1W::UCRXIFG1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIFG1W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIFG1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIFG1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucrxifg1_0(self) -> &'a mut W {
        self.variant(UCRXIFG1W::UCRXIFG1_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucrxifg1_1(self) -> &'a mut W {
        self.variant(UCRXIFG1W::UCRXIFG1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIFG1`"]
pub enum UCTXIFG1W {
    #[doc = "No interrupt pending"]
    UCTXIFG1_0,
    #[doc = "Interrupt pending"]
    UCTXIFG1_1,
}
impl UCTXIFG1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIFG1W::UCTXIFG1_0 => false,
            UCTXIFG1W::UCTXIFG1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIFG1W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIFG1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIFG1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxifg1_0(self) -> &'a mut W {
        self.variant(UCTXIFG1W::UCTXIFG1_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxifg1_1(self) -> &'a mut W {
        self.variant(UCTXIFG1W::UCTXIFG1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIFG2`"]
pub enum UCRXIFG2W {
    #[doc = "No interrupt pending"]
    UCRXIFG2_0,
    #[doc = "Interrupt pending"]
    UCRXIFG2_1,
}
impl UCRXIFG2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIFG2W::UCRXIFG2_0 => false,
            UCRXIFG2W::UCRXIFG2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIFG2W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIFG2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIFG2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucrxifg2_0(self) -> &'a mut W {
        self.variant(UCRXIFG2W::UCRXIFG2_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucrxifg2_1(self) -> &'a mut W {
        self.variant(UCRXIFG2W::UCRXIFG2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIFG2`"]
pub enum UCTXIFG2W {
    #[doc = "No interrupt pending"]
    UCTXIFG2_0,
    #[doc = "Interrupt pending"]
    UCTXIFG2_1,
}
impl UCTXIFG2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIFG2W::UCTXIFG2_0 => false,
            UCTXIFG2W::UCTXIFG2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIFG2W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIFG2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIFG2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxifg2_0(self) -> &'a mut W {
        self.variant(UCTXIFG2W::UCTXIFG2_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxifg2_1(self) -> &'a mut W {
        self.variant(UCTXIFG2W::UCTXIFG2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIFG3`"]
pub enum UCRXIFG3W {
    #[doc = "No interrupt pending"]
    UCRXIFG3_0,
    #[doc = "Interrupt pending"]
    UCRXIFG3_1,
}
impl UCRXIFG3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIFG3W::UCRXIFG3_0 => false,
            UCRXIFG3W::UCRXIFG3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIFG3W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIFG3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIFG3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucrxifg3_0(self) -> &'a mut W {
        self.variant(UCRXIFG3W::UCRXIFG3_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucrxifg3_1(self) -> &'a mut W {
        self.variant(UCRXIFG3W::UCRXIFG3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIFG3`"]
pub enum UCTXIFG3W {
    #[doc = "No interrupt pending"]
    UCTXIFG3_0,
    #[doc = "Interrupt pending"]
    UCTXIFG3_1,
}
impl UCTXIFG3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIFG3W::UCTXIFG3_0 => false,
            UCTXIFG3W::UCTXIFG3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIFG3W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIFG3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIFG3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn uctxifg3_0(self) -> &'a mut W {
        self.variant(UCTXIFG3W::UCTXIFG3_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn uctxifg3_1(self) -> &'a mut W {
        self.variant(UCTXIFG3W::UCTXIFG3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBIT9IFG`"]
pub enum UCBIT9IFGW {
    #[doc = "No interrupt pending"]
    UCBIT9IFG_0,
    #[doc = "Interrupt pending"]
    UCBIT9IFG_1,
}
impl UCBIT9IFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBIT9IFGW::UCBIT9IFG_0 => false,
            UCBIT9IFGW::UCBIT9IFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBIT9IFGW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBIT9IFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBIT9IFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn ucbit9ifg_0(self) -> &'a mut W {
        self.variant(UCBIT9IFGW::UCBIT9IFG_0)
    }
    #[doc = "Interrupt pending"]
    #[inline]
    pub fn ucbit9ifg_1(self) -> &'a mut W {
        self.variant(UCBIT9IFGW::UCBIT9IFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - eUSCI_B receive interrupt flag 0"]
    #[inline]
    pub fn ucrxifg0(&self) -> UCRXIFG0R {
        UCRXIFG0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - eUSCI_B transmit interrupt flag 0"]
    #[inline]
    pub fn uctxifg0(&self) -> UCTXIFG0R {
        UCTXIFG0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - START condition interrupt flag"]
    #[inline]
    pub fn ucsttifg(&self) -> UCSTTIFGR {
        UCSTTIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - STOP condition interrupt flag"]
    #[inline]
    pub fn ucstpifg(&self) -> UCSTPIFGR {
        UCSTPIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Arbitration lost interrupt flag"]
    #[inline]
    pub fn ucalifg(&self) -> UCALIFGR {
        UCALIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Not-acknowledge received interrupt flag"]
    #[inline]
    pub fn ucnackifg(&self) -> UCNACKIFGR {
        UCNACKIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Byte counter interrupt flag"]
    #[inline]
    pub fn ucbcntifg(&self) -> UCBCNTIFGR {
        UCBCNTIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Clock low timeout interrupt flag"]
    #[inline]
    pub fn uccltoifg(&self) -> UCCLTOIFGR {
        UCCLTOIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 8 - eUSCI_B receive interrupt flag 1"]
    #[inline]
    pub fn ucrxifg1(&self) -> UCRXIFG1R {
        UCRXIFG1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 9 - eUSCI_B transmit interrupt flag 1"]
    #[inline]
    pub fn uctxifg1(&self) -> UCTXIFG1R {
        UCTXIFG1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 10 - eUSCI_B receive interrupt flag 2"]
    #[inline]
    pub fn ucrxifg2(&self) -> UCRXIFG2R {
        UCRXIFG2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 11 - eUSCI_B transmit interrupt flag 2"]
    #[inline]
    pub fn uctxifg2(&self) -> UCTXIFG2R {
        UCTXIFG2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 12 - eUSCI_B receive interrupt flag 3"]
    #[inline]
    pub fn ucrxifg3(&self) -> UCRXIFG3R {
        UCRXIFG3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - eUSCI_B transmit interrupt flag 3"]
    #[inline]
    pub fn uctxifg3(&self) -> UCTXIFG3R {
        UCTXIFG3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Bit position 9 interrupt flag"]
    #[inline]
    pub fn ucbit9ifg(&self) -> UCBIT9IFGR {
        UCBIT9IFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 2 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - eUSCI_B receive interrupt flag 0"]
    #[inline]
    pub fn ucrxifg0(&mut self) -> _UCRXIFG0W {
        _UCRXIFG0W { w: self }
    }
    #[doc = "Bit 1 - eUSCI_B transmit interrupt flag 0"]
    #[inline]
    pub fn uctxifg0(&mut self) -> _UCTXIFG0W {
        _UCTXIFG0W { w: self }
    }
    #[doc = "Bit 2 - START condition interrupt flag"]
    #[inline]
    pub fn ucsttifg(&mut self) -> _UCSTTIFGW {
        _UCSTTIFGW { w: self }
    }
    #[doc = "Bit 3 - STOP condition interrupt flag"]
    #[inline]
    pub fn ucstpifg(&mut self) -> _UCSTPIFGW {
        _UCSTPIFGW { w: self }
    }
    #[doc = "Bit 4 - Arbitration lost interrupt flag"]
    #[inline]
    pub fn ucalifg(&mut self) -> _UCALIFGW {
        _UCALIFGW { w: self }
    }
    #[doc = "Bit 5 - Not-acknowledge received interrupt flag"]
    #[inline]
    pub fn ucnackifg(&mut self) -> _UCNACKIFGW {
        _UCNACKIFGW { w: self }
    }
    #[doc = "Bit 6 - Byte counter interrupt flag"]
    #[inline]
    pub fn ucbcntifg(&mut self) -> _UCBCNTIFGW {
        _UCBCNTIFGW { w: self }
    }
    #[doc = "Bit 7 - Clock low timeout interrupt flag"]
    #[inline]
    pub fn uccltoifg(&mut self) -> _UCCLTOIFGW {
        _UCCLTOIFGW { w: self }
    }
    #[doc = "Bit 8 - eUSCI_B receive interrupt flag 1"]
    #[inline]
    pub fn ucrxifg1(&mut self) -> _UCRXIFG1W {
        _UCRXIFG1W { w: self }
    }
    #[doc = "Bit 9 - eUSCI_B transmit interrupt flag 1"]
    #[inline]
    pub fn uctxifg1(&mut self) -> _UCTXIFG1W {
        _UCTXIFG1W { w: self }
    }
    #[doc = "Bit 10 - eUSCI_B receive interrupt flag 2"]
    #[inline]
    pub fn ucrxifg2(&mut self) -> _UCRXIFG2W {
        _UCRXIFG2W { w: self }
    }
    #[doc = "Bit 11 - eUSCI_B transmit interrupt flag 2"]
    #[inline]
    pub fn uctxifg2(&mut self) -> _UCTXIFG2W {
        _UCTXIFG2W { w: self }
    }
    #[doc = "Bit 12 - eUSCI_B receive interrupt flag 3"]
    #[inline]
    pub fn ucrxifg3(&mut self) -> _UCRXIFG3W {
        _UCRXIFG3W { w: self }
    }
    #[doc = "Bit 13 - eUSCI_B transmit interrupt flag 3"]
    #[inline]
    pub fn uctxifg3(&mut self) -> _UCTXIFG3W {
        _UCTXIFG3W { w: self }
    }
    #[doc = "Bit 14 - Bit position 9 interrupt flag"]
    #[inline]
    pub fn ucbit9ifg(&mut self) -> _UCBIT9IFGW {
        _UCBIT9IFGW { w: self }
    }
}
