#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXSTATW {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCBBUSY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBBUSYR {
    #[doc = "Bus inactive"]
    UCBBUSY_0,
    #[doc = "Bus busy"]
    UCBBUSY_1,
}
impl UCBBUSYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBBUSYR::UCBBUSY_0 => false,
            UCBBUSYR::UCBBUSY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBBUSYR {
        match value {
            false => UCBBUSYR::UCBBUSY_0,
            true => UCBBUSYR::UCBBUSY_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBBUSY_0`"]
    #[inline]
    pub fn is_ucbbusy_0(&self) -> bool {
        *self == UCBBUSYR::UCBBUSY_0
    }
    #[doc = "Checks if the value of the field is `UCBBUSY_1`"]
    #[inline]
    pub fn is_ucbbusy_1(&self) -> bool {
        *self == UCBBUSYR::UCBBUSY_1
    }
}
#[doc = "Possible values of the field `UCGC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCGCR {
    #[doc = "No general call address received"]
    UCGC_0,
    #[doc = "General call address received"]
    UCGC_1,
}
impl UCGCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCGCR::UCGC_0 => false,
            UCGCR::UCGC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCGCR {
        match value {
            false => UCGCR::UCGC_0,
            true => UCGCR::UCGC_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCGC_0`"]
    #[inline]
    pub fn is_ucgc_0(&self) -> bool {
        *self == UCGCR::UCGC_0
    }
    #[doc = "Checks if the value of the field is `UCGC_1`"]
    #[inline]
    pub fn is_ucgc_1(&self) -> bool {
        *self == UCGCR::UCGC_1
    }
}
#[doc = "Possible values of the field `UCSCLLOW`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSCLLOWR {
    #[doc = "SCL is not held low"]
    UCSCLLOW_0,
    #[doc = "SCL is held low"]
    UCSCLLOW_1,
}
impl UCSCLLOWR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSCLLOWR::UCSCLLOW_0 => false,
            UCSCLLOWR::UCSCLLOW_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSCLLOWR {
        match value {
            false => UCSCLLOWR::UCSCLLOW_0,
            true => UCSCLLOWR::UCSCLLOW_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSCLLOW_0`"]
    #[inline]
    pub fn is_ucscllow_0(&self) -> bool {
        *self == UCSCLLOWR::UCSCLLOW_0
    }
    #[doc = "Checks if the value of the field is `UCSCLLOW_1`"]
    #[inline]
    pub fn is_ucscllow_1(&self) -> bool {
        *self == UCSCLLOWR::UCSCLLOW_1
    }
}
#[doc = r" Value of the field"]
pub struct UCBCNTR {
    bits: u8,
}
impl UCBCNTR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 4 - Bus busy"]
    #[inline]
    pub fn ucbbusy(&self) -> UCBBUSYR {
        UCBBUSYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - General call address received"]
    #[inline]
    pub fn ucgc(&self) -> UCGCR {
        UCGCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - SCL low"]
    #[inline]
    pub fn ucscllow(&self) -> UCSCLLOWR {
        UCSCLLOWR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 8:15 - Hardware byte counter value"]
    #[inline]
    pub fn ucbcnt(&self) -> UCBCNTR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        UCBCNTR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
}
