#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::UCBXIE {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `UCRXIE0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIE0R {
    #[doc = "Interrupt disabled"]
    UCRXIE0_0,
    #[doc = "Interrupt enabled"]
    UCRXIE0_1,
}
impl UCRXIE0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIE0R::UCRXIE0_0 => false,
            UCRXIE0R::UCRXIE0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIE0R {
        match value {
            false => UCRXIE0R::UCRXIE0_0,
            true => UCRXIE0R::UCRXIE0_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIE0_0`"]
    #[inline]
    pub fn is_ucrxie0_0(&self) -> bool {
        *self == UCRXIE0R::UCRXIE0_0
    }
    #[doc = "Checks if the value of the field is `UCRXIE0_1`"]
    #[inline]
    pub fn is_ucrxie0_1(&self) -> bool {
        *self == UCRXIE0R::UCRXIE0_1
    }
}
#[doc = "Possible values of the field `UCTXIE0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIE0R {
    #[doc = "Interrupt disabled"]
    UCTXIE0_0,
    #[doc = "Interrupt enabled"]
    UCTXIE0_1,
}
impl UCTXIE0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIE0R::UCTXIE0_0 => false,
            UCTXIE0R::UCTXIE0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIE0R {
        match value {
            false => UCTXIE0R::UCTXIE0_0,
            true => UCTXIE0R::UCTXIE0_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIE0_0`"]
    #[inline]
    pub fn is_uctxie0_0(&self) -> bool {
        *self == UCTXIE0R::UCTXIE0_0
    }
    #[doc = "Checks if the value of the field is `UCTXIE0_1`"]
    #[inline]
    pub fn is_uctxie0_1(&self) -> bool {
        *self == UCTXIE0R::UCTXIE0_1
    }
}
#[doc = "Possible values of the field `UCSTTIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTTIER {
    #[doc = "Interrupt disabled"]
    UCSTTIE_0,
    #[doc = "Interrupt enabled"]
    UCSTTIE_1,
}
impl UCSTTIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTTIER::UCSTTIE_0 => false,
            UCSTTIER::UCSTTIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTTIER {
        match value {
            false => UCSTTIER::UCSTTIE_0,
            true => UCSTTIER::UCSTTIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTTIE_0`"]
    #[inline]
    pub fn is_ucsttie_0(&self) -> bool {
        *self == UCSTTIER::UCSTTIE_0
    }
    #[doc = "Checks if the value of the field is `UCSTTIE_1`"]
    #[inline]
    pub fn is_ucsttie_1(&self) -> bool {
        *self == UCSTTIER::UCSTTIE_1
    }
}
#[doc = "Possible values of the field `UCSTPIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCSTPIER {
    #[doc = "Interrupt disabled"]
    UCSTPIE_0,
    #[doc = "Interrupt enabled"]
    UCSTPIE_1,
}
impl UCSTPIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCSTPIER::UCSTPIE_0 => false,
            UCSTPIER::UCSTPIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCSTPIER {
        match value {
            false => UCSTPIER::UCSTPIE_0,
            true => UCSTPIER::UCSTPIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCSTPIE_0`"]
    #[inline]
    pub fn is_ucstpie_0(&self) -> bool {
        *self == UCSTPIER::UCSTPIE_0
    }
    #[doc = "Checks if the value of the field is `UCSTPIE_1`"]
    #[inline]
    pub fn is_ucstpie_1(&self) -> bool {
        *self == UCSTPIER::UCSTPIE_1
    }
}
#[doc = "Possible values of the field `UCALIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCALIER {
    #[doc = "Interrupt disabled"]
    UCALIE_0,
    #[doc = "Interrupt enabled"]
    UCALIE_1,
}
impl UCALIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCALIER::UCALIE_0 => false,
            UCALIER::UCALIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCALIER {
        match value {
            false => UCALIER::UCALIE_0,
            true => UCALIER::UCALIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCALIE_0`"]
    #[inline]
    pub fn is_ucalie_0(&self) -> bool {
        *self == UCALIER::UCALIE_0
    }
    #[doc = "Checks if the value of the field is `UCALIE_1`"]
    #[inline]
    pub fn is_ucalie_1(&self) -> bool {
        *self == UCALIER::UCALIE_1
    }
}
#[doc = "Possible values of the field `UCNACKIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCNACKIER {
    #[doc = "Interrupt disabled"]
    UCNACKIE_0,
    #[doc = "Interrupt enabled"]
    UCNACKIE_1,
}
impl UCNACKIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCNACKIER::UCNACKIE_0 => false,
            UCNACKIER::UCNACKIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCNACKIER {
        match value {
            false => UCNACKIER::UCNACKIE_0,
            true => UCNACKIER::UCNACKIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCNACKIE_0`"]
    #[inline]
    pub fn is_ucnackie_0(&self) -> bool {
        *self == UCNACKIER::UCNACKIE_0
    }
    #[doc = "Checks if the value of the field is `UCNACKIE_1`"]
    #[inline]
    pub fn is_ucnackie_1(&self) -> bool {
        *self == UCNACKIER::UCNACKIE_1
    }
}
#[doc = "Possible values of the field `UCBCNTIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBCNTIER {
    #[doc = "Interrupt disabled"]
    UCBCNTIE_0,
    #[doc = "Interrupt enabled"]
    UCBCNTIE_1,
}
impl UCBCNTIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBCNTIER::UCBCNTIE_0 => false,
            UCBCNTIER::UCBCNTIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBCNTIER {
        match value {
            false => UCBCNTIER::UCBCNTIE_0,
            true => UCBCNTIER::UCBCNTIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBCNTIE_0`"]
    #[inline]
    pub fn is_ucbcntie_0(&self) -> bool {
        *self == UCBCNTIER::UCBCNTIE_0
    }
    #[doc = "Checks if the value of the field is `UCBCNTIE_1`"]
    #[inline]
    pub fn is_ucbcntie_1(&self) -> bool {
        *self == UCBCNTIER::UCBCNTIE_1
    }
}
#[doc = "Possible values of the field `UCCLTOIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCCLTOIER {
    #[doc = "Interrupt disabled"]
    UCCLTOIE_0,
    #[doc = "Interrupt enabled"]
    UCCLTOIE_1,
}
impl UCCLTOIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCCLTOIER::UCCLTOIE_0 => false,
            UCCLTOIER::UCCLTOIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCCLTOIER {
        match value {
            false => UCCLTOIER::UCCLTOIE_0,
            true => UCCLTOIER::UCCLTOIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCCLTOIE_0`"]
    #[inline]
    pub fn is_uccltoie_0(&self) -> bool {
        *self == UCCLTOIER::UCCLTOIE_0
    }
    #[doc = "Checks if the value of the field is `UCCLTOIE_1`"]
    #[inline]
    pub fn is_uccltoie_1(&self) -> bool {
        *self == UCCLTOIER::UCCLTOIE_1
    }
}
#[doc = "Possible values of the field `UCRXIE1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIE1R {
    #[doc = "Interrupt disabled"]
    UCRXIE1_0,
    #[doc = "Interrupt enabled"]
    UCRXIE1_1,
}
impl UCRXIE1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIE1R::UCRXIE1_0 => false,
            UCRXIE1R::UCRXIE1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIE1R {
        match value {
            false => UCRXIE1R::UCRXIE1_0,
            true => UCRXIE1R::UCRXIE1_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIE1_0`"]
    #[inline]
    pub fn is_ucrxie1_0(&self) -> bool {
        *self == UCRXIE1R::UCRXIE1_0
    }
    #[doc = "Checks if the value of the field is `UCRXIE1_1`"]
    #[inline]
    pub fn is_ucrxie1_1(&self) -> bool {
        *self == UCRXIE1R::UCRXIE1_1
    }
}
#[doc = "Possible values of the field `UCTXIE1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIE1R {
    #[doc = "Interrupt disabled"]
    UCTXIE1_0,
    #[doc = "Interrupt enabled"]
    UCTXIE1_1,
}
impl UCTXIE1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIE1R::UCTXIE1_0 => false,
            UCTXIE1R::UCTXIE1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIE1R {
        match value {
            false => UCTXIE1R::UCTXIE1_0,
            true => UCTXIE1R::UCTXIE1_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIE1_0`"]
    #[inline]
    pub fn is_uctxie1_0(&self) -> bool {
        *self == UCTXIE1R::UCTXIE1_0
    }
    #[doc = "Checks if the value of the field is `UCTXIE1_1`"]
    #[inline]
    pub fn is_uctxie1_1(&self) -> bool {
        *self == UCTXIE1R::UCTXIE1_1
    }
}
#[doc = "Possible values of the field `UCRXIE2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIE2R {
    #[doc = "Interrupt disabled"]
    UCRXIE2_0,
    #[doc = "Interrupt enabled"]
    UCRXIE2_1,
}
impl UCRXIE2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIE2R::UCRXIE2_0 => false,
            UCRXIE2R::UCRXIE2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIE2R {
        match value {
            false => UCRXIE2R::UCRXIE2_0,
            true => UCRXIE2R::UCRXIE2_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIE2_0`"]
    #[inline]
    pub fn is_ucrxie2_0(&self) -> bool {
        *self == UCRXIE2R::UCRXIE2_0
    }
    #[doc = "Checks if the value of the field is `UCRXIE2_1`"]
    #[inline]
    pub fn is_ucrxie2_1(&self) -> bool {
        *self == UCRXIE2R::UCRXIE2_1
    }
}
#[doc = "Possible values of the field `UCTXIE2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIE2R {
    #[doc = "Interrupt disabled"]
    UCTXIE2_0,
    #[doc = "Interrupt enabled"]
    UCTXIE2_1,
}
impl UCTXIE2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIE2R::UCTXIE2_0 => false,
            UCTXIE2R::UCTXIE2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIE2R {
        match value {
            false => UCTXIE2R::UCTXIE2_0,
            true => UCTXIE2R::UCTXIE2_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIE2_0`"]
    #[inline]
    pub fn is_uctxie2_0(&self) -> bool {
        *self == UCTXIE2R::UCTXIE2_0
    }
    #[doc = "Checks if the value of the field is `UCTXIE2_1`"]
    #[inline]
    pub fn is_uctxie2_1(&self) -> bool {
        *self == UCTXIE2R::UCTXIE2_1
    }
}
#[doc = "Possible values of the field `UCRXIE3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCRXIE3R {
    #[doc = "Interrupt disabled"]
    UCRXIE3_0,
    #[doc = "Interrupt enabled"]
    UCRXIE3_1,
}
impl UCRXIE3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCRXIE3R::UCRXIE3_0 => false,
            UCRXIE3R::UCRXIE3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCRXIE3R {
        match value {
            false => UCRXIE3R::UCRXIE3_0,
            true => UCRXIE3R::UCRXIE3_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCRXIE3_0`"]
    #[inline]
    pub fn is_ucrxie3_0(&self) -> bool {
        *self == UCRXIE3R::UCRXIE3_0
    }
    #[doc = "Checks if the value of the field is `UCRXIE3_1`"]
    #[inline]
    pub fn is_ucrxie3_1(&self) -> bool {
        *self == UCRXIE3R::UCRXIE3_1
    }
}
#[doc = "Possible values of the field `UCTXIE3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCTXIE3R {
    #[doc = "Interrupt disabled"]
    UCTXIE3_0,
    #[doc = "Interrupt enabled"]
    UCTXIE3_1,
}
impl UCTXIE3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCTXIE3R::UCTXIE3_0 => false,
            UCTXIE3R::UCTXIE3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCTXIE3R {
        match value {
            false => UCTXIE3R::UCTXIE3_0,
            true => UCTXIE3R::UCTXIE3_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCTXIE3_0`"]
    #[inline]
    pub fn is_uctxie3_0(&self) -> bool {
        *self == UCTXIE3R::UCTXIE3_0
    }
    #[doc = "Checks if the value of the field is `UCTXIE3_1`"]
    #[inline]
    pub fn is_uctxie3_1(&self) -> bool {
        *self == UCTXIE3R::UCTXIE3_1
    }
}
#[doc = "Possible values of the field `UCBIT9IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCBIT9IER {
    #[doc = "Interrupt disabled"]
    UCBIT9IE_0,
    #[doc = "Interrupt enabled"]
    UCBIT9IE_1,
}
impl UCBIT9IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            UCBIT9IER::UCBIT9IE_0 => false,
            UCBIT9IER::UCBIT9IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> UCBIT9IER {
        match value {
            false => UCBIT9IER::UCBIT9IE_0,
            true => UCBIT9IER::UCBIT9IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `UCBIT9IE_0`"]
    #[inline]
    pub fn is_ucbit9ie_0(&self) -> bool {
        *self == UCBIT9IER::UCBIT9IE_0
    }
    #[doc = "Checks if the value of the field is `UCBIT9IE_1`"]
    #[inline]
    pub fn is_ucbit9ie_1(&self) -> bool {
        *self == UCBIT9IER::UCBIT9IE_1
    }
}
#[doc = "Values that can be written to the field `UCRXIE0`"]
pub enum UCRXIE0W {
    #[doc = "Interrupt disabled"]
    UCRXIE0_0,
    #[doc = "Interrupt enabled"]
    UCRXIE0_1,
}
impl UCRXIE0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIE0W::UCRXIE0_0 => false,
            UCRXIE0W::UCRXIE0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIE0W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIE0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIE0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucrxie0_0(self) -> &'a mut W {
        self.variant(UCRXIE0W::UCRXIE0_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucrxie0_1(self) -> &'a mut W {
        self.variant(UCRXIE0W::UCRXIE0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIE0`"]
pub enum UCTXIE0W {
    #[doc = "Interrupt disabled"]
    UCTXIE0_0,
    #[doc = "Interrupt enabled"]
    UCTXIE0_1,
}
impl UCTXIE0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIE0W::UCTXIE0_0 => false,
            UCTXIE0W::UCTXIE0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIE0W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIE0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIE0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxie0_0(self) -> &'a mut W {
        self.variant(UCTXIE0W::UCTXIE0_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxie0_1(self) -> &'a mut W {
        self.variant(UCTXIE0W::UCTXIE0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTTIE`"]
pub enum UCSTTIEW {
    #[doc = "Interrupt disabled"]
    UCSTTIE_0,
    #[doc = "Interrupt enabled"]
    UCSTTIE_1,
}
impl UCSTTIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTTIEW::UCSTTIE_0 => false,
            UCSTTIEW::UCSTTIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTTIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTTIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTTIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucsttie_0(self) -> &'a mut W {
        self.variant(UCSTTIEW::UCSTTIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucsttie_1(self) -> &'a mut W {
        self.variant(UCSTTIEW::UCSTTIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCSTPIE`"]
pub enum UCSTPIEW {
    #[doc = "Interrupt disabled"]
    UCSTPIE_0,
    #[doc = "Interrupt enabled"]
    UCSTPIE_1,
}
impl UCSTPIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCSTPIEW::UCSTPIE_0 => false,
            UCSTPIEW::UCSTPIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCSTPIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCSTPIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCSTPIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucstpie_0(self) -> &'a mut W {
        self.variant(UCSTPIEW::UCSTPIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucstpie_1(self) -> &'a mut W {
        self.variant(UCSTPIEW::UCSTPIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCALIE`"]
pub enum UCALIEW {
    #[doc = "Interrupt disabled"]
    UCALIE_0,
    #[doc = "Interrupt enabled"]
    UCALIE_1,
}
impl UCALIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCALIEW::UCALIE_0 => false,
            UCALIEW::UCALIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCALIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCALIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCALIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucalie_0(self) -> &'a mut W {
        self.variant(UCALIEW::UCALIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucalie_1(self) -> &'a mut W {
        self.variant(UCALIEW::UCALIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCNACKIE`"]
pub enum UCNACKIEW {
    #[doc = "Interrupt disabled"]
    UCNACKIE_0,
    #[doc = "Interrupt enabled"]
    UCNACKIE_1,
}
impl UCNACKIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCNACKIEW::UCNACKIE_0 => false,
            UCNACKIEW::UCNACKIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCNACKIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCNACKIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCNACKIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucnackie_0(self) -> &'a mut W {
        self.variant(UCNACKIEW::UCNACKIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucnackie_1(self) -> &'a mut W {
        self.variant(UCNACKIEW::UCNACKIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBCNTIE`"]
pub enum UCBCNTIEW {
    #[doc = "Interrupt disabled"]
    UCBCNTIE_0,
    #[doc = "Interrupt enabled"]
    UCBCNTIE_1,
}
impl UCBCNTIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBCNTIEW::UCBCNTIE_0 => false,
            UCBCNTIEW::UCBCNTIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBCNTIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBCNTIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBCNTIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucbcntie_0(self) -> &'a mut W {
        self.variant(UCBCNTIEW::UCBCNTIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucbcntie_1(self) -> &'a mut W {
        self.variant(UCBCNTIEW::UCBCNTIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCCLTOIE`"]
pub enum UCCLTOIEW {
    #[doc = "Interrupt disabled"]
    UCCLTOIE_0,
    #[doc = "Interrupt enabled"]
    UCCLTOIE_1,
}
impl UCCLTOIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCCLTOIEW::UCCLTOIE_0 => false,
            UCCLTOIEW::UCCLTOIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCCLTOIEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCCLTOIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCCLTOIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uccltoie_0(self) -> &'a mut W {
        self.variant(UCCLTOIEW::UCCLTOIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uccltoie_1(self) -> &'a mut W {
        self.variant(UCCLTOIEW::UCCLTOIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIE1`"]
pub enum UCRXIE1W {
    #[doc = "Interrupt disabled"]
    UCRXIE1_0,
    #[doc = "Interrupt enabled"]
    UCRXIE1_1,
}
impl UCRXIE1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIE1W::UCRXIE1_0 => false,
            UCRXIE1W::UCRXIE1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIE1W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIE1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIE1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucrxie1_0(self) -> &'a mut W {
        self.variant(UCRXIE1W::UCRXIE1_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucrxie1_1(self) -> &'a mut W {
        self.variant(UCRXIE1W::UCRXIE1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIE1`"]
pub enum UCTXIE1W {
    #[doc = "Interrupt disabled"]
    UCTXIE1_0,
    #[doc = "Interrupt enabled"]
    UCTXIE1_1,
}
impl UCTXIE1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIE1W::UCTXIE1_0 => false,
            UCTXIE1W::UCTXIE1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIE1W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIE1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIE1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxie1_0(self) -> &'a mut W {
        self.variant(UCTXIE1W::UCTXIE1_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxie1_1(self) -> &'a mut W {
        self.variant(UCTXIE1W::UCTXIE1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIE2`"]
pub enum UCRXIE2W {
    #[doc = "Interrupt disabled"]
    UCRXIE2_0,
    #[doc = "Interrupt enabled"]
    UCRXIE2_1,
}
impl UCRXIE2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIE2W::UCRXIE2_0 => false,
            UCRXIE2W::UCRXIE2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIE2W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIE2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIE2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucrxie2_0(self) -> &'a mut W {
        self.variant(UCRXIE2W::UCRXIE2_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucrxie2_1(self) -> &'a mut W {
        self.variant(UCRXIE2W::UCRXIE2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIE2`"]
pub enum UCTXIE2W {
    #[doc = "Interrupt disabled"]
    UCTXIE2_0,
    #[doc = "Interrupt enabled"]
    UCTXIE2_1,
}
impl UCTXIE2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIE2W::UCTXIE2_0 => false,
            UCTXIE2W::UCTXIE2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIE2W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIE2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIE2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxie2_0(self) -> &'a mut W {
        self.variant(UCTXIE2W::UCTXIE2_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxie2_1(self) -> &'a mut W {
        self.variant(UCTXIE2W::UCTXIE2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCRXIE3`"]
pub enum UCRXIE3W {
    #[doc = "Interrupt disabled"]
    UCRXIE3_0,
    #[doc = "Interrupt enabled"]
    UCRXIE3_1,
}
impl UCRXIE3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCRXIE3W::UCRXIE3_0 => false,
            UCRXIE3W::UCRXIE3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCRXIE3W<'a> {
    w: &'a mut W,
}
impl<'a> _UCRXIE3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCRXIE3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucrxie3_0(self) -> &'a mut W {
        self.variant(UCRXIE3W::UCRXIE3_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucrxie3_1(self) -> &'a mut W {
        self.variant(UCRXIE3W::UCRXIE3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCTXIE3`"]
pub enum UCTXIE3W {
    #[doc = "Interrupt disabled"]
    UCTXIE3_0,
    #[doc = "Interrupt enabled"]
    UCTXIE3_1,
}
impl UCTXIE3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCTXIE3W::UCTXIE3_0 => false,
            UCTXIE3W::UCTXIE3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCTXIE3W<'a> {
    w: &'a mut W,
}
impl<'a> _UCTXIE3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCTXIE3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn uctxie3_0(self) -> &'a mut W {
        self.variant(UCTXIE3W::UCTXIE3_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn uctxie3_1(self) -> &'a mut W {
        self.variant(UCTXIE3W::UCTXIE3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `UCBIT9IE`"]
pub enum UCBIT9IEW {
    #[doc = "Interrupt disabled"]
    UCBIT9IE_0,
    #[doc = "Interrupt enabled"]
    UCBIT9IE_1,
}
impl UCBIT9IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            UCBIT9IEW::UCBIT9IE_0 => false,
            UCBIT9IEW::UCBIT9IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _UCBIT9IEW<'a> {
    w: &'a mut W,
}
impl<'a> _UCBIT9IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: UCBIT9IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn ucbit9ie_0(self) -> &'a mut W {
        self.variant(UCBIT9IEW::UCBIT9IE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn ucbit9ie_1(self) -> &'a mut W {
        self.variant(UCBIT9IEW::UCBIT9IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Receive interrupt enable 0"]
    #[inline]
    pub fn ucrxie0(&self) -> UCRXIE0R {
        UCRXIE0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Transmit interrupt enable 0"]
    #[inline]
    pub fn uctxie0(&self) -> UCTXIE0R {
        UCTXIE0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - START condition interrupt enable"]
    #[inline]
    pub fn ucsttie(&self) -> UCSTTIER {
        UCSTTIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - STOP condition interrupt enable"]
    #[inline]
    pub fn ucstpie(&self) -> UCSTPIER {
        UCSTPIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Arbitration lost interrupt enable"]
    #[inline]
    pub fn ucalie(&self) -> UCALIER {
        UCALIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Not-acknowledge interrupt enable"]
    #[inline]
    pub fn ucnackie(&self) -> UCNACKIER {
        UCNACKIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Byte counter interrupt enable"]
    #[inline]
    pub fn ucbcntie(&self) -> UCBCNTIER {
        UCBCNTIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Clock low timeout interrupt enable"]
    #[inline]
    pub fn uccltoie(&self) -> UCCLTOIER {
        UCCLTOIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 8 - Receive interrupt enable 1"]
    #[inline]
    pub fn ucrxie1(&self) -> UCRXIE1R {
        UCRXIE1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 9 - Transmit interrupt enable 1"]
    #[inline]
    pub fn uctxie1(&self) -> UCTXIE1R {
        UCTXIE1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 10 - Receive interrupt enable 2"]
    #[inline]
    pub fn ucrxie2(&self) -> UCRXIE2R {
        UCRXIE2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 11 - Transmit interrupt enable 2"]
    #[inline]
    pub fn uctxie2(&self) -> UCTXIE2R {
        UCTXIE2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 12 - Receive interrupt enable 3"]
    #[inline]
    pub fn ucrxie3(&self) -> UCRXIE3R {
        UCRXIE3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - Transmit interrupt enable 3"]
    #[inline]
    pub fn uctxie3(&self) -> UCTXIE3R {
        UCTXIE3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Bit position 9 interrupt enable"]
    #[inline]
    pub fn ucbit9ie(&self) -> UCBIT9IER {
        UCBIT9IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Receive interrupt enable 0"]
    #[inline]
    pub fn ucrxie0(&mut self) -> _UCRXIE0W {
        _UCRXIE0W { w: self }
    }
    #[doc = "Bit 1 - Transmit interrupt enable 0"]
    #[inline]
    pub fn uctxie0(&mut self) -> _UCTXIE0W {
        _UCTXIE0W { w: self }
    }
    #[doc = "Bit 2 - START condition interrupt enable"]
    #[inline]
    pub fn ucsttie(&mut self) -> _UCSTTIEW {
        _UCSTTIEW { w: self }
    }
    #[doc = "Bit 3 - STOP condition interrupt enable"]
    #[inline]
    pub fn ucstpie(&mut self) -> _UCSTPIEW {
        _UCSTPIEW { w: self }
    }
    #[doc = "Bit 4 - Arbitration lost interrupt enable"]
    #[inline]
    pub fn ucalie(&mut self) -> _UCALIEW {
        _UCALIEW { w: self }
    }
    #[doc = "Bit 5 - Not-acknowledge interrupt enable"]
    #[inline]
    pub fn ucnackie(&mut self) -> _UCNACKIEW {
        _UCNACKIEW { w: self }
    }
    #[doc = "Bit 6 - Byte counter interrupt enable"]
    #[inline]
    pub fn ucbcntie(&mut self) -> _UCBCNTIEW {
        _UCBCNTIEW { w: self }
    }
    #[doc = "Bit 7 - Clock low timeout interrupt enable"]
    #[inline]
    pub fn uccltoie(&mut self) -> _UCCLTOIEW {
        _UCCLTOIEW { w: self }
    }
    #[doc = "Bit 8 - Receive interrupt enable 1"]
    #[inline]
    pub fn ucrxie1(&mut self) -> _UCRXIE1W {
        _UCRXIE1W { w: self }
    }
    #[doc = "Bit 9 - Transmit interrupt enable 1"]
    #[inline]
    pub fn uctxie1(&mut self) -> _UCTXIE1W {
        _UCTXIE1W { w: self }
    }
    #[doc = "Bit 10 - Receive interrupt enable 2"]
    #[inline]
    pub fn ucrxie2(&mut self) -> _UCRXIE2W {
        _UCRXIE2W { w: self }
    }
    #[doc = "Bit 11 - Transmit interrupt enable 2"]
    #[inline]
    pub fn uctxie2(&mut self) -> _UCTXIE2W {
        _UCTXIE2W { w: self }
    }
    #[doc = "Bit 12 - Receive interrupt enable 3"]
    #[inline]
    pub fn ucrxie3(&mut self) -> _UCRXIE3W {
        _UCRXIE3W { w: self }
    }
    #[doc = "Bit 13 - Transmit interrupt enable 3"]
    #[inline]
    pub fn uctxie3(&mut self) -> _UCTXIE3W {
        _UCTXIE3W { w: self }
    }
    #[doc = "Bit 14 - Bit position 9 interrupt enable"]
    #[inline]
    pub fn ucbit9ie(&mut self) -> _UCBIT9IEW {
        _UCBIT9IEW { w: self }
    }
}
