#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::UCBXIV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `UCIV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UCIVR {
    #[doc = "No interrupt pending"]
    UCIV_0,
    #[doc = "Interrupt Source: Arbitration lost; Interrupt Flag: UCALIFG; Interrupt Priority: Highest"]
    UCIV_2,
    #[doc = "Interrupt Source: Not acknowledgment; Interrupt Flag: UCNACKIFG"]
    UCIV_4,
    #[doc = "Interrupt Source: Start condition received; Interrupt Flag: UCSTTIFG"]
    UCIV_6,
    #[doc = "Interrupt Source: Stop condition received; Interrupt Flag: UCSTPIFG"]
    UCIV_8,
    #[doc = "Interrupt Source: Slave 3 Data received; Interrupt Flag: UCRXIFG3"]
    UCIV_10,
    #[doc = "Interrupt Source: Slave 3 Transmit buffer empty; Interrupt Flag: UCTXIFG3"]
    UCIV_12,
    #[doc = "Interrupt Source: Slave 2 Data received; Interrupt Flag: UCRXIFG2"]
    UCIV_14,
    #[doc = "Interrupt Source: Slave 2 Transmit buffer empty; Interrupt Flag: UCTXIFG2"]
    UCIV_16,
    #[doc = "Interrupt Source: Slave 1 Data received; Interrupt Flag: UCRXIFG1"]
    UCIV_18,
    #[doc = "Interrupt Source: Slave 1 Transmit buffer empty; Interrupt Flag: UCTXIFG1"]
    UCIV_20,
    #[doc = "Interrupt Source: Data received; Interrupt Flag: UCRXIFG0"]
    UCIV_22,
    #[doc = "Interrupt Source: Transmit buffer empty; Interrupt Flag: UCTXIFG0"]
    UCIV_24,
    #[doc = "Interrupt Source: Byte counter zero; Interrupt Flag: UCBCNTIFG"]
    UCIV_26,
    #[doc = "Interrupt Source: Clock low timeout; Interrupt Flag: UCCLTOIFG"]
    UCIV_28,
    #[doc = "Interrupt Source: Nineth bit position; Interrupt Flag: UCBIT9IFG; Priority: Lowest"]
    UCIV_30,
    #[doc = r" Reserved"]
    _Reserved(u16),
}
impl UCIVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        match *self {
            UCIVR::UCIV_0 => 0,
            UCIVR::UCIV_2 => 2,
            UCIVR::UCIV_4 => 4,
            UCIVR::UCIV_6 => 6,
            UCIVR::UCIV_8 => 8,
            UCIVR::UCIV_10 => 10,
            UCIVR::UCIV_12 => 12,
            UCIVR::UCIV_14 => 14,
            UCIVR::UCIV_16 => 16,
            UCIVR::UCIV_18 => 18,
            UCIVR::UCIV_20 => 20,
            UCIVR::UCIV_22 => 22,
            UCIVR::UCIV_24 => 24,
            UCIVR::UCIV_26 => 26,
            UCIVR::UCIV_28 => 28,
            UCIVR::UCIV_30 => 30,
            UCIVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u16) -> UCIVR {
        match value {
            0 => UCIVR::UCIV_0,
            2 => UCIVR::UCIV_2,
            4 => UCIVR::UCIV_4,
            6 => UCIVR::UCIV_6,
            8 => UCIVR::UCIV_8,
            10 => UCIVR::UCIV_10,
            12 => UCIVR::UCIV_12,
            14 => UCIVR::UCIV_14,
            16 => UCIVR::UCIV_16,
            18 => UCIVR::UCIV_18,
            20 => UCIVR::UCIV_20,
            22 => UCIVR::UCIV_22,
            24 => UCIVR::UCIV_24,
            26 => UCIVR::UCIV_26,
            28 => UCIVR::UCIV_28,
            30 => UCIVR::UCIV_30,
            i => UCIVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `UCIV_0`"]
    #[inline]
    pub fn is_uciv_0(&self) -> bool {
        *self == UCIVR::UCIV_0
    }
    #[doc = "Checks if the value of the field is `UCIV_2`"]
    #[inline]
    pub fn is_uciv_2(&self) -> bool {
        *self == UCIVR::UCIV_2
    }
    #[doc = "Checks if the value of the field is `UCIV_4`"]
    #[inline]
    pub fn is_uciv_4(&self) -> bool {
        *self == UCIVR::UCIV_4
    }
    #[doc = "Checks if the value of the field is `UCIV_6`"]
    #[inline]
    pub fn is_uciv_6(&self) -> bool {
        *self == UCIVR::UCIV_6
    }
    #[doc = "Checks if the value of the field is `UCIV_8`"]
    #[inline]
    pub fn is_uciv_8(&self) -> bool {
        *self == UCIVR::UCIV_8
    }
    #[doc = "Checks if the value of the field is `UCIV_10`"]
    #[inline]
    pub fn is_uciv_10(&self) -> bool {
        *self == UCIVR::UCIV_10
    }
    #[doc = "Checks if the value of the field is `UCIV_12`"]
    #[inline]
    pub fn is_uciv_12(&self) -> bool {
        *self == UCIVR::UCIV_12
    }
    #[doc = "Checks if the value of the field is `UCIV_14`"]
    #[inline]
    pub fn is_uciv_14(&self) -> bool {
        *self == UCIVR::UCIV_14
    }
    #[doc = "Checks if the value of the field is `UCIV_16`"]
    #[inline]
    pub fn is_uciv_16(&self) -> bool {
        *self == UCIVR::UCIV_16
    }
    #[doc = "Checks if the value of the field is `UCIV_18`"]
    #[inline]
    pub fn is_uciv_18(&self) -> bool {
        *self == UCIVR::UCIV_18
    }
    #[doc = "Checks if the value of the field is `UCIV_20`"]
    #[inline]
    pub fn is_uciv_20(&self) -> bool {
        *self == UCIVR::UCIV_20
    }
    #[doc = "Checks if the value of the field is `UCIV_22`"]
    #[inline]
    pub fn is_uciv_22(&self) -> bool {
        *self == UCIVR::UCIV_22
    }
    #[doc = "Checks if the value of the field is `UCIV_24`"]
    #[inline]
    pub fn is_uciv_24(&self) -> bool {
        *self == UCIVR::UCIV_24
    }
    #[doc = "Checks if the value of the field is `UCIV_26`"]
    #[inline]
    pub fn is_uciv_26(&self) -> bool {
        *self == UCIVR::UCIV_26
    }
    #[doc = "Checks if the value of the field is `UCIV_28`"]
    #[inline]
    pub fn is_uciv_28(&self) -> bool {
        *self == UCIVR::UCIV_28
    }
    #[doc = "Checks if the value of the field is `UCIV_30`"]
    #[inline]
    pub fn is_uciv_30(&self) -> bool {
        *self == UCIVR::UCIV_30
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:15 - eUSCI_B interrupt vector value"]
    #[inline]
    pub fn uciv(&self) -> UCIVR {
        UCIVR::_from({
            const MASK: u16 = 65535;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        })
    }
}
