#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_BANK1_RDCTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `RD_MODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RD_MODER {
    #[doc = "Normal read mode"]
    RD_MODE_0,
    #[doc = "Read Margin 0"]
    RD_MODE_1,
    #[doc = "Read Margin 1"]
    RD_MODE_2,
    #[doc = "Program Verify"]
    RD_MODE_3,
    #[doc = "Erase Verify"]
    RD_MODE_4,
    #[doc = "Leakage Verify"]
    RD_MODE_5,
    #[doc = "Read Margin 0B"]
    RD_MODE_9,
    #[doc = "Read Margin 1B"]
    RD_MODE_10,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl RD_MODER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RD_MODER::RD_MODE_0 => 0,
            RD_MODER::RD_MODE_1 => 1,
            RD_MODER::RD_MODE_2 => 2,
            RD_MODER::RD_MODE_3 => 3,
            RD_MODER::RD_MODE_4 => 4,
            RD_MODER::RD_MODE_5 => 5,
            RD_MODER::RD_MODE_9 => 9,
            RD_MODER::RD_MODE_10 => 10,
            RD_MODER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RD_MODER {
        match value {
            0 => RD_MODER::RD_MODE_0,
            1 => RD_MODER::RD_MODE_1,
            2 => RD_MODER::RD_MODE_2,
            3 => RD_MODER::RD_MODE_3,
            4 => RD_MODER::RD_MODE_4,
            5 => RD_MODER::RD_MODE_5,
            9 => RD_MODER::RD_MODE_9,
            10 => RD_MODER::RD_MODE_10,
            i => RD_MODER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RD_MODE_0`"]
    #[inline]
    pub fn is_rd_mode_0(&self) -> bool {
        *self == RD_MODER::RD_MODE_0
    }
    #[doc = "Checks if the value of the field is `RD_MODE_1`"]
    #[inline]
    pub fn is_rd_mode_1(&self) -> bool {
        *self == RD_MODER::RD_MODE_1
    }
    #[doc = "Checks if the value of the field is `RD_MODE_2`"]
    #[inline]
    pub fn is_rd_mode_2(&self) -> bool {
        *self == RD_MODER::RD_MODE_2
    }
    #[doc = "Checks if the value of the field is `RD_MODE_3`"]
    #[inline]
    pub fn is_rd_mode_3(&self) -> bool {
        *self == RD_MODER::RD_MODE_3
    }
    #[doc = "Checks if the value of the field is `RD_MODE_4`"]
    #[inline]
    pub fn is_rd_mode_4(&self) -> bool {
        *self == RD_MODER::RD_MODE_4
    }
    #[doc = "Checks if the value of the field is `RD_MODE_5`"]
    #[inline]
    pub fn is_rd_mode_5(&self) -> bool {
        *self == RD_MODER::RD_MODE_5
    }
    #[doc = "Checks if the value of the field is `RD_MODE_9`"]
    #[inline]
    pub fn is_rd_mode_9(&self) -> bool {
        *self == RD_MODER::RD_MODE_9
    }
    #[doc = "Checks if the value of the field is `RD_MODE_10`"]
    #[inline]
    pub fn is_rd_mode_10(&self) -> bool {
        *self == RD_MODER::RD_MODE_10
    }
}
#[doc = r" Value of the field"]
pub struct BUFIR {
    bits: bool,
}
impl BUFIR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct BUFDR {
    bits: bool,
}
impl BUFDR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `RD_MODE_STATUS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RD_MODE_STATUSR {
    #[doc = "Normal read mode"]
    RD_MODE_STATUS_0,
    #[doc = "Read Margin 0"]
    RD_MODE_STATUS_1,
    #[doc = "Read Margin 1"]
    RD_MODE_STATUS_2,
    #[doc = "Program Verify"]
    RD_MODE_STATUS_3,
    #[doc = "Erase Verify"]
    RD_MODE_STATUS_4,
    #[doc = "Leakage Verify"]
    RD_MODE_STATUS_5,
    #[doc = "Read Margin 0B"]
    RD_MODE_STATUS_9,
    #[doc = "Read Margin 1B"]
    RD_MODE_STATUS_10,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl RD_MODE_STATUSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RD_MODE_STATUSR::RD_MODE_STATUS_0 => 0,
            RD_MODE_STATUSR::RD_MODE_STATUS_1 => 1,
            RD_MODE_STATUSR::RD_MODE_STATUS_2 => 2,
            RD_MODE_STATUSR::RD_MODE_STATUS_3 => 3,
            RD_MODE_STATUSR::RD_MODE_STATUS_4 => 4,
            RD_MODE_STATUSR::RD_MODE_STATUS_5 => 5,
            RD_MODE_STATUSR::RD_MODE_STATUS_9 => 9,
            RD_MODE_STATUSR::RD_MODE_STATUS_10 => 10,
            RD_MODE_STATUSR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RD_MODE_STATUSR {
        match value {
            0 => RD_MODE_STATUSR::RD_MODE_STATUS_0,
            1 => RD_MODE_STATUSR::RD_MODE_STATUS_1,
            2 => RD_MODE_STATUSR::RD_MODE_STATUS_2,
            3 => RD_MODE_STATUSR::RD_MODE_STATUS_3,
            4 => RD_MODE_STATUSR::RD_MODE_STATUS_4,
            5 => RD_MODE_STATUSR::RD_MODE_STATUS_5,
            9 => RD_MODE_STATUSR::RD_MODE_STATUS_9,
            10 => RD_MODE_STATUSR::RD_MODE_STATUS_10,
            i => RD_MODE_STATUSR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_0`"]
    #[inline]
    pub fn is_rd_mode_status_0(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_0
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_1`"]
    #[inline]
    pub fn is_rd_mode_status_1(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_1
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_2`"]
    #[inline]
    pub fn is_rd_mode_status_2(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_2
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_3`"]
    #[inline]
    pub fn is_rd_mode_status_3(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_3
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_4`"]
    #[inline]
    pub fn is_rd_mode_status_4(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_4
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_5`"]
    #[inline]
    pub fn is_rd_mode_status_5(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_5
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_9`"]
    #[inline]
    pub fn is_rd_mode_status_9(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_9
    }
    #[doc = "Checks if the value of the field is `RD_MODE_STATUS_10`"]
    #[inline]
    pub fn is_rd_mode_status_10(&self) -> bool {
        *self == RD_MODE_STATUSR::RD_MODE_STATUS_10
    }
}
#[doc = "Possible values of the field `WAIT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITR {
    #[doc = "0 wait states"]
    WAIT_0,
    #[doc = "1 wait states"]
    WAIT_1,
    #[doc = "2 wait states"]
    WAIT_2,
    #[doc = "3 wait states"]
    WAIT_3,
    #[doc = "4 wait states"]
    WAIT_4,
    #[doc = "5 wait states"]
    WAIT_5,
    #[doc = "6 wait states"]
    WAIT_6,
    #[doc = "7 wait states"]
    WAIT_7,
    #[doc = "8 wait states"]
    WAIT_8,
    #[doc = "9 wait states"]
    WAIT_9,
    #[doc = "10 wait states"]
    WAIT_10,
    #[doc = "11 wait states"]
    WAIT_11,
    #[doc = "12 wait states"]
    WAIT_12,
    #[doc = "13 wait states"]
    WAIT_13,
    #[doc = "14 wait states"]
    WAIT_14,
    #[doc = "15 wait states"]
    WAIT_15,
}
impl WAITR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            WAITR::WAIT_0 => 0,
            WAITR::WAIT_1 => 1,
            WAITR::WAIT_2 => 2,
            WAITR::WAIT_3 => 3,
            WAITR::WAIT_4 => 4,
            WAITR::WAIT_5 => 5,
            WAITR::WAIT_6 => 6,
            WAITR::WAIT_7 => 7,
            WAITR::WAIT_8 => 8,
            WAITR::WAIT_9 => 9,
            WAITR::WAIT_10 => 10,
            WAITR::WAIT_11 => 11,
            WAITR::WAIT_12 => 12,
            WAITR::WAIT_13 => 13,
            WAITR::WAIT_14 => 14,
            WAITR::WAIT_15 => 15,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> WAITR {
        match value {
            0 => WAITR::WAIT_0,
            1 => WAITR::WAIT_1,
            2 => WAITR::WAIT_2,
            3 => WAITR::WAIT_3,
            4 => WAITR::WAIT_4,
            5 => WAITR::WAIT_5,
            6 => WAITR::WAIT_6,
            7 => WAITR::WAIT_7,
            8 => WAITR::WAIT_8,
            9 => WAITR::WAIT_9,
            10 => WAITR::WAIT_10,
            11 => WAITR::WAIT_11,
            12 => WAITR::WAIT_12,
            13 => WAITR::WAIT_13,
            14 => WAITR::WAIT_14,
            15 => WAITR::WAIT_15,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `WAIT_0`"]
    #[inline]
    pub fn is_wait_0(&self) -> bool {
        *self == WAITR::WAIT_0
    }
    #[doc = "Checks if the value of the field is `WAIT_1`"]
    #[inline]
    pub fn is_wait_1(&self) -> bool {
        *self == WAITR::WAIT_1
    }
    #[doc = "Checks if the value of the field is `WAIT_2`"]
    #[inline]
    pub fn is_wait_2(&self) -> bool {
        *self == WAITR::WAIT_2
    }
    #[doc = "Checks if the value of the field is `WAIT_3`"]
    #[inline]
    pub fn is_wait_3(&self) -> bool {
        *self == WAITR::WAIT_3
    }
    #[doc = "Checks if the value of the field is `WAIT_4`"]
    #[inline]
    pub fn is_wait_4(&self) -> bool {
        *self == WAITR::WAIT_4
    }
    #[doc = "Checks if the value of the field is `WAIT_5`"]
    #[inline]
    pub fn is_wait_5(&self) -> bool {
        *self == WAITR::WAIT_5
    }
    #[doc = "Checks if the value of the field is `WAIT_6`"]
    #[inline]
    pub fn is_wait_6(&self) -> bool {
        *self == WAITR::WAIT_6
    }
    #[doc = "Checks if the value of the field is `WAIT_7`"]
    #[inline]
    pub fn is_wait_7(&self) -> bool {
        *self == WAITR::WAIT_7
    }
    #[doc = "Checks if the value of the field is `WAIT_8`"]
    #[inline]
    pub fn is_wait_8(&self) -> bool {
        *self == WAITR::WAIT_8
    }
    #[doc = "Checks if the value of the field is `WAIT_9`"]
    #[inline]
    pub fn is_wait_9(&self) -> bool {
        *self == WAITR::WAIT_9
    }
    #[doc = "Checks if the value of the field is `WAIT_10`"]
    #[inline]
    pub fn is_wait_10(&self) -> bool {
        *self == WAITR::WAIT_10
    }
    #[doc = "Checks if the value of the field is `WAIT_11`"]
    #[inline]
    pub fn is_wait_11(&self) -> bool {
        *self == WAITR::WAIT_11
    }
    #[doc = "Checks if the value of the field is `WAIT_12`"]
    #[inline]
    pub fn is_wait_12(&self) -> bool {
        *self == WAITR::WAIT_12
    }
    #[doc = "Checks if the value of the field is `WAIT_13`"]
    #[inline]
    pub fn is_wait_13(&self) -> bool {
        *self == WAITR::WAIT_13
    }
    #[doc = "Checks if the value of the field is `WAIT_14`"]
    #[inline]
    pub fn is_wait_14(&self) -> bool {
        *self == WAITR::WAIT_14
    }
    #[doc = "Checks if the value of the field is `WAIT_15`"]
    #[inline]
    pub fn is_wait_15(&self) -> bool {
        *self == WAITR::WAIT_15
    }
}
#[doc = "Values that can be written to the field `RD_MODE`"]
pub enum RD_MODEW {
    #[doc = "Normal read mode"]
    RD_MODE_0,
    #[doc = "Read Margin 0"]
    RD_MODE_1,
    #[doc = "Read Margin 1"]
    RD_MODE_2,
    #[doc = "Program Verify"]
    RD_MODE_3,
    #[doc = "Erase Verify"]
    RD_MODE_4,
    #[doc = "Leakage Verify"]
    RD_MODE_5,
    #[doc = "Read Margin 0B"]
    RD_MODE_9,
    #[doc = "Read Margin 1B"]
    RD_MODE_10,
}
impl RD_MODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RD_MODEW::RD_MODE_0 => 0,
            RD_MODEW::RD_MODE_1 => 1,
            RD_MODEW::RD_MODE_2 => 2,
            RD_MODEW::RD_MODE_3 => 3,
            RD_MODEW::RD_MODE_4 => 4,
            RD_MODEW::RD_MODE_5 => 5,
            RD_MODEW::RD_MODE_9 => 9,
            RD_MODEW::RD_MODE_10 => 10,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RD_MODEW<'a> {
    w: &'a mut W,
}
impl<'a> _RD_MODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RD_MODEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Normal read mode"]
    #[inline]
    pub fn rd_mode_0(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_0)
    }
    #[doc = "Read Margin 0"]
    #[inline]
    pub fn rd_mode_1(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_1)
    }
    #[doc = "Read Margin 1"]
    #[inline]
    pub fn rd_mode_2(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_2)
    }
    #[doc = "Program Verify"]
    #[inline]
    pub fn rd_mode_3(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_3)
    }
    #[doc = "Erase Verify"]
    #[inline]
    pub fn rd_mode_4(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_4)
    }
    #[doc = "Leakage Verify"]
    #[inline]
    pub fn rd_mode_5(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_5)
    }
    #[doc = "Read Margin 0B"]
    #[inline]
    pub fn rd_mode_9(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_9)
    }
    #[doc = "Read Margin 1B"]
    #[inline]
    pub fn rd_mode_10(self) -> &'a mut W {
        self.variant(RD_MODEW::RD_MODE_10)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _BUFIW<'a> {
    w: &'a mut W,
}
impl<'a> _BUFIW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _BUFDW<'a> {
    w: &'a mut W,
}
impl<'a> _BUFDW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `WAIT`"]
pub enum WAITW {
    #[doc = "0 wait states"]
    WAIT_0,
    #[doc = "1 wait states"]
    WAIT_1,
    #[doc = "2 wait states"]
    WAIT_2,
    #[doc = "3 wait states"]
    WAIT_3,
    #[doc = "4 wait states"]
    WAIT_4,
    #[doc = "5 wait states"]
    WAIT_5,
    #[doc = "6 wait states"]
    WAIT_6,
    #[doc = "7 wait states"]
    WAIT_7,
    #[doc = "8 wait states"]
    WAIT_8,
    #[doc = "9 wait states"]
    WAIT_9,
    #[doc = "10 wait states"]
    WAIT_10,
    #[doc = "11 wait states"]
    WAIT_11,
    #[doc = "12 wait states"]
    WAIT_12,
    #[doc = "13 wait states"]
    WAIT_13,
    #[doc = "14 wait states"]
    WAIT_14,
    #[doc = "15 wait states"]
    WAIT_15,
}
impl WAITW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            WAITW::WAIT_0 => 0,
            WAITW::WAIT_1 => 1,
            WAITW::WAIT_2 => 2,
            WAITW::WAIT_3 => 3,
            WAITW::WAIT_4 => 4,
            WAITW::WAIT_5 => 5,
            WAITW::WAIT_6 => 6,
            WAITW::WAIT_7 => 7,
            WAITW::WAIT_8 => 8,
            WAITW::WAIT_9 => 9,
            WAITW::WAIT_10 => 10,
            WAITW::WAIT_11 => 11,
            WAITW::WAIT_12 => 12,
            WAITW::WAIT_13 => 13,
            WAITW::WAIT_14 => 14,
            WAITW::WAIT_15 => 15,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WAITW<'a> {
    w: &'a mut W,
}
impl<'a> _WAITW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WAITW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "0 wait states"]
    #[inline]
    pub fn wait_0(self) -> &'a mut W {
        self.variant(WAITW::WAIT_0)
    }
    #[doc = "1 wait states"]
    #[inline]
    pub fn wait_1(self) -> &'a mut W {
        self.variant(WAITW::WAIT_1)
    }
    #[doc = "2 wait states"]
    #[inline]
    pub fn wait_2(self) -> &'a mut W {
        self.variant(WAITW::WAIT_2)
    }
    #[doc = "3 wait states"]
    #[inline]
    pub fn wait_3(self) -> &'a mut W {
        self.variant(WAITW::WAIT_3)
    }
    #[doc = "4 wait states"]
    #[inline]
    pub fn wait_4(self) -> &'a mut W {
        self.variant(WAITW::WAIT_4)
    }
    #[doc = "5 wait states"]
    #[inline]
    pub fn wait_5(self) -> &'a mut W {
        self.variant(WAITW::WAIT_5)
    }
    #[doc = "6 wait states"]
    #[inline]
    pub fn wait_6(self) -> &'a mut W {
        self.variant(WAITW::WAIT_6)
    }
    #[doc = "7 wait states"]
    #[inline]
    pub fn wait_7(self) -> &'a mut W {
        self.variant(WAITW::WAIT_7)
    }
    #[doc = "8 wait states"]
    #[inline]
    pub fn wait_8(self) -> &'a mut W {
        self.variant(WAITW::WAIT_8)
    }
    #[doc = "9 wait states"]
    #[inline]
    pub fn wait_9(self) -> &'a mut W {
        self.variant(WAITW::WAIT_9)
    }
    #[doc = "10 wait states"]
    #[inline]
    pub fn wait_10(self) -> &'a mut W {
        self.variant(WAITW::WAIT_10)
    }
    #[doc = "11 wait states"]
    #[inline]
    pub fn wait_11(self) -> &'a mut W {
        self.variant(WAITW::WAIT_11)
    }
    #[doc = "12 wait states"]
    #[inline]
    pub fn wait_12(self) -> &'a mut W {
        self.variant(WAITW::WAIT_12)
    }
    #[doc = "13 wait states"]
    #[inline]
    pub fn wait_13(self) -> &'a mut W {
        self.variant(WAITW::WAIT_13)
    }
    #[doc = "14 wait states"]
    #[inline]
    pub fn wait_14(self) -> &'a mut W {
        self.variant(WAITW::WAIT_14)
    }
    #[doc = "15 wait states"]
    #[inline]
    pub fn wait_15(self) -> &'a mut W {
        self.variant(WAITW::WAIT_15)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:3 - Flash read mode control setting for Bank 0"]
    #[inline]
    pub fn rd_mode(&self) -> RD_MODER {
        RD_MODER::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 4 - Enables read buffering feature for instruction fetches to this Bank"]
    #[inline]
    pub fn bufi(&self) -> BUFIR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        BUFIR { bits }
    }
    #[doc = "Bit 5 - Enables read buffering feature for data reads to this Bank"]
    #[inline]
    pub fn bufd(&self) -> BUFDR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        BUFDR { bits }
    }
    #[doc = "Bits 16:19 - Read mode"]
    #[inline]
    pub fn rd_mode_status(&self) -> RD_MODE_STATUSR {
        RD_MODE_STATUSR::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 12:15 - Number of wait states for read"]
    #[inline]
    pub fn wait(&self) -> WAITR {
        WAITR::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:3 - Flash read mode control setting for Bank 0"]
    #[inline]
    pub fn rd_mode(&mut self) -> _RD_MODEW {
        _RD_MODEW { w: self }
    }
    #[doc = "Bit 4 - Enables read buffering feature for instruction fetches to this Bank"]
    #[inline]
    pub fn bufi(&mut self) -> _BUFIW {
        _BUFIW { w: self }
    }
    #[doc = "Bit 5 - Enables read buffering feature for data reads to this Bank"]
    #[inline]
    pub fn bufd(&mut self) -> _BUFDW {
        _BUFDW { w: self }
    }
    #[doc = "Bits 12:15 - Number of wait states for read"]
    #[inline]
    pub fn wait(&mut self) -> _WAITW {
        _WAITW { w: self }
    }
}
