#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_BMRK_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct I_BMRKR {
    bits: bool,
}
impl I_BMRKR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct D_BMRKR {
    bits: bool,
}
impl D_BMRKR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct CMP_ENR {
    bits: bool,
}
impl CMP_ENR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `CMP_SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CMP_SELR {
    #[doc = "Compares the Instruction Benchmark Register against the threshold value"]
    EN_1_0X0,
    #[doc = "Compares the Data Benchmark Register against the threshold value"]
    EN_2_0X1,
}
impl CMP_SELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CMP_SELR::EN_1_0X0 => false,
            CMP_SELR::EN_2_0X1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CMP_SELR {
        match value {
            false => CMP_SELR::EN_1_0X0,
            true => CMP_SELR::EN_2_0X1,
        }
    }
    #[doc = "Checks if the value of the field is `EN_1_0X0`"]
    #[inline]
    pub fn is_en_1_0x0(&self) -> bool {
        *self == CMP_SELR::EN_1_0X0
    }
    #[doc = "Checks if the value of the field is `EN_2_0X1`"]
    #[inline]
    pub fn is_en_2_0x1(&self) -> bool {
        *self == CMP_SELR::EN_2_0X1
    }
}
#[doc = r" Proxy"]
pub struct _I_BMRKW<'a> {
    w: &'a mut W,
}
impl<'a> _I_BMRKW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _D_BMRKW<'a> {
    w: &'a mut W,
}
impl<'a> _D_BMRKW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CMP_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _CMP_ENW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CMP_SEL`"]
pub enum CMP_SELW {
    #[doc = "Compares the Instruction Benchmark Register against the threshold value"]
    EN_1_0X0,
    #[doc = "Compares the Data Benchmark Register against the threshold value"]
    EN_2_0X1,
}
impl CMP_SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CMP_SELW::EN_1_0X0 => false,
            CMP_SELW::EN_2_0X1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CMP_SELW<'a> {
    w: &'a mut W,
}
impl<'a> _CMP_SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CMP_SELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Compares the Instruction Benchmark Register against the threshold value"]
    #[inline]
    pub fn en_1_0x0(self) -> &'a mut W {
        self.variant(CMP_SELW::EN_1_0X0)
    }
    #[doc = "Compares the Data Benchmark Register against the threshold value"]
    #[inline]
    pub fn en_2_0x1(self) -> &'a mut W {
        self.variant(CMP_SELW::EN_2_0X1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - When 1, increments the Instruction Benchmark count register on each instruction fetch to the Flash"]
    #[inline]
    pub fn i_bmrk(&self) -> I_BMRKR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        I_BMRKR { bits }
    }
    #[doc = "Bit 1 - When 1, increments the Data Benchmark count register on each data read access to the Flash"]
    #[inline]
    pub fn d_bmrk(&self) -> D_BMRKR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        D_BMRKR { bits }
    }
    #[doc = "Bit 2 - When 1, enables comparison of the Instruction or Data Benchmark Registers against the threshold value"]
    #[inline]
    pub fn cmp_en(&self) -> CMP_ENR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        CMP_ENR { bits }
    }
    #[doc = "Bit 3 - Selects which benchmark register should be compared against the threshold"]
    #[inline]
    pub fn cmp_sel(&self) -> CMP_SELR {
        CMP_SELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - When 1, increments the Instruction Benchmark count register on each instruction fetch to the Flash"]
    #[inline]
    pub fn i_bmrk(&mut self) -> _I_BMRKW {
        _I_BMRKW { w: self }
    }
    #[doc = "Bit 1 - When 1, increments the Data Benchmark count register on each data read access to the Flash"]
    #[inline]
    pub fn d_bmrk(&mut self) -> _D_BMRKW {
        _D_BMRKW { w: self }
    }
    #[doc = "Bit 2 - When 1, enables comparison of the Instruction or Data Benchmark Registers against the threshold value"]
    #[inline]
    pub fn cmp_en(&mut self) -> _CMP_ENW {
        _CMP_ENW { w: self }
    }
    #[doc = "Bit 3 - Selects which benchmark register should be compared against the threshold"]
    #[inline]
    pub fn cmp_sel(&mut self) -> _CMP_SELW {
        _CMP_SELW { w: self }
    }
}
