#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_ERASE_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `MODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MODER {
    #[doc = "Sector Erase (controlled by FLTCTL_ERASE_SECTADDR)"]
    MODE_0,
    #[doc = "Mass Erase (includes all Main and Information memory sectors that don't have corresponding WE bits set)"]
    MODE_1,
}
impl MODER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            MODER::MODE_0 => false,
            MODER::MODE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> MODER {
        match value {
            false => MODER::MODE_0,
            true => MODER::MODE_1,
        }
    }
    #[doc = "Checks if the value of the field is `MODE_0`"]
    #[inline]
    pub fn is_mode_0(&self) -> bool {
        *self == MODER::MODE_0
    }
    #[doc = "Checks if the value of the field is `MODE_1`"]
    #[inline]
    pub fn is_mode_1(&self) -> bool {
        *self == MODER::MODE_1
    }
}
#[doc = "Possible values of the field `TYPE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TYPER {
    #[doc = "Main Memory"]
    TYPE_0,
    #[doc = "Information Memory"]
    TYPE_1,
    #[doc = "Engineering Memory"]
    TYPE_3,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl TYPER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            TYPER::TYPE_0 => 0,
            TYPER::TYPE_1 => 1,
            TYPER::TYPE_3 => 3,
            TYPER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> TYPER {
        match value {
            0 => TYPER::TYPE_0,
            1 => TYPER::TYPE_1,
            3 => TYPER::TYPE_3,
            i => TYPER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `TYPE_0`"]
    #[inline]
    pub fn is_type_0(&self) -> bool {
        *self == TYPER::TYPE_0
    }
    #[doc = "Checks if the value of the field is `TYPE_1`"]
    #[inline]
    pub fn is_type_1(&self) -> bool {
        *self == TYPER::TYPE_1
    }
    #[doc = "Checks if the value of the field is `TYPE_3`"]
    #[inline]
    pub fn is_type_3(&self) -> bool {
        *self == TYPER::TYPE_3
    }
}
#[doc = "Possible values of the field `STATUS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum STATUSR {
    #[doc = "Idle (no program operation currently active)"]
    STATUS_0,
    #[doc = "Erase operation triggered to START but pending"]
    STATUS_1,
    #[doc = "Erase operation in progress"]
    STATUS_2,
    #[doc = "Erase operation completed (status of completed erase remains in this state unless explicitly cleared by SW)"]
    STATUS_3,
}
impl STATUSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            STATUSR::STATUS_0 => 0,
            STATUSR::STATUS_1 => 1,
            STATUSR::STATUS_2 => 2,
            STATUSR::STATUS_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> STATUSR {
        match value {
            0 => STATUSR::STATUS_0,
            1 => STATUSR::STATUS_1,
            2 => STATUSR::STATUS_2,
            3 => STATUSR::STATUS_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `STATUS_0`"]
    #[inline]
    pub fn is_status_0(&self) -> bool {
        *self == STATUSR::STATUS_0
    }
    #[doc = "Checks if the value of the field is `STATUS_1`"]
    #[inline]
    pub fn is_status_1(&self) -> bool {
        *self == STATUSR::STATUS_1
    }
    #[doc = "Checks if the value of the field is `STATUS_2`"]
    #[inline]
    pub fn is_status_2(&self) -> bool {
        *self == STATUSR::STATUS_2
    }
    #[doc = "Checks if the value of the field is `STATUS_3`"]
    #[inline]
    pub fn is_status_3(&self) -> bool {
        *self == STATUSR::STATUS_3
    }
}
#[doc = r" Value of the field"]
pub struct ADDR_ERRR {
    bits: bool,
}
impl ADDR_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Proxy"]
pub struct _STARTW<'a> {
    w: &'a mut W,
}
impl<'a> _STARTW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `MODE`"]
pub enum MODEW {
    #[doc = "Sector Erase (controlled by FLTCTL_ERASE_SECTADDR)"]
    MODE_0,
    #[doc = "Mass Erase (includes all Main and Information memory sectors that don't have corresponding WE bits set)"]
    MODE_1,
}
impl MODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            MODEW::MODE_0 => false,
            MODEW::MODE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _MODEW<'a> {
    w: &'a mut W,
}
impl<'a> _MODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: MODEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Sector Erase (controlled by FLTCTL_ERASE_SECTADDR)"]
    #[inline]
    pub fn mode_0(self) -> &'a mut W {
        self.variant(MODEW::MODE_0)
    }
    #[doc = "Mass Erase (includes all Main and Information memory sectors that don't have corresponding WE bits set)"]
    #[inline]
    pub fn mode_1(self) -> &'a mut W {
        self.variant(MODEW::MODE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TYPE`"]
pub enum TYPEW {
    #[doc = "Main Memory"]
    TYPE_0,
    #[doc = "Information Memory"]
    TYPE_1,
    #[doc = "Engineering Memory"]
    TYPE_3,
}
impl TYPEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            TYPEW::TYPE_0 => 0,
            TYPEW::TYPE_1 => 1,
            TYPEW::TYPE_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TYPEW<'a> {
    w: &'a mut W,
}
impl<'a> _TYPEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TYPEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Main Memory"]
    #[inline]
    pub fn type_0(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_0)
    }
    #[doc = "Information Memory"]
    #[inline]
    pub fn type_1(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_1)
    }
    #[doc = "Engineering Memory"]
    #[inline]
    pub fn type_3(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_STATW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_STATW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 19;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 1 - Erase mode selected by application"]
    #[inline]
    pub fn mode(&self) -> MODER {
        MODER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 2:3 - Type of memory that erase operation is carried out on"]
    #[inline]
    pub fn type_(&self) -> TYPER {
        TYPER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 16:17 - Status of erase operations in the Flash memory"]
    #[inline]
    pub fn status(&self) -> STATUSR {
        STATUSR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 18 - Erase Operation was terminated due to attempted erase of reserved memory address"]
    #[inline]
    pub fn addr_err(&self) -> ADDR_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        ADDR_ERRR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Start of Erase operation"]
    #[inline]
    pub fn start(&mut self) -> _STARTW {
        _STARTW { w: self }
    }
    #[doc = "Bit 1 - Erase mode selected by application"]
    #[inline]
    pub fn mode(&mut self) -> _MODEW {
        _MODEW { w: self }
    }
    #[doc = "Bits 2:3 - Type of memory that erase operation is carried out on"]
    #[inline]
    pub fn type_(&mut self) -> _TYPEW {
        _TYPEW { w: self }
    }
    #[doc = "Bit 19 - Clear status bits 18-16 of this register"]
    #[inline]
    pub fn clr_stat(&mut self) -> _CLR_STATW {
        _CLR_STATW { w: self }
    }
}
