#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::FLCTL_POWER_STAT {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `PSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PSTATR {
    #[doc = "Flash IP in power-down mode"]
    PSTAT_0,
    #[doc = "Flash IP Vdd domain power-up in progress"]
    PSTAT_1,
    #[doc = "PSS LDO_GOOD, IREF_OK and VREF_OK check in progress"]
    PSTAT_2,
    #[doc = "Flash IP SAFE_LV check in progress"]
    PSTAT_3,
    #[doc = "Flash IP Active"]
    PSTAT_4,
    #[doc = "Flash IP Active in Low-Frequency Active and Low-Frequency LPM0 modes."]
    PSTAT_5,
    #[doc = "Flash IP in Standby mode"]
    PSTAT_6,
    #[doc = "Flash IP in Current mirror boost state"]
    PSTAT_7,
}
impl PSTATR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PSTATR::PSTAT_0 => 0,
            PSTATR::PSTAT_1 => 1,
            PSTATR::PSTAT_2 => 2,
            PSTATR::PSTAT_3 => 3,
            PSTATR::PSTAT_4 => 4,
            PSTATR::PSTAT_5 => 5,
            PSTATR::PSTAT_6 => 6,
            PSTATR::PSTAT_7 => 7,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PSTATR {
        match value {
            0 => PSTATR::PSTAT_0,
            1 => PSTATR::PSTAT_1,
            2 => PSTATR::PSTAT_2,
            3 => PSTATR::PSTAT_3,
            4 => PSTATR::PSTAT_4,
            5 => PSTATR::PSTAT_5,
            6 => PSTATR::PSTAT_6,
            7 => PSTATR::PSTAT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `PSTAT_0`"]
    #[inline]
    pub fn is_pstat_0(&self) -> bool {
        *self == PSTATR::PSTAT_0
    }
    #[doc = "Checks if the value of the field is `PSTAT_1`"]
    #[inline]
    pub fn is_pstat_1(&self) -> bool {
        *self == PSTATR::PSTAT_1
    }
    #[doc = "Checks if the value of the field is `PSTAT_2`"]
    #[inline]
    pub fn is_pstat_2(&self) -> bool {
        *self == PSTATR::PSTAT_2
    }
    #[doc = "Checks if the value of the field is `PSTAT_3`"]
    #[inline]
    pub fn is_pstat_3(&self) -> bool {
        *self == PSTATR::PSTAT_3
    }
    #[doc = "Checks if the value of the field is `PSTAT_4`"]
    #[inline]
    pub fn is_pstat_4(&self) -> bool {
        *self == PSTATR::PSTAT_4
    }
    #[doc = "Checks if the value of the field is `PSTAT_5`"]
    #[inline]
    pub fn is_pstat_5(&self) -> bool {
        *self == PSTATR::PSTAT_5
    }
    #[doc = "Checks if the value of the field is `PSTAT_6`"]
    #[inline]
    pub fn is_pstat_6(&self) -> bool {
        *self == PSTATR::PSTAT_6
    }
    #[doc = "Checks if the value of the field is `PSTAT_7`"]
    #[inline]
    pub fn is_pstat_7(&self) -> bool {
        *self == PSTATR::PSTAT_7
    }
}
#[doc = "Possible values of the field `LDOSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LDOSTATR {
    #[doc = "FLDO not GOOD"]
    LDOSTAT_0,
    #[doc = "FLDO GOOD"]
    LDOSTAT_1,
}
impl LDOSTATR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            LDOSTATR::LDOSTAT_0 => false,
            LDOSTATR::LDOSTAT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> LDOSTATR {
        match value {
            false => LDOSTATR::LDOSTAT_0,
            true => LDOSTATR::LDOSTAT_1,
        }
    }
    #[doc = "Checks if the value of the field is `LDOSTAT_0`"]
    #[inline]
    pub fn is_ldostat_0(&self) -> bool {
        *self == LDOSTATR::LDOSTAT_0
    }
    #[doc = "Checks if the value of the field is `LDOSTAT_1`"]
    #[inline]
    pub fn is_ldostat_1(&self) -> bool {
        *self == LDOSTATR::LDOSTAT_1
    }
}
#[doc = "Possible values of the field `VREFSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VREFSTATR {
    #[doc = "Flash LDO not stable"]
    VREFSTAT_0,
    #[doc = "Flash LDO stable"]
    VREFSTAT_1,
}
impl VREFSTATR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            VREFSTATR::VREFSTAT_0 => false,
            VREFSTATR::VREFSTAT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> VREFSTATR {
        match value {
            false => VREFSTATR::VREFSTAT_0,
            true => VREFSTATR::VREFSTAT_1,
        }
    }
    #[doc = "Checks if the value of the field is `VREFSTAT_0`"]
    #[inline]
    pub fn is_vrefstat_0(&self) -> bool {
        *self == VREFSTATR::VREFSTAT_0
    }
    #[doc = "Checks if the value of the field is `VREFSTAT_1`"]
    #[inline]
    pub fn is_vrefstat_1(&self) -> bool {
        *self == VREFSTATR::VREFSTAT_1
    }
}
#[doc = "Possible values of the field `IREFSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IREFSTATR {
    #[doc = "IREF not stable"]
    IREFSTAT_0,
    #[doc = "IREF stable"]
    IREFSTAT_1,
}
impl IREFSTATR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            IREFSTATR::IREFSTAT_0 => false,
            IREFSTATR::IREFSTAT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> IREFSTATR {
        match value {
            false => IREFSTATR::IREFSTAT_0,
            true => IREFSTATR::IREFSTAT_1,
        }
    }
    #[doc = "Checks if the value of the field is `IREFSTAT_0`"]
    #[inline]
    pub fn is_irefstat_0(&self) -> bool {
        *self == IREFSTATR::IREFSTAT_0
    }
    #[doc = "Checks if the value of the field is `IREFSTAT_1`"]
    #[inline]
    pub fn is_irefstat_1(&self) -> bool {
        *self == IREFSTATR::IREFSTAT_1
    }
}
#[doc = "Possible values of the field `TRIMSTAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TRIMSTATR {
    #[doc = "PSS trim not complete"]
    TRIMSTAT_0,
    #[doc = "PSS trim complete"]
    TRIMSTAT_1,
}
impl TRIMSTATR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TRIMSTATR::TRIMSTAT_0 => false,
            TRIMSTATR::TRIMSTAT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TRIMSTATR {
        match value {
            false => TRIMSTATR::TRIMSTAT_0,
            true => TRIMSTATR::TRIMSTAT_1,
        }
    }
    #[doc = "Checks if the value of the field is `TRIMSTAT_0`"]
    #[inline]
    pub fn is_trimstat_0(&self) -> bool {
        *self == TRIMSTATR::TRIMSTAT_0
    }
    #[doc = "Checks if the value of the field is `TRIMSTAT_1`"]
    #[inline]
    pub fn is_trimstat_1(&self) -> bool {
        *self == TRIMSTATR::TRIMSTAT_1
    }
}
#[doc = "Possible values of the field `RD_2T`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RD_2TR {
    #[doc = "Flash reads are in 1T mode"]
    RD_2T_0,
    #[doc = "Flash reads are in 2T mode"]
    RD_2T_1,
}
impl RD_2TR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RD_2TR::RD_2T_0 => false,
            RD_2TR::RD_2T_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RD_2TR {
        match value {
            false => RD_2TR::RD_2T_0,
            true => RD_2TR::RD_2T_1,
        }
    }
    #[doc = "Checks if the value of the field is `RD_2T_0`"]
    #[inline]
    pub fn is_rd_2t_0(&self) -> bool {
        *self == RD_2TR::RD_2T_0
    }
    #[doc = "Checks if the value of the field is `RD_2T_1`"]
    #[inline]
    pub fn is_rd_2t_1(&self) -> bool {
        *self == RD_2TR::RD_2T_1
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:2 - Flash power status"]
    #[inline]
    pub fn pstat(&self) -> PSTATR {
        PSTATR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 3 - PSS FLDO GOOD status"]
    #[inline]
    pub fn ldostat(&self) -> LDOSTATR {
        LDOSTATR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - PSS VREF stable status"]
    #[inline]
    pub fn vrefstat(&self) -> VREFSTATR {
        VREFSTATR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - PSS IREF stable status"]
    #[inline]
    pub fn irefstat(&self) -> IREFSTATR {
        IREFSTATR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - PSS trim done status"]
    #[inline]
    pub fn trimstat(&self) -> TRIMSTATR {
        TRIMSTATR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Indicates if Flash is being accessed in 2T mode"]
    #[inline]
    pub fn rd_2t(&self) -> RD_2TR {
        RD_2TR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
