#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_PRG_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `ENABLE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ENABLER {
    #[doc = "Word program operation disabled"]
    ENABLE_0,
    #[doc = "Word program operation enabled"]
    ENABLE_1,
}
impl ENABLER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            ENABLER::ENABLE_0 => false,
            ENABLER::ENABLE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> ENABLER {
        match value {
            false => ENABLER::ENABLE_0,
            true => ENABLER::ENABLE_1,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_0`"]
    #[inline]
    pub fn is_enable_0(&self) -> bool {
        *self == ENABLER::ENABLE_0
    }
    #[doc = "Checks if the value of the field is `ENABLE_1`"]
    #[inline]
    pub fn is_enable_1(&self) -> bool {
        *self == ENABLER::ENABLE_1
    }
}
#[doc = "Possible values of the field `MODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MODER {
    #[doc = "Write immediate mode. Starts program operation immediately on each write to the Flash"]
    MODE_0,
    #[doc = "Full word write mode. Flash controller collates data over multiple writes to compose the full 128bit word before initiating the program operation"]
    MODE_1,
}
impl MODER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            MODER::MODE_0 => false,
            MODER::MODE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> MODER {
        match value {
            false => MODER::MODE_0,
            true => MODER::MODE_1,
        }
    }
    #[doc = "Checks if the value of the field is `MODE_0`"]
    #[inline]
    pub fn is_mode_0(&self) -> bool {
        *self == MODER::MODE_0
    }
    #[doc = "Checks if the value of the field is `MODE_1`"]
    #[inline]
    pub fn is_mode_1(&self) -> bool {
        *self == MODER::MODE_1
    }
}
#[doc = "Possible values of the field `VER_PRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VER_PRER {
    #[doc = "No pre program verification"]
    VER_PRE_0,
    #[doc = "Pre verify feature automatically invoked for each write operation (irrespective of the mode)"]
    VER_PRE_1,
}
impl VER_PRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            VER_PRER::VER_PRE_0 => false,
            VER_PRER::VER_PRE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> VER_PRER {
        match value {
            false => VER_PRER::VER_PRE_0,
            true => VER_PRER::VER_PRE_1,
        }
    }
    #[doc = "Checks if the value of the field is `VER_PRE_0`"]
    #[inline]
    pub fn is_ver_pre_0(&self) -> bool {
        *self == VER_PRER::VER_PRE_0
    }
    #[doc = "Checks if the value of the field is `VER_PRE_1`"]
    #[inline]
    pub fn is_ver_pre_1(&self) -> bool {
        *self == VER_PRER::VER_PRE_1
    }
}
#[doc = "Possible values of the field `VER_PST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VER_PSTR {
    #[doc = "No post program verification"]
    VER_PST_0,
    #[doc = "Post verify feature automatically invoked for each write operation (irrespective of the mode)"]
    VER_PST_1,
}
impl VER_PSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            VER_PSTR::VER_PST_0 => false,
            VER_PSTR::VER_PST_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> VER_PSTR {
        match value {
            false => VER_PSTR::VER_PST_0,
            true => VER_PSTR::VER_PST_1,
        }
    }
    #[doc = "Checks if the value of the field is `VER_PST_0`"]
    #[inline]
    pub fn is_ver_pst_0(&self) -> bool {
        *self == VER_PSTR::VER_PST_0
    }
    #[doc = "Checks if the value of the field is `VER_PST_1`"]
    #[inline]
    pub fn is_ver_pst_1(&self) -> bool {
        *self == VER_PSTR::VER_PST_1
    }
}
#[doc = "Possible values of the field `STATUS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum STATUSR {
    #[doc = "Idle (no program operation currently active)"]
    STATUS_0,
    #[doc = "Single word program operation triggered, but pending"]
    STATUS_1,
    #[doc = "Single word program in progress"]
    STATUS_2,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl STATUSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            STATUSR::STATUS_0 => 0,
            STATUSR::STATUS_1 => 1,
            STATUSR::STATUS_2 => 2,
            STATUSR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> STATUSR {
        match value {
            0 => STATUSR::STATUS_0,
            1 => STATUSR::STATUS_1,
            2 => STATUSR::STATUS_2,
            i => STATUSR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `STATUS_0`"]
    #[inline]
    pub fn is_status_0(&self) -> bool {
        *self == STATUSR::STATUS_0
    }
    #[doc = "Checks if the value of the field is `STATUS_1`"]
    #[inline]
    pub fn is_status_1(&self) -> bool {
        *self == STATUSR::STATUS_1
    }
    #[doc = "Checks if the value of the field is `STATUS_2`"]
    #[inline]
    pub fn is_status_2(&self) -> bool {
        *self == STATUSR::STATUS_2
    }
}
#[doc = "Possible values of the field `BNK_ACT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK_ACTR {
    #[doc = "Word in Bank0 being programmed"]
    BNK_ACT_0,
    #[doc = "Word in Bank1 being programmed"]
    BNK_ACT_1,
}
impl BNK_ACTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK_ACTR::BNK_ACT_0 => false,
            BNK_ACTR::BNK_ACT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK_ACTR {
        match value {
            false => BNK_ACTR::BNK_ACT_0,
            true => BNK_ACTR::BNK_ACT_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK_ACT_0`"]
    #[inline]
    pub fn is_bnk_act_0(&self) -> bool {
        *self == BNK_ACTR::BNK_ACT_0
    }
    #[doc = "Checks if the value of the field is `BNK_ACT_1`"]
    #[inline]
    pub fn is_bnk_act_1(&self) -> bool {
        *self == BNK_ACTR::BNK_ACT_1
    }
}
#[doc = "Values that can be written to the field `ENABLE`"]
pub enum ENABLEW {
    #[doc = "Word program operation disabled"]
    ENABLE_0,
    #[doc = "Word program operation enabled"]
    ENABLE_1,
}
impl ENABLEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            ENABLEW::ENABLE_0 => false,
            ENABLEW::ENABLE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ENABLEW<'a> {
    w: &'a mut W,
}
impl<'a> _ENABLEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ENABLEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Word program operation disabled"]
    #[inline]
    pub fn enable_0(self) -> &'a mut W {
        self.variant(ENABLEW::ENABLE_0)
    }
    #[doc = "Word program operation enabled"]
    #[inline]
    pub fn enable_1(self) -> &'a mut W {
        self.variant(ENABLEW::ENABLE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `MODE`"]
pub enum MODEW {
    #[doc = "Write immediate mode. Starts program operation immediately on each write to the Flash"]
    MODE_0,
    #[doc = "Full word write mode. Flash controller collates data over multiple writes to compose the full 128bit word before initiating the program operation"]
    MODE_1,
}
impl MODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            MODEW::MODE_0 => false,
            MODEW::MODE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _MODEW<'a> {
    w: &'a mut W,
}
impl<'a> _MODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: MODEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Write immediate mode. Starts program operation immediately on each write to the Flash"]
    #[inline]
    pub fn mode_0(self) -> &'a mut W {
        self.variant(MODEW::MODE_0)
    }
    #[doc = "Full word write mode. Flash controller collates data over multiple writes to compose the full 128bit word before initiating the program operation"]
    #[inline]
    pub fn mode_1(self) -> &'a mut W {
        self.variant(MODEW::MODE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `VER_PRE`"]
pub enum VER_PREW {
    #[doc = "No pre program verification"]
    VER_PRE_0,
    #[doc = "Pre verify feature automatically invoked for each write operation (irrespective of the mode)"]
    VER_PRE_1,
}
impl VER_PREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            VER_PREW::VER_PRE_0 => false,
            VER_PREW::VER_PRE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _VER_PREW<'a> {
    w: &'a mut W,
}
impl<'a> _VER_PREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: VER_PREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No pre program verification"]
    #[inline]
    pub fn ver_pre_0(self) -> &'a mut W {
        self.variant(VER_PREW::VER_PRE_0)
    }
    #[doc = "Pre verify feature automatically invoked for each write operation (irrespective of the mode)"]
    #[inline]
    pub fn ver_pre_1(self) -> &'a mut W {
        self.variant(VER_PREW::VER_PRE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `VER_PST`"]
pub enum VER_PSTW {
    #[doc = "No post program verification"]
    VER_PST_0,
    #[doc = "Post verify feature automatically invoked for each write operation (irrespective of the mode)"]
    VER_PST_1,
}
impl VER_PSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            VER_PSTW::VER_PST_0 => false,
            VER_PSTW::VER_PST_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _VER_PSTW<'a> {
    w: &'a mut W,
}
impl<'a> _VER_PSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: VER_PSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No post program verification"]
    #[inline]
    pub fn ver_pst_0(self) -> &'a mut W {
        self.variant(VER_PSTW::VER_PST_0)
    }
    #[doc = "Post verify feature automatically invoked for each write operation (irrespective of the mode)"]
    #[inline]
    pub fn ver_pst_1(self) -> &'a mut W {
        self.variant(VER_PSTW::VER_PST_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Master control for all word program operations"]
    #[inline]
    pub fn enable(&self) -> ENABLER {
        ENABLER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - Write mode"]
    #[inline]
    pub fn mode(&self) -> MODER {
        MODER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Controls automatic pre program verify operations"]
    #[inline]
    pub fn ver_pre(&self) -> VER_PRER {
        VER_PRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - Controls automatic post program verify operations"]
    #[inline]
    pub fn ver_pst(&self) -> VER_PSTR {
        VER_PSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 16:17 - Status of program operations in the Flash memory"]
    #[inline]
    pub fn status(&self) -> STATUSR {
        STATUSR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 18 - Bank active"]
    #[inline]
    pub fn bnk_act(&self) -> BNK_ACTR {
        BNK_ACTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 12 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Master control for all word program operations"]
    #[inline]
    pub fn enable(&mut self) -> _ENABLEW {
        _ENABLEW { w: self }
    }
    #[doc = "Bit 1 - Write mode"]
    #[inline]
    pub fn mode(&mut self) -> _MODEW {
        _MODEW { w: self }
    }
    #[doc = "Bit 2 - Controls automatic pre program verify operations"]
    #[inline]
    pub fn ver_pre(&mut self) -> _VER_PREW {
        _VER_PREW { w: self }
    }
    #[doc = "Bit 3 - Controls automatic post program verify operations"]
    #[inline]
    pub fn ver_pst(&mut self) -> _VER_PSTW {
        _VER_PSTW { w: self }
    }
}
