#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_PRGBRST_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `TYPE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TYPER {
    #[doc = "Main Memory"]
    TYPE_0,
    #[doc = "Information Memory"]
    TYPE_1,
    #[doc = "Engineering Memory"]
    TYPE_3,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl TYPER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            TYPER::TYPE_0 => 0,
            TYPER::TYPE_1 => 1,
            TYPER::TYPE_3 => 3,
            TYPER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> TYPER {
        match value {
            0 => TYPER::TYPE_0,
            1 => TYPER::TYPE_1,
            3 => TYPER::TYPE_3,
            i => TYPER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `TYPE_0`"]
    #[inline]
    pub fn is_type_0(&self) -> bool {
        *self == TYPER::TYPE_0
    }
    #[doc = "Checks if the value of the field is `TYPE_1`"]
    #[inline]
    pub fn is_type_1(&self) -> bool {
        *self == TYPER::TYPE_1
    }
    #[doc = "Checks if the value of the field is `TYPE_3`"]
    #[inline]
    pub fn is_type_3(&self) -> bool {
        *self == TYPER::TYPE_3
    }
}
#[doc = "Possible values of the field `LEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LENR {
    #[doc = "No burst operation"]
    LEN_0,
    #[doc = "1 word burst of 128 bits, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_1,
    #[doc = "2*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_2,
    #[doc = "3*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_3,
    #[doc = "4*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_4,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl LENR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            LENR::LEN_0 => 0,
            LENR::LEN_1 => 1,
            LENR::LEN_2 => 2,
            LENR::LEN_3 => 3,
            LENR::LEN_4 => 4,
            LENR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> LENR {
        match value {
            0 => LENR::LEN_0,
            1 => LENR::LEN_1,
            2 => LENR::LEN_2,
            3 => LENR::LEN_3,
            4 => LENR::LEN_4,
            i => LENR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `LEN_0`"]
    #[inline]
    pub fn is_len_0(&self) -> bool {
        *self == LENR::LEN_0
    }
    #[doc = "Checks if the value of the field is `LEN_1`"]
    #[inline]
    pub fn is_len_1(&self) -> bool {
        *self == LENR::LEN_1
    }
    #[doc = "Checks if the value of the field is `LEN_2`"]
    #[inline]
    pub fn is_len_2(&self) -> bool {
        *self == LENR::LEN_2
    }
    #[doc = "Checks if the value of the field is `LEN_3`"]
    #[inline]
    pub fn is_len_3(&self) -> bool {
        *self == LENR::LEN_3
    }
    #[doc = "Checks if the value of the field is `LEN_4`"]
    #[inline]
    pub fn is_len_4(&self) -> bool {
        *self == LENR::LEN_4
    }
}
#[doc = "Possible values of the field `AUTO_PRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTO_PRER {
    #[doc = "No program verify operations carried out"]
    AUTO_PRE_0,
    #[doc = "Causes an automatic Burst Program Verify after the Burst Program Operation"]
    AUTO_PRE_1,
}
impl AUTO_PRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AUTO_PRER::AUTO_PRE_0 => false,
            AUTO_PRER::AUTO_PRE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AUTO_PRER {
        match value {
            false => AUTO_PRER::AUTO_PRE_0,
            true => AUTO_PRER::AUTO_PRE_1,
        }
    }
    #[doc = "Checks if the value of the field is `AUTO_PRE_0`"]
    #[inline]
    pub fn is_auto_pre_0(&self) -> bool {
        *self == AUTO_PRER::AUTO_PRE_0
    }
    #[doc = "Checks if the value of the field is `AUTO_PRE_1`"]
    #[inline]
    pub fn is_auto_pre_1(&self) -> bool {
        *self == AUTO_PRER::AUTO_PRE_1
    }
}
#[doc = "Possible values of the field `AUTO_PST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTO_PSTR {
    #[doc = "No program verify operations carried out"]
    AUTO_PST_0,
    #[doc = "Causes an automatic Burst Program Verify before the Burst Program Operation"]
    AUTO_PST_1,
}
impl AUTO_PSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AUTO_PSTR::AUTO_PST_0 => false,
            AUTO_PSTR::AUTO_PST_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AUTO_PSTR {
        match value {
            false => AUTO_PSTR::AUTO_PST_0,
            true => AUTO_PSTR::AUTO_PST_1,
        }
    }
    #[doc = "Checks if the value of the field is `AUTO_PST_0`"]
    #[inline]
    pub fn is_auto_pst_0(&self) -> bool {
        *self == AUTO_PSTR::AUTO_PST_0
    }
    #[doc = "Checks if the value of the field is `AUTO_PST_1`"]
    #[inline]
    pub fn is_auto_pst_1(&self) -> bool {
        *self == AUTO_PSTR::AUTO_PST_1
    }
}
#[doc = "Possible values of the field `BURST_STATUS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BURST_STATUSR {
    #[doc = "Idle (Burst not active)"]
    BURST_STATUS_0,
    #[doc = "Burst program started but pending"]
    BURST_STATUS_1,
    #[doc = "Burst active, with 1st 128 bit word being written into Flash"]
    BURST_STATUS_2,
    #[doc = "Burst active, with 2nd 128 bit word being written into Flash"]
    BURST_STATUS_3,
    #[doc = "Burst active, with 3rd 128 bit word being written into Flash"]
    BURST_STATUS_4,
    #[doc = "Burst active, with 4th 128 bit word being written into Flash"]
    BURST_STATUS_5,
    #[doc = "Burst Complete (status of completed burst remains in this state unless explicitly cleared by SW)"]
    BURST_STATUS_7,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl BURST_STATUSR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            BURST_STATUSR::BURST_STATUS_0 => 0,
            BURST_STATUSR::BURST_STATUS_1 => 1,
            BURST_STATUSR::BURST_STATUS_2 => 2,
            BURST_STATUSR::BURST_STATUS_3 => 3,
            BURST_STATUSR::BURST_STATUS_4 => 4,
            BURST_STATUSR::BURST_STATUS_5 => 5,
            BURST_STATUSR::BURST_STATUS_7 => 7,
            BURST_STATUSR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> BURST_STATUSR {
        match value {
            0 => BURST_STATUSR::BURST_STATUS_0,
            1 => BURST_STATUSR::BURST_STATUS_1,
            2 => BURST_STATUSR::BURST_STATUS_2,
            3 => BURST_STATUSR::BURST_STATUS_3,
            4 => BURST_STATUSR::BURST_STATUS_4,
            5 => BURST_STATUSR::BURST_STATUS_5,
            7 => BURST_STATUSR::BURST_STATUS_7,
            i => BURST_STATUSR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_0`"]
    #[inline]
    pub fn is_burst_status_0(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_0
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_1`"]
    #[inline]
    pub fn is_burst_status_1(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_1
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_2`"]
    #[inline]
    pub fn is_burst_status_2(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_2
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_3`"]
    #[inline]
    pub fn is_burst_status_3(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_3
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_4`"]
    #[inline]
    pub fn is_burst_status_4(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_4
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_5`"]
    #[inline]
    pub fn is_burst_status_5(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_5
    }
    #[doc = "Checks if the value of the field is `BURST_STATUS_7`"]
    #[inline]
    pub fn is_burst_status_7(&self) -> bool {
        *self == BURST_STATUSR::BURST_STATUS_7
    }
}
#[doc = r" Value of the field"]
pub struct PRE_ERRR {
    bits: bool,
}
impl PRE_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct PST_ERRR {
    bits: bool,
}
impl PST_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct ADDR_ERRR {
    bits: bool,
}
impl ADDR_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Proxy"]
pub struct _STARTW<'a> {
    w: &'a mut W,
}
impl<'a> _STARTW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TYPE`"]
pub enum TYPEW {
    #[doc = "Main Memory"]
    TYPE_0,
    #[doc = "Information Memory"]
    TYPE_1,
    #[doc = "Engineering Memory"]
    TYPE_3,
}
impl TYPEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            TYPEW::TYPE_0 => 0,
            TYPEW::TYPE_1 => 1,
            TYPEW::TYPE_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TYPEW<'a> {
    w: &'a mut W,
}
impl<'a> _TYPEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TYPEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Main Memory"]
    #[inline]
    pub fn type_0(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_0)
    }
    #[doc = "Information Memory"]
    #[inline]
    pub fn type_1(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_1)
    }
    #[doc = "Engineering Memory"]
    #[inline]
    pub fn type_3(self) -> &'a mut W {
        self.variant(TYPEW::TYPE_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LEN`"]
pub enum LENW {
    #[doc = "No burst operation"]
    LEN_0,
    #[doc = "1 word burst of 128 bits, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_1,
    #[doc = "2*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_2,
    #[doc = "3*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_3,
    #[doc = "4*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    LEN_4,
}
impl LENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            LENW::LEN_0 => 0,
            LENW::LEN_1 => 1,
            LENW::LEN_2 => 2,
            LENW::LEN_3 => 3,
            LENW::LEN_4 => 4,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LENW<'a> {
    w: &'a mut W,
}
impl<'a> _LENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LENW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No burst operation"]
    #[inline]
    pub fn len_0(self) -> &'a mut W {
        self.variant(LENW::LEN_0)
    }
    #[doc = "1 word burst of 128 bits, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    #[inline]
    pub fn len_1(self) -> &'a mut W {
        self.variant(LENW::LEN_1)
    }
    #[doc = "2*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    #[inline]
    pub fn len_2(self) -> &'a mut W {
        self.variant(LENW::LEN_2)
    }
    #[doc = "3*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    #[inline]
    pub fn len_3(self) -> &'a mut W {
        self.variant(LENW::LEN_3)
    }
    #[doc = "4*128 bits burst write, starting with address in the FLCTL_PRGBRST_STARTADDR Register"]
    #[inline]
    pub fn len_4(self) -> &'a mut W {
        self.variant(LENW::LEN_4)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `AUTO_PRE`"]
pub enum AUTO_PREW {
    #[doc = "No program verify operations carried out"]
    AUTO_PRE_0,
    #[doc = "Causes an automatic Burst Program Verify after the Burst Program Operation"]
    AUTO_PRE_1,
}
impl AUTO_PREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AUTO_PREW::AUTO_PRE_0 => false,
            AUTO_PREW::AUTO_PRE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AUTO_PREW<'a> {
    w: &'a mut W,
}
impl<'a> _AUTO_PREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AUTO_PREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No program verify operations carried out"]
    #[inline]
    pub fn auto_pre_0(self) -> &'a mut W {
        self.variant(AUTO_PREW::AUTO_PRE_0)
    }
    #[doc = "Causes an automatic Burst Program Verify after the Burst Program Operation"]
    #[inline]
    pub fn auto_pre_1(self) -> &'a mut W {
        self.variant(AUTO_PREW::AUTO_PRE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `AUTO_PST`"]
pub enum AUTO_PSTW {
    #[doc = "No program verify operations carried out"]
    AUTO_PST_0,
    #[doc = "Causes an automatic Burst Program Verify before the Burst Program Operation"]
    AUTO_PST_1,
}
impl AUTO_PSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AUTO_PSTW::AUTO_PST_0 => false,
            AUTO_PSTW::AUTO_PST_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AUTO_PSTW<'a> {
    w: &'a mut W,
}
impl<'a> _AUTO_PSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AUTO_PSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No program verify operations carried out"]
    #[inline]
    pub fn auto_pst_0(self) -> &'a mut W {
        self.variant(AUTO_PSTW::AUTO_PST_0)
    }
    #[doc = "Causes an automatic Burst Program Verify before the Burst Program Operation"]
    #[inline]
    pub fn auto_pst_1(self) -> &'a mut W {
        self.variant(AUTO_PSTW::AUTO_PST_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_STATW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_STATW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 23;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 1:2 - Type of memory that burst program is carried out on"]
    #[inline]
    pub fn type_(&self) -> TYPER {
        TYPER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 3:5 - Length of burst"]
    #[inline]
    pub fn len(&self) -> LENR {
        LENR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 6 - Auto-Verify operation before the Burst Program"]
    #[inline]
    pub fn auto_pre(&self) -> AUTO_PRER {
        AUTO_PRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Auto-Verify operation after the Burst Program"]
    #[inline]
    pub fn auto_pst(&self) -> AUTO_PSTR {
        AUTO_PSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 16:18 - Status of a Burst Operation"]
    #[inline]
    pub fn burst_status(&self) -> BURST_STATUSR {
        BURST_STATUSR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 19 - Burst Operation encountered preprogram auto-verify errors"]
    #[inline]
    pub fn pre_err(&self) -> PRE_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 19;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        PRE_ERRR { bits }
    }
    #[doc = "Bit 20 - Burst Operation encountered postprogram auto-verify errors"]
    #[inline]
    pub fn pst_err(&self) -> PST_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 20;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        PST_ERRR { bits }
    }
    #[doc = "Bit 21 - Burst Operation was terminated due to attempted program of reserved memory"]
    #[inline]
    pub fn addr_err(&self) -> ADDR_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 21;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        ADDR_ERRR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 192 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Trigger start of burst program operation"]
    #[inline]
    pub fn start(&mut self) -> _STARTW {
        _STARTW { w: self }
    }
    #[doc = "Bits 1:2 - Type of memory that burst program is carried out on"]
    #[inline]
    pub fn type_(&mut self) -> _TYPEW {
        _TYPEW { w: self }
    }
    #[doc = "Bits 3:5 - Length of burst"]
    #[inline]
    pub fn len(&mut self) -> _LENW {
        _LENW { w: self }
    }
    #[doc = "Bit 6 - Auto-Verify operation before the Burst Program"]
    #[inline]
    pub fn auto_pre(&mut self) -> _AUTO_PREW {
        _AUTO_PREW { w: self }
    }
    #[doc = "Bit 7 - Auto-Verify operation after the Burst Program"]
    #[inline]
    pub fn auto_pst(&mut self) -> _AUTO_PSTW {
        _AUTO_PSTW { w: self }
    }
    #[doc = "Bit 23 - Clear status bits 21-16 of this register"]
    #[inline]
    pub fn clr_stat(&mut self) -> _CLR_STATW {
        _CLR_STATW { w: self }
    }
}
