#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::FLCTL_PRGVER_TIMCTL {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = r" Value of the field"]
pub struct SETUPR {
    bits: u8,
}
impl SETUPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct ACTIVER {
    bits: u8,
}
impl ACTIVER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct HOLDR {
    bits: u8,
}
impl HOLDR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:7 - Length of the Setup phase for this operation"]
    #[inline]
    pub fn setup(&self) -> SETUPR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SETUPR { bits }
    }
    #[doc = "Bits 8:11 - Length of the Active phase for this operation"]
    #[inline]
    pub fn active(&self) -> ACTIVER {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        ACTIVER { bits }
    }
    #[doc = "Bits 12:15 - Length of the Hold phase for this operation"]
    #[inline]
    pub fn hold(&self) -> HOLDR {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        HOLDR { bits }
    }
}
