#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::FLCTL_RDBRST_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `MEM_TYPE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MEM_TYPER {
    #[doc = "Main Memory"]
    MEM_TYPE_0,
    #[doc = "Information Memory"]
    MEM_TYPE_1,
    #[doc = "Engineering Memory"]
    MEM_TYPE_3,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl MEM_TYPER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            MEM_TYPER::MEM_TYPE_0 => 0,
            MEM_TYPER::MEM_TYPE_1 => 1,
            MEM_TYPER::MEM_TYPE_3 => 3,
            MEM_TYPER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> MEM_TYPER {
        match value {
            0 => MEM_TYPER::MEM_TYPE_0,
            1 => MEM_TYPER::MEM_TYPE_1,
            3 => MEM_TYPER::MEM_TYPE_3,
            i => MEM_TYPER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `MEM_TYPE_0`"]
    #[inline]
    pub fn is_mem_type_0(&self) -> bool {
        *self == MEM_TYPER::MEM_TYPE_0
    }
    #[doc = "Checks if the value of the field is `MEM_TYPE_1`"]
    #[inline]
    pub fn is_mem_type_1(&self) -> bool {
        *self == MEM_TYPER::MEM_TYPE_1
    }
    #[doc = "Checks if the value of the field is `MEM_TYPE_3`"]
    #[inline]
    pub fn is_mem_type_3(&self) -> bool {
        *self == MEM_TYPER::MEM_TYPE_3
    }
}
#[doc = r" Value of the field"]
pub struct STOP_FAILR {
    bits: bool,
}
impl STOP_FAILR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `DATA_CMP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DATA_CMPR {
    #[doc = "0000_0000_0000_0000_0000_0000_0000_0000"]
    DATA_CMP_0,
    #[doc = "FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF"]
    DATA_CMP_1,
}
impl DATA_CMPR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            DATA_CMPR::DATA_CMP_0 => false,
            DATA_CMPR::DATA_CMP_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> DATA_CMPR {
        match value {
            false => DATA_CMPR::DATA_CMP_0,
            true => DATA_CMPR::DATA_CMP_1,
        }
    }
    #[doc = "Checks if the value of the field is `DATA_CMP_0`"]
    #[inline]
    pub fn is_data_cmp_0(&self) -> bool {
        *self == DATA_CMPR::DATA_CMP_0
    }
    #[doc = "Checks if the value of the field is `DATA_CMP_1`"]
    #[inline]
    pub fn is_data_cmp_1(&self) -> bool {
        *self == DATA_CMPR::DATA_CMP_1
    }
}
#[doc = r" Value of the field"]
pub struct TEST_ENR {
    bits: bool,
}
impl TEST_ENR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `BRST_STAT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BRST_STATR {
    #[doc = "Idle"]
    BRST_STAT_0,
    #[doc = "Burst/Compare START bit written, but operation pending"]
    BRST_STAT_1,
    #[doc = "Burst/Compare in progress"]
    BRST_STAT_2,
    #[doc = "Burst complete (status of completed burst remains in this state unless explicitly cleared by SW)"]
    BRST_STAT_3,
}
impl BRST_STATR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            BRST_STATR::BRST_STAT_0 => 0,
            BRST_STATR::BRST_STAT_1 => 1,
            BRST_STATR::BRST_STAT_2 => 2,
            BRST_STATR::BRST_STAT_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> BRST_STATR {
        match value {
            0 => BRST_STATR::BRST_STAT_0,
            1 => BRST_STATR::BRST_STAT_1,
            2 => BRST_STATR::BRST_STAT_2,
            3 => BRST_STATR::BRST_STAT_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `BRST_STAT_0`"]
    #[inline]
    pub fn is_brst_stat_0(&self) -> bool {
        *self == BRST_STATR::BRST_STAT_0
    }
    #[doc = "Checks if the value of the field is `BRST_STAT_1`"]
    #[inline]
    pub fn is_brst_stat_1(&self) -> bool {
        *self == BRST_STATR::BRST_STAT_1
    }
    #[doc = "Checks if the value of the field is `BRST_STAT_2`"]
    #[inline]
    pub fn is_brst_stat_2(&self) -> bool {
        *self == BRST_STATR::BRST_STAT_2
    }
    #[doc = "Checks if the value of the field is `BRST_STAT_3`"]
    #[inline]
    pub fn is_brst_stat_3(&self) -> bool {
        *self == BRST_STATR::BRST_STAT_3
    }
}
#[doc = r" Value of the field"]
pub struct CMP_ERRR {
    bits: bool,
}
impl CMP_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct ADDR_ERRR {
    bits: bool,
}
impl ADDR_ERRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Proxy"]
pub struct _STARTW<'a> {
    w: &'a mut W,
}
impl<'a> _STARTW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `MEM_TYPE`"]
pub enum MEM_TYPEW {
    #[doc = "Main Memory"]
    MEM_TYPE_0,
    #[doc = "Information Memory"]
    MEM_TYPE_1,
    #[doc = "Engineering Memory"]
    MEM_TYPE_3,
}
impl MEM_TYPEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            MEM_TYPEW::MEM_TYPE_0 => 0,
            MEM_TYPEW::MEM_TYPE_1 => 1,
            MEM_TYPEW::MEM_TYPE_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _MEM_TYPEW<'a> {
    w: &'a mut W,
}
impl<'a> _MEM_TYPEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: MEM_TYPEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Main Memory"]
    #[inline]
    pub fn mem_type_0(self) -> &'a mut W {
        self.variant(MEM_TYPEW::MEM_TYPE_0)
    }
    #[doc = "Information Memory"]
    #[inline]
    pub fn mem_type_1(self) -> &'a mut W {
        self.variant(MEM_TYPEW::MEM_TYPE_1)
    }
    #[doc = "Engineering Memory"]
    #[inline]
    pub fn mem_type_3(self) -> &'a mut W {
        self.variant(MEM_TYPEW::MEM_TYPE_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _STOP_FAILW<'a> {
    w: &'a mut W,
}
impl<'a> _STOP_FAILW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `DATA_CMP`"]
pub enum DATA_CMPW {
    #[doc = "0000_0000_0000_0000_0000_0000_0000_0000"]
    DATA_CMP_0,
    #[doc = "FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF"]
    DATA_CMP_1,
}
impl DATA_CMPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            DATA_CMPW::DATA_CMP_0 => false,
            DATA_CMPW::DATA_CMP_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _DATA_CMPW<'a> {
    w: &'a mut W,
}
impl<'a> _DATA_CMPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: DATA_CMPW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "0000_0000_0000_0000_0000_0000_0000_0000"]
    #[inline]
    pub fn data_cmp_0(self) -> &'a mut W {
        self.variant(DATA_CMPW::DATA_CMP_0)
    }
    #[doc = "FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF"]
    #[inline]
    pub fn data_cmp_1(self) -> &'a mut W {
        self.variant(DATA_CMPW::DATA_CMP_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _TEST_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _TEST_ENW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_STATW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_STATW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 23;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 1:2 - Type of memory that burst is carried out on"]
    #[inline]
    pub fn mem_type(&self) -> MEM_TYPER {
        MEM_TYPER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 3 - Terminate burst/compare operation"]
    #[inline]
    pub fn stop_fail(&self) -> STOP_FAILR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        STOP_FAILR { bits }
    }
    #[doc = "Bit 4 - Data pattern used for comparison against memory read data"]
    #[inline]
    pub fn data_cmp(&self) -> DATA_CMPR {
        DATA_CMPR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - Enable comparison against test data compare registers"]
    #[inline]
    pub fn test_en(&self) -> TEST_ENR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        TEST_ENR { bits }
    }
    #[doc = "Bits 16:17 - Status of Burst/Compare operation"]
    #[inline]
    pub fn brst_stat(&self) -> BRST_STATR {
        BRST_STATR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 18 - Burst/Compare Operation encountered atleast one data"]
    #[inline]
    pub fn cmp_err(&self) -> CMP_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        CMP_ERRR { bits }
    }
    #[doc = "Bit 19 - Burst/Compare Operation was terminated due to access to"]
    #[inline]
    pub fn addr_err(&self) -> ADDR_ERRR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 19;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        ADDR_ERRR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Start of burst/compare operation"]
    #[inline]
    pub fn start(&mut self) -> _STARTW {
        _STARTW { w: self }
    }
    #[doc = "Bits 1:2 - Type of memory that burst is carried out on"]
    #[inline]
    pub fn mem_type(&mut self) -> _MEM_TYPEW {
        _MEM_TYPEW { w: self }
    }
    #[doc = "Bit 3 - Terminate burst/compare operation"]
    #[inline]
    pub fn stop_fail(&mut self) -> _STOP_FAILW {
        _STOP_FAILW { w: self }
    }
    #[doc = "Bit 4 - Data pattern used for comparison against memory read data"]
    #[inline]
    pub fn data_cmp(&mut self) -> _DATA_CMPW {
        _DATA_CMPW { w: self }
    }
    #[doc = "Bit 6 - Enable comparison against test data compare registers"]
    #[inline]
    pub fn test_en(&mut self) -> _TEST_ENW {
        _TEST_ENW { w: self }
    }
    #[doc = "Bit 23 - Clear status bits 19-16 of this register"]
    #[inline]
    pub fn clr_stat(&mut self) -> _CLR_STATW {
        _CLR_STATW { w: self }
    }
}
