#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::FLCTL_READ_TIMCTL {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = r" Value of the field"]
pub struct SETUPR {
    bits: u8,
}
impl SETUPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct IREF_BOOST1R {
    bits: u8,
}
impl IREF_BOOST1R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct SETUP_LONGR {
    bits: u8,
}
impl SETUP_LONGR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:7 - Configures the length of the Setup phase for this operation"]
    #[inline]
    pub fn setup(&self) -> SETUPR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SETUPR { bits }
    }
    #[doc = "Bits 12:15 - Length of the IREF_BOOST1 signal of the IP"]
    #[inline]
    pub fn iref_boost1(&self) -> IREF_BOOST1R {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        IREF_BOOST1R { bits }
    }
    #[doc = "Bits 16:23 - Length of the Setup time into read mode when the device is recovering from one of the following conditions: Moving from Power-down or Standby back to Active and device is not trimmed. Moving from standby to active state in low-frequency active mode. Recovering from the LDO Boost operation after a Mass Erase."]
    #[inline]
    pub fn setup_long(&self) -> SETUP_LONGR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SETUP_LONGR { bits }
    }
}
