#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PCMCLRIFG {
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
}
#[doc = r" Proxy"]
pub struct _CLR_LPM_INVALID_TR_IFGW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_LPM_INVALID_TR_IFGW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_LPM_INVALID_CLK_IFGW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_LPM_INVALID_CLK_IFGW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_AM_INVALID_TR_IFGW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_AM_INVALID_TR_IFGW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CLR_DCDC_ERROR_IFGW<'a> {
    w: &'a mut W,
}
impl<'a> _CLR_DCDC_ERROR_IFGW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Clear LPM invalid transition flag"]
    #[inline]
    pub fn clr_lpm_invalid_tr_ifg(&mut self) -> _CLR_LPM_INVALID_TR_IFGW {
        _CLR_LPM_INVALID_TR_IFGW { w: self }
    }
    #[doc = "Bit 1 - Clear LPM invalid clock flag"]
    #[inline]
    pub fn clr_lpm_invalid_clk_ifg(&mut self) -> _CLR_LPM_INVALID_CLK_IFGW {
        _CLR_LPM_INVALID_CLK_IFGW { w: self }
    }
    #[doc = "Bit 2 - Clear active mode invalid transition flag"]
    #[inline]
    pub fn clr_am_invalid_tr_ifg(&mut self) -> _CLR_AM_INVALID_TR_IFGW {
        _CLR_AM_INVALID_TR_IFGW { w: self }
    }
    #[doc = "Bit 6 - Clear DC-DC error flag"]
    #[inline]
    pub fn clr_dcdc_error_ifg(&mut self) -> _CLR_DCDC_ERROR_IFGW {
        _CLR_DCDC_ERROR_IFGW { w: self }
    }
}
