#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PCMCTL0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `AMR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AMRR {
    #[doc = "LDO based Active Mode at Core voltage setting 0."]
    AMR_0,
    #[doc = "LDO based Active Mode at Core voltage setting 1."]
    AMR_1,
    #[doc = "DC-DC based Active Mode at Core voltage setting 0."]
    AMR_4,
    #[doc = "DC-DC based Active Mode at Core voltage setting 1."]
    AMR_5,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 0."]
    AMR_8,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 1."]
    AMR_9,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl AMRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            AMRR::AMR_0 => 0,
            AMRR::AMR_1 => 1,
            AMRR::AMR_4 => 4,
            AMRR::AMR_5 => 5,
            AMRR::AMR_8 => 8,
            AMRR::AMR_9 => 9,
            AMRR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> AMRR {
        match value {
            0 => AMRR::AMR_0,
            1 => AMRR::AMR_1,
            4 => AMRR::AMR_4,
            5 => AMRR::AMR_5,
            8 => AMRR::AMR_8,
            9 => AMRR::AMR_9,
            i => AMRR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `AMR_0`"]
    #[inline]
    pub fn is_amr_0(&self) -> bool {
        *self == AMRR::AMR_0
    }
    #[doc = "Checks if the value of the field is `AMR_1`"]
    #[inline]
    pub fn is_amr_1(&self) -> bool {
        *self == AMRR::AMR_1
    }
    #[doc = "Checks if the value of the field is `AMR_4`"]
    #[inline]
    pub fn is_amr_4(&self) -> bool {
        *self == AMRR::AMR_4
    }
    #[doc = "Checks if the value of the field is `AMR_5`"]
    #[inline]
    pub fn is_amr_5(&self) -> bool {
        *self == AMRR::AMR_5
    }
    #[doc = "Checks if the value of the field is `AMR_8`"]
    #[inline]
    pub fn is_amr_8(&self) -> bool {
        *self == AMRR::AMR_8
    }
    #[doc = "Checks if the value of the field is `AMR_9`"]
    #[inline]
    pub fn is_amr_9(&self) -> bool {
        *self == AMRR::AMR_9
    }
}
#[doc = "Possible values of the field `LPMR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LPMRR {
    #[doc = "LPM3. Core voltage setting is similar to the mode from which LPM3 is entered."]
    LPMR_0,
    #[doc = "LPM3.5. Core voltage setting 0."]
    LPMR_10,
    #[doc = "LPM4.5"]
    LPMR_12,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl LPMRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            LPMRR::LPMR_0 => 0,
            LPMRR::LPMR_10 => 10,
            LPMRR::LPMR_12 => 12,
            LPMRR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> LPMRR {
        match value {
            0 => LPMRR::LPMR_0,
            10 => LPMRR::LPMR_10,
            12 => LPMRR::LPMR_12,
            i => LPMRR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `LPMR_0`"]
    #[inline]
    pub fn is_lpmr_0(&self) -> bool {
        *self == LPMRR::LPMR_0
    }
    #[doc = "Checks if the value of the field is `LPMR_10`"]
    #[inline]
    pub fn is_lpmr_10(&self) -> bool {
        *self == LPMRR::LPMR_10
    }
    #[doc = "Checks if the value of the field is `LPMR_12`"]
    #[inline]
    pub fn is_lpmr_12(&self) -> bool {
        *self == LPMRR::LPMR_12
    }
}
#[doc = "Possible values of the field `CPM`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CPMR {
    #[doc = "LDO based Active Mode at Core voltage setting 0."]
    CPM_0,
    #[doc = "LDO based Active Mode at Core voltage setting 1."]
    CPM_1,
    #[doc = "DC-DC based Active Mode at Core voltage setting 0."]
    CPM_4,
    #[doc = "DC-DC based Active Mode at Core voltage setting 1."]
    CPM_5,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 0."]
    CPM_8,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 1."]
    CPM_9,
    #[doc = "LDO based LPM0 at Core voltage setting 0."]
    CPM_16,
    #[doc = "LDO based LPM0 at Core voltage setting 1."]
    CPM_17,
    #[doc = "DC-DC based LPM0 at Core voltage setting 0."]
    CPM_20,
    #[doc = "DC-DC based LPM0 at Core voltage setting 1."]
    CPM_21,
    #[doc = "Low-Frequency LPM0 at Core voltage setting 0."]
    CPM_24,
    #[doc = "Low-Frequency LPM0 at Core voltage setting 1."]
    CPM_25,
    #[doc = "LPM3"]
    CPM_32,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl CPMR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            CPMR::CPM_0 => 0,
            CPMR::CPM_1 => 1,
            CPMR::CPM_4 => 4,
            CPMR::CPM_5 => 5,
            CPMR::CPM_8 => 8,
            CPMR::CPM_9 => 9,
            CPMR::CPM_16 => 16,
            CPMR::CPM_17 => 17,
            CPMR::CPM_20 => 20,
            CPMR::CPM_21 => 21,
            CPMR::CPM_24 => 24,
            CPMR::CPM_25 => 25,
            CPMR::CPM_32 => 32,
            CPMR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> CPMR {
        match value {
            0 => CPMR::CPM_0,
            1 => CPMR::CPM_1,
            4 => CPMR::CPM_4,
            5 => CPMR::CPM_5,
            8 => CPMR::CPM_8,
            9 => CPMR::CPM_9,
            16 => CPMR::CPM_16,
            17 => CPMR::CPM_17,
            20 => CPMR::CPM_20,
            21 => CPMR::CPM_21,
            24 => CPMR::CPM_24,
            25 => CPMR::CPM_25,
            32 => CPMR::CPM_32,
            i => CPMR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `CPM_0`"]
    #[inline]
    pub fn is_cpm_0(&self) -> bool {
        *self == CPMR::CPM_0
    }
    #[doc = "Checks if the value of the field is `CPM_1`"]
    #[inline]
    pub fn is_cpm_1(&self) -> bool {
        *self == CPMR::CPM_1
    }
    #[doc = "Checks if the value of the field is `CPM_4`"]
    #[inline]
    pub fn is_cpm_4(&self) -> bool {
        *self == CPMR::CPM_4
    }
    #[doc = "Checks if the value of the field is `CPM_5`"]
    #[inline]
    pub fn is_cpm_5(&self) -> bool {
        *self == CPMR::CPM_5
    }
    #[doc = "Checks if the value of the field is `CPM_8`"]
    #[inline]
    pub fn is_cpm_8(&self) -> bool {
        *self == CPMR::CPM_8
    }
    #[doc = "Checks if the value of the field is `CPM_9`"]
    #[inline]
    pub fn is_cpm_9(&self) -> bool {
        *self == CPMR::CPM_9
    }
    #[doc = "Checks if the value of the field is `CPM_16`"]
    #[inline]
    pub fn is_cpm_16(&self) -> bool {
        *self == CPMR::CPM_16
    }
    #[doc = "Checks if the value of the field is `CPM_17`"]
    #[inline]
    pub fn is_cpm_17(&self) -> bool {
        *self == CPMR::CPM_17
    }
    #[doc = "Checks if the value of the field is `CPM_20`"]
    #[inline]
    pub fn is_cpm_20(&self) -> bool {
        *self == CPMR::CPM_20
    }
    #[doc = "Checks if the value of the field is `CPM_21`"]
    #[inline]
    pub fn is_cpm_21(&self) -> bool {
        *self == CPMR::CPM_21
    }
    #[doc = "Checks if the value of the field is `CPM_24`"]
    #[inline]
    pub fn is_cpm_24(&self) -> bool {
        *self == CPMR::CPM_24
    }
    #[doc = "Checks if the value of the field is `CPM_25`"]
    #[inline]
    pub fn is_cpm_25(&self) -> bool {
        *self == CPMR::CPM_25
    }
    #[doc = "Checks if the value of the field is `CPM_32`"]
    #[inline]
    pub fn is_cpm_32(&self) -> bool {
        *self == CPMR::CPM_32
    }
}
#[doc = r" Value of the field"]
pub struct PCMKEYR {
    bits: u16,
}
impl PCMKEYR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `AMR`"]
pub enum AMRW {
    #[doc = "LDO based Active Mode at Core voltage setting 0."]
    AMR_0,
    #[doc = "LDO based Active Mode at Core voltage setting 1."]
    AMR_1,
    #[doc = "DC-DC based Active Mode at Core voltage setting 0."]
    AMR_4,
    #[doc = "DC-DC based Active Mode at Core voltage setting 1."]
    AMR_5,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 0."]
    AMR_8,
    #[doc = "Low-Frequency Active Mode at Core voltage setting 1."]
    AMR_9,
}
impl AMRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            AMRW::AMR_0 => 0,
            AMRW::AMR_1 => 1,
            AMRW::AMR_4 => 4,
            AMRW::AMR_5 => 5,
            AMRW::AMR_8 => 8,
            AMRW::AMR_9 => 9,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AMRW<'a> {
    w: &'a mut W,
}
impl<'a> _AMRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AMRW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "LDO based Active Mode at Core voltage setting 0."]
    #[inline]
    pub fn amr_0(self) -> &'a mut W {
        self.variant(AMRW::AMR_0)
    }
    #[doc = "LDO based Active Mode at Core voltage setting 1."]
    #[inline]
    pub fn amr_1(self) -> &'a mut W {
        self.variant(AMRW::AMR_1)
    }
    #[doc = "DC-DC based Active Mode at Core voltage setting 0."]
    #[inline]
    pub fn amr_4(self) -> &'a mut W {
        self.variant(AMRW::AMR_4)
    }
    #[doc = "DC-DC based Active Mode at Core voltage setting 1."]
    #[inline]
    pub fn amr_5(self) -> &'a mut W {
        self.variant(AMRW::AMR_5)
    }
    #[doc = "Low-Frequency Active Mode at Core voltage setting 0."]
    #[inline]
    pub fn amr_8(self) -> &'a mut W {
        self.variant(AMRW::AMR_8)
    }
    #[doc = "Low-Frequency Active Mode at Core voltage setting 1."]
    #[inline]
    pub fn amr_9(self) -> &'a mut W {
        self.variant(AMRW::AMR_9)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LPMR`"]
pub enum LPMRW {
    #[doc = "LPM3. Core voltage setting is similar to the mode from which LPM3 is entered."]
    LPMR_0,
    #[doc = "LPM3.5. Core voltage setting 0."]
    LPMR_10,
    #[doc = "LPM4.5"]
    LPMR_12,
}
impl LPMRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            LPMRW::LPMR_0 => 0,
            LPMRW::LPMR_10 => 10,
            LPMRW::LPMR_12 => 12,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LPMRW<'a> {
    w: &'a mut W,
}
impl<'a> _LPMRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LPMRW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "LPM3. Core voltage setting is similar to the mode from which LPM3 is entered."]
    #[inline]
    pub fn lpmr_0(self) -> &'a mut W {
        self.variant(LPMRW::LPMR_0)
    }
    #[doc = "LPM3.5. Core voltage setting 0."]
    #[inline]
    pub fn lpmr_10(self) -> &'a mut W {
        self.variant(LPMRW::LPMR_10)
    }
    #[doc = "LPM4.5"]
    #[inline]
    pub fn lpmr_12(self) -> &'a mut W {
        self.variant(LPMRW::LPMR_12)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PCMKEYW<'a> {
    w: &'a mut W,
}
impl<'a> _PCMKEYW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 65535;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:3 - Active Mode Request"]
    #[inline]
    pub fn amr(&self) -> AMRR {
        AMRR::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 4:7 - Low Power Mode Request"]
    #[inline]
    pub fn lpmr(&self) -> LPMRR {
        LPMRR::_from({
            const MASK: u8 = 15;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 8:13 - Current Power Mode"]
    #[inline]
    pub fn cpm(&self) -> CPMR {
        CPMR::_from({
            const MASK: u8 = 63;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 16:31 - PCM key"]
    #[inline]
    pub fn pcmkey(&self) -> PCMKEYR {
        let bits = {
            const MASK: u16 = 65535;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u16
        };
        PCMKEYR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 2778071040 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:3 - Active Mode Request"]
    #[inline]
    pub fn amr(&mut self) -> _AMRW {
        _AMRW { w: self }
    }
    #[doc = "Bits 4:7 - Low Power Mode Request"]
    #[inline]
    pub fn lpmr(&mut self) -> _LPMRW {
        _LPMRW { w: self }
    }
    #[doc = "Bits 16:31 - PCM key"]
    #[inline]
    pub fn pcmkey(&mut self) -> _PCMKEYW {
        _PCMKEYW { w: self }
    }
}
