#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PCMCTL1 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `LOCKLPM5`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LOCKLPM5R {
    #[doc = "LPMx.5 configuration defaults to reset condition"]
    LOCKLPM5_0,
    #[doc = "LPMx.5 configuration remains locked during LPMx.5 entry and exit"]
    LOCKLPM5_1,
}
impl LOCKLPM5R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            LOCKLPM5R::LOCKLPM5_0 => false,
            LOCKLPM5R::LOCKLPM5_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> LOCKLPM5R {
        match value {
            false => LOCKLPM5R::LOCKLPM5_0,
            true => LOCKLPM5R::LOCKLPM5_1,
        }
    }
    #[doc = "Checks if the value of the field is `LOCKLPM5_0`"]
    #[inline]
    pub fn is_locklpm5_0(&self) -> bool {
        *self == LOCKLPM5R::LOCKLPM5_0
    }
    #[doc = "Checks if the value of the field is `LOCKLPM5_1`"]
    #[inline]
    pub fn is_locklpm5_1(&self) -> bool {
        *self == LOCKLPM5R::LOCKLPM5_1
    }
}
#[doc = "Possible values of the field `LOCKBKUP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LOCKBKUPR {
    #[doc = "Backup domain configuration defaults to reset condition"]
    LOCKBKUP_0,
    #[doc = "Backup domain configuration remains locked during LPM3.5 entry and exit"]
    LOCKBKUP_1,
}
impl LOCKBKUPR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            LOCKBKUPR::LOCKBKUP_0 => false,
            LOCKBKUPR::LOCKBKUP_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> LOCKBKUPR {
        match value {
            false => LOCKBKUPR::LOCKBKUP_0,
            true => LOCKBKUPR::LOCKBKUP_1,
        }
    }
    #[doc = "Checks if the value of the field is `LOCKBKUP_0`"]
    #[inline]
    pub fn is_lockbkup_0(&self) -> bool {
        *self == LOCKBKUPR::LOCKBKUP_0
    }
    #[doc = "Checks if the value of the field is `LOCKBKUP_1`"]
    #[inline]
    pub fn is_lockbkup_1(&self) -> bool {
        *self == LOCKBKUPR::LOCKBKUP_1
    }
}
#[doc = "Possible values of the field `FORCE_LPM_ENTRY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FORCE_LPM_ENTRYR {
    #[doc = "PCM aborts LPM3/LPMx.5 transition if the active clock configuration does not meet the LPM3/LPMx.5 entry criteria. PCM generates the LPM_INVALID_CLK flag on abort to LPM3/LPMx.5 entry."]
    FORCE_LPM_ENTRY_0,
    #[doc = "PCM enters LPM3/LPMx.5 after shuting off the clocks forcefully. Application needs to ensure RTC and WDT are clocked using BCLK tree to keep these modules alive in LPM3/LPM3.5. In LPM4.5 all clocks are forcefully shutoff and the core voltage is turned off."]
    FORCE_LPM_ENTRY_1,
}
impl FORCE_LPM_ENTRYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_0 => false,
            FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> FORCE_LPM_ENTRYR {
        match value {
            false => FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_0,
            true => FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_1,
        }
    }
    #[doc = "Checks if the value of the field is `FORCE_LPM_ENTRY_0`"]
    #[inline]
    pub fn is_force_lpm_entry_0(&self) -> bool {
        *self == FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_0
    }
    #[doc = "Checks if the value of the field is `FORCE_LPM_ENTRY_1`"]
    #[inline]
    pub fn is_force_lpm_entry_1(&self) -> bool {
        *self == FORCE_LPM_ENTRYR::FORCE_LPM_ENTRY_1
    }
}
#[doc = r" Value of the field"]
pub struct PMR_BUSYR {
    bits: bool,
}
impl PMR_BUSYR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r" Value of the field"]
pub struct PCMKEYR {
    bits: u16,
}
impl PCMKEYR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `LOCKLPM5`"]
pub enum LOCKLPM5W {
    #[doc = "LPMx.5 configuration defaults to reset condition"]
    LOCKLPM5_0,
    #[doc = "LPMx.5 configuration remains locked during LPMx.5 entry and exit"]
    LOCKLPM5_1,
}
impl LOCKLPM5W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            LOCKLPM5W::LOCKLPM5_0 => false,
            LOCKLPM5W::LOCKLPM5_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LOCKLPM5W<'a> {
    w: &'a mut W,
}
impl<'a> _LOCKLPM5W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LOCKLPM5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "LPMx.5 configuration defaults to reset condition"]
    #[inline]
    pub fn locklpm5_0(self) -> &'a mut W {
        self.variant(LOCKLPM5W::LOCKLPM5_0)
    }
    #[doc = "LPMx.5 configuration remains locked during LPMx.5 entry and exit"]
    #[inline]
    pub fn locklpm5_1(self) -> &'a mut W {
        self.variant(LOCKLPM5W::LOCKLPM5_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LOCKBKUP`"]
pub enum LOCKBKUPW {
    #[doc = "Backup domain configuration defaults to reset condition"]
    LOCKBKUP_0,
    #[doc = "Backup domain configuration remains locked during LPM3.5 entry and exit"]
    LOCKBKUP_1,
}
impl LOCKBKUPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            LOCKBKUPW::LOCKBKUP_0 => false,
            LOCKBKUPW::LOCKBKUP_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LOCKBKUPW<'a> {
    w: &'a mut W,
}
impl<'a> _LOCKBKUPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LOCKBKUPW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Backup domain configuration defaults to reset condition"]
    #[inline]
    pub fn lockbkup_0(self) -> &'a mut W {
        self.variant(LOCKBKUPW::LOCKBKUP_0)
    }
    #[doc = "Backup domain configuration remains locked during LPM3.5 entry and exit"]
    #[inline]
    pub fn lockbkup_1(self) -> &'a mut W {
        self.variant(LOCKBKUPW::LOCKBKUP_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `FORCE_LPM_ENTRY`"]
pub enum FORCE_LPM_ENTRYW {
    #[doc = "PCM aborts LPM3/LPMx.5 transition if the active clock configuration does not meet the LPM3/LPMx.5 entry criteria. PCM generates the LPM_INVALID_CLK flag on abort to LPM3/LPMx.5 entry."]
    FORCE_LPM_ENTRY_0,
    #[doc = "PCM enters LPM3/LPMx.5 after shuting off the clocks forcefully. Application needs to ensure RTC and WDT are clocked using BCLK tree to keep these modules alive in LPM3/LPM3.5. In LPM4.5 all clocks are forcefully shutoff and the core voltage is turned off."]
    FORCE_LPM_ENTRY_1,
}
impl FORCE_LPM_ENTRYW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            FORCE_LPM_ENTRYW::FORCE_LPM_ENTRY_0 => false,
            FORCE_LPM_ENTRYW::FORCE_LPM_ENTRY_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _FORCE_LPM_ENTRYW<'a> {
    w: &'a mut W,
}
impl<'a> _FORCE_LPM_ENTRYW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: FORCE_LPM_ENTRYW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "PCM aborts LPM3/LPMx.5 transition if the active clock configuration does not meet the LPM3/LPMx.5 entry criteria. PCM generates the LPM_INVALID_CLK flag on abort to LPM3/LPMx.5 entry."]
    #[inline]
    pub fn force_lpm_entry_0(self) -> &'a mut W {
        self.variant(FORCE_LPM_ENTRYW::FORCE_LPM_ENTRY_0)
    }
    #[doc = "PCM enters LPM3/LPMx.5 after shuting off the clocks forcefully. Application needs to ensure RTC and WDT are clocked using BCLK tree to keep these modules alive in LPM3/LPM3.5. In LPM4.5 all clocks are forcefully shutoff and the core voltage is turned off."]
    #[inline]
    pub fn force_lpm_entry_1(self) -> &'a mut W {
        self.variant(FORCE_LPM_ENTRYW::FORCE_LPM_ENTRY_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PMR_BUSYW<'a> {
    w: &'a mut W,
}
impl<'a> _PMR_BUSYW<'a> {
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PCMKEYW<'a> {
    w: &'a mut W,
}
impl<'a> _PCMKEYW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 65535;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Lock LPM5"]
    #[inline]
    pub fn locklpm5(&self) -> LOCKLPM5R {
        LOCKLPM5R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - Lock Backup"]
    #[inline]
    pub fn lockbkup(&self) -> LOCKBKUPR {
        LOCKBKUPR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Force LPM entry"]
    #[inline]
    pub fn force_lpm_entry(&self) -> FORCE_LPM_ENTRYR {
        FORCE_LPM_ENTRYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 8 - Power mode request busy flag"]
    #[inline]
    pub fn pmr_busy(&self) -> PMR_BUSYR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        PMR_BUSYR { bits }
    }
    #[doc = "Bits 16:31 - PCM key"]
    #[inline]
    pub fn pcmkey(&self) -> PCMKEYR {
        let bits = {
            const MASK: u16 = 65535;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u16
        };
        PCMKEYR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 2778071040 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Lock LPM5"]
    #[inline]
    pub fn locklpm5(&mut self) -> _LOCKLPM5W {
        _LOCKLPM5W { w: self }
    }
    #[doc = "Bit 1 - Lock Backup"]
    #[inline]
    pub fn lockbkup(&mut self) -> _LOCKBKUPW {
        _LOCKBKUPW { w: self }
    }
    #[doc = "Bit 2 - Force LPM entry"]
    #[inline]
    pub fn force_lpm_entry(&mut self) -> _FORCE_LPM_ENTRYW {
        _FORCE_LPM_ENTRYW { w: self }
    }
    #[doc = "Bit 8 - Power mode request busy flag"]
    #[inline]
    pub fn pmr_busy(&mut self) -> _PMR_BUSYW {
        _PMR_BUSYW { w: self }
    }
    #[doc = "Bits 16:31 - PCM key"]
    #[inline]
    pub fn pcmkey(&mut self) -> _PCMKEYW {
        _PCMKEYW { w: self }
    }
}
