#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PCMIE {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `LPM_INVALID_TR_IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LPM_INVALID_TR_IER {
    #[doc = "Disabled"]
    LPM_INVALID_TR_IE_0,
    #[doc = "Enabled"]
    LPM_INVALID_TR_IE_1,
}
impl LPM_INVALID_TR_IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_0 => false,
            LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> LPM_INVALID_TR_IER {
        match value {
            false => LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_0,
            true => LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `LPM_INVALID_TR_IE_0`"]
    #[inline]
    pub fn is_lpm_invalid_tr_ie_0(&self) -> bool {
        *self == LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_0
    }
    #[doc = "Checks if the value of the field is `LPM_INVALID_TR_IE_1`"]
    #[inline]
    pub fn is_lpm_invalid_tr_ie_1(&self) -> bool {
        *self == LPM_INVALID_TR_IER::LPM_INVALID_TR_IE_1
    }
}
#[doc = "Possible values of the field `LPM_INVALID_CLK_IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LPM_INVALID_CLK_IER {
    #[doc = "Disabled"]
    LPM_INVALID_CLK_IE_0,
    #[doc = "Enabled"]
    LPM_INVALID_CLK_IE_1,
}
impl LPM_INVALID_CLK_IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_0 => false,
            LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> LPM_INVALID_CLK_IER {
        match value {
            false => LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_0,
            true => LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `LPM_INVALID_CLK_IE_0`"]
    #[inline]
    pub fn is_lpm_invalid_clk_ie_0(&self) -> bool {
        *self == LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_0
    }
    #[doc = "Checks if the value of the field is `LPM_INVALID_CLK_IE_1`"]
    #[inline]
    pub fn is_lpm_invalid_clk_ie_1(&self) -> bool {
        *self == LPM_INVALID_CLK_IER::LPM_INVALID_CLK_IE_1
    }
}
#[doc = "Possible values of the field `AM_INVALID_TR_IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AM_INVALID_TR_IER {
    #[doc = "Disabled"]
    AM_INVALID_TR_IE_0,
    #[doc = "Enabled"]
    AM_INVALID_TR_IE_1,
}
impl AM_INVALID_TR_IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AM_INVALID_TR_IER::AM_INVALID_TR_IE_0 => false,
            AM_INVALID_TR_IER::AM_INVALID_TR_IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AM_INVALID_TR_IER {
        match value {
            false => AM_INVALID_TR_IER::AM_INVALID_TR_IE_0,
            true => AM_INVALID_TR_IER::AM_INVALID_TR_IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `AM_INVALID_TR_IE_0`"]
    #[inline]
    pub fn is_am_invalid_tr_ie_0(&self) -> bool {
        *self == AM_INVALID_TR_IER::AM_INVALID_TR_IE_0
    }
    #[doc = "Checks if the value of the field is `AM_INVALID_TR_IE_1`"]
    #[inline]
    pub fn is_am_invalid_tr_ie_1(&self) -> bool {
        *self == AM_INVALID_TR_IER::AM_INVALID_TR_IE_1
    }
}
#[doc = "Possible values of the field `DCDC_ERROR_IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DCDC_ERROR_IER {
    #[doc = "Disabled"]
    DCDC_ERROR_IE_0,
    #[doc = "Enabled"]
    DCDC_ERROR_IE_1,
}
impl DCDC_ERROR_IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            DCDC_ERROR_IER::DCDC_ERROR_IE_0 => false,
            DCDC_ERROR_IER::DCDC_ERROR_IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> DCDC_ERROR_IER {
        match value {
            false => DCDC_ERROR_IER::DCDC_ERROR_IE_0,
            true => DCDC_ERROR_IER::DCDC_ERROR_IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `DCDC_ERROR_IE_0`"]
    #[inline]
    pub fn is_dcdc_error_ie_0(&self) -> bool {
        *self == DCDC_ERROR_IER::DCDC_ERROR_IE_0
    }
    #[doc = "Checks if the value of the field is `DCDC_ERROR_IE_1`"]
    #[inline]
    pub fn is_dcdc_error_ie_1(&self) -> bool {
        *self == DCDC_ERROR_IER::DCDC_ERROR_IE_1
    }
}
#[doc = "Values that can be written to the field `LPM_INVALID_TR_IE`"]
pub enum LPM_INVALID_TR_IEW {
    #[doc = "Disabled"]
    LPM_INVALID_TR_IE_0,
    #[doc = "Enabled"]
    LPM_INVALID_TR_IE_1,
}
impl LPM_INVALID_TR_IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            LPM_INVALID_TR_IEW::LPM_INVALID_TR_IE_0 => false,
            LPM_INVALID_TR_IEW::LPM_INVALID_TR_IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LPM_INVALID_TR_IEW<'a> {
    w: &'a mut W,
}
impl<'a> _LPM_INVALID_TR_IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LPM_INVALID_TR_IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn lpm_invalid_tr_ie_0(self) -> &'a mut W {
        self.variant(LPM_INVALID_TR_IEW::LPM_INVALID_TR_IE_0)
    }
    #[doc = "Enabled"]
    #[inline]
    pub fn lpm_invalid_tr_ie_1(self) -> &'a mut W {
        self.variant(LPM_INVALID_TR_IEW::LPM_INVALID_TR_IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LPM_INVALID_CLK_IE`"]
pub enum LPM_INVALID_CLK_IEW {
    #[doc = "Disabled"]
    LPM_INVALID_CLK_IE_0,
    #[doc = "Enabled"]
    LPM_INVALID_CLK_IE_1,
}
impl LPM_INVALID_CLK_IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            LPM_INVALID_CLK_IEW::LPM_INVALID_CLK_IE_0 => false,
            LPM_INVALID_CLK_IEW::LPM_INVALID_CLK_IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LPM_INVALID_CLK_IEW<'a> {
    w: &'a mut W,
}
impl<'a> _LPM_INVALID_CLK_IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LPM_INVALID_CLK_IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn lpm_invalid_clk_ie_0(self) -> &'a mut W {
        self.variant(LPM_INVALID_CLK_IEW::LPM_INVALID_CLK_IE_0)
    }
    #[doc = "Enabled"]
    #[inline]
    pub fn lpm_invalid_clk_ie_1(self) -> &'a mut W {
        self.variant(LPM_INVALID_CLK_IEW::LPM_INVALID_CLK_IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `AM_INVALID_TR_IE`"]
pub enum AM_INVALID_TR_IEW {
    #[doc = "Disabled"]
    AM_INVALID_TR_IE_0,
    #[doc = "Enabled"]
    AM_INVALID_TR_IE_1,
}
impl AM_INVALID_TR_IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AM_INVALID_TR_IEW::AM_INVALID_TR_IE_0 => false,
            AM_INVALID_TR_IEW::AM_INVALID_TR_IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AM_INVALID_TR_IEW<'a> {
    w: &'a mut W,
}
impl<'a> _AM_INVALID_TR_IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AM_INVALID_TR_IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn am_invalid_tr_ie_0(self) -> &'a mut W {
        self.variant(AM_INVALID_TR_IEW::AM_INVALID_TR_IE_0)
    }
    #[doc = "Enabled"]
    #[inline]
    pub fn am_invalid_tr_ie_1(self) -> &'a mut W {
        self.variant(AM_INVALID_TR_IEW::AM_INVALID_TR_IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `DCDC_ERROR_IE`"]
pub enum DCDC_ERROR_IEW {
    #[doc = "Disabled"]
    DCDC_ERROR_IE_0,
    #[doc = "Enabled"]
    DCDC_ERROR_IE_1,
}
impl DCDC_ERROR_IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            DCDC_ERROR_IEW::DCDC_ERROR_IE_0 => false,
            DCDC_ERROR_IEW::DCDC_ERROR_IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _DCDC_ERROR_IEW<'a> {
    w: &'a mut W,
}
impl<'a> _DCDC_ERROR_IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: DCDC_ERROR_IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disabled"]
    #[inline]
    pub fn dcdc_error_ie_0(self) -> &'a mut W {
        self.variant(DCDC_ERROR_IEW::DCDC_ERROR_IE_0)
    }
    #[doc = "Enabled"]
    #[inline]
    pub fn dcdc_error_ie_1(self) -> &'a mut W {
        self.variant(DCDC_ERROR_IEW::DCDC_ERROR_IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - LPM invalid transition interrupt enable"]
    #[inline]
    pub fn lpm_invalid_tr_ie(&self) -> LPM_INVALID_TR_IER {
        LPM_INVALID_TR_IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - LPM invalid clock interrupt enable"]
    #[inline]
    pub fn lpm_invalid_clk_ie(&self) -> LPM_INVALID_CLK_IER {
        LPM_INVALID_CLK_IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Active mode invalid transition interrupt enable"]
    #[inline]
    pub fn am_invalid_tr_ie(&self) -> AM_INVALID_TR_IER {
        AM_INVALID_TR_IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - DC-DC error interrupt enable"]
    #[inline]
    pub fn dcdc_error_ie(&self) -> DCDC_ERROR_IER {
        DCDC_ERROR_IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - LPM invalid transition interrupt enable"]
    #[inline]
    pub fn lpm_invalid_tr_ie(&mut self) -> _LPM_INVALID_TR_IEW {
        _LPM_INVALID_TR_IEW { w: self }
    }
    #[doc = "Bit 1 - LPM invalid clock interrupt enable"]
    #[inline]
    pub fn lpm_invalid_clk_ie(&mut self) -> _LPM_INVALID_CLK_IEW {
        _LPM_INVALID_CLK_IEW { w: self }
    }
    #[doc = "Bit 2 - Active mode invalid transition interrupt enable"]
    #[inline]
    pub fn am_invalid_tr_ie(&mut self) -> _AM_INVALID_TR_IEW {
        _AM_INVALID_TR_IEW { w: self }
    }
    #[doc = "Bit 6 - DC-DC error interrupt enable"]
    #[inline]
    pub fn dcdc_error_ie(&mut self) -> _DCDC_ERROR_IEW {
        _DCDC_ERROR_IEW { w: self }
    }
}
