#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Port Mapping Key Register"]
    pub pmapkeyid: PMAPKEYID,
    #[doc = "0x02 - Port Mapping Control Register"]
    pub pmapctl: PMAPCTL,
    _reserved0: [u8; 4usize],
    #[doc = "0x08 - Port mapping register, P1.0 and P1.1"]
    pub p1map01: P1MAP01,
    #[doc = "0x0a - Port mapping register, P1.2 and P1.3"]
    pub p1map23: P1MAP23,
    #[doc = "0x0c - Port mapping register, P1.4 and P1.5"]
    pub p1map45: P1MAP45,
    #[doc = "0x0e - Port mapping register, P1.6 and P1.7"]
    pub p1map67: P1MAP67,
    #[doc = "0x10 - Port mapping register, P2.0 and P2.1"]
    pub p2map01: P2MAP01,
    #[doc = "0x12 - Port mapping register, P2.2 and P2.3"]
    pub p2map23: P2MAP23,
    #[doc = "0x14 - Port mapping register, P2.4 and P2.5"]
    pub p2map45: P2MAP45,
    #[doc = "0x16 - Port mapping register, P2.6 and P2.7"]
    pub p2map67: P2MAP67,
    #[doc = "0x18 - Port mapping register, P3.0 and P3.1"]
    pub p3map01: P3MAP01,
    #[doc = "0x1a - Port mapping register, P3.2 and P3.3"]
    pub p3map23: P3MAP23,
    #[doc = "0x1c - Port mapping register, P3.4 and P3.5"]
    pub p3map45: P3MAP45,
    #[doc = "0x1e - Port mapping register, P3.6 and P3.7"]
    pub p3map67: P3MAP67,
    #[doc = "0x20 - Port mapping register, P4.0 and P4.1"]
    pub p4map01: P4MAP01,
    #[doc = "0x22 - Port mapping register, P4.2 and P4.3"]
    pub p4map23: P4MAP23,
    #[doc = "0x24 - Port mapping register, P4.4 and P4.5"]
    pub p4map45: P4MAP45,
    #[doc = "0x26 - Port mapping register, P4.6 and P4.7"]
    pub p4map67: P4MAP67,
    #[doc = "0x28 - Port mapping register, P5.0 and P5.1"]
    pub p5map01: P5MAP01,
    #[doc = "0x2a - Port mapping register, P5.2 and P5.3"]
    pub p5map23: P5MAP23,
    #[doc = "0x2c - Port mapping register, P5.4 and P5.5"]
    pub p5map45: P5MAP45,
    #[doc = "0x2e - Port mapping register, P5.6 and P5.7"]
    pub p5map67: P5MAP67,
    #[doc = "0x30 - Port mapping register, P6.0 and P6.1"]
    pub p6map01: P6MAP01,
    #[doc = "0x32 - Port mapping register, P6.2 and P6.3"]
    pub p6map23: P6MAP23,
    #[doc = "0x34 - Port mapping register, P6.4 and P6.5"]
    pub p6map45: P6MAP45,
    #[doc = "0x36 - Port mapping register, P6.6 and P6.7"]
    pub p6map67: P6MAP67,
    #[doc = "0x38 - Port mapping register, P7.0 and P7.1"]
    pub p7map01: P7MAP01,
    #[doc = "0x3a - Port mapping register, P7.2 and P7.3"]
    pub p7map23: P7MAP23,
    #[doc = "0x3c - Port mapping register, P7.4 and P7.5"]
    pub p7map45: P7MAP45,
    #[doc = "0x3e - Port mapping register, P7.6 and P7.7"]
    pub p7map67: P7MAP67,
}
#[doc = "Port Mapping Key Register"]
pub struct PMAPKEYID {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port Mapping Key Register"]
pub mod pmapkeyid;
#[doc = "Port Mapping Control Register"]
pub struct PMAPCTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port Mapping Control Register"]
pub mod pmapctl;
#[doc = "Port mapping register, P1.0 and P1.1"]
pub struct P1MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P1.0 and P1.1"]
pub mod p1map01;
#[doc = "Port mapping register, P1.2 and P1.3"]
pub struct P1MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P1.2 and P1.3"]
pub mod p1map23;
#[doc = "Port mapping register, P1.4 and P1.5"]
pub struct P1MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P1.4 and P1.5"]
pub mod p1map45;
#[doc = "Port mapping register, P1.6 and P1.7"]
pub struct P1MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P1.6 and P1.7"]
pub mod p1map67;
#[doc = "Port mapping register, P2.0 and P2.1"]
pub struct P2MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P2.0 and P2.1"]
pub mod p2map01;
#[doc = "Port mapping register, P2.2 and P2.3"]
pub struct P2MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P2.2 and P2.3"]
pub mod p2map23;
#[doc = "Port mapping register, P2.4 and P2.5"]
pub struct P2MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P2.4 and P2.5"]
pub mod p2map45;
#[doc = "Port mapping register, P2.6 and P2.7"]
pub struct P2MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P2.6 and P2.7"]
pub mod p2map67;
#[doc = "Port mapping register, P3.0 and P3.1"]
pub struct P3MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P3.0 and P3.1"]
pub mod p3map01;
#[doc = "Port mapping register, P3.2 and P3.3"]
pub struct P3MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P3.2 and P3.3"]
pub mod p3map23;
#[doc = "Port mapping register, P3.4 and P3.5"]
pub struct P3MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P3.4 and P3.5"]
pub mod p3map45;
#[doc = "Port mapping register, P3.6 and P3.7"]
pub struct P3MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P3.6 and P3.7"]
pub mod p3map67;
#[doc = "Port mapping register, P4.0 and P4.1"]
pub struct P4MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P4.0 and P4.1"]
pub mod p4map01;
#[doc = "Port mapping register, P4.2 and P4.3"]
pub struct P4MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P4.2 and P4.3"]
pub mod p4map23;
#[doc = "Port mapping register, P4.4 and P4.5"]
pub struct P4MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P4.4 and P4.5"]
pub mod p4map45;
#[doc = "Port mapping register, P4.6 and P4.7"]
pub struct P4MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P4.6 and P4.7"]
pub mod p4map67;
#[doc = "Port mapping register, P5.0 and P5.1"]
pub struct P5MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P5.0 and P5.1"]
pub mod p5map01;
#[doc = "Port mapping register, P5.2 and P5.3"]
pub struct P5MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P5.2 and P5.3"]
pub mod p5map23;
#[doc = "Port mapping register, P5.4 and P5.5"]
pub struct P5MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P5.4 and P5.5"]
pub mod p5map45;
#[doc = "Port mapping register, P5.6 and P5.7"]
pub struct P5MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P5.6 and P5.7"]
pub mod p5map67;
#[doc = "Port mapping register, P6.0 and P6.1"]
pub struct P6MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P6.0 and P6.1"]
pub mod p6map01;
#[doc = "Port mapping register, P6.2 and P6.3"]
pub struct P6MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P6.2 and P6.3"]
pub mod p6map23;
#[doc = "Port mapping register, P6.4 and P6.5"]
pub struct P6MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P6.4 and P6.5"]
pub mod p6map45;
#[doc = "Port mapping register, P6.6 and P6.7"]
pub struct P6MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P6.6 and P6.7"]
pub mod p6map67;
#[doc = "Port mapping register, P7.0 and P7.1"]
pub struct P7MAP01 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P7.0 and P7.1"]
pub mod p7map01;
#[doc = "Port mapping register, P7.2 and P7.3"]
pub struct P7MAP23 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P7.2 and P7.3"]
pub mod p7map23;
#[doc = "Port mapping register, P7.4 and P7.5"]
pub struct P7MAP45 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P7.4 and P7.5"]
pub mod p7map45;
#[doc = "Port mapping register, P7.6 and P7.7"]
pub struct P7MAP67 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Port mapping register, P7.6 and P7.7"]
pub mod p7map67;
