#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::PMAPCTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `PMAPLOCKED`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PMAPLOCKEDR {
    #[doc = "Access to mapping registers is granted"]
    PMAPLOCKED_0,
    #[doc = "Access to mapping registers is locked"]
    PMAPLOCKED_1,
}
impl PMAPLOCKEDR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PMAPLOCKEDR::PMAPLOCKED_0 => false,
            PMAPLOCKEDR::PMAPLOCKED_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PMAPLOCKEDR {
        match value {
            false => PMAPLOCKEDR::PMAPLOCKED_0,
            true => PMAPLOCKEDR::PMAPLOCKED_1,
        }
    }
    #[doc = "Checks if the value of the field is `PMAPLOCKED_0`"]
    #[inline]
    pub fn is_pmaplocked_0(&self) -> bool {
        *self == PMAPLOCKEDR::PMAPLOCKED_0
    }
    #[doc = "Checks if the value of the field is `PMAPLOCKED_1`"]
    #[inline]
    pub fn is_pmaplocked_1(&self) -> bool {
        *self == PMAPLOCKEDR::PMAPLOCKED_1
    }
}
#[doc = "Possible values of the field `PMAPRECFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PMAPRECFGR {
    #[doc = "Configuration allowed only once"]
    PMAPRECFG_0,
    #[doc = "Allow reconfiguration of port mapping"]
    PMAPRECFG_1,
}
impl PMAPRECFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PMAPRECFGR::PMAPRECFG_0 => false,
            PMAPRECFGR::PMAPRECFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PMAPRECFGR {
        match value {
            false => PMAPRECFGR::PMAPRECFG_0,
            true => PMAPRECFGR::PMAPRECFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `PMAPRECFG_0`"]
    #[inline]
    pub fn is_pmaprecfg_0(&self) -> bool {
        *self == PMAPRECFGR::PMAPRECFG_0
    }
    #[doc = "Checks if the value of the field is `PMAPRECFG_1`"]
    #[inline]
    pub fn is_pmaprecfg_1(&self) -> bool {
        *self == PMAPRECFGR::PMAPRECFG_1
    }
}
#[doc = "Values that can be written to the field `PMAPRECFG`"]
pub enum PMAPRECFGW {
    #[doc = "Configuration allowed only once"]
    PMAPRECFG_0,
    #[doc = "Allow reconfiguration of port mapping"]
    PMAPRECFG_1,
}
impl PMAPRECFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PMAPRECFGW::PMAPRECFG_0 => false,
            PMAPRECFGW::PMAPRECFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PMAPRECFGW<'a> {
    w: &'a mut W,
}
impl<'a> _PMAPRECFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PMAPRECFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Configuration allowed only once"]
    #[inline]
    pub fn pmaprecfg_0(self) -> &'a mut W {
        self.variant(PMAPRECFGW::PMAPRECFG_0)
    }
    #[doc = "Allow reconfiguration of port mapping"]
    #[inline]
    pub fn pmaprecfg_1(self) -> &'a mut W {
        self.variant(PMAPRECFGW::PMAPRECFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Port mapping lock bit"]
    #[inline]
    pub fn pmaplocked(&self) -> PMAPLOCKEDR {
        PMAPLOCKEDR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Port mapping reconfiguration control bit"]
    #[inline]
    pub fn pmaprecfg(&self) -> PMAPRECFGR {
        PMAPRECFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 1 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 1 - Port mapping reconfiguration control bit"]
    #[inline]
    pub fn pmaprecfg(&mut self) -> _PMAPRECFGW {
        _PMAPRECFGW { w: self }
    }
}
