#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Key Register"]
    pub psskey: PSSKEY,
    #[doc = "0x04 - Control 0 Register"]
    pub pssctl0: PSSCTL0,
    _reserved0: [u8; 44usize],
    #[doc = "0x34 - Interrupt Enable Register"]
    pub pssie: PSSIE,
    #[doc = "0x38 - Interrupt Flag Register"]
    pub pssifg: PSSIFG,
    #[doc = "0x3c - Clear Interrupt Flag Register"]
    pub pssclrifg: PSSCLRIFG,
}
#[doc = "Key Register"]
pub struct PSSKEY {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Key Register"]
pub mod psskey;
#[doc = "Control 0 Register"]
pub struct PSSCTL0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Control 0 Register"]
pub mod pssctl0;
#[doc = "Interrupt Enable Register"]
pub struct PSSIE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Enable Register"]
pub mod pssie;
#[doc = "Interrupt Flag Register"]
pub struct PSSIFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Interrupt Flag Register"]
pub mod pssifg;
#[doc = "Clear Interrupt Flag Register"]
pub struct PSSCLRIFG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clear Interrupt Flag Register"]
pub mod pssclrifg;
