#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PSSCTL0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SVSMHOFF`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVSMHOFFR {
    #[doc = "The SVSMH is on"]
    SVSMHOFF_0,
    #[doc = "The SVSMH is off"]
    SVSMHOFF_1,
}
impl SVSMHOFFR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVSMHOFFR::SVSMHOFF_0 => false,
            SVSMHOFFR::SVSMHOFF_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVSMHOFFR {
        match value {
            false => SVSMHOFFR::SVSMHOFF_0,
            true => SVSMHOFFR::SVSMHOFF_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVSMHOFF_0`"]
    #[inline]
    pub fn is_svsmhoff_0(&self) -> bool {
        *self == SVSMHOFFR::SVSMHOFF_0
    }
    #[doc = "Checks if the value of the field is `SVSMHOFF_1`"]
    #[inline]
    pub fn is_svsmhoff_1(&self) -> bool {
        *self == SVSMHOFFR::SVSMHOFF_1
    }
}
#[doc = "Possible values of the field `SVSMHLP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVSMHLPR {
    #[doc = "Full performance mode. See the device-specific data sheet for response times."]
    SVSMHLP_0,
    #[doc = "Low power normal performance mode in LPM3, LPM4, and LPMx.5, full performance in all other modes. See the device-specific data sheet for response times."]
    SVSMHLP_1,
}
impl SVSMHLPR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVSMHLPR::SVSMHLP_0 => false,
            SVSMHLPR::SVSMHLP_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVSMHLPR {
        match value {
            false => SVSMHLPR::SVSMHLP_0,
            true => SVSMHLPR::SVSMHLP_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVSMHLP_0`"]
    #[inline]
    pub fn is_svsmhlp_0(&self) -> bool {
        *self == SVSMHLPR::SVSMHLP_0
    }
    #[doc = "Checks if the value of the field is `SVSMHLP_1`"]
    #[inline]
    pub fn is_svsmhlp_1(&self) -> bool {
        *self == SVSMHLPR::SVSMHLP_1
    }
}
#[doc = "Possible values of the field `SVSMHS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVSMHSR {
    #[doc = "Configure as SVSH"]
    SVSMHS_0,
    #[doc = "Configure as SVMH"]
    SVSMHS_1,
}
impl SVSMHSR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVSMHSR::SVSMHS_0 => false,
            SVSMHSR::SVSMHS_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVSMHSR {
        match value {
            false => SVSMHSR::SVSMHS_0,
            true => SVSMHSR::SVSMHS_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVSMHS_0`"]
    #[inline]
    pub fn is_svsmhs_0(&self) -> bool {
        *self == SVSMHSR::SVSMHS_0
    }
    #[doc = "Checks if the value of the field is `SVSMHS_1`"]
    #[inline]
    pub fn is_svsmhs_1(&self) -> bool {
        *self == SVSMHSR::SVSMHS_1
    }
}
#[doc = r" Value of the field"]
pub struct SVSMHTHR {
    bits: u8,
}
impl SVSMHTHR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Possible values of the field `SVMHOE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVMHOER {
    #[doc = "SVSMHIFG bit is not output"]
    SVMHOE_0,
    #[doc = "SVSMHIFG bit is output to the device SVMHOUT pin. The device-specific port logic must be configured accordingly"]
    SVMHOE_1,
}
impl SVMHOER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVMHOER::SVMHOE_0 => false,
            SVMHOER::SVMHOE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVMHOER {
        match value {
            false => SVMHOER::SVMHOE_0,
            true => SVMHOER::SVMHOE_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVMHOE_0`"]
    #[inline]
    pub fn is_svmhoe_0(&self) -> bool {
        *self == SVMHOER::SVMHOE_0
    }
    #[doc = "Checks if the value of the field is `SVMHOE_1`"]
    #[inline]
    pub fn is_svmhoe_1(&self) -> bool {
        *self == SVMHOER::SVMHOE_1
    }
}
#[doc = "Possible values of the field `SVMHOUTPOLAL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVMHOUTPOLALR {
    #[doc = "SVMHOUT is active high. An error condition is signaled by a 1 at the SVMHOUT pin"]
    SVMHOUTPOLAL_0,
    #[doc = "SVMHOUT is active low. An error condition is signaled by a 0 at the SVMHOUT pin"]
    SVMHOUTPOLAL_1,
}
impl SVMHOUTPOLALR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVMHOUTPOLALR::SVMHOUTPOLAL_0 => false,
            SVMHOUTPOLALR::SVMHOUTPOLAL_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVMHOUTPOLALR {
        match value {
            false => SVMHOUTPOLALR::SVMHOUTPOLAL_0,
            true => SVMHOUTPOLALR::SVMHOUTPOLAL_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVMHOUTPOLAL_0`"]
    #[inline]
    pub fn is_svmhoutpolal_0(&self) -> bool {
        *self == SVMHOUTPOLALR::SVMHOUTPOLAL_0
    }
    #[doc = "Checks if the value of the field is `SVMHOUTPOLAL_1`"]
    #[inline]
    pub fn is_svmhoutpolal_1(&self) -> bool {
        *self == SVMHOUTPOLALR::SVMHOUTPOLAL_1
    }
}
#[doc = "Possible values of the field `DCDC_FORCE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DCDC_FORCER {
    #[doc = "DC-DC regulator operation not forced. Automatic fail-safe mechanism switches the core voltage regulator from DC-DC to LDO when the supply voltage falls below the minimum supply voltage necessary for DC-DC operation."]
    DCDC_FORCE_0,
    #[doc = "DC-DC regulator operation forced. Automatic fail-safe mechanism is disabled and device continues to operate out of DC-DC regulator."]
    DCDC_FORCE_1,
}
impl DCDC_FORCER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            DCDC_FORCER::DCDC_FORCE_0 => false,
            DCDC_FORCER::DCDC_FORCE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> DCDC_FORCER {
        match value {
            false => DCDC_FORCER::DCDC_FORCE_0,
            true => DCDC_FORCER::DCDC_FORCE_1,
        }
    }
    #[doc = "Checks if the value of the field is `DCDC_FORCE_0`"]
    #[inline]
    pub fn is_dcdc_force_0(&self) -> bool {
        *self == DCDC_FORCER::DCDC_FORCE_0
    }
    #[doc = "Checks if the value of the field is `DCDC_FORCE_1`"]
    #[inline]
    pub fn is_dcdc_force_1(&self) -> bool {
        *self == DCDC_FORCER::DCDC_FORCE_1
    }
}
#[doc = "Possible values of the field `VCORETRAN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VCORETRANR {
    #[doc = "32 s / 100 mV"]
    VCORETRAN_0,
    #[doc = "64 s / 100 mV"]
    VCORETRAN_1,
    #[doc = "128 s / 100 mV (default)"]
    VCORETRAN_2,
    #[doc = "256 s / 100 mV"]
    VCORETRAN_3,
}
impl VCORETRANR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            VCORETRANR::VCORETRAN_0 => 0,
            VCORETRANR::VCORETRAN_1 => 1,
            VCORETRANR::VCORETRAN_2 => 2,
            VCORETRANR::VCORETRAN_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> VCORETRANR {
        match value {
            0 => VCORETRANR::VCORETRAN_0,
            1 => VCORETRANR::VCORETRAN_1,
            2 => VCORETRANR::VCORETRAN_2,
            3 => VCORETRANR::VCORETRAN_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `VCORETRAN_0`"]
    #[inline]
    pub fn is_vcoretran_0(&self) -> bool {
        *self == VCORETRANR::VCORETRAN_0
    }
    #[doc = "Checks if the value of the field is `VCORETRAN_1`"]
    #[inline]
    pub fn is_vcoretran_1(&self) -> bool {
        *self == VCORETRANR::VCORETRAN_1
    }
    #[doc = "Checks if the value of the field is `VCORETRAN_2`"]
    #[inline]
    pub fn is_vcoretran_2(&self) -> bool {
        *self == VCORETRANR::VCORETRAN_2
    }
    #[doc = "Checks if the value of the field is `VCORETRAN_3`"]
    #[inline]
    pub fn is_vcoretran_3(&self) -> bool {
        *self == VCORETRANR::VCORETRAN_3
    }
}
#[doc = "Values that can be written to the field `SVSMHOFF`"]
pub enum SVSMHOFFW {
    #[doc = "The SVSMH is on"]
    SVSMHOFF_0,
    #[doc = "The SVSMH is off"]
    SVSMHOFF_1,
}
impl SVSMHOFFW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVSMHOFFW::SVSMHOFF_0 => false,
            SVSMHOFFW::SVSMHOFF_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVSMHOFFW<'a> {
    w: &'a mut W,
}
impl<'a> _SVSMHOFFW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVSMHOFFW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The SVSMH is on"]
    #[inline]
    pub fn svsmhoff_0(self) -> &'a mut W {
        self.variant(SVSMHOFFW::SVSMHOFF_0)
    }
    #[doc = "The SVSMH is off"]
    #[inline]
    pub fn svsmhoff_1(self) -> &'a mut W {
        self.variant(SVSMHOFFW::SVSMHOFF_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SVSMHLP`"]
pub enum SVSMHLPW {
    #[doc = "Full performance mode. See the device-specific data sheet for response times."]
    SVSMHLP_0,
    #[doc = "Low power normal performance mode in LPM3, LPM4, and LPMx.5, full performance in all other modes. See the device-specific data sheet for response times."]
    SVSMHLP_1,
}
impl SVSMHLPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVSMHLPW::SVSMHLP_0 => false,
            SVSMHLPW::SVSMHLP_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVSMHLPW<'a> {
    w: &'a mut W,
}
impl<'a> _SVSMHLPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVSMHLPW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Full performance mode. See the device-specific data sheet for response times."]
    #[inline]
    pub fn svsmhlp_0(self) -> &'a mut W {
        self.variant(SVSMHLPW::SVSMHLP_0)
    }
    #[doc = "Low power normal performance mode in LPM3, LPM4, and LPMx.5, full performance in all other modes. See the device-specific data sheet for response times."]
    #[inline]
    pub fn svsmhlp_1(self) -> &'a mut W {
        self.variant(SVSMHLPW::SVSMHLP_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SVSMHS`"]
pub enum SVSMHSW {
    #[doc = "Configure as SVSH"]
    SVSMHS_0,
    #[doc = "Configure as SVMH"]
    SVSMHS_1,
}
impl SVSMHSW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVSMHSW::SVSMHS_0 => false,
            SVSMHSW::SVSMHS_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVSMHSW<'a> {
    w: &'a mut W,
}
impl<'a> _SVSMHSW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVSMHSW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Configure as SVSH"]
    #[inline]
    pub fn svsmhs_0(self) -> &'a mut W {
        self.variant(SVSMHSW::SVSMHS_0)
    }
    #[doc = "Configure as SVMH"]
    #[inline]
    pub fn svsmhs_1(self) -> &'a mut W {
        self.variant(SVSMHSW::SVSMHS_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _SVSMHTHW<'a> {
    w: &'a mut W,
}
impl<'a> _SVSMHTHW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SVMHOE`"]
pub enum SVMHOEW {
    #[doc = "SVSMHIFG bit is not output"]
    SVMHOE_0,
    #[doc = "SVSMHIFG bit is output to the device SVMHOUT pin. The device-specific port logic must be configured accordingly"]
    SVMHOE_1,
}
impl SVMHOEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVMHOEW::SVMHOE_0 => false,
            SVMHOEW::SVMHOE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVMHOEW<'a> {
    w: &'a mut W,
}
impl<'a> _SVMHOEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVMHOEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "SVSMHIFG bit is not output"]
    #[inline]
    pub fn svmhoe_0(self) -> &'a mut W {
        self.variant(SVMHOEW::SVMHOE_0)
    }
    #[doc = "SVSMHIFG bit is output to the device SVMHOUT pin. The device-specific port logic must be configured accordingly"]
    #[inline]
    pub fn svmhoe_1(self) -> &'a mut W {
        self.variant(SVMHOEW::SVMHOE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SVMHOUTPOLAL`"]
pub enum SVMHOUTPOLALW {
    #[doc = "SVMHOUT is active high. An error condition is signaled by a 1 at the SVMHOUT pin"]
    SVMHOUTPOLAL_0,
    #[doc = "SVMHOUT is active low. An error condition is signaled by a 0 at the SVMHOUT pin"]
    SVMHOUTPOLAL_1,
}
impl SVMHOUTPOLALW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVMHOUTPOLALW::SVMHOUTPOLAL_0 => false,
            SVMHOUTPOLALW::SVMHOUTPOLAL_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVMHOUTPOLALW<'a> {
    w: &'a mut W,
}
impl<'a> _SVMHOUTPOLALW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVMHOUTPOLALW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "SVMHOUT is active high. An error condition is signaled by a 1 at the SVMHOUT pin"]
    #[inline]
    pub fn svmhoutpolal_0(self) -> &'a mut W {
        self.variant(SVMHOUTPOLALW::SVMHOUTPOLAL_0)
    }
    #[doc = "SVMHOUT is active low. An error condition is signaled by a 0 at the SVMHOUT pin"]
    #[inline]
    pub fn svmhoutpolal_1(self) -> &'a mut W {
        self.variant(SVMHOUTPOLALW::SVMHOUTPOLAL_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `DCDC_FORCE`"]
pub enum DCDC_FORCEW {
    #[doc = "DC-DC regulator operation not forced. Automatic fail-safe mechanism switches the core voltage regulator from DC-DC to LDO when the supply voltage falls below the minimum supply voltage necessary for DC-DC operation."]
    DCDC_FORCE_0,
    #[doc = "DC-DC regulator operation forced. Automatic fail-safe mechanism is disabled and device continues to operate out of DC-DC regulator."]
    DCDC_FORCE_1,
}
impl DCDC_FORCEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            DCDC_FORCEW::DCDC_FORCE_0 => false,
            DCDC_FORCEW::DCDC_FORCE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _DCDC_FORCEW<'a> {
    w: &'a mut W,
}
impl<'a> _DCDC_FORCEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: DCDC_FORCEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "DC-DC regulator operation not forced. Automatic fail-safe mechanism switches the core voltage regulator from DC-DC to LDO when the supply voltage falls below the minimum supply voltage necessary for DC-DC operation."]
    #[inline]
    pub fn dcdc_force_0(self) -> &'a mut W {
        self.variant(DCDC_FORCEW::DCDC_FORCE_0)
    }
    #[doc = "DC-DC regulator operation forced. Automatic fail-safe mechanism is disabled and device continues to operate out of DC-DC regulator."]
    #[inline]
    pub fn dcdc_force_1(self) -> &'a mut W {
        self.variant(DCDC_FORCEW::DCDC_FORCE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `VCORETRAN`"]
pub enum VCORETRANW {
    #[doc = "32 s / 100 mV"]
    VCORETRAN_0,
    #[doc = "64 s / 100 mV"]
    VCORETRAN_1,
    #[doc = "128 s / 100 mV (default)"]
    VCORETRAN_2,
    #[doc = "256 s / 100 mV"]
    VCORETRAN_3,
}
impl VCORETRANW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            VCORETRANW::VCORETRAN_0 => 0,
            VCORETRANW::VCORETRAN_1 => 1,
            VCORETRANW::VCORETRAN_2 => 2,
            VCORETRANW::VCORETRAN_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _VCORETRANW<'a> {
    w: &'a mut W,
}
impl<'a> _VCORETRANW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: VCORETRANW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "32 s / 100 mV"]
    #[inline]
    pub fn vcoretran_0(self) -> &'a mut W {
        self.variant(VCORETRANW::VCORETRAN_0)
    }
    #[doc = "64 s / 100 mV"]
    #[inline]
    pub fn vcoretran_1(self) -> &'a mut W {
        self.variant(VCORETRANW::VCORETRAN_1)
    }
    #[doc = "128 s / 100 mV (default)"]
    #[inline]
    pub fn vcoretran_2(self) -> &'a mut W {
        self.variant(VCORETRANW::VCORETRAN_2)
    }
    #[doc = "256 s / 100 mV"]
    #[inline]
    pub fn vcoretran_3(self) -> &'a mut W {
        self.variant(VCORETRANW::VCORETRAN_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - SVSM high-side off"]
    #[inline]
    pub fn svsmhoff(&self) -> SVSMHOFFR {
        SVSMHOFFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - SVSM high-side low power normal performance mode"]
    #[inline]
    pub fn svsmhlp(&self) -> SVSMHLPR {
        SVSMHLPR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Supply supervisor or monitor selection for the high-side"]
    #[inline]
    pub fn svsmhs(&self) -> SVSMHSR {
        SVSMHSR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 3:5 - SVSM high-side reset voltage level"]
    #[inline]
    pub fn svsmhth(&self) -> SVSMHTHR {
        let bits = {
            const MASK: u8 = 7;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SVSMHTHR { bits }
    }
    #[doc = "Bit 6 - SVSM high-side output enable"]
    #[inline]
    pub fn svmhoe(&self) -> SVMHOER {
        SVMHOER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - SVMHOUT pin polarity active low"]
    #[inline]
    pub fn svmhoutpolal(&self) -> SVMHOUTPOLALR {
        SVMHOUTPOLALR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 10 - Force DC-DC regulator operation"]
    #[inline]
    pub fn dcdc_force(&self) -> DCDC_FORCER {
        DCDC_FORCER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 12:13 - Controls core voltage level transition time"]
    #[inline]
    pub fn vcoretran(&self) -> VCORETRANR {
        VCORETRANR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 8192 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - SVSM high-side off"]
    #[inline]
    pub fn svsmhoff(&mut self) -> _SVSMHOFFW {
        _SVSMHOFFW { w: self }
    }
    #[doc = "Bit 1 - SVSM high-side low power normal performance mode"]
    #[inline]
    pub fn svsmhlp(&mut self) -> _SVSMHLPW {
        _SVSMHLPW { w: self }
    }
    #[doc = "Bit 2 - Supply supervisor or monitor selection for the high-side"]
    #[inline]
    pub fn svsmhs(&mut self) -> _SVSMHSW {
        _SVSMHSW { w: self }
    }
    #[doc = "Bits 3:5 - SVSM high-side reset voltage level"]
    #[inline]
    pub fn svsmhth(&mut self) -> _SVSMHTHW {
        _SVSMHTHW { w: self }
    }
    #[doc = "Bit 6 - SVSM high-side output enable"]
    #[inline]
    pub fn svmhoe(&mut self) -> _SVMHOEW {
        _SVMHOEW { w: self }
    }
    #[doc = "Bit 7 - SVMHOUT pin polarity active low"]
    #[inline]
    pub fn svmhoutpolal(&mut self) -> _SVMHOUTPOLALW {
        _SVMHOUTPOLALW { w: self }
    }
    #[doc = "Bit 10 - Force DC-DC regulator operation"]
    #[inline]
    pub fn dcdc_force(&mut self) -> _DCDC_FORCEW {
        _DCDC_FORCEW { w: self }
    }
    #[doc = "Bits 12:13 - Controls core voltage level transition time"]
    #[inline]
    pub fn vcoretran(&mut self) -> _VCORETRANW {
        _VCORETRANW { w: self }
    }
}
