#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PSSIE {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SVSMHIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVSMHIER {
    #[doc = "Interrupt disabled"]
    SVSMHIE_0,
    #[doc = "Interrupt enabled"]
    SVSMHIE_1,
}
impl SVSMHIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVSMHIER::SVSMHIE_0 => false,
            SVSMHIER::SVSMHIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVSMHIER {
        match value {
            false => SVSMHIER::SVSMHIE_0,
            true => SVSMHIER::SVSMHIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVSMHIE_0`"]
    #[inline]
    pub fn is_svsmhie_0(&self) -> bool {
        *self == SVSMHIER::SVSMHIE_0
    }
    #[doc = "Checks if the value of the field is `SVSMHIE_1`"]
    #[inline]
    pub fn is_svsmhie_1(&self) -> bool {
        *self == SVSMHIER::SVSMHIE_1
    }
}
#[doc = "Values that can be written to the field `SVSMHIE`"]
pub enum SVSMHIEW {
    #[doc = "Interrupt disabled"]
    SVSMHIE_0,
    #[doc = "Interrupt enabled"]
    SVSMHIE_1,
}
impl SVSMHIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SVSMHIEW::SVSMHIE_0 => false,
            SVSMHIEW::SVSMHIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SVSMHIEW<'a> {
    w: &'a mut W,
}
impl<'a> _SVSMHIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SVSMHIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn svsmhie_0(self) -> &'a mut W {
        self.variant(SVSMHIEW::SVSMHIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn svsmhie_1(self) -> &'a mut W {
        self.variant(SVSMHIEW::SVSMHIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 1 - High-side SVSM interrupt enable"]
    #[inline]
    pub fn svsmhie(&self) -> SVSMHIER {
        SVSMHIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 1 - High-side SVSM interrupt enable"]
    #[inline]
    pub fn svsmhie(&mut self) -> _SVSMHIEW {
        _SVSMHIEW { w: self }
    }
}
