#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::PSSIFG {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `SVSMHIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SVSMHIFGR {
    #[doc = "No interrupt pending"]
    SVSMHIFG_0,
    #[doc = "Interrupt due to SVSMH"]
    SVSMHIFG_1,
}
impl SVSMHIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SVSMHIFGR::SVSMHIFG_0 => false,
            SVSMHIFGR::SVSMHIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SVSMHIFGR {
        match value {
            false => SVSMHIFGR::SVSMHIFG_0,
            true => SVSMHIFGR::SVSMHIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `SVSMHIFG_0`"]
    #[inline]
    pub fn is_svsmhifg_0(&self) -> bool {
        *self == SVSMHIFGR::SVSMHIFG_0
    }
    #[doc = "Checks if the value of the field is `SVSMHIFG_1`"]
    #[inline]
    pub fn is_svsmhifg_1(&self) -> bool {
        *self == SVSMHIFGR::SVSMHIFG_1
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 1 - High-side SVSM interrupt flag"]
    #[inline]
    pub fn svsmhifg(&self) -> SVSMHIFGR {
        SVSMHIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
