#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::REFCTL0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `REFON`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFONR {
    #[doc = "Disables reference if no other reference requests are pending"]
    REFON_0,
    #[doc = "Enables reference in static mode"]
    REFON_1,
}
impl REFONR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFONR::REFON_0 => false,
            REFONR::REFON_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFONR {
        match value {
            false => REFONR::REFON_0,
            true => REFONR::REFON_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFON_0`"]
    #[inline]
    pub fn is_refon_0(&self) -> bool {
        *self == REFONR::REFON_0
    }
    #[doc = "Checks if the value of the field is `REFON_1`"]
    #[inline]
    pub fn is_refon_1(&self) -> bool {
        *self == REFONR::REFON_1
    }
}
#[doc = "Possible values of the field `REFOUT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFOUTR {
    #[doc = "Reference output not available externally"]
    REFOUT_0,
    #[doc = "Reference output available externally. If ADC14REFBURST = 0, output is available continuously. If ADC14REFBURST = 1, output is available only during an ADC14 conversion."]
    REFOUT_1,
}
impl REFOUTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFOUTR::REFOUT_0 => false,
            REFOUTR::REFOUT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFOUTR {
        match value {
            false => REFOUTR::REFOUT_0,
            true => REFOUTR::REFOUT_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFOUT_0`"]
    #[inline]
    pub fn is_refout_0(&self) -> bool {
        *self == REFOUTR::REFOUT_0
    }
    #[doc = "Checks if the value of the field is `REFOUT_1`"]
    #[inline]
    pub fn is_refout_1(&self) -> bool {
        *self == REFOUTR::REFOUT_1
    }
}
#[doc = "Possible values of the field `REFTCOFF`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFTCOFFR {
    #[doc = "Temperature sensor enabled"]
    REFTCOFF_0,
    #[doc = "Temperature sensor disabled to save power"]
    REFTCOFF_1,
}
impl REFTCOFFR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFTCOFFR::REFTCOFF_0 => false,
            REFTCOFFR::REFTCOFF_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFTCOFFR {
        match value {
            false => REFTCOFFR::REFTCOFF_0,
            true => REFTCOFFR::REFTCOFF_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFTCOFF_0`"]
    #[inline]
    pub fn is_reftcoff_0(&self) -> bool {
        *self == REFTCOFFR::REFTCOFF_0
    }
    #[doc = "Checks if the value of the field is `REFTCOFF_1`"]
    #[inline]
    pub fn is_reftcoff_1(&self) -> bool {
        *self == REFTCOFFR::REFTCOFF_1
    }
}
#[doc = "Possible values of the field `REFVSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFVSELR {
    #[doc = "1.2 V available when reference requested or REFON = 1"]
    REFVSEL_0,
    #[doc = "1.45 V available when reference requested or REFON = 1"]
    REFVSEL_1,
    #[doc = "2.5 V available when reference requested or REFON = 1"]
    REFVSEL_3,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl REFVSELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            REFVSELR::REFVSEL_0 => 0,
            REFVSELR::REFVSEL_1 => 1,
            REFVSELR::REFVSEL_3 => 3,
            REFVSELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> REFVSELR {
        match value {
            0 => REFVSELR::REFVSEL_0,
            1 => REFVSELR::REFVSEL_1,
            3 => REFVSELR::REFVSEL_3,
            i => REFVSELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `REFVSEL_0`"]
    #[inline]
    pub fn is_refvsel_0(&self) -> bool {
        *self == REFVSELR::REFVSEL_0
    }
    #[doc = "Checks if the value of the field is `REFVSEL_1`"]
    #[inline]
    pub fn is_refvsel_1(&self) -> bool {
        *self == REFVSELR::REFVSEL_1
    }
    #[doc = "Checks if the value of the field is `REFVSEL_3`"]
    #[inline]
    pub fn is_refvsel_3(&self) -> bool {
        *self == REFVSELR::REFVSEL_3
    }
}
#[doc = "Possible values of the field `REFGENOT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFGENOTR {
    #[doc = "No trigger"]
    REFGENOT_0,
    #[doc = "Generation of the reference voltage is started by writing 1 or by a hardware trigger"]
    REFGENOT_1,
}
impl REFGENOTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFGENOTR::REFGENOT_0 => false,
            REFGENOTR::REFGENOT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFGENOTR {
        match value {
            false => REFGENOTR::REFGENOT_0,
            true => REFGENOTR::REFGENOT_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFGENOT_0`"]
    #[inline]
    pub fn is_refgenot_0(&self) -> bool {
        *self == REFGENOTR::REFGENOT_0
    }
    #[doc = "Checks if the value of the field is `REFGENOT_1`"]
    #[inline]
    pub fn is_refgenot_1(&self) -> bool {
        *self == REFGENOTR::REFGENOT_1
    }
}
#[doc = "Possible values of the field `REFBGOT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFBGOTR {
    #[doc = "No trigger"]
    REFBGOT_0,
    #[doc = "Generation of the bandgap voltage is started by writing 1 or by a hardware trigger"]
    REFBGOT_1,
}
impl REFBGOTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFBGOTR::REFBGOT_0 => false,
            REFBGOTR::REFBGOT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFBGOTR {
        match value {
            false => REFBGOTR::REFBGOT_0,
            true => REFBGOTR::REFBGOT_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFBGOT_0`"]
    #[inline]
    pub fn is_refbgot_0(&self) -> bool {
        *self == REFBGOTR::REFBGOT_0
    }
    #[doc = "Checks if the value of the field is `REFBGOT_1`"]
    #[inline]
    pub fn is_refbgot_1(&self) -> bool {
        *self == REFBGOTR::REFBGOT_1
    }
}
#[doc = "Possible values of the field `REFGENACT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFGENACTR {
    #[doc = "Reference generator not active"]
    REFGENACT_0,
    #[doc = "Reference generator active"]
    REFGENACT_1,
}
impl REFGENACTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFGENACTR::REFGENACT_0 => false,
            REFGENACTR::REFGENACT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFGENACTR {
        match value {
            false => REFGENACTR::REFGENACT_0,
            true => REFGENACTR::REFGENACT_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFGENACT_0`"]
    #[inline]
    pub fn is_refgenact_0(&self) -> bool {
        *self == REFGENACTR::REFGENACT_0
    }
    #[doc = "Checks if the value of the field is `REFGENACT_1`"]
    #[inline]
    pub fn is_refgenact_1(&self) -> bool {
        *self == REFGENACTR::REFGENACT_1
    }
}
#[doc = "Possible values of the field `REFBGACT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFBGACTR {
    #[doc = "Reference bandgap buffer not active"]
    REFBGACT_0,
    #[doc = "Reference bandgap buffer active"]
    REFBGACT_1,
}
impl REFBGACTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFBGACTR::REFBGACT_0 => false,
            REFBGACTR::REFBGACT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFBGACTR {
        match value {
            false => REFBGACTR::REFBGACT_0,
            true => REFBGACTR::REFBGACT_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFBGACT_0`"]
    #[inline]
    pub fn is_refbgact_0(&self) -> bool {
        *self == REFBGACTR::REFBGACT_0
    }
    #[doc = "Checks if the value of the field is `REFBGACT_1`"]
    #[inline]
    pub fn is_refbgact_1(&self) -> bool {
        *self == REFBGACTR::REFBGACT_1
    }
}
#[doc = "Possible values of the field `REFGENBUSY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFGENBUSYR {
    #[doc = "Reference generator not busy"]
    REFGENBUSY_0,
    #[doc = "Reference generator busy"]
    REFGENBUSY_1,
}
impl REFGENBUSYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFGENBUSYR::REFGENBUSY_0 => false,
            REFGENBUSYR::REFGENBUSY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFGENBUSYR {
        match value {
            false => REFGENBUSYR::REFGENBUSY_0,
            true => REFGENBUSYR::REFGENBUSY_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFGENBUSY_0`"]
    #[inline]
    pub fn is_refgenbusy_0(&self) -> bool {
        *self == REFGENBUSYR::REFGENBUSY_0
    }
    #[doc = "Checks if the value of the field is `REFGENBUSY_1`"]
    #[inline]
    pub fn is_refgenbusy_1(&self) -> bool {
        *self == REFGENBUSYR::REFGENBUSY_1
    }
}
#[doc = "Possible values of the field `BGMODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BGMODER {
    #[doc = "Static mode"]
    BGMODE_0,
    #[doc = "Sampled mode"]
    BGMODE_1,
}
impl BGMODER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BGMODER::BGMODE_0 => false,
            BGMODER::BGMODE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BGMODER {
        match value {
            false => BGMODER::BGMODE_0,
            true => BGMODER::BGMODE_1,
        }
    }
    #[doc = "Checks if the value of the field is `BGMODE_0`"]
    #[inline]
    pub fn is_bgmode_0(&self) -> bool {
        *self == BGMODER::BGMODE_0
    }
    #[doc = "Checks if the value of the field is `BGMODE_1`"]
    #[inline]
    pub fn is_bgmode_1(&self) -> bool {
        *self == BGMODER::BGMODE_1
    }
}
#[doc = "Possible values of the field `REFGENRDY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFGENRDYR {
    #[doc = "Reference voltage output is not ready to be used"]
    REFGENRDY_0,
    #[doc = "Reference voltage output is ready to be used"]
    REFGENRDY_1,
}
impl REFGENRDYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFGENRDYR::REFGENRDY_0 => false,
            REFGENRDYR::REFGENRDY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFGENRDYR {
        match value {
            false => REFGENRDYR::REFGENRDY_0,
            true => REFGENRDYR::REFGENRDY_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFGENRDY_0`"]
    #[inline]
    pub fn is_refgenrdy_0(&self) -> bool {
        *self == REFGENRDYR::REFGENRDY_0
    }
    #[doc = "Checks if the value of the field is `REFGENRDY_1`"]
    #[inline]
    pub fn is_refgenrdy_1(&self) -> bool {
        *self == REFGENRDYR::REFGENRDY_1
    }
}
#[doc = "Possible values of the field `REFBGRDY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum REFBGRDYR {
    #[doc = "Buffered bandgap voltage is not ready to be used"]
    REFBGRDY_0,
    #[doc = "Buffered bandgap voltage is ready to be used"]
    REFBGRDY_1,
}
impl REFBGRDYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            REFBGRDYR::REFBGRDY_0 => false,
            REFBGRDYR::REFBGRDY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> REFBGRDYR {
        match value {
            false => REFBGRDYR::REFBGRDY_0,
            true => REFBGRDYR::REFBGRDY_1,
        }
    }
    #[doc = "Checks if the value of the field is `REFBGRDY_0`"]
    #[inline]
    pub fn is_refbgrdy_0(&self) -> bool {
        *self == REFBGRDYR::REFBGRDY_0
    }
    #[doc = "Checks if the value of the field is `REFBGRDY_1`"]
    #[inline]
    pub fn is_refbgrdy_1(&self) -> bool {
        *self == REFBGRDYR::REFBGRDY_1
    }
}
#[doc = "Values that can be written to the field `REFON`"]
pub enum REFONW {
    #[doc = "Disables reference if no other reference requests are pending"]
    REFON_0,
    #[doc = "Enables reference in static mode"]
    REFON_1,
}
impl REFONW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            REFONW::REFON_0 => false,
            REFONW::REFON_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFONW<'a> {
    w: &'a mut W,
}
impl<'a> _REFONW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFONW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables reference if no other reference requests are pending"]
    #[inline]
    pub fn refon_0(self) -> &'a mut W {
        self.variant(REFONW::REFON_0)
    }
    #[doc = "Enables reference in static mode"]
    #[inline]
    pub fn refon_1(self) -> &'a mut W {
        self.variant(REFONW::REFON_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `REFOUT`"]
pub enum REFOUTW {
    #[doc = "Reference output not available externally"]
    REFOUT_0,
    #[doc = "Reference output available externally. If ADC14REFBURST = 0, output is available continuously. If ADC14REFBURST = 1, output is available only during an ADC14 conversion."]
    REFOUT_1,
}
impl REFOUTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            REFOUTW::REFOUT_0 => false,
            REFOUTW::REFOUT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFOUTW<'a> {
    w: &'a mut W,
}
impl<'a> _REFOUTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFOUTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reference output not available externally"]
    #[inline]
    pub fn refout_0(self) -> &'a mut W {
        self.variant(REFOUTW::REFOUT_0)
    }
    #[doc = "Reference output available externally. If ADC14REFBURST = 0, output is available continuously. If ADC14REFBURST = 1, output is available only during an ADC14 conversion."]
    #[inline]
    pub fn refout_1(self) -> &'a mut W {
        self.variant(REFOUTW::REFOUT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `REFTCOFF`"]
pub enum REFTCOFFW {
    #[doc = "Temperature sensor enabled"]
    REFTCOFF_0,
    #[doc = "Temperature sensor disabled to save power"]
    REFTCOFF_1,
}
impl REFTCOFFW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            REFTCOFFW::REFTCOFF_0 => false,
            REFTCOFFW::REFTCOFF_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFTCOFFW<'a> {
    w: &'a mut W,
}
impl<'a> _REFTCOFFW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFTCOFFW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Temperature sensor enabled"]
    #[inline]
    pub fn reftcoff_0(self) -> &'a mut W {
        self.variant(REFTCOFFW::REFTCOFF_0)
    }
    #[doc = "Temperature sensor disabled to save power"]
    #[inline]
    pub fn reftcoff_1(self) -> &'a mut W {
        self.variant(REFTCOFFW::REFTCOFF_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `REFVSEL`"]
pub enum REFVSELW {
    #[doc = "1.2 V available when reference requested or REFON = 1"]
    REFVSEL_0,
    #[doc = "1.45 V available when reference requested or REFON = 1"]
    REFVSEL_1,
    #[doc = "2.5 V available when reference requested or REFON = 1"]
    REFVSEL_3,
}
impl REFVSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            REFVSELW::REFVSEL_0 => 0,
            REFVSELW::REFVSEL_1 => 1,
            REFVSELW::REFVSEL_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFVSELW<'a> {
    w: &'a mut W,
}
impl<'a> _REFVSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFVSELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "1.2 V available when reference requested or REFON = 1"]
    #[inline]
    pub fn refvsel_0(self) -> &'a mut W {
        self.variant(REFVSELW::REFVSEL_0)
    }
    #[doc = "1.45 V available when reference requested or REFON = 1"]
    #[inline]
    pub fn refvsel_1(self) -> &'a mut W {
        self.variant(REFVSELW::REFVSEL_1)
    }
    #[doc = "2.5 V available when reference requested or REFON = 1"]
    #[inline]
    pub fn refvsel_3(self) -> &'a mut W {
        self.variant(REFVSELW::REFVSEL_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `REFGENOT`"]
pub enum REFGENOTW {
    #[doc = "No trigger"]
    REFGENOT_0,
    #[doc = "Generation of the reference voltage is started by writing 1 or by a hardware trigger"]
    REFGENOT_1,
}
impl REFGENOTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            REFGENOTW::REFGENOT_0 => false,
            REFGENOTW::REFGENOT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFGENOTW<'a> {
    w: &'a mut W,
}
impl<'a> _REFGENOTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFGENOTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No trigger"]
    #[inline]
    pub fn refgenot_0(self) -> &'a mut W {
        self.variant(REFGENOTW::REFGENOT_0)
    }
    #[doc = "Generation of the reference voltage is started by writing 1 or by a hardware trigger"]
    #[inline]
    pub fn refgenot_1(self) -> &'a mut W {
        self.variant(REFGENOTW::REFGENOT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `REFBGOT`"]
pub enum REFBGOTW {
    #[doc = "No trigger"]
    REFBGOT_0,
    #[doc = "Generation of the bandgap voltage is started by writing 1 or by a hardware trigger"]
    REFBGOT_1,
}
impl REFBGOTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            REFBGOTW::REFBGOT_0 => false,
            REFBGOTW::REFBGOT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _REFBGOTW<'a> {
    w: &'a mut W,
}
impl<'a> _REFBGOTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: REFBGOTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No trigger"]
    #[inline]
    pub fn refbgot_0(self) -> &'a mut W {
        self.variant(REFBGOTW::REFBGOT_0)
    }
    #[doc = "Generation of the bandgap voltage is started by writing 1 or by a hardware trigger"]
    #[inline]
    pub fn refbgot_1(self) -> &'a mut W {
        self.variant(REFBGOTW::REFBGOT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Reference enable"]
    #[inline]
    pub fn refon(&self) -> REFONR {
        REFONR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Reference output buffer"]
    #[inline]
    pub fn refout(&self) -> REFOUTR {
        REFOUTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - Temperature sensor disabled"]
    #[inline]
    pub fn reftcoff(&self) -> REFTCOFFR {
        REFTCOFFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 4:5 - Reference voltage level select"]
    #[inline]
    pub fn refvsel(&self) -> REFVSELR {
        REFVSELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 6 - Reference generator one-time trigger"]
    #[inline]
    pub fn refgenot(&self) -> REFGENOTR {
        REFGENOTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Bandgap and bandgap buffer one-time trigger"]
    #[inline]
    pub fn refbgot(&self) -> REFBGOTR {
        REFBGOTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 8 - Reference generator active"]
    #[inline]
    pub fn refgenact(&self) -> REFGENACTR {
        REFGENACTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 9 - Reference bandgap active"]
    #[inline]
    pub fn refbgact(&self) -> REFBGACTR {
        REFBGACTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 10 - Reference generator busy"]
    #[inline]
    pub fn refgenbusy(&self) -> REFGENBUSYR {
        REFGENBUSYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 11 - Bandgap mode"]
    #[inline]
    pub fn bgmode(&self) -> BGMODER {
        BGMODER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 12 - Variable reference voltage ready status"]
    #[inline]
    pub fn refgenrdy(&self) -> REFGENRDYR {
        REFGENRDYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 13 - Buffered bandgap voltage ready status"]
    #[inline]
    pub fn refbgrdy(&self) -> REFBGRDYR {
        REFBGRDYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Reference enable"]
    #[inline]
    pub fn refon(&mut self) -> _REFONW {
        _REFONW { w: self }
    }
    #[doc = "Bit 1 - Reference output buffer"]
    #[inline]
    pub fn refout(&mut self) -> _REFOUTW {
        _REFOUTW { w: self }
    }
    #[doc = "Bit 3 - Temperature sensor disabled"]
    #[inline]
    pub fn reftcoff(&mut self) -> _REFTCOFFW {
        _REFTCOFFW { w: self }
    }
    #[doc = "Bits 4:5 - Reference voltage level select"]
    #[inline]
    pub fn refvsel(&mut self) -> _REFVSELW {
        _REFVSELW { w: self }
    }
    #[doc = "Bit 6 - Reference generator one-time trigger"]
    #[inline]
    pub fn refgenot(&mut self) -> _REFGENOTW {
        _REFGENOTW { w: self }
    }
    #[doc = "Bit 7 - Bandgap and bandgap buffer one-time trigger"]
    #[inline]
    pub fn refbgot(&mut self) -> _REFBGOTW {
        _REFBGOTW { w: self }
    }
}
