#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Reset Request Register"]
    pub rstctl_reset_req: RSTCTL_RESET_REQ,
    #[doc = "0x04 - Hard Reset Status Register"]
    pub rstctl_hardreset_stat: RSTCTL_HARDRESET_STAT,
    #[doc = "0x08 - Hard Reset Status Clear Register"]
    pub rstctl_hardreset_clr: RSTCTL_HARDRESET_CLR,
    #[doc = "0x0c - Hard Reset Status Set Register"]
    pub rstctl_hardreset_set: RSTCTL_HARDRESET_SET,
    #[doc = "0x10 - Soft Reset Status Register"]
    pub rstctl_softreset_stat: RSTCTL_SOFTRESET_STAT,
    #[doc = "0x14 - Soft Reset Status Clear Register"]
    pub rstctl_softreset_clr: RSTCTL_SOFTRESET_CLR,
    #[doc = "0x18 - Soft Reset Status Set Register"]
    pub rstctl_softreset_set: RSTCTL_SOFTRESET_SET,
    _reserved0: [u8; 228usize],
    #[doc = "0x100 - PSS Reset Status Register"]
    pub rstctl_pssreset_stat: RSTCTL_PSSRESET_STAT,
    #[doc = "0x104 - PSS Reset Status Clear Register"]
    pub rstctl_pssreset_clr: RSTCTL_PSSRESET_CLR,
    #[doc = "0x108 - PCM Reset Status Register"]
    pub rstctl_pcmreset_stat: RSTCTL_PCMRESET_STAT,
    #[doc = "0x10c - PCM Reset Status Clear Register"]
    pub rstctl_pcmreset_clr: RSTCTL_PCMRESET_CLR,
    #[doc = "0x110 - Pin Reset Status Register"]
    pub rstctl_pinreset_stat: RSTCTL_PINRESET_STAT,
    #[doc = "0x114 - Pin Reset Status Clear Register"]
    pub rstctl_pinreset_clr: RSTCTL_PINRESET_CLR,
    #[doc = "0x118 - Reboot Reset Status Register"]
    pub rstctl_rebootreset_stat: RSTCTL_REBOOTRESET_STAT,
    #[doc = "0x11c - Reboot Reset Status Clear Register"]
    pub rstctl_rebootreset_clr: RSTCTL_REBOOTRESET_CLR,
    #[doc = "0x120 - CS Reset Status Register"]
    pub rstctl_csreset_stat: RSTCTL_CSRESET_STAT,
    #[doc = "0x124 - CS Reset Status Clear Register"]
    pub rstctl_csreset_clr: RSTCTL_CSRESET_CLR,
}
#[doc = "Reset Request Register"]
pub struct RSTCTL_RESET_REQ {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reset Request Register"]
pub mod rstctl_reset_req;
#[doc = "Hard Reset Status Register"]
pub struct RSTCTL_HARDRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Hard Reset Status Register"]
pub mod rstctl_hardreset_stat;
#[doc = "Hard Reset Status Clear Register"]
pub struct RSTCTL_HARDRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Hard Reset Status Clear Register"]
pub mod rstctl_hardreset_clr;
#[doc = "Hard Reset Status Set Register"]
pub struct RSTCTL_HARDRESET_SET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Hard Reset Status Set Register"]
pub mod rstctl_hardreset_set;
#[doc = "Soft Reset Status Register"]
pub struct RSTCTL_SOFTRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Soft Reset Status Register"]
pub mod rstctl_softreset_stat;
#[doc = "Soft Reset Status Clear Register"]
pub struct RSTCTL_SOFTRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Soft Reset Status Clear Register"]
pub mod rstctl_softreset_clr;
#[doc = "Soft Reset Status Set Register"]
pub struct RSTCTL_SOFTRESET_SET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Soft Reset Status Set Register"]
pub mod rstctl_softreset_set;
#[doc = "PSS Reset Status Register"]
pub struct RSTCTL_PSSRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "PSS Reset Status Register"]
pub mod rstctl_pssreset_stat;
#[doc = "PSS Reset Status Clear Register"]
pub struct RSTCTL_PSSRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "PSS Reset Status Clear Register"]
pub mod rstctl_pssreset_clr;
#[doc = "PCM Reset Status Register"]
pub struct RSTCTL_PCMRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "PCM Reset Status Register"]
pub mod rstctl_pcmreset_stat;
#[doc = "PCM Reset Status Clear Register"]
pub struct RSTCTL_PCMRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "PCM Reset Status Clear Register"]
pub mod rstctl_pcmreset_clr;
#[doc = "Pin Reset Status Register"]
pub struct RSTCTL_PINRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Pin Reset Status Register"]
pub mod rstctl_pinreset_stat;
#[doc = "Pin Reset Status Clear Register"]
pub struct RSTCTL_PINRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Pin Reset Status Clear Register"]
pub mod rstctl_pinreset_clr;
#[doc = "Reboot Reset Status Register"]
pub struct RSTCTL_REBOOTRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reboot Reset Status Register"]
pub mod rstctl_rebootreset_stat;
#[doc = "Reboot Reset Status Clear Register"]
pub struct RSTCTL_REBOOTRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reboot Reset Status Clear Register"]
pub mod rstctl_rebootreset_clr;
#[doc = "CS Reset Status Register"]
pub struct RSTCTL_CSRESET_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CS Reset Status Register"]
pub mod rstctl_csreset_stat;
#[doc = "CS Reset Status Clear Register"]
pub struct RSTCTL_CSRESET_CLR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CS Reset Status Clear Register"]
pub mod rstctl_csreset_clr;
