#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RTCCTL0 Register"]
    pub rtcctl0: RTCCTL0,
    #[doc = "0x02 - RTCCTL13 Register"]
    pub rtcctl13: RTCCTL13,
    #[doc = "0x04 - RTCOCAL Register"]
    pub rtcocal: RTCOCAL,
    #[doc = "0x06 - RTCTCMP Register"]
    pub rtctcmp: RTCTCMP,
    #[doc = "0x08 - Real-Time Clock Prescale Timer 0 Control Register"]
    pub rtcps0ctl: RTCPS0CTL,
    #[doc = "0x0a - Real-Time Clock Prescale Timer 1 Control Register"]
    pub rtcps1ctl: RTCPS1CTL,
    #[doc = "0x0c - Real-Time Clock Prescale Timer Counter Register"]
    pub rtcps: RTCPS,
    #[doc = "0x0e - Real-Time Clock Interrupt Vector Register"]
    pub rtciv: RTCIV,
    #[doc = "0x10 - RTCTIM0 Register Hexadecimal Format"]
    pub rtctim0: RTCTIM0,
    #[doc = "0x12 - Real-Time Clock Hour, Day of Week"]
    pub rtctim1: RTCTIM1,
    #[doc = "0x14 - RTCDATE - Hexadecimal Format"]
    pub rtcdate: RTCDATE,
    #[doc = "0x16 - RTCYEAR Register Hexadecimal Format"]
    pub rtcyear: RTCYEAR,
    #[doc = "0x18 - RTCMINHR - Hexadecimal Format"]
    pub rtcaminhr: RTCAMINHR,
    #[doc = "0x1a - RTCADOWDAY - Hexadecimal Format"]
    pub rtcadowday: RTCADOWDAY,
    #[doc = "0x1c - Binary-to-BCD Conversion Register"]
    pub rtcbin2bcd: RTCBIN2BCD,
    #[doc = "0x1e - BCD-to-Binary Conversion Register"]
    pub rtcbcd2bin: RTCBCD2BIN,
}
#[doc = "RTCCTL0 Register"]
pub struct RTCCTL0 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCCTL0 Register"]
pub mod rtcctl0;
#[doc = "RTCCTL13 Register"]
pub struct RTCCTL13 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCCTL13 Register"]
pub mod rtcctl13;
#[doc = "RTCOCAL Register"]
pub struct RTCOCAL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCOCAL Register"]
pub mod rtcocal;
#[doc = "RTCTCMP Register"]
pub struct RTCTCMP {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCTCMP Register"]
pub mod rtctcmp;
#[doc = "Real-Time Clock Prescale Timer 0 Control Register"]
pub struct RTCPS0CTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Real-Time Clock Prescale Timer 0 Control Register"]
pub mod rtcps0ctl;
#[doc = "Real-Time Clock Prescale Timer 1 Control Register"]
pub struct RTCPS1CTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Real-Time Clock Prescale Timer 1 Control Register"]
pub mod rtcps1ctl;
#[doc = "Real-Time Clock Prescale Timer Counter Register"]
pub struct RTCPS {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Real-Time Clock Prescale Timer Counter Register"]
pub mod rtcps;
#[doc = "Real-Time Clock Interrupt Vector Register"]
pub struct RTCIV {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Real-Time Clock Interrupt Vector Register"]
pub mod rtciv;
#[doc = "RTCTIM0 Register Hexadecimal Format"]
pub struct RTCTIM0 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCTIM0 Register Hexadecimal Format"]
pub mod rtctim0;
#[doc = "Real-Time Clock Hour, Day of Week"]
pub struct RTCTIM1 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Real-Time Clock Hour, Day of Week"]
pub mod rtctim1;
#[doc = "RTCDATE - Hexadecimal Format"]
pub struct RTCDATE {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCDATE - Hexadecimal Format"]
pub mod rtcdate;
#[doc = "RTCYEAR Register Hexadecimal Format"]
pub struct RTCYEAR {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCYEAR Register Hexadecimal Format"]
pub mod rtcyear;
#[doc = "RTCMINHR - Hexadecimal Format"]
pub struct RTCAMINHR {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCMINHR - Hexadecimal Format"]
pub mod rtcaminhr;
#[doc = "RTCADOWDAY - Hexadecimal Format"]
pub struct RTCADOWDAY {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "RTCADOWDAY - Hexadecimal Format"]
pub mod rtcadowday;
#[doc = "Binary-to-BCD Conversion Register"]
pub struct RTCBIN2BCD {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Binary-to-BCD Conversion Register"]
pub mod rtcbin2bcd;
#[doc = "BCD-to-Binary Conversion Register"]
pub struct RTCBCD2BIN {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "BCD-to-Binary Conversion Register"]
pub mod rtcbcd2bin;
