#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCCTL0 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `RTCRDYIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCRDYIFGR {
    #[doc = "RTC cannot be read safely"]
    RTCRDYIFG_0,
    #[doc = "RTC can be read safely"]
    RTCRDYIFG_1,
}
impl RTCRDYIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCRDYIFGR::RTCRDYIFG_0 => false,
            RTCRDYIFGR::RTCRDYIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCRDYIFGR {
        match value {
            false => RTCRDYIFGR::RTCRDYIFG_0,
            true => RTCRDYIFGR::RTCRDYIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCRDYIFG_0`"]
    #[inline]
    pub fn is_rtcrdyifg_0(&self) -> bool {
        *self == RTCRDYIFGR::RTCRDYIFG_0
    }
    #[doc = "Checks if the value of the field is `RTCRDYIFG_1`"]
    #[inline]
    pub fn is_rtcrdyifg_1(&self) -> bool {
        *self == RTCRDYIFGR::RTCRDYIFG_1
    }
}
#[doc = "Possible values of the field `RTCAIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCAIFGR {
    #[doc = "No time event occurred"]
    RTCAIFG_0,
    #[doc = "Time event occurred"]
    RTCAIFG_1,
}
impl RTCAIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCAIFGR::RTCAIFG_0 => false,
            RTCAIFGR::RTCAIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCAIFGR {
        match value {
            false => RTCAIFGR::RTCAIFG_0,
            true => RTCAIFGR::RTCAIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCAIFG_0`"]
    #[inline]
    pub fn is_rtcaifg_0(&self) -> bool {
        *self == RTCAIFGR::RTCAIFG_0
    }
    #[doc = "Checks if the value of the field is `RTCAIFG_1`"]
    #[inline]
    pub fn is_rtcaifg_1(&self) -> bool {
        *self == RTCAIFGR::RTCAIFG_1
    }
}
#[doc = "Possible values of the field `RTCTEVIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCTEVIFGR {
    #[doc = "No time event occurred"]
    RTCTEVIFG_0,
    #[doc = "Time event occurred"]
    RTCTEVIFG_1,
}
impl RTCTEVIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCTEVIFGR::RTCTEVIFG_0 => false,
            RTCTEVIFGR::RTCTEVIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCTEVIFGR {
        match value {
            false => RTCTEVIFGR::RTCTEVIFG_0,
            true => RTCTEVIFGR::RTCTEVIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCTEVIFG_0`"]
    #[inline]
    pub fn is_rtctevifg_0(&self) -> bool {
        *self == RTCTEVIFGR::RTCTEVIFG_0
    }
    #[doc = "Checks if the value of the field is `RTCTEVIFG_1`"]
    #[inline]
    pub fn is_rtctevifg_1(&self) -> bool {
        *self == RTCTEVIFGR::RTCTEVIFG_1
    }
}
#[doc = "Possible values of the field `RTCOFIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCOFIFGR {
    #[doc = "No interrupt pending"]
    RTCOFIFG_0,
    #[doc = "Interrupt pending. A 32-kHz crystal oscillator fault occurred after last reset."]
    RTCOFIFG_1,
}
impl RTCOFIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCOFIFGR::RTCOFIFG_0 => false,
            RTCOFIFGR::RTCOFIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCOFIFGR {
        match value {
            false => RTCOFIFGR::RTCOFIFG_0,
            true => RTCOFIFGR::RTCOFIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCOFIFG_0`"]
    #[inline]
    pub fn is_rtcofifg_0(&self) -> bool {
        *self == RTCOFIFGR::RTCOFIFG_0
    }
    #[doc = "Checks if the value of the field is `RTCOFIFG_1`"]
    #[inline]
    pub fn is_rtcofifg_1(&self) -> bool {
        *self == RTCOFIFGR::RTCOFIFG_1
    }
}
#[doc = "Possible values of the field `RTCRDYIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCRDYIER {
    #[doc = "Interrupt not enabled"]
    RTCRDYIE_0,
    #[doc = "Interrupt enabled"]
    RTCRDYIE_1,
}
impl RTCRDYIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCRDYIER::RTCRDYIE_0 => false,
            RTCRDYIER::RTCRDYIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCRDYIER {
        match value {
            false => RTCRDYIER::RTCRDYIE_0,
            true => RTCRDYIER::RTCRDYIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCRDYIE_0`"]
    #[inline]
    pub fn is_rtcrdyie_0(&self) -> bool {
        *self == RTCRDYIER::RTCRDYIE_0
    }
    #[doc = "Checks if the value of the field is `RTCRDYIE_1`"]
    #[inline]
    pub fn is_rtcrdyie_1(&self) -> bool {
        *self == RTCRDYIER::RTCRDYIE_1
    }
}
#[doc = "Possible values of the field `RTCAIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCAIER {
    #[doc = "Interrupt not enabled"]
    RTCAIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCAIE_1,
}
impl RTCAIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCAIER::RTCAIE_0 => false,
            RTCAIER::RTCAIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCAIER {
        match value {
            false => RTCAIER::RTCAIE_0,
            true => RTCAIER::RTCAIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCAIE_0`"]
    #[inline]
    pub fn is_rtcaie_0(&self) -> bool {
        *self == RTCAIER::RTCAIE_0
    }
    #[doc = "Checks if the value of the field is `RTCAIE_1`"]
    #[inline]
    pub fn is_rtcaie_1(&self) -> bool {
        *self == RTCAIER::RTCAIE_1
    }
}
#[doc = "Possible values of the field `RTCTEVIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCTEVIER {
    #[doc = "Interrupt not enabled"]
    RTCTEVIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCTEVIE_1,
}
impl RTCTEVIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCTEVIER::RTCTEVIE_0 => false,
            RTCTEVIER::RTCTEVIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCTEVIER {
        match value {
            false => RTCTEVIER::RTCTEVIE_0,
            true => RTCTEVIER::RTCTEVIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCTEVIE_0`"]
    #[inline]
    pub fn is_rtctevie_0(&self) -> bool {
        *self == RTCTEVIER::RTCTEVIE_0
    }
    #[doc = "Checks if the value of the field is `RTCTEVIE_1`"]
    #[inline]
    pub fn is_rtctevie_1(&self) -> bool {
        *self == RTCTEVIER::RTCTEVIE_1
    }
}
#[doc = "Possible values of the field `RTCOFIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCOFIER {
    #[doc = "Interrupt not enabled"]
    RTCOFIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCOFIE_1,
}
impl RTCOFIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCOFIER::RTCOFIE_0 => false,
            RTCOFIER::RTCOFIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCOFIER {
        match value {
            false => RTCOFIER::RTCOFIE_0,
            true => RTCOFIER::RTCOFIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCOFIE_0`"]
    #[inline]
    pub fn is_rtcofie_0(&self) -> bool {
        *self == RTCOFIER::RTCOFIE_0
    }
    #[doc = "Checks if the value of the field is `RTCOFIE_1`"]
    #[inline]
    pub fn is_rtcofie_1(&self) -> bool {
        *self == RTCOFIER::RTCOFIE_1
    }
}
#[doc = r" Value of the field"]
pub struct RTCKEYR {
    bits: u8,
}
impl RTCKEYR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `RTCRDYIFG`"]
pub enum RTCRDYIFGW {
    #[doc = "RTC cannot be read safely"]
    RTCRDYIFG_0,
    #[doc = "RTC can be read safely"]
    RTCRDYIFG_1,
}
impl RTCRDYIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCRDYIFGW::RTCRDYIFG_0 => false,
            RTCRDYIFGW::RTCRDYIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCRDYIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCRDYIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCRDYIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "RTC cannot be read safely"]
    #[inline]
    pub fn rtcrdyifg_0(self) -> &'a mut W {
        self.variant(RTCRDYIFGW::RTCRDYIFG_0)
    }
    #[doc = "RTC can be read safely"]
    #[inline]
    pub fn rtcrdyifg_1(self) -> &'a mut W {
        self.variant(RTCRDYIFGW::RTCRDYIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCAIFG`"]
pub enum RTCAIFGW {
    #[doc = "No time event occurred"]
    RTCAIFG_0,
    #[doc = "Time event occurred"]
    RTCAIFG_1,
}
impl RTCAIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCAIFGW::RTCAIFG_0 => false,
            RTCAIFGW::RTCAIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCAIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCAIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCAIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No time event occurred"]
    #[inline]
    pub fn rtcaifg_0(self) -> &'a mut W {
        self.variant(RTCAIFGW::RTCAIFG_0)
    }
    #[doc = "Time event occurred"]
    #[inline]
    pub fn rtcaifg_1(self) -> &'a mut W {
        self.variant(RTCAIFGW::RTCAIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCTEVIFG`"]
pub enum RTCTEVIFGW {
    #[doc = "No time event occurred"]
    RTCTEVIFG_0,
    #[doc = "Time event occurred"]
    RTCTEVIFG_1,
}
impl RTCTEVIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCTEVIFGW::RTCTEVIFG_0 => false,
            RTCTEVIFGW::RTCTEVIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCTEVIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCTEVIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCTEVIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No time event occurred"]
    #[inline]
    pub fn rtctevifg_0(self) -> &'a mut W {
        self.variant(RTCTEVIFGW::RTCTEVIFG_0)
    }
    #[doc = "Time event occurred"]
    #[inline]
    pub fn rtctevifg_1(self) -> &'a mut W {
        self.variant(RTCTEVIFGW::RTCTEVIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCOFIFG`"]
pub enum RTCOFIFGW {
    #[doc = "No interrupt pending"]
    RTCOFIFG_0,
    #[doc = "Interrupt pending. A 32-kHz crystal oscillator fault occurred after last reset."]
    RTCOFIFG_1,
}
impl RTCOFIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCOFIFGW::RTCOFIFG_0 => false,
            RTCOFIFGW::RTCOFIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCOFIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCOFIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCOFIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No interrupt pending"]
    #[inline]
    pub fn rtcofifg_0(self) -> &'a mut W {
        self.variant(RTCOFIFGW::RTCOFIFG_0)
    }
    #[doc = "Interrupt pending. A 32-kHz crystal oscillator fault occurred after last reset."]
    #[inline]
    pub fn rtcofifg_1(self) -> &'a mut W {
        self.variant(RTCOFIFGW::RTCOFIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCRDYIE`"]
pub enum RTCRDYIEW {
    #[doc = "Interrupt not enabled"]
    RTCRDYIE_0,
    #[doc = "Interrupt enabled"]
    RTCRDYIE_1,
}
impl RTCRDYIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCRDYIEW::RTCRDYIE_0 => false,
            RTCRDYIEW::RTCRDYIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rtcrdyie_0(self) -> &'a mut W {
        self.variant(RTCRDYIEW::RTCRDYIE_0)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn rtcrdyie_1(self) -> &'a mut W {
        self.variant(RTCRDYIEW::RTCRDYIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCAIE`"]
pub enum RTCAIEW {
    #[doc = "Interrupt not enabled"]
    RTCAIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCAIE_1,
}
impl RTCAIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCAIEW::RTCAIE_0 => false,
            RTCAIEW::RTCAIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCAIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCAIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCAIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rtcaie_0(self) -> &'a mut W {
        self.variant(RTCAIEW::RTCAIE_0)
    }
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    #[inline]
    pub fn rtcaie_1(self) -> &'a mut W {
        self.variant(RTCAIEW::RTCAIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCTEVIE`"]
pub enum RTCTEVIEW {
    #[doc = "Interrupt not enabled"]
    RTCTEVIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCTEVIE_1,
}
impl RTCTEVIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCTEVIEW::RTCTEVIE_0 => false,
            RTCTEVIEW::RTCTEVIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCTEVIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCTEVIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCTEVIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rtctevie_0(self) -> &'a mut W {
        self.variant(RTCTEVIEW::RTCTEVIE_0)
    }
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    #[inline]
    pub fn rtctevie_1(self) -> &'a mut W {
        self.variant(RTCTEVIEW::RTCTEVIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCOFIE`"]
pub enum RTCOFIEW {
    #[doc = "Interrupt not enabled"]
    RTCOFIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RTCOFIE_1,
}
impl RTCOFIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCOFIEW::RTCOFIE_0 => false,
            RTCOFIEW::RTCOFIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCOFIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCOFIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCOFIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rtcofie_0(self) -> &'a mut W {
        self.variant(RTCOFIEW::RTCOFIE_0)
    }
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    #[inline]
    pub fn rtcofie_1(self) -> &'a mut W {
        self.variant(RTCOFIEW::RTCOFIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _RTCKEYW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCKEYW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 255;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Real-time clock ready interrupt flag"]
    #[inline]
    pub fn rtcrdyifg(&self) -> RTCRDYIFGR {
        RTCRDYIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Real-time clock alarm interrupt flag"]
    #[inline]
    pub fn rtcaifg(&self) -> RTCAIFGR {
        RTCAIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 2 - Real-time clock time event interrupt flag"]
    #[inline]
    pub fn rtctevifg(&self) -> RTCTEVIFGR {
        RTCTEVIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 3 - 32-kHz crystal oscillator fault interrupt flag"]
    #[inline]
    pub fn rtcofifg(&self) -> RTCOFIFGR {
        RTCOFIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 4 - Real-time clock ready interrupt enable"]
    #[inline]
    pub fn rtcrdyie(&self) -> RTCRDYIER {
        RTCRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5 - Real-time clock alarm interrupt enable"]
    #[inline]
    pub fn rtcaie(&self) -> RTCAIER {
        RTCAIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Real-time clock time event interrupt enable"]
    #[inline]
    pub fn rtctevie(&self) -> RTCTEVIER {
        RTCTEVIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - 32-kHz crystal oscillator fault interrupt enable"]
    #[inline]
    pub fn rtcofie(&self) -> RTCOFIER {
        RTCOFIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 8:15 - Real-time clock key"]
    #[inline]
    pub fn rtckey(&self) -> RTCKEYR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        RTCKEYR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 38408 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Real-time clock ready interrupt flag"]
    #[inline]
    pub fn rtcrdyifg(&mut self) -> _RTCRDYIFGW {
        _RTCRDYIFGW { w: self }
    }
    #[doc = "Bit 1 - Real-time clock alarm interrupt flag"]
    #[inline]
    pub fn rtcaifg(&mut self) -> _RTCAIFGW {
        _RTCAIFGW { w: self }
    }
    #[doc = "Bit 2 - Real-time clock time event interrupt flag"]
    #[inline]
    pub fn rtctevifg(&mut self) -> _RTCTEVIFGW {
        _RTCTEVIFGW { w: self }
    }
    #[doc = "Bit 3 - 32-kHz crystal oscillator fault interrupt flag"]
    #[inline]
    pub fn rtcofifg(&mut self) -> _RTCOFIFGW {
        _RTCOFIFGW { w: self }
    }
    #[doc = "Bit 4 - Real-time clock ready interrupt enable"]
    #[inline]
    pub fn rtcrdyie(&mut self) -> _RTCRDYIEW {
        _RTCRDYIEW { w: self }
    }
    #[doc = "Bit 5 - Real-time clock alarm interrupt enable"]
    #[inline]
    pub fn rtcaie(&mut self) -> _RTCAIEW {
        _RTCAIEW { w: self }
    }
    #[doc = "Bit 6 - Real-time clock time event interrupt enable"]
    #[inline]
    pub fn rtctevie(&mut self) -> _RTCTEVIEW {
        _RTCTEVIEW { w: self }
    }
    #[doc = "Bit 7 - 32-kHz crystal oscillator fault interrupt enable"]
    #[inline]
    pub fn rtcofie(&mut self) -> _RTCOFIEW {
        _RTCOFIEW { w: self }
    }
    #[doc = "Bits 8:15 - Real-time clock key"]
    #[inline]
    pub fn rtckey(&mut self) -> _RTCKEYW {
        _RTCKEYW { w: self }
    }
}
