#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCCTL13 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `RTCTEV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCTEVR {
    #[doc = "Minute changed"]
    RTCTEV_0,
    #[doc = "Hour changed"]
    RTCTEV_1,
    #[doc = "Every day at midnight (00:00)"]
    RTCTEV_2,
    #[doc = "Every day at noon (12:00)"]
    RTCTEV_3,
}
impl RTCTEVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RTCTEVR::RTCTEV_0 => 0,
            RTCTEVR::RTCTEV_1 => 1,
            RTCTEVR::RTCTEV_2 => 2,
            RTCTEVR::RTCTEV_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RTCTEVR {
        match value {
            0 => RTCTEVR::RTCTEV_0,
            1 => RTCTEVR::RTCTEV_1,
            2 => RTCTEVR::RTCTEV_2,
            3 => RTCTEVR::RTCTEV_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RTCTEV_0`"]
    #[inline]
    pub fn is_rtctev_0(&self) -> bool {
        *self == RTCTEVR::RTCTEV_0
    }
    #[doc = "Checks if the value of the field is `RTCTEV_1`"]
    #[inline]
    pub fn is_rtctev_1(&self) -> bool {
        *self == RTCTEVR::RTCTEV_1
    }
    #[doc = "Checks if the value of the field is `RTCTEV_2`"]
    #[inline]
    pub fn is_rtctev_2(&self) -> bool {
        *self == RTCTEVR::RTCTEV_2
    }
    #[doc = "Checks if the value of the field is `RTCTEV_3`"]
    #[inline]
    pub fn is_rtctev_3(&self) -> bool {
        *self == RTCTEVR::RTCTEV_3
    }
}
#[doc = "Possible values of the field `RTCSSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCSSELR {
    #[doc = "BCLK"]
    RTCSSEL_0,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl RTCSSELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RTCSSELR::RTCSSEL_0 => 0,
            RTCSSELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RTCSSELR {
        match value {
            0 => RTCSSELR::RTCSSEL_0,
            i => RTCSSELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RTCSSEL_0`"]
    #[inline]
    pub fn is_rtcssel_0(&self) -> bool {
        *self == RTCSSELR::RTCSSEL_0
    }
}
#[doc = "Possible values of the field `RTCRDY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCRDYR {
    #[doc = "RTC time values in transition"]
    RTCRDY_0,
    #[doc = "RTC time values safe for reading. This bit indicates when the real-time clock time values are safe for reading."]
    RTCRDY_1,
}
impl RTCRDYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCRDYR::RTCRDY_0 => false,
            RTCRDYR::RTCRDY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCRDYR {
        match value {
            false => RTCRDYR::RTCRDY_0,
            true => RTCRDYR::RTCRDY_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCRDY_0`"]
    #[inline]
    pub fn is_rtcrdy_0(&self) -> bool {
        *self == RTCRDYR::RTCRDY_0
    }
    #[doc = "Checks if the value of the field is `RTCRDY_1`"]
    #[inline]
    pub fn is_rtcrdy_1(&self) -> bool {
        *self == RTCRDYR::RTCRDY_1
    }
}
#[doc = "Possible values of the field `RTCMODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCMODER {
    #[doc = "Calendar mode. Always reads a value of 1."]
    RTCMODE_1,
    #[doc = r" Reserved"]
    _Reserved(bool),
}
impl RTCMODER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCMODER::RTCMODE_1 => true,
            RTCMODER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCMODER {
        match value {
            true => RTCMODER::RTCMODE_1,
            i => RTCMODER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RTCMODE_1`"]
    #[inline]
    pub fn is_rtcmode_1(&self) -> bool {
        *self == RTCMODER::RTCMODE_1
    }
}
#[doc = "Possible values of the field `RTCHOLD`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCHOLDR {
    #[doc = "Real-time clock is operational"]
    RTCHOLD_0,
    #[doc = "When set, the calendar is stopped as well as the prescale counters, RT0PS and RT1PS are don't care"]
    RTCHOLD_1,
}
impl RTCHOLDR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCHOLDR::RTCHOLD_0 => false,
            RTCHOLDR::RTCHOLD_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCHOLDR {
        match value {
            false => RTCHOLDR::RTCHOLD_0,
            true => RTCHOLDR::RTCHOLD_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCHOLD_0`"]
    #[inline]
    pub fn is_rtchold_0(&self) -> bool {
        *self == RTCHOLDR::RTCHOLD_0
    }
    #[doc = "Checks if the value of the field is `RTCHOLD_1`"]
    #[inline]
    pub fn is_rtchold_1(&self) -> bool {
        *self == RTCHOLDR::RTCHOLD_1
    }
}
#[doc = "Possible values of the field `RTCBCD`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCBCDR {
    #[doc = "Binary (hexadecimal) code selected"]
    RTCBCD_0,
    #[doc = "Binary coded decimal (BCD) code selected"]
    RTCBCD_1,
}
impl RTCBCDR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCBCDR::RTCBCD_0 => false,
            RTCBCDR::RTCBCD_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCBCDR {
        match value {
            false => RTCBCDR::RTCBCD_0,
            true => RTCBCDR::RTCBCD_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCBCD_0`"]
    #[inline]
    pub fn is_rtcbcd_0(&self) -> bool {
        *self == RTCBCDR::RTCBCD_0
    }
    #[doc = "Checks if the value of the field is `RTCBCD_1`"]
    #[inline]
    pub fn is_rtcbcd_1(&self) -> bool {
        *self == RTCBCDR::RTCBCD_1
    }
}
#[doc = "Possible values of the field `RTCCALF`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCCALFR {
    #[doc = "No frequency output to RTCCLK pin"]
    RTCCALF_0,
    #[doc = "512 Hz"]
    RTCCALF_1,
    #[doc = "256 Hz"]
    RTCCALF_2,
    #[doc = "1 Hz"]
    RTCCALF_3,
}
impl RTCCALFR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RTCCALFR::RTCCALF_0 => 0,
            RTCCALFR::RTCCALF_1 => 1,
            RTCCALFR::RTCCALF_2 => 2,
            RTCCALFR::RTCCALF_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RTCCALFR {
        match value {
            0 => RTCCALFR::RTCCALF_0,
            1 => RTCCALFR::RTCCALF_1,
            2 => RTCCALFR::RTCCALF_2,
            3 => RTCCALFR::RTCCALF_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RTCCALF_0`"]
    #[inline]
    pub fn is_rtccalf_0(&self) -> bool {
        *self == RTCCALFR::RTCCALF_0
    }
    #[doc = "Checks if the value of the field is `RTCCALF_1`"]
    #[inline]
    pub fn is_rtccalf_1(&self) -> bool {
        *self == RTCCALFR::RTCCALF_1
    }
    #[doc = "Checks if the value of the field is `RTCCALF_2`"]
    #[inline]
    pub fn is_rtccalf_2(&self) -> bool {
        *self == RTCCALFR::RTCCALF_2
    }
    #[doc = "Checks if the value of the field is `RTCCALF_3`"]
    #[inline]
    pub fn is_rtccalf_3(&self) -> bool {
        *self == RTCCALFR::RTCCALF_3
    }
}
#[doc = "Values that can be written to the field `RTCTEV`"]
pub enum RTCTEVW {
    #[doc = "Minute changed"]
    RTCTEV_0,
    #[doc = "Hour changed"]
    RTCTEV_1,
    #[doc = "Every day at midnight (00:00)"]
    RTCTEV_2,
    #[doc = "Every day at noon (12:00)"]
    RTCTEV_3,
}
impl RTCTEVW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RTCTEVW::RTCTEV_0 => 0,
            RTCTEVW::RTCTEV_1 => 1,
            RTCTEVW::RTCTEV_2 => 2,
            RTCTEVW::RTCTEV_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCTEVW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCTEVW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCTEVW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "Minute changed"]
    #[inline]
    pub fn rtctev_0(self) -> &'a mut W {
        self.variant(RTCTEVW::RTCTEV_0)
    }
    #[doc = "Hour changed"]
    #[inline]
    pub fn rtctev_1(self) -> &'a mut W {
        self.variant(RTCTEVW::RTCTEV_1)
    }
    #[doc = "Every day at midnight (00:00)"]
    #[inline]
    pub fn rtctev_2(self) -> &'a mut W {
        self.variant(RTCTEVW::RTCTEV_2)
    }
    #[doc = "Every day at noon (12:00)"]
    #[inline]
    pub fn rtctev_3(self) -> &'a mut W {
        self.variant(RTCTEVW::RTCTEV_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCSSEL`"]
pub enum RTCSSELW {
    #[doc = "BCLK"]
    RTCSSEL_0,
}
impl RTCSSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RTCSSELW::RTCSSEL_0 => 0,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCSSELW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCSSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCSSELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "BCLK"]
    #[inline]
    pub fn rtcssel_0(self) -> &'a mut W {
        self.variant(RTCSSELW::RTCSSEL_0)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCHOLD`"]
pub enum RTCHOLDW {
    #[doc = "Real-time clock is operational"]
    RTCHOLD_0,
    #[doc = "When set, the calendar is stopped as well as the prescale counters, RT0PS and RT1PS are don't care"]
    RTCHOLD_1,
}
impl RTCHOLDW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCHOLDW::RTCHOLD_0 => false,
            RTCHOLDW::RTCHOLD_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCHOLDW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCHOLDW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCHOLDW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Real-time clock is operational"]
    #[inline]
    pub fn rtchold_0(self) -> &'a mut W {
        self.variant(RTCHOLDW::RTCHOLD_0)
    }
    #[doc = "When set, the calendar is stopped as well as the prescale counters, RT0PS and RT1PS are don't care"]
    #[inline]
    pub fn rtchold_1(self) -> &'a mut W {
        self.variant(RTCHOLDW::RTCHOLD_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCBCD`"]
pub enum RTCBCDW {
    #[doc = "Binary (hexadecimal) code selected"]
    RTCBCD_0,
    #[doc = "Binary coded decimal (BCD) code selected"]
    RTCBCD_1,
}
impl RTCBCDW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCBCDW::RTCBCD_0 => false,
            RTCBCDW::RTCBCD_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCBCDW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCBCDW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCBCDW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Binary (hexadecimal) code selected"]
    #[inline]
    pub fn rtcbcd_0(self) -> &'a mut W {
        self.variant(RTCBCDW::RTCBCD_0)
    }
    #[doc = "Binary coded decimal (BCD) code selected"]
    #[inline]
    pub fn rtcbcd_1(self) -> &'a mut W {
        self.variant(RTCBCDW::RTCBCD_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCCALF`"]
pub enum RTCCALFW {
    #[doc = "No frequency output to RTCCLK pin"]
    RTCCALF_0,
    #[doc = "512 Hz"]
    RTCCALF_1,
    #[doc = "256 Hz"]
    RTCCALF_2,
    #[doc = "1 Hz"]
    RTCCALF_3,
}
impl RTCCALFW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RTCCALFW::RTCCALF_0 => 0,
            RTCCALFW::RTCCALF_1 => 1,
            RTCCALFW::RTCCALF_2 => 2,
            RTCCALFW::RTCCALF_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCCALFW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCCALFW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCCALFW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "No frequency output to RTCCLK pin"]
    #[inline]
    pub fn rtccalf_0(self) -> &'a mut W {
        self.variant(RTCCALFW::RTCCALF_0)
    }
    #[doc = "512 Hz"]
    #[inline]
    pub fn rtccalf_1(self) -> &'a mut W {
        self.variant(RTCCALFW::RTCCALF_1)
    }
    #[doc = "256 Hz"]
    #[inline]
    pub fn rtccalf_2(self) -> &'a mut W {
        self.variant(RTCCALFW::RTCCALF_2)
    }
    #[doc = "1 Hz"]
    #[inline]
    pub fn rtccalf_3(self) -> &'a mut W {
        self.variant(RTCCALFW::RTCCALF_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:1 - Real-time clock time event"]
    #[inline]
    pub fn rtctev(&self) -> RTCTEVR {
        RTCTEVR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bits 2:3 - Real-time clock source select"]
    #[inline]
    pub fn rtcssel(&self) -> RTCSSELR {
        RTCSSELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 4 - Real-time clock ready"]
    #[inline]
    pub fn rtcrdy(&self) -> RTCRDYR {
        RTCRDYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 5"]
    #[inline]
    pub fn rtcmode(&self) -> RTCMODER {
        RTCMODER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 6 - Real-time clock hold"]
    #[inline]
    pub fn rtchold(&self) -> RTCHOLDR {
        RTCHOLDR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 7 - Real-time clock BCD select"]
    #[inline]
    pub fn rtcbcd(&self) -> RTCBCDR {
        RTCBCDR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 8:9 - Real-time clock calibration frequency"]
    #[inline]
    pub fn rtccalf(&self) -> RTCCALFR {
        RTCCALFR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 112 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:1 - Real-time clock time event"]
    #[inline]
    pub fn rtctev(&mut self) -> _RTCTEVW {
        _RTCTEVW { w: self }
    }
    #[doc = "Bits 2:3 - Real-time clock source select"]
    #[inline]
    pub fn rtcssel(&mut self) -> _RTCSSELW {
        _RTCSSELW { w: self }
    }
    #[doc = "Bit 6 - Real-time clock hold"]
    #[inline]
    pub fn rtchold(&mut self) -> _RTCHOLDW {
        _RTCHOLDW { w: self }
    }
    #[doc = "Bit 7 - Real-time clock BCD select"]
    #[inline]
    pub fn rtcbcd(&mut self) -> _RTCBCDW {
        _RTCBCDW { w: self }
    }
    #[doc = "Bits 8:9 - Real-time clock calibration frequency"]
    #[inline]
    pub fn rtccalf(&mut self) -> _RTCCALFW {
        _RTCCALFW { w: self }
    }
}
