#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::RTCIV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `RTCIV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCIVR {
    #[doc = "No interrupt pending"]
    RTCIV_0,
    #[doc = "Interrupt Source: RTC oscillator failure; Interrupt Flag: RTCOFIFG; Interrupt Priority: Highest"]
    RTCIV_2,
    #[doc = "Interrupt Source: RTC ready; Interrupt Flag: RTCRDYIFG"]
    RTCIV_4,
    #[doc = "Interrupt Source: RTC interval timer; Interrupt Flag: RTCTEVIFG"]
    RTCIV_6,
    #[doc = "Interrupt Source: RTC user alarm; Interrupt Flag: RTCAIFG"]
    RTCIV_8,
    #[doc = "Interrupt Source: RTC prescaler 0; Interrupt Flag: RT0PSIFG"]
    RTCIV_10,
    #[doc = "Interrupt Source: RTC prescaler 1; Interrupt Flag: RT1PSIFG"]
    RTCIV_12,
    #[doc = r" Reserved"]
    _Reserved(u16),
}
impl RTCIVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        match *self {
            RTCIVR::RTCIV_0 => 0,
            RTCIVR::RTCIV_2 => 2,
            RTCIVR::RTCIV_4 => 4,
            RTCIVR::RTCIV_6 => 6,
            RTCIVR::RTCIV_8 => 8,
            RTCIVR::RTCIV_10 => 10,
            RTCIVR::RTCIV_12 => 12,
            RTCIVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u16) -> RTCIVR {
        match value {
            0 => RTCIVR::RTCIV_0,
            2 => RTCIVR::RTCIV_2,
            4 => RTCIVR::RTCIV_4,
            6 => RTCIVR::RTCIV_6,
            8 => RTCIVR::RTCIV_8,
            10 => RTCIVR::RTCIV_10,
            12 => RTCIVR::RTCIV_12,
            i => RTCIVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RTCIV_0`"]
    #[inline]
    pub fn is_rtciv_0(&self) -> bool {
        *self == RTCIVR::RTCIV_0
    }
    #[doc = "Checks if the value of the field is `RTCIV_2`"]
    #[inline]
    pub fn is_rtciv_2(&self) -> bool {
        *self == RTCIVR::RTCIV_2
    }
    #[doc = "Checks if the value of the field is `RTCIV_4`"]
    #[inline]
    pub fn is_rtciv_4(&self) -> bool {
        *self == RTCIVR::RTCIV_4
    }
    #[doc = "Checks if the value of the field is `RTCIV_6`"]
    #[inline]
    pub fn is_rtciv_6(&self) -> bool {
        *self == RTCIVR::RTCIV_6
    }
    #[doc = "Checks if the value of the field is `RTCIV_8`"]
    #[inline]
    pub fn is_rtciv_8(&self) -> bool {
        *self == RTCIVR::RTCIV_8
    }
    #[doc = "Checks if the value of the field is `RTCIV_10`"]
    #[inline]
    pub fn is_rtciv_10(&self) -> bool {
        *self == RTCIVR::RTCIV_10
    }
    #[doc = "Checks if the value of the field is `RTCIV_12`"]
    #[inline]
    pub fn is_rtciv_12(&self) -> bool {
        *self == RTCIVR::RTCIV_12
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:15 - Real-time clock interrupt vector value"]
    #[inline]
    pub fn rtciv(&self) -> RTCIVR {
        RTCIVR::_from({
            const MASK: u16 = 65535;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        })
    }
}
