#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCOCAL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct RTCOCALR {
    bits: u8,
}
impl RTCOCALR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Possible values of the field `RTCOCALS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCOCALSR {
    #[doc = "Down calibration. Frequency adjusted down."]
    RTCOCALS_0,
    #[doc = "Up calibration. Frequency adjusted up."]
    RTCOCALS_1,
}
impl RTCOCALSR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCOCALSR::RTCOCALS_0 => false,
            RTCOCALSR::RTCOCALS_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCOCALSR {
        match value {
            false => RTCOCALSR::RTCOCALS_0,
            true => RTCOCALSR::RTCOCALS_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCOCALS_0`"]
    #[inline]
    pub fn is_rtcocals_0(&self) -> bool {
        *self == RTCOCALSR::RTCOCALS_0
    }
    #[doc = "Checks if the value of the field is `RTCOCALS_1`"]
    #[inline]
    pub fn is_rtcocals_1(&self) -> bool {
        *self == RTCOCALSR::RTCOCALS_1
    }
}
#[doc = r" Proxy"]
pub struct _RTCOCALW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCOCALW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 255;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCOCALS`"]
pub enum RTCOCALSW {
    #[doc = "Down calibration. Frequency adjusted down."]
    RTCOCALS_0,
    #[doc = "Up calibration. Frequency adjusted up."]
    RTCOCALS_1,
}
impl RTCOCALSW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCOCALSW::RTCOCALS_0 => false,
            RTCOCALSW::RTCOCALS_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCOCALSW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCOCALSW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCOCALSW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Down calibration. Frequency adjusted down."]
    #[inline]
    pub fn rtcocals_0(self) -> &'a mut W {
        self.variant(RTCOCALSW::RTCOCALS_0)
    }
    #[doc = "Up calibration. Frequency adjusted up."]
    #[inline]
    pub fn rtcocals_1(self) -> &'a mut W {
        self.variant(RTCOCALSW::RTCOCALS_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:7 - Real-time clock offset error calibration"]
    #[inline]
    pub fn rtcocal(&self) -> RTCOCALR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        RTCOCALR { bits }
    }
    #[doc = "Bit 15 - Real-time clock offset error calibration sign"]
    #[inline]
    pub fn rtcocals(&self) -> RTCOCALSR {
        RTCOCALSR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:7 - Real-time clock offset error calibration"]
    #[inline]
    pub fn rtcocal(&mut self) -> _RTCOCALW {
        _RTCOCALW { w: self }
    }
    #[doc = "Bit 15 - Real-time clock offset error calibration sign"]
    #[inline]
    pub fn rtcocals(&mut self) -> _RTCOCALSW {
        _RTCOCALSW { w: self }
    }
}
