#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCPS0CTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `RT0PSIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT0PSIFGR {
    #[doc = "No time event occurred"]
    RT0PSIFG_0,
    #[doc = "Time event occurred"]
    RT0PSIFG_1,
}
impl RT0PSIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RT0PSIFGR::RT0PSIFG_0 => false,
            RT0PSIFGR::RT0PSIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RT0PSIFGR {
        match value {
            false => RT0PSIFGR::RT0PSIFG_0,
            true => RT0PSIFGR::RT0PSIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RT0PSIFG_0`"]
    #[inline]
    pub fn is_rt0psifg_0(&self) -> bool {
        *self == RT0PSIFGR::RT0PSIFG_0
    }
    #[doc = "Checks if the value of the field is `RT0PSIFG_1`"]
    #[inline]
    pub fn is_rt0psifg_1(&self) -> bool {
        *self == RT0PSIFGR::RT0PSIFG_1
    }
}
#[doc = "Possible values of the field `RT0PSIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT0PSIER {
    #[doc = "Interrupt not enabled"]
    RT0PSIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RT0PSIE_1,
}
impl RT0PSIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RT0PSIER::RT0PSIE_0 => false,
            RT0PSIER::RT0PSIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RT0PSIER {
        match value {
            false => RT0PSIER::RT0PSIE_0,
            true => RT0PSIER::RT0PSIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RT0PSIE_0`"]
    #[inline]
    pub fn is_rt0psie_0(&self) -> bool {
        *self == RT0PSIER::RT0PSIE_0
    }
    #[doc = "Checks if the value of the field is `RT0PSIE_1`"]
    #[inline]
    pub fn is_rt0psie_1(&self) -> bool {
        *self == RT0PSIER::RT0PSIE_1
    }
}
#[doc = "Possible values of the field `RT0IP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT0IPR {
    #[doc = "Divide by 2"]
    RT0IP_0,
    #[doc = "Divide by 4"]
    RT0IP_1,
    #[doc = "Divide by 8"]
    RT0IP_2,
    #[doc = "Divide by 16"]
    RT0IP_3,
    #[doc = "Divide by 32"]
    RT0IP_4,
    #[doc = "Divide by 64"]
    RT0IP_5,
    #[doc = "Divide by 128"]
    RT0IP_6,
    #[doc = "Divide by 256"]
    RT0IP_7,
}
impl RT0IPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RT0IPR::RT0IP_0 => 0,
            RT0IPR::RT0IP_1 => 1,
            RT0IPR::RT0IP_2 => 2,
            RT0IPR::RT0IP_3 => 3,
            RT0IPR::RT0IP_4 => 4,
            RT0IPR::RT0IP_5 => 5,
            RT0IPR::RT0IP_6 => 6,
            RT0IPR::RT0IP_7 => 7,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RT0IPR {
        match value {
            0 => RT0IPR::RT0IP_0,
            1 => RT0IPR::RT0IP_1,
            2 => RT0IPR::RT0IP_2,
            3 => RT0IPR::RT0IP_3,
            4 => RT0IPR::RT0IP_4,
            5 => RT0IPR::RT0IP_5,
            6 => RT0IPR::RT0IP_6,
            7 => RT0IPR::RT0IP_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RT0IP_0`"]
    #[inline]
    pub fn is_rt0ip_0(&self) -> bool {
        *self == RT0IPR::RT0IP_0
    }
    #[doc = "Checks if the value of the field is `RT0IP_1`"]
    #[inline]
    pub fn is_rt0ip_1(&self) -> bool {
        *self == RT0IPR::RT0IP_1
    }
    #[doc = "Checks if the value of the field is `RT0IP_2`"]
    #[inline]
    pub fn is_rt0ip_2(&self) -> bool {
        *self == RT0IPR::RT0IP_2
    }
    #[doc = "Checks if the value of the field is `RT0IP_3`"]
    #[inline]
    pub fn is_rt0ip_3(&self) -> bool {
        *self == RT0IPR::RT0IP_3
    }
    #[doc = "Checks if the value of the field is `RT0IP_4`"]
    #[inline]
    pub fn is_rt0ip_4(&self) -> bool {
        *self == RT0IPR::RT0IP_4
    }
    #[doc = "Checks if the value of the field is `RT0IP_5`"]
    #[inline]
    pub fn is_rt0ip_5(&self) -> bool {
        *self == RT0IPR::RT0IP_5
    }
    #[doc = "Checks if the value of the field is `RT0IP_6`"]
    #[inline]
    pub fn is_rt0ip_6(&self) -> bool {
        *self == RT0IPR::RT0IP_6
    }
    #[doc = "Checks if the value of the field is `RT0IP_7`"]
    #[inline]
    pub fn is_rt0ip_7(&self) -> bool {
        *self == RT0IPR::RT0IP_7
    }
}
#[doc = "Values that can be written to the field `RT0PSIFG`"]
pub enum RT0PSIFGW {
    #[doc = "No time event occurred"]
    RT0PSIFG_0,
    #[doc = "Time event occurred"]
    RT0PSIFG_1,
}
impl RT0PSIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RT0PSIFGW::RT0PSIFG_0 => false,
            RT0PSIFGW::RT0PSIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT0PSIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RT0PSIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT0PSIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No time event occurred"]
    #[inline]
    pub fn rt0psifg_0(self) -> &'a mut W {
        self.variant(RT0PSIFGW::RT0PSIFG_0)
    }
    #[doc = "Time event occurred"]
    #[inline]
    pub fn rt0psifg_1(self) -> &'a mut W {
        self.variant(RT0PSIFGW::RT0PSIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RT0PSIE`"]
pub enum RT0PSIEW {
    #[doc = "Interrupt not enabled"]
    RT0PSIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RT0PSIE_1,
}
impl RT0PSIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RT0PSIEW::RT0PSIE_0 => false,
            RT0PSIEW::RT0PSIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT0PSIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RT0PSIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT0PSIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rt0psie_0(self) -> &'a mut W {
        self.variant(RT0PSIEW::RT0PSIE_0)
    }
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    #[inline]
    pub fn rt0psie_1(self) -> &'a mut W {
        self.variant(RT0PSIEW::RT0PSIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RT0IP`"]
pub enum RT0IPW {
    #[doc = "Divide by 2"]
    RT0IP_0,
    #[doc = "Divide by 4"]
    RT0IP_1,
    #[doc = "Divide by 8"]
    RT0IP_2,
    #[doc = "Divide by 16"]
    RT0IP_3,
    #[doc = "Divide by 32"]
    RT0IP_4,
    #[doc = "Divide by 64"]
    RT0IP_5,
    #[doc = "Divide by 128"]
    RT0IP_6,
    #[doc = "Divide by 256"]
    RT0IP_7,
}
impl RT0IPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RT0IPW::RT0IP_0 => 0,
            RT0IPW::RT0IP_1 => 1,
            RT0IPW::RT0IP_2 => 2,
            RT0IPW::RT0IP_3 => 3,
            RT0IPW::RT0IP_4 => 4,
            RT0IPW::RT0IP_5 => 5,
            RT0IPW::RT0IP_6 => 6,
            RT0IPW::RT0IP_7 => 7,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT0IPW<'a> {
    w: &'a mut W,
}
impl<'a> _RT0IPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT0IPW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "Divide by 2"]
    #[inline]
    pub fn rt0ip_0(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_0)
    }
    #[doc = "Divide by 4"]
    #[inline]
    pub fn rt0ip_1(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_1)
    }
    #[doc = "Divide by 8"]
    #[inline]
    pub fn rt0ip_2(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_2)
    }
    #[doc = "Divide by 16"]
    #[inline]
    pub fn rt0ip_3(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_3)
    }
    #[doc = "Divide by 32"]
    #[inline]
    pub fn rt0ip_4(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_4)
    }
    #[doc = "Divide by 64"]
    #[inline]
    pub fn rt0ip_5(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_5)
    }
    #[doc = "Divide by 128"]
    #[inline]
    pub fn rt0ip_6(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_6)
    }
    #[doc = "Divide by 256"]
    #[inline]
    pub fn rt0ip_7(self) -> &'a mut W {
        self.variant(RT0IPW::RT0IP_7)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Prescale timer 0 interrupt flag"]
    #[inline]
    pub fn rt0psifg(&self) -> RT0PSIFGR {
        RT0PSIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Prescale timer 0 interrupt enable"]
    #[inline]
    pub fn rt0psie(&self) -> RT0PSIER {
        RT0PSIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 2:4 - Prescale timer 0 interrupt interval"]
    #[inline]
    pub fn rt0ip(&self) -> RT0IPR {
        RT0IPR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Prescale timer 0 interrupt flag"]
    #[inline]
    pub fn rt0psifg(&mut self) -> _RT0PSIFGW {
        _RT0PSIFGW { w: self }
    }
    #[doc = "Bit 1 - Prescale timer 0 interrupt enable"]
    #[inline]
    pub fn rt0psie(&mut self) -> _RT0PSIEW {
        _RT0PSIEW { w: self }
    }
    #[doc = "Bits 2:4 - Prescale timer 0 interrupt interval"]
    #[inline]
    pub fn rt0ip(&mut self) -> _RT0IPW {
        _RT0IPW { w: self }
    }
}
