#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCPS1CTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `RT1PSIFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT1PSIFGR {
    #[doc = "No time event occurred"]
    RT1PSIFG_0,
    #[doc = "Time event occurred"]
    RT1PSIFG_1,
}
impl RT1PSIFGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RT1PSIFGR::RT1PSIFG_0 => false,
            RT1PSIFGR::RT1PSIFG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RT1PSIFGR {
        match value {
            false => RT1PSIFGR::RT1PSIFG_0,
            true => RT1PSIFGR::RT1PSIFG_1,
        }
    }
    #[doc = "Checks if the value of the field is `RT1PSIFG_0`"]
    #[inline]
    pub fn is_rt1psifg_0(&self) -> bool {
        *self == RT1PSIFGR::RT1PSIFG_0
    }
    #[doc = "Checks if the value of the field is `RT1PSIFG_1`"]
    #[inline]
    pub fn is_rt1psifg_1(&self) -> bool {
        *self == RT1PSIFGR::RT1PSIFG_1
    }
}
#[doc = "Possible values of the field `RT1PSIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT1PSIER {
    #[doc = "Interrupt not enabled"]
    RT1PSIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RT1PSIE_1,
}
impl RT1PSIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RT1PSIER::RT1PSIE_0 => false,
            RT1PSIER::RT1PSIE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RT1PSIER {
        match value {
            false => RT1PSIER::RT1PSIE_0,
            true => RT1PSIER::RT1PSIE_1,
        }
    }
    #[doc = "Checks if the value of the field is `RT1PSIE_0`"]
    #[inline]
    pub fn is_rt1psie_0(&self) -> bool {
        *self == RT1PSIER::RT1PSIE_0
    }
    #[doc = "Checks if the value of the field is `RT1PSIE_1`"]
    #[inline]
    pub fn is_rt1psie_1(&self) -> bool {
        *self == RT1PSIER::RT1PSIE_1
    }
}
#[doc = "Possible values of the field `RT1IP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RT1IPR {
    #[doc = "Divide by 2"]
    RT1IP_0,
    #[doc = "Divide by 4"]
    RT1IP_1,
    #[doc = "Divide by 8"]
    RT1IP_2,
    #[doc = "Divide by 16"]
    RT1IP_3,
    #[doc = "Divide by 32"]
    RT1IP_4,
    #[doc = "Divide by 64"]
    RT1IP_5,
    #[doc = "Divide by 128"]
    RT1IP_6,
    #[doc = "Divide by 256"]
    RT1IP_7,
}
impl RT1IPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            RT1IPR::RT1IP_0 => 0,
            RT1IPR::RT1IP_1 => 1,
            RT1IPR::RT1IP_2 => 2,
            RT1IPR::RT1IP_3 => 3,
            RT1IPR::RT1IP_4 => 4,
            RT1IPR::RT1IP_5 => 5,
            RT1IPR::RT1IP_6 => 6,
            RT1IPR::RT1IP_7 => 7,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> RT1IPR {
        match value {
            0 => RT1IPR::RT1IP_0,
            1 => RT1IPR::RT1IP_1,
            2 => RT1IPR::RT1IP_2,
            3 => RT1IPR::RT1IP_3,
            4 => RT1IPR::RT1IP_4,
            5 => RT1IPR::RT1IP_5,
            6 => RT1IPR::RT1IP_6,
            7 => RT1IPR::RT1IP_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RT1IP_0`"]
    #[inline]
    pub fn is_rt1ip_0(&self) -> bool {
        *self == RT1IPR::RT1IP_0
    }
    #[doc = "Checks if the value of the field is `RT1IP_1`"]
    #[inline]
    pub fn is_rt1ip_1(&self) -> bool {
        *self == RT1IPR::RT1IP_1
    }
    #[doc = "Checks if the value of the field is `RT1IP_2`"]
    #[inline]
    pub fn is_rt1ip_2(&self) -> bool {
        *self == RT1IPR::RT1IP_2
    }
    #[doc = "Checks if the value of the field is `RT1IP_3`"]
    #[inline]
    pub fn is_rt1ip_3(&self) -> bool {
        *self == RT1IPR::RT1IP_3
    }
    #[doc = "Checks if the value of the field is `RT1IP_4`"]
    #[inline]
    pub fn is_rt1ip_4(&self) -> bool {
        *self == RT1IPR::RT1IP_4
    }
    #[doc = "Checks if the value of the field is `RT1IP_5`"]
    #[inline]
    pub fn is_rt1ip_5(&self) -> bool {
        *self == RT1IPR::RT1IP_5
    }
    #[doc = "Checks if the value of the field is `RT1IP_6`"]
    #[inline]
    pub fn is_rt1ip_6(&self) -> bool {
        *self == RT1IPR::RT1IP_6
    }
    #[doc = "Checks if the value of the field is `RT1IP_7`"]
    #[inline]
    pub fn is_rt1ip_7(&self) -> bool {
        *self == RT1IPR::RT1IP_7
    }
}
#[doc = "Values that can be written to the field `RT1PSIFG`"]
pub enum RT1PSIFGW {
    #[doc = "No time event occurred"]
    RT1PSIFG_0,
    #[doc = "Time event occurred"]
    RT1PSIFG_1,
}
impl RT1PSIFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RT1PSIFGW::RT1PSIFG_0 => false,
            RT1PSIFGW::RT1PSIFG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT1PSIFGW<'a> {
    w: &'a mut W,
}
impl<'a> _RT1PSIFGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT1PSIFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No time event occurred"]
    #[inline]
    pub fn rt1psifg_0(self) -> &'a mut W {
        self.variant(RT1PSIFGW::RT1PSIFG_0)
    }
    #[doc = "Time event occurred"]
    #[inline]
    pub fn rt1psifg_1(self) -> &'a mut W {
        self.variant(RT1PSIFGW::RT1PSIFG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RT1PSIE`"]
pub enum RT1PSIEW {
    #[doc = "Interrupt not enabled"]
    RT1PSIE_0,
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    RT1PSIE_1,
}
impl RT1PSIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RT1PSIEW::RT1PSIE_0 => false,
            RT1PSIEW::RT1PSIE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT1PSIEW<'a> {
    w: &'a mut W,
}
impl<'a> _RT1PSIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT1PSIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt not enabled"]
    #[inline]
    pub fn rt1psie_0(self) -> &'a mut W {
        self.variant(RT1PSIEW::RT1PSIE_0)
    }
    #[doc = "Interrupt enabled (LPM3/LPM3.5 wake-up enabled)"]
    #[inline]
    pub fn rt1psie_1(self) -> &'a mut W {
        self.variant(RT1PSIEW::RT1PSIE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RT1IP`"]
pub enum RT1IPW {
    #[doc = "Divide by 2"]
    RT1IP_0,
    #[doc = "Divide by 4"]
    RT1IP_1,
    #[doc = "Divide by 8"]
    RT1IP_2,
    #[doc = "Divide by 16"]
    RT1IP_3,
    #[doc = "Divide by 32"]
    RT1IP_4,
    #[doc = "Divide by 64"]
    RT1IP_5,
    #[doc = "Divide by 128"]
    RT1IP_6,
    #[doc = "Divide by 256"]
    RT1IP_7,
}
impl RT1IPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            RT1IPW::RT1IP_0 => 0,
            RT1IPW::RT1IP_1 => 1,
            RT1IPW::RT1IP_2 => 2,
            RT1IPW::RT1IP_3 => 3,
            RT1IPW::RT1IP_4 => 4,
            RT1IPW::RT1IP_5 => 5,
            RT1IPW::RT1IP_6 => 6,
            RT1IPW::RT1IP_7 => 7,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RT1IPW<'a> {
    w: &'a mut W,
}
impl<'a> _RT1IPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RT1IPW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "Divide by 2"]
    #[inline]
    pub fn rt1ip_0(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_0)
    }
    #[doc = "Divide by 4"]
    #[inline]
    pub fn rt1ip_1(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_1)
    }
    #[doc = "Divide by 8"]
    #[inline]
    pub fn rt1ip_2(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_2)
    }
    #[doc = "Divide by 16"]
    #[inline]
    pub fn rt1ip_3(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_3)
    }
    #[doc = "Divide by 32"]
    #[inline]
    pub fn rt1ip_4(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_4)
    }
    #[doc = "Divide by 64"]
    #[inline]
    pub fn rt1ip_5(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_5)
    }
    #[doc = "Divide by 128"]
    #[inline]
    pub fn rt1ip_6(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_6)
    }
    #[doc = "Divide by 256"]
    #[inline]
    pub fn rt1ip_7(self) -> &'a mut W {
        self.variant(RT1IPW::RT1IP_7)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bit 0 - Prescale timer 1 interrupt flag"]
    #[inline]
    pub fn rt1psifg(&self) -> RT1PSIFGR {
        RT1PSIFGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 1 - Prescale timer 1 interrupt enable"]
    #[inline]
    pub fn rt1psie(&self) -> RT1PSIER {
        RT1PSIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 2:4 - Prescale timer 1 interrupt interval"]
    #[inline]
    pub fn rt1ip(&self) -> RT1IPR {
        RT1IPR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Prescale timer 1 interrupt flag"]
    #[inline]
    pub fn rt1psifg(&mut self) -> _RT1PSIFGW {
        _RT1PSIFGW { w: self }
    }
    #[doc = "Bit 1 - Prescale timer 1 interrupt enable"]
    #[inline]
    pub fn rt1psie(&mut self) -> _RT1PSIEW {
        _RT1PSIEW { w: self }
    }
    #[doc = "Bits 2:4 - Prescale timer 1 interrupt interval"]
    #[inline]
    pub fn rt1ip(&mut self) -> _RT1IPW {
        _RT1IPW { w: self }
    }
}
