#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::RTCTCMP {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct RTCTCMPR {
    bits: u8,
}
impl RTCTCMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Possible values of the field `RTCTCOK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCTCOKR {
    #[doc = "Write to RTCTCMPx is unsuccessful"]
    RTCTCOK_0,
    #[doc = "Write to RTCTCMPx is successful"]
    RTCTCOK_1,
}
impl RTCTCOKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCTCOKR::RTCTCOK_0 => false,
            RTCTCOKR::RTCTCOK_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCTCOKR {
        match value {
            false => RTCTCOKR::RTCTCOK_0,
            true => RTCTCOKR::RTCTCOK_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCTCOK_0`"]
    #[inline]
    pub fn is_rtctcok_0(&self) -> bool {
        *self == RTCTCOKR::RTCTCOK_0
    }
    #[doc = "Checks if the value of the field is `RTCTCOK_1`"]
    #[inline]
    pub fn is_rtctcok_1(&self) -> bool {
        *self == RTCTCOKR::RTCTCOK_1
    }
}
#[doc = r" Value of the field"]
pub struct RTCTCRDYR {
    bits: bool,
}
impl RTCTCRDYR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `RTCTCMPS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTCTCMPSR {
    #[doc = "Down calibration. Frequency adjusted down"]
    RTCTCMPS_0,
    #[doc = "Up calibration. Frequency adjusted up"]
    RTCTCMPS_1,
}
impl RTCTCMPSR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            RTCTCMPSR::RTCTCMPS_0 => false,
            RTCTCMPSR::RTCTCMPS_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> RTCTCMPSR {
        match value {
            false => RTCTCMPSR::RTCTCMPS_0,
            true => RTCTCMPSR::RTCTCMPS_1,
        }
    }
    #[doc = "Checks if the value of the field is `RTCTCMPS_0`"]
    #[inline]
    pub fn is_rtctcmps_0(&self) -> bool {
        *self == RTCTCMPSR::RTCTCMPS_0
    }
    #[doc = "Checks if the value of the field is `RTCTCMPS_1`"]
    #[inline]
    pub fn is_rtctcmps_1(&self) -> bool {
        *self == RTCTCMPSR::RTCTCMPS_1
    }
}
#[doc = r" Proxy"]
pub struct _RTCTCMPW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCTCMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 255;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RTCTCMPS`"]
pub enum RTCTCMPSW {
    #[doc = "Down calibration. Frequency adjusted down"]
    RTCTCMPS_0,
    #[doc = "Up calibration. Frequency adjusted up"]
    RTCTCMPS_1,
}
impl RTCTCMPSW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            RTCTCMPSW::RTCTCMPS_0 => false,
            RTCTCMPSW::RTCTCMPS_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _RTCTCMPSW<'a> {
    w: &'a mut W,
}
impl<'a> _RTCTCMPSW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RTCTCMPSW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Down calibration. Frequency adjusted down"]
    #[inline]
    pub fn rtctcmps_0(self) -> &'a mut W {
        self.variant(RTCTCMPSW::RTCTCMPS_0)
    }
    #[doc = "Up calibration. Frequency adjusted up"]
    #[inline]
    pub fn rtctcmps_1(self) -> &'a mut W {
        self.variant(RTCTCMPSW::RTCTCMPS_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:7 - Real-time clock temperature compensation"]
    #[inline]
    pub fn rtctcmp(&self) -> RTCTCMPR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        RTCTCMPR { bits }
    }
    #[doc = "Bit 13 - Real-time clock temperature compensation write OK"]
    #[inline]
    pub fn rtctcok(&self) -> RTCTCOKR {
        RTCTCOKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bit 14 - Real-time clock temperature compensation ready"]
    #[inline]
    pub fn rtctcrdy(&self) -> RTCTCRDYR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        };
        RTCTCRDYR { bits }
    }
    #[doc = "Bit 15 - Real-time clock temperature compensation sign"]
    #[inline]
    pub fn rtctcmps(&self) -> RTCTCMPSR {
        RTCTCMPSR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 16384 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:7 - Real-time clock temperature compensation"]
    #[inline]
    pub fn rtctcmp(&mut self) -> _RTCTCMPW {
        _RTCTCMPW { w: self }
    }
    #[doc = "Bit 15 - Real-time clock temperature compensation sign"]
    #[inline]
    pub fn rtctcmps(&mut self) -> _RTCTCMPSW {
        _RTCTCMPSW { w: self }
    }
}
