#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Reboot Control Register"]
    pub sys_reboot_ctl: SYS_REBOOT_CTL,
    #[doc = "0x04 - NMI Control and Status Register"]
    pub sys_nmi_ctlstat: SYS_NMI_CTLSTAT,
    #[doc = "0x08 - Watchdog Reset Control Register"]
    pub sys_wdtreset_ctl: SYS_WDTRESET_CTL,
    #[doc = "0x0c - Peripheral Halt Control Register"]
    pub sys_perihalt_ctl: SYS_PERIHALT_CTL,
    #[doc = "0x10 - SRAM Size Register"]
    pub sys_sram_size: SYS_SRAM_SIZE,
    #[doc = "0x14 - SRAM Bank Enable Register"]
    pub sys_sram_banken: SYS_SRAM_BANKEN,
    #[doc = "0x18 - SRAM Bank Retention Control Register"]
    pub sys_sram_bankret: SYS_SRAM_BANKRET,
    _reserved0: [u8; 4usize],
    #[doc = "0x20 - Flash Size Register"]
    pub sys_flash_size: SYS_FLASH_SIZE,
    _reserved1: [u8; 12usize],
    #[doc = "0x30 - Digital I/O Glitch Filter Control Register"]
    pub sys_dio_gltflt_ctl: SYS_DIO_GLTFLT_CTL,
    _reserved2: [u8; 12usize],
    #[doc = "0x40 - IP Protected Secure Zone Data Access Unlock Register"]
    pub sys_secdata_unlock: SYS_SECDATA_UNLOCK,
    _reserved3: [u8; 4028usize],
    #[doc = "0x1000 - Master Unlock Register"]
    pub sys_master_unlock: SYS_MASTER_UNLOCK,
    #[doc = "0x1004 - Boot Override Request Register"]
    pub sys_bootover_req: [SYS_BOOTOVER_REQ; 2],
    #[doc = "0x100c - Boot Override Acknowledge Register"]
    pub sys_bootover_ack: SYS_BOOTOVER_ACK,
    #[doc = "0x1010 - Reset Request Register"]
    pub sys_reset_req: SYS_RESET_REQ,
    #[doc = "0x1014 - Reset Status and Override Register"]
    pub sys_reset_statover: SYS_RESET_STATOVER,
    _reserved4: [u8; 8usize],
    #[doc = "0x1020 - System Status Register"]
    pub sys_system_stat: SYS_SYSTEM_STAT,
}
#[doc = "Reboot Control Register"]
pub struct SYS_REBOOT_CTL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reboot Control Register"]
pub mod sys_reboot_ctl;
#[doc = "NMI Control and Status Register"]
pub struct SYS_NMI_CTLSTAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "NMI Control and Status Register"]
pub mod sys_nmi_ctlstat;
#[doc = "Watchdog Reset Control Register"]
pub struct SYS_WDTRESET_CTL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Watchdog Reset Control Register"]
pub mod sys_wdtreset_ctl;
#[doc = "Peripheral Halt Control Register"]
pub struct SYS_PERIHALT_CTL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Peripheral Halt Control Register"]
pub mod sys_perihalt_ctl;
#[doc = "SRAM Size Register"]
pub struct SYS_SRAM_SIZE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SRAM Size Register"]
pub mod sys_sram_size;
#[doc = "SRAM Bank Enable Register"]
pub struct SYS_SRAM_BANKEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SRAM Bank Enable Register"]
pub mod sys_sram_banken;
#[doc = "SRAM Bank Retention Control Register"]
pub struct SYS_SRAM_BANKRET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SRAM Bank Retention Control Register"]
pub mod sys_sram_bankret;
#[doc = "Flash Size Register"]
pub struct SYS_FLASH_SIZE {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Flash Size Register"]
pub mod sys_flash_size;
#[doc = "Digital I/O Glitch Filter Control Register"]
pub struct SYS_DIO_GLTFLT_CTL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Digital I/O Glitch Filter Control Register"]
pub mod sys_dio_gltflt_ctl;
#[doc = "IP Protected Secure Zone Data Access Unlock Register"]
pub struct SYS_SECDATA_UNLOCK {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "IP Protected Secure Zone Data Access Unlock Register"]
pub mod sys_secdata_unlock;
#[doc = "Master Unlock Register"]
pub struct SYS_MASTER_UNLOCK {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Master Unlock Register"]
pub mod sys_master_unlock;
#[doc = "Boot Override Request Register"]
pub struct SYS_BOOTOVER_REQ {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Boot Override Request Register"]
pub mod sys_bootover_req;
#[doc = "Boot Override Acknowledge Register"]
pub struct SYS_BOOTOVER_ACK {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Boot Override Acknowledge Register"]
pub mod sys_bootover_ack;
#[doc = "Reset Request Register"]
pub struct SYS_RESET_REQ {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reset Request Register"]
pub mod sys_reset_req;
#[doc = "Reset Status and Override Register"]
pub struct SYS_RESET_STATOVER {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reset Status and Override Register"]
pub mod sys_reset_statover;
#[doc = "System Status Register"]
pub struct SYS_SYSTEM_STAT {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "System Status Register"]
pub mod sys_system_stat;
