#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_DIO_GLTFLT_CTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `GLTCH_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum GLTCH_ENR {
    #[doc = "Disables glitch filter on the digital I/Os"]
    GLTCH_EN_0,
    #[doc = "Enables glitch filter on the digital I/Os"]
    GLTCH_EN_1,
}
impl GLTCH_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            GLTCH_ENR::GLTCH_EN_0 => false,
            GLTCH_ENR::GLTCH_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> GLTCH_ENR {
        match value {
            false => GLTCH_ENR::GLTCH_EN_0,
            true => GLTCH_ENR::GLTCH_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `GLTCH_EN_0`"]
    #[inline]
    pub fn is_gltch_en_0(&self) -> bool {
        *self == GLTCH_ENR::GLTCH_EN_0
    }
    #[doc = "Checks if the value of the field is `GLTCH_EN_1`"]
    #[inline]
    pub fn is_gltch_en_1(&self) -> bool {
        *self == GLTCH_ENR::GLTCH_EN_1
    }
}
#[doc = "Values that can be written to the field `GLTCH_EN`"]
pub enum GLTCH_ENW {
    #[doc = "Disables glitch filter on the digital I/Os"]
    GLTCH_EN_0,
    #[doc = "Enables glitch filter on the digital I/Os"]
    GLTCH_EN_1,
}
impl GLTCH_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            GLTCH_ENW::GLTCH_EN_0 => false,
            GLTCH_ENW::GLTCH_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _GLTCH_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _GLTCH_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: GLTCH_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables glitch filter on the digital I/Os"]
    #[inline]
    pub fn gltch_en_0(self) -> &'a mut W {
        self.variant(GLTCH_ENW::GLTCH_EN_0)
    }
    #[doc = "Enables glitch filter on the digital I/Os"]
    #[inline]
    pub fn gltch_en_1(self) -> &'a mut W {
        self.variant(GLTCH_ENW::GLTCH_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Glitch filter enable"]
    #[inline]
    pub fn gltch_en(&self) -> GLTCH_ENR {
        GLTCH_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 1 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Glitch filter enable"]
    #[inline]
    pub fn gltch_en(&mut self) -> _GLTCH_ENW {
        _GLTCH_ENW { w: self }
    }
}
