#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_NMI_CTLSTAT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `CS_SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CS_SRCR {
    #[doc = "Disables CS interrupt as a source of NMI"]
    CS_SRC_0,
    #[doc = "Enables CS interrupt as a source of NMI"]
    CS_SRC_1,
}
impl CS_SRCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CS_SRCR::CS_SRC_0 => false,
            CS_SRCR::CS_SRC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CS_SRCR {
        match value {
            false => CS_SRCR::CS_SRC_0,
            true => CS_SRCR::CS_SRC_1,
        }
    }
    #[doc = "Checks if the value of the field is `CS_SRC_0`"]
    #[inline]
    pub fn is_cs_src_0(&self) -> bool {
        *self == CS_SRCR::CS_SRC_0
    }
    #[doc = "Checks if the value of the field is `CS_SRC_1`"]
    #[inline]
    pub fn is_cs_src_1(&self) -> bool {
        *self == CS_SRCR::CS_SRC_1
    }
}
#[doc = "Possible values of the field `PSS_SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PSS_SRCR {
    #[doc = "Disables the PSS interrupt as a source of NMI"]
    PSS_SRC_0,
    #[doc = "Enables the PSS interrupt as a source of NMI"]
    PSS_SRC_1,
}
impl PSS_SRCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PSS_SRCR::PSS_SRC_0 => false,
            PSS_SRCR::PSS_SRC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PSS_SRCR {
        match value {
            false => PSS_SRCR::PSS_SRC_0,
            true => PSS_SRCR::PSS_SRC_1,
        }
    }
    #[doc = "Checks if the value of the field is `PSS_SRC_0`"]
    #[inline]
    pub fn is_pss_src_0(&self) -> bool {
        *self == PSS_SRCR::PSS_SRC_0
    }
    #[doc = "Checks if the value of the field is `PSS_SRC_1`"]
    #[inline]
    pub fn is_pss_src_1(&self) -> bool {
        *self == PSS_SRCR::PSS_SRC_1
    }
}
#[doc = "Possible values of the field `PCM_SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PCM_SRCR {
    #[doc = "Disbles the PCM interrupt as a source of NMI"]
    PCM_SRC_0,
    #[doc = "Enables the PCM interrupt as a source of NMI"]
    PCM_SRC_1,
}
impl PCM_SRCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PCM_SRCR::PCM_SRC_0 => false,
            PCM_SRCR::PCM_SRC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PCM_SRCR {
        match value {
            false => PCM_SRCR::PCM_SRC_0,
            true => PCM_SRCR::PCM_SRC_1,
        }
    }
    #[doc = "Checks if the value of the field is `PCM_SRC_0`"]
    #[inline]
    pub fn is_pcm_src_0(&self) -> bool {
        *self == PCM_SRCR::PCM_SRC_0
    }
    #[doc = "Checks if the value of the field is `PCM_SRC_1`"]
    #[inline]
    pub fn is_pcm_src_1(&self) -> bool {
        *self == PCM_SRCR::PCM_SRC_1
    }
}
#[doc = "Possible values of the field `PIN_SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PIN_SRCR {
    #[doc = "Configures the RSTn_NMI pin as a source of POR Class Reset"]
    PIN_SRC_0,
    #[doc = "Configures the RSTn_NMI pin as a source of NMI"]
    PIN_SRC_1,
}
impl PIN_SRCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PIN_SRCR::PIN_SRC_0 => false,
            PIN_SRCR::PIN_SRC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PIN_SRCR {
        match value {
            false => PIN_SRCR::PIN_SRC_0,
            true => PIN_SRCR::PIN_SRC_1,
        }
    }
    #[doc = "Checks if the value of the field is `PIN_SRC_0`"]
    #[inline]
    pub fn is_pin_src_0(&self) -> bool {
        *self == PIN_SRCR::PIN_SRC_0
    }
    #[doc = "Checks if the value of the field is `PIN_SRC_1`"]
    #[inline]
    pub fn is_pin_src_1(&self) -> bool {
        *self == PIN_SRCR::PIN_SRC_1
    }
}
#[doc = "Possible values of the field `CS_FLG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CS_FLGR {
    #[doc = "indicates CS interrupt was not the source of NMI"]
    CS_FLG_0,
    #[doc = "indicates CS interrupt was the source of NMI"]
    CS_FLG_1,
}
impl CS_FLGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CS_FLGR::CS_FLG_0 => false,
            CS_FLGR::CS_FLG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CS_FLGR {
        match value {
            false => CS_FLGR::CS_FLG_0,
            true => CS_FLGR::CS_FLG_1,
        }
    }
    #[doc = "Checks if the value of the field is `CS_FLG_0`"]
    #[inline]
    pub fn is_cs_flg_0(&self) -> bool {
        *self == CS_FLGR::CS_FLG_0
    }
    #[doc = "Checks if the value of the field is `CS_FLG_1`"]
    #[inline]
    pub fn is_cs_flg_1(&self) -> bool {
        *self == CS_FLGR::CS_FLG_1
    }
}
#[doc = "Possible values of the field `PSS_FLG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PSS_FLGR {
    #[doc = "indicates the PSS interrupt was not the source of NMI"]
    PSS_FLG_0,
    #[doc = "indicates the PSS interrupt was the source of NMI"]
    PSS_FLG_1,
}
impl PSS_FLGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PSS_FLGR::PSS_FLG_0 => false,
            PSS_FLGR::PSS_FLG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PSS_FLGR {
        match value {
            false => PSS_FLGR::PSS_FLG_0,
            true => PSS_FLGR::PSS_FLG_1,
        }
    }
    #[doc = "Checks if the value of the field is `PSS_FLG_0`"]
    #[inline]
    pub fn is_pss_flg_0(&self) -> bool {
        *self == PSS_FLGR::PSS_FLG_0
    }
    #[doc = "Checks if the value of the field is `PSS_FLG_1`"]
    #[inline]
    pub fn is_pss_flg_1(&self) -> bool {
        *self == PSS_FLGR::PSS_FLG_1
    }
}
#[doc = "Possible values of the field `PCM_FLG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PCM_FLGR {
    #[doc = "indicates the PCM interrupt was not the source of NMI"]
    PCM_FLG_0,
    #[doc = "indicates the PCM interrupt was the source of NMI"]
    PCM_FLG_1,
}
impl PCM_FLGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PCM_FLGR::PCM_FLG_0 => false,
            PCM_FLGR::PCM_FLG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PCM_FLGR {
        match value {
            false => PCM_FLGR::PCM_FLG_0,
            true => PCM_FLGR::PCM_FLG_1,
        }
    }
    #[doc = "Checks if the value of the field is `PCM_FLG_0`"]
    #[inline]
    pub fn is_pcm_flg_0(&self) -> bool {
        *self == PCM_FLGR::PCM_FLG_0
    }
    #[doc = "Checks if the value of the field is `PCM_FLG_1`"]
    #[inline]
    pub fn is_pcm_flg_1(&self) -> bool {
        *self == PCM_FLGR::PCM_FLG_1
    }
}
#[doc = "Possible values of the field `PIN_FLG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PIN_FLGR {
    #[doc = "Indicates the RSTn_NMI pin was not the source of NMI"]
    PIN_FLG_0,
    #[doc = "Indicates the RSTn_NMI pin was the source of NMI"]
    PIN_FLG_1,
}
impl PIN_FLGR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PIN_FLGR::PIN_FLG_0 => false,
            PIN_FLGR::PIN_FLG_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PIN_FLGR {
        match value {
            false => PIN_FLGR::PIN_FLG_0,
            true => PIN_FLGR::PIN_FLG_1,
        }
    }
    #[doc = "Checks if the value of the field is `PIN_FLG_0`"]
    #[inline]
    pub fn is_pin_flg_0(&self) -> bool {
        *self == PIN_FLGR::PIN_FLG_0
    }
    #[doc = "Checks if the value of the field is `PIN_FLG_1`"]
    #[inline]
    pub fn is_pin_flg_1(&self) -> bool {
        *self == PIN_FLGR::PIN_FLG_1
    }
}
#[doc = "Values that can be written to the field `CS_SRC`"]
pub enum CS_SRCW {
    #[doc = "Disables CS interrupt as a source of NMI"]
    CS_SRC_0,
    #[doc = "Enables CS interrupt as a source of NMI"]
    CS_SRC_1,
}
impl CS_SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CS_SRCW::CS_SRC_0 => false,
            CS_SRCW::CS_SRC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CS_SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _CS_SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CS_SRCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables CS interrupt as a source of NMI"]
    #[inline]
    pub fn cs_src_0(self) -> &'a mut W {
        self.variant(CS_SRCW::CS_SRC_0)
    }
    #[doc = "Enables CS interrupt as a source of NMI"]
    #[inline]
    pub fn cs_src_1(self) -> &'a mut W {
        self.variant(CS_SRCW::CS_SRC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PSS_SRC`"]
pub enum PSS_SRCW {
    #[doc = "Disables the PSS interrupt as a source of NMI"]
    PSS_SRC_0,
    #[doc = "Enables the PSS interrupt as a source of NMI"]
    PSS_SRC_1,
}
impl PSS_SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PSS_SRCW::PSS_SRC_0 => false,
            PSS_SRCW::PSS_SRC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PSS_SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _PSS_SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PSS_SRCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables the PSS interrupt as a source of NMI"]
    #[inline]
    pub fn pss_src_0(self) -> &'a mut W {
        self.variant(PSS_SRCW::PSS_SRC_0)
    }
    #[doc = "Enables the PSS interrupt as a source of NMI"]
    #[inline]
    pub fn pss_src_1(self) -> &'a mut W {
        self.variant(PSS_SRCW::PSS_SRC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PCM_SRC`"]
pub enum PCM_SRCW {
    #[doc = "Disbles the PCM interrupt as a source of NMI"]
    PCM_SRC_0,
    #[doc = "Enables the PCM interrupt as a source of NMI"]
    PCM_SRC_1,
}
impl PCM_SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PCM_SRCW::PCM_SRC_0 => false,
            PCM_SRCW::PCM_SRC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PCM_SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _PCM_SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PCM_SRCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disbles the PCM interrupt as a source of NMI"]
    #[inline]
    pub fn pcm_src_0(self) -> &'a mut W {
        self.variant(PCM_SRCW::PCM_SRC_0)
    }
    #[doc = "Enables the PCM interrupt as a source of NMI"]
    #[inline]
    pub fn pcm_src_1(self) -> &'a mut W {
        self.variant(PCM_SRCW::PCM_SRC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PIN_SRC`"]
pub enum PIN_SRCW {
    #[doc = "Configures the RSTn_NMI pin as a source of POR Class Reset"]
    PIN_SRC_0,
    #[doc = "Configures the RSTn_NMI pin as a source of NMI"]
    PIN_SRC_1,
}
impl PIN_SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PIN_SRCW::PIN_SRC_0 => false,
            PIN_SRCW::PIN_SRC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PIN_SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _PIN_SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PIN_SRCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Configures the RSTn_NMI pin as a source of POR Class Reset"]
    #[inline]
    pub fn pin_src_0(self) -> &'a mut W {
        self.variant(PIN_SRCW::PIN_SRC_0)
    }
    #[doc = "Configures the RSTn_NMI pin as a source of NMI"]
    #[inline]
    pub fn pin_src_1(self) -> &'a mut W {
        self.variant(PIN_SRCW::PIN_SRC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PIN_FLG`"]
pub enum PIN_FLGW {
    #[doc = "Indicates the RSTn_NMI pin was not the source of NMI"]
    PIN_FLG_0,
    #[doc = "Indicates the RSTn_NMI pin was the source of NMI"]
    PIN_FLG_1,
}
impl PIN_FLGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PIN_FLGW::PIN_FLG_0 => false,
            PIN_FLGW::PIN_FLG_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PIN_FLGW<'a> {
    w: &'a mut W,
}
impl<'a> _PIN_FLGW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PIN_FLGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Indicates the RSTn_NMI pin was not the source of NMI"]
    #[inline]
    pub fn pin_flg_0(self) -> &'a mut W {
        self.variant(PIN_FLGW::PIN_FLG_0)
    }
    #[doc = "Indicates the RSTn_NMI pin was the source of NMI"]
    #[inline]
    pub fn pin_flg_1(self) -> &'a mut W {
        self.variant(PIN_FLGW::PIN_FLG_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 19;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - CS interrupt as a source of NMI"]
    #[inline]
    pub fn cs_src(&self) -> CS_SRCR {
        CS_SRCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - PSS interrupt as a source of NMI"]
    #[inline]
    pub fn pss_src(&self) -> PSS_SRCR {
        PSS_SRCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - PCM interrupt as a source of NMI"]
    #[inline]
    pub fn pcm_src(&self) -> PCM_SRCR {
        PCM_SRCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - RSTn/NMI pin configuration Note: When the device enters LPM3/LPM4 modes of operation, the functionality selected by this bit is retained. If selected as an NMI, activity on this pin in LPM3/LPM4 wakes the device and processes the interrupt, without causing a POR. If selected as a Reset, activity on this pin in LPM3/LPM4 causes a device-level POR When the device enters LPM3.5/LPM4.5 modes of operation, this bit is always cleared to 0. In other words, the RSTn/NMI pin always assumes a reset functionality in LPM3.5/LPM4.5 modes."]
    #[inline]
    pub fn pin_src(&self) -> PIN_SRCR {
        PIN_SRCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 16 - CS interrupt was the source of NMI"]
    #[inline]
    pub fn cs_flg(&self) -> CS_FLGR {
        CS_FLGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 17 - PSS interrupt was the source of NMI"]
    #[inline]
    pub fn pss_flg(&self) -> PSS_FLGR {
        PSS_FLGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 17;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 18 - PCM interrupt was the source of NMI"]
    #[inline]
    pub fn pcm_flg(&self) -> PCM_FLGR {
        PCM_FLGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 19 - RSTn/NMI pin was the source of NMI"]
    #[inline]
    pub fn pin_flg(&self) -> PIN_FLGR {
        PIN_FLGR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 19;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 7 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - CS interrupt as a source of NMI"]
    #[inline]
    pub fn cs_src(&mut self) -> _CS_SRCW {
        _CS_SRCW { w: self }
    }
    #[doc = "Bit 1 - PSS interrupt as a source of NMI"]
    #[inline]
    pub fn pss_src(&mut self) -> _PSS_SRCW {
        _PSS_SRCW { w: self }
    }
    #[doc = "Bit 2 - PCM interrupt as a source of NMI"]
    #[inline]
    pub fn pcm_src(&mut self) -> _PCM_SRCW {
        _PCM_SRCW { w: self }
    }
    #[doc = "Bit 3 - RSTn/NMI pin configuration Note: When the device enters LPM3/LPM4 modes of operation, the functionality selected by this bit is retained. If selected as an NMI, activity on this pin in LPM3/LPM4 wakes the device and processes the interrupt, without causing a POR. If selected as a Reset, activity on this pin in LPM3/LPM4 causes a device-level POR When the device enters LPM3.5/LPM4.5 modes of operation, this bit is always cleared to 0. In other words, the RSTn/NMI pin always assumes a reset functionality in LPM3.5/LPM4.5 modes."]
    #[inline]
    pub fn pin_src(&mut self) -> _PIN_SRCW {
        _PIN_SRCW { w: self }
    }
    #[doc = "Bit 19 - RSTn/NMI pin was the source of NMI"]
    #[inline]
    pub fn pin_flg(&mut self) -> _PIN_FLGW {
        _PIN_FLGW { w: self }
    }
}
