#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_PERIHALT_CTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `HALT_T16_0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_T16_0R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_0_1,
}
impl HALT_T16_0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_T16_0R::HALT_T16_0_0 => false,
            HALT_T16_0R::HALT_T16_0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_T16_0R {
        match value {
            false => HALT_T16_0R::HALT_T16_0_0,
            true => HALT_T16_0R::HALT_T16_0_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_T16_0_0`"]
    #[inline]
    pub fn is_halt_t16_0_0(&self) -> bool {
        *self == HALT_T16_0R::HALT_T16_0_0
    }
    #[doc = "Checks if the value of the field is `HALT_T16_0_1`"]
    #[inline]
    pub fn is_halt_t16_0_1(&self) -> bool {
        *self == HALT_T16_0R::HALT_T16_0_1
    }
}
#[doc = "Possible values of the field `HALT_T16_1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_T16_1R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_1_1,
}
impl HALT_T16_1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_T16_1R::HALT_T16_1_0 => false,
            HALT_T16_1R::HALT_T16_1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_T16_1R {
        match value {
            false => HALT_T16_1R::HALT_T16_1_0,
            true => HALT_T16_1R::HALT_T16_1_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_T16_1_0`"]
    #[inline]
    pub fn is_halt_t16_1_0(&self) -> bool {
        *self == HALT_T16_1R::HALT_T16_1_0
    }
    #[doc = "Checks if the value of the field is `HALT_T16_1_1`"]
    #[inline]
    pub fn is_halt_t16_1_1(&self) -> bool {
        *self == HALT_T16_1R::HALT_T16_1_1
    }
}
#[doc = "Possible values of the field `HALT_T16_2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_T16_2R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_2_1,
}
impl HALT_T16_2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_T16_2R::HALT_T16_2_0 => false,
            HALT_T16_2R::HALT_T16_2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_T16_2R {
        match value {
            false => HALT_T16_2R::HALT_T16_2_0,
            true => HALT_T16_2R::HALT_T16_2_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_T16_2_0`"]
    #[inline]
    pub fn is_halt_t16_2_0(&self) -> bool {
        *self == HALT_T16_2R::HALT_T16_2_0
    }
    #[doc = "Checks if the value of the field is `HALT_T16_2_1`"]
    #[inline]
    pub fn is_halt_t16_2_1(&self) -> bool {
        *self == HALT_T16_2R::HALT_T16_2_1
    }
}
#[doc = "Possible values of the field `HALT_T16_3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_T16_3R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_3_1,
}
impl HALT_T16_3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_T16_3R::HALT_T16_3_0 => false,
            HALT_T16_3R::HALT_T16_3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_T16_3R {
        match value {
            false => HALT_T16_3R::HALT_T16_3_0,
            true => HALT_T16_3R::HALT_T16_3_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_T16_3_0`"]
    #[inline]
    pub fn is_halt_t16_3_0(&self) -> bool {
        *self == HALT_T16_3R::HALT_T16_3_0
    }
    #[doc = "Checks if the value of the field is `HALT_T16_3_1`"]
    #[inline]
    pub fn is_halt_t16_3_1(&self) -> bool {
        *self == HALT_T16_3R::HALT_T16_3_1
    }
}
#[doc = "Possible values of the field `HALT_T32_0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_T32_0R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T32_0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T32_0_1,
}
impl HALT_T32_0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_T32_0R::HALT_T32_0_0 => false,
            HALT_T32_0R::HALT_T32_0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_T32_0R {
        match value {
            false => HALT_T32_0R::HALT_T32_0_0,
            true => HALT_T32_0R::HALT_T32_0_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_T32_0_0`"]
    #[inline]
    pub fn is_halt_t32_0_0(&self) -> bool {
        *self == HALT_T32_0R::HALT_T32_0_0
    }
    #[doc = "Checks if the value of the field is `HALT_T32_0_1`"]
    #[inline]
    pub fn is_halt_t32_0_1(&self) -> bool {
        *self == HALT_T32_0R::HALT_T32_0_1
    }
}
#[doc = "Possible values of the field `HALT_eUA0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUA0R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA0_1,
}
impl HALT_EUA0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUA0R::HALT_EUA0_0 => false,
            HALT_EUA0R::HALT_EUA0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUA0R {
        match value {
            false => HALT_EUA0R::HALT_EUA0_0,
            true => HALT_EUA0R::HALT_EUA0_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUA0_0`"]
    #[inline]
    pub fn is_halt_e_ua0_0(&self) -> bool {
        *self == HALT_EUA0R::HALT_EUA0_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUA0_1`"]
    #[inline]
    pub fn is_halt_e_ua0_1(&self) -> bool {
        *self == HALT_EUA0R::HALT_EUA0_1
    }
}
#[doc = "Possible values of the field `HALT_eUA1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUA1R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA1_1,
}
impl HALT_EUA1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUA1R::HALT_EUA1_0 => false,
            HALT_EUA1R::HALT_EUA1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUA1R {
        match value {
            false => HALT_EUA1R::HALT_EUA1_0,
            true => HALT_EUA1R::HALT_EUA1_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUA1_0`"]
    #[inline]
    pub fn is_halt_e_ua1_0(&self) -> bool {
        *self == HALT_EUA1R::HALT_EUA1_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUA1_1`"]
    #[inline]
    pub fn is_halt_e_ua1_1(&self) -> bool {
        *self == HALT_EUA1R::HALT_EUA1_1
    }
}
#[doc = "Possible values of the field `HALT_eUA2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUA2R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA2_1,
}
impl HALT_EUA2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUA2R::HALT_EUA2_0 => false,
            HALT_EUA2R::HALT_EUA2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUA2R {
        match value {
            false => HALT_EUA2R::HALT_EUA2_0,
            true => HALT_EUA2R::HALT_EUA2_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUA2_0`"]
    #[inline]
    pub fn is_halt_e_ua2_0(&self) -> bool {
        *self == HALT_EUA2R::HALT_EUA2_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUA2_1`"]
    #[inline]
    pub fn is_halt_e_ua2_1(&self) -> bool {
        *self == HALT_EUA2R::HALT_EUA2_1
    }
}
#[doc = "Possible values of the field `HALT_eUA3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUA3R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA3_1,
}
impl HALT_EUA3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUA3R::HALT_EUA3_0 => false,
            HALT_EUA3R::HALT_EUA3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUA3R {
        match value {
            false => HALT_EUA3R::HALT_EUA3_0,
            true => HALT_EUA3R::HALT_EUA3_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUA3_0`"]
    #[inline]
    pub fn is_halt_e_ua3_0(&self) -> bool {
        *self == HALT_EUA3R::HALT_EUA3_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUA3_1`"]
    #[inline]
    pub fn is_halt_e_ua3_1(&self) -> bool {
        *self == HALT_EUA3R::HALT_EUA3_1
    }
}
#[doc = "Possible values of the field `HALT_eUB0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUB0R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB0_1,
}
impl HALT_EUB0R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUB0R::HALT_EUB0_0 => false,
            HALT_EUB0R::HALT_EUB0_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUB0R {
        match value {
            false => HALT_EUB0R::HALT_EUB0_0,
            true => HALT_EUB0R::HALT_EUB0_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUB0_0`"]
    #[inline]
    pub fn is_halt_e_ub0_0(&self) -> bool {
        *self == HALT_EUB0R::HALT_EUB0_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUB0_1`"]
    #[inline]
    pub fn is_halt_e_ub0_1(&self) -> bool {
        *self == HALT_EUB0R::HALT_EUB0_1
    }
}
#[doc = "Possible values of the field `HALT_eUB1`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUB1R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB1_1,
}
impl HALT_EUB1R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUB1R::HALT_EUB1_0 => false,
            HALT_EUB1R::HALT_EUB1_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUB1R {
        match value {
            false => HALT_EUB1R::HALT_EUB1_0,
            true => HALT_EUB1R::HALT_EUB1_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUB1_0`"]
    #[inline]
    pub fn is_halt_e_ub1_0(&self) -> bool {
        *self == HALT_EUB1R::HALT_EUB1_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUB1_1`"]
    #[inline]
    pub fn is_halt_e_ub1_1(&self) -> bool {
        *self == HALT_EUB1R::HALT_EUB1_1
    }
}
#[doc = "Possible values of the field `HALT_eUB2`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUB2R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB2_1,
}
impl HALT_EUB2R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUB2R::HALT_EUB2_0 => false,
            HALT_EUB2R::HALT_EUB2_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUB2R {
        match value {
            false => HALT_EUB2R::HALT_EUB2_0,
            true => HALT_EUB2R::HALT_EUB2_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUB2_0`"]
    #[inline]
    pub fn is_halt_e_ub2_0(&self) -> bool {
        *self == HALT_EUB2R::HALT_EUB2_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUB2_1`"]
    #[inline]
    pub fn is_halt_e_ub2_1(&self) -> bool {
        *self == HALT_EUB2R::HALT_EUB2_1
    }
}
#[doc = "Possible values of the field `HALT_eUB3`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_EUB3R {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB3_1,
}
impl HALT_EUB3R {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_EUB3R::HALT_EUB3_0 => false,
            HALT_EUB3R::HALT_EUB3_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_EUB3R {
        match value {
            false => HALT_EUB3R::HALT_EUB3_0,
            true => HALT_EUB3R::HALT_EUB3_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_EUB3_0`"]
    #[inline]
    pub fn is_halt_e_ub3_0(&self) -> bool {
        *self == HALT_EUB3R::HALT_EUB3_0
    }
    #[doc = "Checks if the value of the field is `HALT_EUB3_1`"]
    #[inline]
    pub fn is_halt_e_ub3_1(&self) -> bool {
        *self == HALT_EUB3R::HALT_EUB3_1
    }
}
#[doc = "Possible values of the field `HALT_ADC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_ADCR {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_ADC_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_ADC_1,
}
impl HALT_ADCR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_ADCR::HALT_ADC_0 => false,
            HALT_ADCR::HALT_ADC_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_ADCR {
        match value {
            false => HALT_ADCR::HALT_ADC_0,
            true => HALT_ADCR::HALT_ADC_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_ADC_0`"]
    #[inline]
    pub fn is_halt_adc_0(&self) -> bool {
        *self == HALT_ADCR::HALT_ADC_0
    }
    #[doc = "Checks if the value of the field is `HALT_ADC_1`"]
    #[inline]
    pub fn is_halt_adc_1(&self) -> bool {
        *self == HALT_ADCR::HALT_ADC_1
    }
}
#[doc = "Possible values of the field `HALT_WDT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_WDTR {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_WDT_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_WDT_1,
}
impl HALT_WDTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_WDTR::HALT_WDT_0 => false,
            HALT_WDTR::HALT_WDT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_WDTR {
        match value {
            false => HALT_WDTR::HALT_WDT_0,
            true => HALT_WDTR::HALT_WDT_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_WDT_0`"]
    #[inline]
    pub fn is_halt_wdt_0(&self) -> bool {
        *self == HALT_WDTR::HALT_WDT_0
    }
    #[doc = "Checks if the value of the field is `HALT_WDT_1`"]
    #[inline]
    pub fn is_halt_wdt_1(&self) -> bool {
        *self == HALT_WDTR::HALT_WDT_1
    }
}
#[doc = "Possible values of the field `HALT_DMA`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HALT_DMAR {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_DMA_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_DMA_1,
}
impl HALT_DMAR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            HALT_DMAR::HALT_DMA_0 => false,
            HALT_DMAR::HALT_DMA_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> HALT_DMAR {
        match value {
            false => HALT_DMAR::HALT_DMA_0,
            true => HALT_DMAR::HALT_DMA_1,
        }
    }
    #[doc = "Checks if the value of the field is `HALT_DMA_0`"]
    #[inline]
    pub fn is_halt_dma_0(&self) -> bool {
        *self == HALT_DMAR::HALT_DMA_0
    }
    #[doc = "Checks if the value of the field is `HALT_DMA_1`"]
    #[inline]
    pub fn is_halt_dma_1(&self) -> bool {
        *self == HALT_DMAR::HALT_DMA_1
    }
}
#[doc = "Values that can be written to the field `HALT_T16_0`"]
pub enum HALT_T16_0W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_0_1,
}
impl HALT_T16_0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_T16_0W::HALT_T16_0_0 => false,
            HALT_T16_0W::HALT_T16_0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_T16_0W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_T16_0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_T16_0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_t16_0_0(self) -> &'a mut W {
        self.variant(HALT_T16_0W::HALT_T16_0_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_0_1(self) -> &'a mut W {
        self.variant(HALT_T16_0W::HALT_T16_0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_T16_1`"]
pub enum HALT_T16_1W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_1_1,
}
impl HALT_T16_1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_T16_1W::HALT_T16_1_0 => false,
            HALT_T16_1W::HALT_T16_1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_T16_1W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_T16_1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_T16_1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_t16_1_0(self) -> &'a mut W {
        self.variant(HALT_T16_1W::HALT_T16_1_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_1_1(self) -> &'a mut W {
        self.variant(HALT_T16_1W::HALT_T16_1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_T16_2`"]
pub enum HALT_T16_2W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_2_1,
}
impl HALT_T16_2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_T16_2W::HALT_T16_2_0 => false,
            HALT_T16_2W::HALT_T16_2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_T16_2W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_T16_2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_T16_2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_t16_2_0(self) -> &'a mut W {
        self.variant(HALT_T16_2W::HALT_T16_2_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_2_1(self) -> &'a mut W {
        self.variant(HALT_T16_2W::HALT_T16_2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_T16_3`"]
pub enum HALT_T16_3W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T16_3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T16_3_1,
}
impl HALT_T16_3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_T16_3W::HALT_T16_3_0 => false,
            HALT_T16_3W::HALT_T16_3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_T16_3W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_T16_3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_T16_3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_t16_3_0(self) -> &'a mut W {
        self.variant(HALT_T16_3W::HALT_T16_3_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_3_1(self) -> &'a mut W {
        self.variant(HALT_T16_3W::HALT_T16_3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_T32_0`"]
pub enum HALT_T32_0W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_T32_0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_T32_0_1,
}
impl HALT_T32_0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_T32_0W::HALT_T32_0_0 => false,
            HALT_T32_0W::HALT_T32_0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_T32_0W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_T32_0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_T32_0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_t32_0_0(self) -> &'a mut W {
        self.variant(HALT_T32_0W::HALT_T32_0_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t32_0_1(self) -> &'a mut W {
        self.variant(HALT_T32_0W::HALT_T32_0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUA0`"]
pub enum HALT_EUA0W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA0_1,
}
impl HALT_EUA0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUA0W::HALT_EUA0_0 => false,
            HALT_EUA0W::HALT_EUA0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUA0W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUA0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUA0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ua0_0(self) -> &'a mut W {
        self.variant(HALT_EUA0W::HALT_EUA0_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua0_1(self) -> &'a mut W {
        self.variant(HALT_EUA0W::HALT_EUA0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUA1`"]
pub enum HALT_EUA1W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA1_1,
}
impl HALT_EUA1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUA1W::HALT_EUA1_0 => false,
            HALT_EUA1W::HALT_EUA1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUA1W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUA1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUA1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ua1_0(self) -> &'a mut W {
        self.variant(HALT_EUA1W::HALT_EUA1_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua1_1(self) -> &'a mut W {
        self.variant(HALT_EUA1W::HALT_EUA1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUA2`"]
pub enum HALT_EUA2W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA2_1,
}
impl HALT_EUA2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUA2W::HALT_EUA2_0 => false,
            HALT_EUA2W::HALT_EUA2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUA2W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUA2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUA2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ua2_0(self) -> &'a mut W {
        self.variant(HALT_EUA2W::HALT_EUA2_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua2_1(self) -> &'a mut W {
        self.variant(HALT_EUA2W::HALT_EUA2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUA3`"]
pub enum HALT_EUA3W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUA3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUA3_1,
}
impl HALT_EUA3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUA3W::HALT_EUA3_0 => false,
            HALT_EUA3W::HALT_EUA3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUA3W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUA3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUA3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ua3_0(self) -> &'a mut W {
        self.variant(HALT_EUA3W::HALT_EUA3_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua3_1(self) -> &'a mut W {
        self.variant(HALT_EUA3W::HALT_EUA3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUB0`"]
pub enum HALT_EUB0W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB0_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB0_1,
}
impl HALT_EUB0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUB0W::HALT_EUB0_0 => false,
            HALT_EUB0W::HALT_EUB0_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUB0W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUB0W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUB0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ub0_0(self) -> &'a mut W {
        self.variant(HALT_EUB0W::HALT_EUB0_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub0_1(self) -> &'a mut W {
        self.variant(HALT_EUB0W::HALT_EUB0_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUB1`"]
pub enum HALT_EUB1W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB1_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB1_1,
}
impl HALT_EUB1W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUB1W::HALT_EUB1_0 => false,
            HALT_EUB1W::HALT_EUB1_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUB1W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUB1W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUB1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ub1_0(self) -> &'a mut W {
        self.variant(HALT_EUB1W::HALT_EUB1_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub1_1(self) -> &'a mut W {
        self.variant(HALT_EUB1W::HALT_EUB1_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUB2`"]
pub enum HALT_EUB2W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB2_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB2_1,
}
impl HALT_EUB2W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUB2W::HALT_EUB2_0 => false,
            HALT_EUB2W::HALT_EUB2_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUB2W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUB2W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUB2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ub2_0(self) -> &'a mut W {
        self.variant(HALT_EUB2W::HALT_EUB2_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub2_1(self) -> &'a mut W {
        self.variant(HALT_EUB2W::HALT_EUB2_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_eUB3`"]
pub enum HALT_EUB3W {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_EUB3_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_EUB3_1,
}
impl HALT_EUB3W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_EUB3W::HALT_EUB3_0 => false,
            HALT_EUB3W::HALT_EUB3_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_EUB3W<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_EUB3W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_EUB3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_e_ub3_0(self) -> &'a mut W {
        self.variant(HALT_EUB3W::HALT_EUB3_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub3_1(self) -> &'a mut W {
        self.variant(HALT_EUB3W::HALT_EUB3_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_ADC`"]
pub enum HALT_ADCW {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_ADC_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_ADC_1,
}
impl HALT_ADCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_ADCW::HALT_ADC_0 => false,
            HALT_ADCW::HALT_ADC_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_ADCW<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_ADCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_ADCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_adc_0(self) -> &'a mut W {
        self.variant(HALT_ADCW::HALT_ADC_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_adc_1(self) -> &'a mut W {
        self.variant(HALT_ADCW::HALT_ADC_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_WDT`"]
pub enum HALT_WDTW {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_WDT_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_WDT_1,
}
impl HALT_WDTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_WDTW::HALT_WDT_0 => false,
            HALT_WDTW::HALT_WDT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_WDTW<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_WDTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_WDTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_wdt_0(self) -> &'a mut W {
        self.variant(HALT_WDTW::HALT_WDT_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_wdt_1(self) -> &'a mut W {
        self.variant(HALT_WDTW::HALT_WDT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HALT_DMA`"]
pub enum HALT_DMAW {
    #[doc = "IP operation unaffected when CPU is halted"]
    HALT_DMA_0,
    #[doc = "freezes IP operation when CPU is halted"]
    HALT_DMA_1,
}
impl HALT_DMAW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            HALT_DMAW::HALT_DMA_0 => false,
            HALT_DMAW::HALT_DMA_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _HALT_DMAW<'a> {
    w: &'a mut W,
}
impl<'a> _HALT_DMAW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HALT_DMAW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "IP operation unaffected when CPU is halted"]
    #[inline]
    pub fn halt_dma_0(self) -> &'a mut W {
        self.variant(HALT_DMAW::HALT_DMA_0)
    }
    #[doc = "freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_dma_1(self) -> &'a mut W {
        self.variant(HALT_DMAW::HALT_DMA_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_0(&self) -> HALT_T16_0R {
        HALT_T16_0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_1(&self) -> HALT_T16_1R {
        HALT_T16_1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_2(&self) -> HALT_T16_2R {
        HALT_T16_2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_3(&self) -> HALT_T16_3R {
        HALT_T16_3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t32_0(&self) -> HALT_T32_0R {
        HALT_T32_0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua0(&self) -> HALT_EUA0R {
        HALT_EUA0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua1(&self) -> HALT_EUA1R {
        HALT_EUA1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua2(&self) -> HALT_EUA2R {
        HALT_EUA2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 8 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua3(&self) -> HALT_EUA3R {
        HALT_EUA3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 9 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub0(&self) -> HALT_EUB0R {
        HALT_EUB0R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 10 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub1(&self) -> HALT_EUB1R {
        HALT_EUB1R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 11 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub2(&self) -> HALT_EUB2R {
        HALT_EUB2R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 12 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub3(&self) -> HALT_EUB3R {
        HALT_EUB3R::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 13 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_adc(&self) -> HALT_ADCR {
        HALT_ADCR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 14 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_wdt(&self) -> HALT_WDTR {
        HALT_WDTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 15 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_dma(&self) -> HALT_DMAR {
        HALT_DMAR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 16384 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_0(&mut self) -> _HALT_T16_0W {
        _HALT_T16_0W { w: self }
    }
    #[doc = "Bit 1 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_1(&mut self) -> _HALT_T16_1W {
        _HALT_T16_1W { w: self }
    }
    #[doc = "Bit 2 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_2(&mut self) -> _HALT_T16_2W {
        _HALT_T16_2W { w: self }
    }
    #[doc = "Bit 3 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t16_3(&mut self) -> _HALT_T16_3W {
        _HALT_T16_3W { w: self }
    }
    #[doc = "Bit 4 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_t32_0(&mut self) -> _HALT_T32_0W {
        _HALT_T32_0W { w: self }
    }
    #[doc = "Bit 5 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua0(&mut self) -> _HALT_EUA0W {
        _HALT_EUA0W { w: self }
    }
    #[doc = "Bit 6 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua1(&mut self) -> _HALT_EUA1W {
        _HALT_EUA1W { w: self }
    }
    #[doc = "Bit 7 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua2(&mut self) -> _HALT_EUA2W {
        _HALT_EUA2W { w: self }
    }
    #[doc = "Bit 8 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ua3(&mut self) -> _HALT_EUA3W {
        _HALT_EUA3W { w: self }
    }
    #[doc = "Bit 9 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub0(&mut self) -> _HALT_EUB0W {
        _HALT_EUB0W { w: self }
    }
    #[doc = "Bit 10 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub1(&mut self) -> _HALT_EUB1W {
        _HALT_EUB1W { w: self }
    }
    #[doc = "Bit 11 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub2(&mut self) -> _HALT_EUB2W {
        _HALT_EUB2W { w: self }
    }
    #[doc = "Bit 12 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_e_ub3(&mut self) -> _HALT_EUB3W {
        _HALT_EUB3W { w: self }
    }
    #[doc = "Bit 13 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_adc(&mut self) -> _HALT_ADCW {
        _HALT_ADCW { w: self }
    }
    #[doc = "Bit 14 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_wdt(&mut self) -> _HALT_WDTW {
        _HALT_WDTW { w: self }
    }
    #[doc = "Bit 15 - Freezes IP operation when CPU is halted"]
    #[inline]
    pub fn halt_dma(&mut self) -> _HALT_DMAW {
        _HALT_DMAW { w: self }
    }
}
