#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_SRAM_BANKEN {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct BNK0_ENR {
    bits: bool,
}
impl BNK0_ENR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `BNK1_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK1_ENR {
    #[doc = "Disables Bank1 of the SRAM"]
    BNK1_EN_0,
    #[doc = "Enables Bank1 of the SRAM"]
    BNK1_EN_1,
}
impl BNK1_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK1_ENR::BNK1_EN_0 => false,
            BNK1_ENR::BNK1_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK1_ENR {
        match value {
            false => BNK1_ENR::BNK1_EN_0,
            true => BNK1_ENR::BNK1_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK1_EN_0`"]
    #[inline]
    pub fn is_bnk1_en_0(&self) -> bool {
        *self == BNK1_ENR::BNK1_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK1_EN_1`"]
    #[inline]
    pub fn is_bnk1_en_1(&self) -> bool {
        *self == BNK1_ENR::BNK1_EN_1
    }
}
#[doc = "Possible values of the field `BNK2_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK2_ENR {
    #[doc = "Disables Bank2 of the SRAM"]
    BNK2_EN_0,
    #[doc = "Enables Bank2 of the SRAM"]
    BNK2_EN_1,
}
impl BNK2_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK2_ENR::BNK2_EN_0 => false,
            BNK2_ENR::BNK2_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK2_ENR {
        match value {
            false => BNK2_ENR::BNK2_EN_0,
            true => BNK2_ENR::BNK2_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK2_EN_0`"]
    #[inline]
    pub fn is_bnk2_en_0(&self) -> bool {
        *self == BNK2_ENR::BNK2_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK2_EN_1`"]
    #[inline]
    pub fn is_bnk2_en_1(&self) -> bool {
        *self == BNK2_ENR::BNK2_EN_1
    }
}
#[doc = "Possible values of the field `BNK3_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK3_ENR {
    #[doc = "Disables Bank3 of the SRAM"]
    BNK3_EN_0,
    #[doc = "Enables Bank3 of the SRAM"]
    BNK3_EN_1,
}
impl BNK3_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK3_ENR::BNK3_EN_0 => false,
            BNK3_ENR::BNK3_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK3_ENR {
        match value {
            false => BNK3_ENR::BNK3_EN_0,
            true => BNK3_ENR::BNK3_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK3_EN_0`"]
    #[inline]
    pub fn is_bnk3_en_0(&self) -> bool {
        *self == BNK3_ENR::BNK3_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK3_EN_1`"]
    #[inline]
    pub fn is_bnk3_en_1(&self) -> bool {
        *self == BNK3_ENR::BNK3_EN_1
    }
}
#[doc = "Possible values of the field `BNK4_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK4_ENR {
    #[doc = "Disables Bank4 of the SRAM"]
    BNK4_EN_0,
    #[doc = "Enables Bank4 of the SRAM"]
    BNK4_EN_1,
}
impl BNK4_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK4_ENR::BNK4_EN_0 => false,
            BNK4_ENR::BNK4_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK4_ENR {
        match value {
            false => BNK4_ENR::BNK4_EN_0,
            true => BNK4_ENR::BNK4_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK4_EN_0`"]
    #[inline]
    pub fn is_bnk4_en_0(&self) -> bool {
        *self == BNK4_ENR::BNK4_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK4_EN_1`"]
    #[inline]
    pub fn is_bnk4_en_1(&self) -> bool {
        *self == BNK4_ENR::BNK4_EN_1
    }
}
#[doc = "Possible values of the field `BNK5_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK5_ENR {
    #[doc = "Disables Bank5 of the SRAM"]
    BNK5_EN_0,
    #[doc = "Enables Bank5 of the SRAM"]
    BNK5_EN_1,
}
impl BNK5_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK5_ENR::BNK5_EN_0 => false,
            BNK5_ENR::BNK5_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK5_ENR {
        match value {
            false => BNK5_ENR::BNK5_EN_0,
            true => BNK5_ENR::BNK5_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK5_EN_0`"]
    #[inline]
    pub fn is_bnk5_en_0(&self) -> bool {
        *self == BNK5_ENR::BNK5_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK5_EN_1`"]
    #[inline]
    pub fn is_bnk5_en_1(&self) -> bool {
        *self == BNK5_ENR::BNK5_EN_1
    }
}
#[doc = "Possible values of the field `BNK6_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK6_ENR {
    #[doc = "Disables Bank6 of the SRAM"]
    BNK6_EN_0,
    #[doc = "Enables Bank6 of the SRAM"]
    BNK6_EN_1,
}
impl BNK6_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK6_ENR::BNK6_EN_0 => false,
            BNK6_ENR::BNK6_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK6_ENR {
        match value {
            false => BNK6_ENR::BNK6_EN_0,
            true => BNK6_ENR::BNK6_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK6_EN_0`"]
    #[inline]
    pub fn is_bnk6_en_0(&self) -> bool {
        *self == BNK6_ENR::BNK6_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK6_EN_1`"]
    #[inline]
    pub fn is_bnk6_en_1(&self) -> bool {
        *self == BNK6_ENR::BNK6_EN_1
    }
}
#[doc = "Possible values of the field `BNK7_EN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK7_ENR {
    #[doc = "Disables Bank7 of the SRAM"]
    BNK7_EN_0,
    #[doc = "Enables Bank7 of the SRAM"]
    BNK7_EN_1,
}
impl BNK7_ENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK7_ENR::BNK7_EN_0 => false,
            BNK7_ENR::BNK7_EN_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK7_ENR {
        match value {
            false => BNK7_ENR::BNK7_EN_0,
            true => BNK7_ENR::BNK7_EN_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK7_EN_0`"]
    #[inline]
    pub fn is_bnk7_en_0(&self) -> bool {
        *self == BNK7_ENR::BNK7_EN_0
    }
    #[doc = "Checks if the value of the field is `BNK7_EN_1`"]
    #[inline]
    pub fn is_bnk7_en_1(&self) -> bool {
        *self == BNK7_ENR::BNK7_EN_1
    }
}
#[doc = "Possible values of the field `SRAM_RDY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SRAM_RDYR {
    #[doc = "SRAM is not ready for accesses. Banks are undergoing an enable or disable sequence, and reads or writes to SRAM are stalled until the banks are ready"]
    SRAM_RDY_0,
    #[doc = "SRAM is ready for accesses. All SRAM banks are enabled/disabled according to values of bits 7:0 of this register"]
    SRAM_RDY_1,
}
impl SRAM_RDYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SRAM_RDYR::SRAM_RDY_0 => false,
            SRAM_RDYR::SRAM_RDY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SRAM_RDYR {
        match value {
            false => SRAM_RDYR::SRAM_RDY_0,
            true => SRAM_RDYR::SRAM_RDY_1,
        }
    }
    #[doc = "Checks if the value of the field is `SRAM_RDY_0`"]
    #[inline]
    pub fn is_sram_rdy_0(&self) -> bool {
        *self == SRAM_RDYR::SRAM_RDY_0
    }
    #[doc = "Checks if the value of the field is `SRAM_RDY_1`"]
    #[inline]
    pub fn is_sram_rdy_1(&self) -> bool {
        *self == SRAM_RDYR::SRAM_RDY_1
    }
}
#[doc = "Values that can be written to the field `BNK1_EN`"]
pub enum BNK1_ENW {
    #[doc = "Disables Bank1 of the SRAM"]
    BNK1_EN_0,
    #[doc = "Enables Bank1 of the SRAM"]
    BNK1_EN_1,
}
impl BNK1_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK1_ENW::BNK1_EN_0 => false,
            BNK1_ENW::BNK1_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK1_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK1_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK1_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank1 of the SRAM"]
    #[inline]
    pub fn bnk1_en_0(self) -> &'a mut W {
        self.variant(BNK1_ENW::BNK1_EN_0)
    }
    #[doc = "Enables Bank1 of the SRAM"]
    #[inline]
    pub fn bnk1_en_1(self) -> &'a mut W {
        self.variant(BNK1_ENW::BNK1_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK2_EN`"]
pub enum BNK2_ENW {
    #[doc = "Disables Bank2 of the SRAM"]
    BNK2_EN_0,
    #[doc = "Enables Bank2 of the SRAM"]
    BNK2_EN_1,
}
impl BNK2_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK2_ENW::BNK2_EN_0 => false,
            BNK2_ENW::BNK2_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK2_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK2_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK2_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank2 of the SRAM"]
    #[inline]
    pub fn bnk2_en_0(self) -> &'a mut W {
        self.variant(BNK2_ENW::BNK2_EN_0)
    }
    #[doc = "Enables Bank2 of the SRAM"]
    #[inline]
    pub fn bnk2_en_1(self) -> &'a mut W {
        self.variant(BNK2_ENW::BNK2_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK3_EN`"]
pub enum BNK3_ENW {
    #[doc = "Disables Bank3 of the SRAM"]
    BNK3_EN_0,
    #[doc = "Enables Bank3 of the SRAM"]
    BNK3_EN_1,
}
impl BNK3_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK3_ENW::BNK3_EN_0 => false,
            BNK3_ENW::BNK3_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK3_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK3_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK3_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank3 of the SRAM"]
    #[inline]
    pub fn bnk3_en_0(self) -> &'a mut W {
        self.variant(BNK3_ENW::BNK3_EN_0)
    }
    #[doc = "Enables Bank3 of the SRAM"]
    #[inline]
    pub fn bnk3_en_1(self) -> &'a mut W {
        self.variant(BNK3_ENW::BNK3_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK4_EN`"]
pub enum BNK4_ENW {
    #[doc = "Disables Bank4 of the SRAM"]
    BNK4_EN_0,
    #[doc = "Enables Bank4 of the SRAM"]
    BNK4_EN_1,
}
impl BNK4_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK4_ENW::BNK4_EN_0 => false,
            BNK4_ENW::BNK4_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK4_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK4_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK4_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank4 of the SRAM"]
    #[inline]
    pub fn bnk4_en_0(self) -> &'a mut W {
        self.variant(BNK4_ENW::BNK4_EN_0)
    }
    #[doc = "Enables Bank4 of the SRAM"]
    #[inline]
    pub fn bnk4_en_1(self) -> &'a mut W {
        self.variant(BNK4_ENW::BNK4_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK5_EN`"]
pub enum BNK5_ENW {
    #[doc = "Disables Bank5 of the SRAM"]
    BNK5_EN_0,
    #[doc = "Enables Bank5 of the SRAM"]
    BNK5_EN_1,
}
impl BNK5_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK5_ENW::BNK5_EN_0 => false,
            BNK5_ENW::BNK5_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK5_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK5_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK5_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank5 of the SRAM"]
    #[inline]
    pub fn bnk5_en_0(self) -> &'a mut W {
        self.variant(BNK5_ENW::BNK5_EN_0)
    }
    #[doc = "Enables Bank5 of the SRAM"]
    #[inline]
    pub fn bnk5_en_1(self) -> &'a mut W {
        self.variant(BNK5_ENW::BNK5_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK6_EN`"]
pub enum BNK6_ENW {
    #[doc = "Disables Bank6 of the SRAM"]
    BNK6_EN_0,
    #[doc = "Enables Bank6 of the SRAM"]
    BNK6_EN_1,
}
impl BNK6_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK6_ENW::BNK6_EN_0 => false,
            BNK6_ENW::BNK6_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK6_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK6_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK6_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank6 of the SRAM"]
    #[inline]
    pub fn bnk6_en_0(self) -> &'a mut W {
        self.variant(BNK6_ENW::BNK6_EN_0)
    }
    #[doc = "Enables Bank6 of the SRAM"]
    #[inline]
    pub fn bnk6_en_1(self) -> &'a mut W {
        self.variant(BNK6_ENW::BNK6_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK7_EN`"]
pub enum BNK7_ENW {
    #[doc = "Disables Bank7 of the SRAM"]
    BNK7_EN_0,
    #[doc = "Enables Bank7 of the SRAM"]
    BNK7_EN_1,
}
impl BNK7_ENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK7_ENW::BNK7_EN_0 => false,
            BNK7_ENW::BNK7_EN_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK7_ENW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK7_ENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK7_ENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Disables Bank7 of the SRAM"]
    #[inline]
    pub fn bnk7_en_0(self) -> &'a mut W {
        self.variant(BNK7_ENW::BNK7_EN_0)
    }
    #[doc = "Enables Bank7 of the SRAM"]
    #[inline]
    pub fn bnk7_en_1(self) -> &'a mut W {
        self.variant(BNK7_ENW::BNK7_EN_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - SRAM Bank0 enable"]
    #[inline]
    pub fn bnk0_en(&self) -> BNK0_ENR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        BNK0_ENR { bits }
    }
    #[doc = "Bit 1 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk1_en(&self) -> BNK1_ENR {
        BNK1_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk2_en(&self) -> BNK2_ENR {
        BNK2_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk3_en(&self) -> BNK3_ENR {
        BNK3_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk4_en(&self) -> BNK4_ENR {
        BNK4_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk5_en(&self) -> BNK5_ENR {
        BNK5_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk6_en(&self) -> BNK6_ENR {
        BNK6_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk7_en(&self) -> BNK7_ENR {
        BNK7_ENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 16 - SRAM ready"]
    #[inline]
    pub fn sram_rdy(&self) -> SRAM_RDYR {
        SRAM_RDYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 255 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 1 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk1_en(&mut self) -> _BNK1_ENW {
        _BNK1_ENW { w: self }
    }
    #[doc = "Bit 2 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk2_en(&mut self) -> _BNK2_ENW {
        _BNK2_ENW { w: self }
    }
    #[doc = "Bit 3 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk3_en(&mut self) -> _BNK3_ENW {
        _BNK3_ENW { w: self }
    }
    #[doc = "Bit 4 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk4_en(&mut self) -> _BNK4_ENW {
        _BNK4_ENW { w: self }
    }
    #[doc = "Bit 5 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk5_en(&mut self) -> _BNK5_ENW {
        _BNK5_ENW { w: self }
    }
    #[doc = "Bit 6 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk6_en(&mut self) -> _BNK6_ENW {
        _BNK6_ENW { w: self }
    }
    #[doc = "Bit 7 - SRAM Bank1 enable"]
    #[inline]
    pub fn bnk7_en(&mut self) -> _BNK7_ENW {
        _BNK7_ENW { w: self }
    }
}
