#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_SRAM_BANKRET {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct BNK0_RETR {
    bits: bool,
}
impl BNK0_RETR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = "Possible values of the field `BNK1_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK1_RETR {
    #[doc = "Bank1 of the SRAM is not retained in LPM3 or LPM4"]
    BNK1_RET_0,
    #[doc = "Bank1 of the SRAM is retained in LPM3 and LPM4"]
    BNK1_RET_1,
}
impl BNK1_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK1_RETR::BNK1_RET_0 => false,
            BNK1_RETR::BNK1_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK1_RETR {
        match value {
            false => BNK1_RETR::BNK1_RET_0,
            true => BNK1_RETR::BNK1_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK1_RET_0`"]
    #[inline]
    pub fn is_bnk1_ret_0(&self) -> bool {
        *self == BNK1_RETR::BNK1_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK1_RET_1`"]
    #[inline]
    pub fn is_bnk1_ret_1(&self) -> bool {
        *self == BNK1_RETR::BNK1_RET_1
    }
}
#[doc = "Possible values of the field `BNK2_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK2_RETR {
    #[doc = "Bank2 of the SRAM is not retained in LPM3 or LPM4"]
    BNK2_RET_0,
    #[doc = "Bank2 of the SRAM is retained in LPM3 and LPM4"]
    BNK2_RET_1,
}
impl BNK2_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK2_RETR::BNK2_RET_0 => false,
            BNK2_RETR::BNK2_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK2_RETR {
        match value {
            false => BNK2_RETR::BNK2_RET_0,
            true => BNK2_RETR::BNK2_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK2_RET_0`"]
    #[inline]
    pub fn is_bnk2_ret_0(&self) -> bool {
        *self == BNK2_RETR::BNK2_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK2_RET_1`"]
    #[inline]
    pub fn is_bnk2_ret_1(&self) -> bool {
        *self == BNK2_RETR::BNK2_RET_1
    }
}
#[doc = "Possible values of the field `BNK3_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK3_RETR {
    #[doc = "Bank3 of the SRAM is not retained in LPM3 or LPM4"]
    BNK3_RET_0,
    #[doc = "Bank3 of the SRAM is retained in LPM3 and LPM4"]
    BNK3_RET_1,
}
impl BNK3_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK3_RETR::BNK3_RET_0 => false,
            BNK3_RETR::BNK3_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK3_RETR {
        match value {
            false => BNK3_RETR::BNK3_RET_0,
            true => BNK3_RETR::BNK3_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK3_RET_0`"]
    #[inline]
    pub fn is_bnk3_ret_0(&self) -> bool {
        *self == BNK3_RETR::BNK3_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK3_RET_1`"]
    #[inline]
    pub fn is_bnk3_ret_1(&self) -> bool {
        *self == BNK3_RETR::BNK3_RET_1
    }
}
#[doc = "Possible values of the field `BNK4_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK4_RETR {
    #[doc = "Bank4 of the SRAM is not retained in LPM3 or LPM4"]
    BNK4_RET_0,
    #[doc = "Bank4 of the SRAM is retained in LPM3 and LPM4"]
    BNK4_RET_1,
}
impl BNK4_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK4_RETR::BNK4_RET_0 => false,
            BNK4_RETR::BNK4_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK4_RETR {
        match value {
            false => BNK4_RETR::BNK4_RET_0,
            true => BNK4_RETR::BNK4_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK4_RET_0`"]
    #[inline]
    pub fn is_bnk4_ret_0(&self) -> bool {
        *self == BNK4_RETR::BNK4_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK4_RET_1`"]
    #[inline]
    pub fn is_bnk4_ret_1(&self) -> bool {
        *self == BNK4_RETR::BNK4_RET_1
    }
}
#[doc = "Possible values of the field `BNK5_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK5_RETR {
    #[doc = "Bank5 of the SRAM is not retained in LPM3 or LPM4"]
    BNK5_RET_0,
    #[doc = "Bank5 of the SRAM is retained in LPM3 and LPM4"]
    BNK5_RET_1,
}
impl BNK5_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK5_RETR::BNK5_RET_0 => false,
            BNK5_RETR::BNK5_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK5_RETR {
        match value {
            false => BNK5_RETR::BNK5_RET_0,
            true => BNK5_RETR::BNK5_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK5_RET_0`"]
    #[inline]
    pub fn is_bnk5_ret_0(&self) -> bool {
        *self == BNK5_RETR::BNK5_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK5_RET_1`"]
    #[inline]
    pub fn is_bnk5_ret_1(&self) -> bool {
        *self == BNK5_RETR::BNK5_RET_1
    }
}
#[doc = "Possible values of the field `BNK6_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK6_RETR {
    #[doc = "Bank6 of the SRAM is not retained in LPM3 or LPM4"]
    BNK6_RET_0,
    #[doc = "Bank6 of the SRAM is retained in LPM3 and LPM4"]
    BNK6_RET_1,
}
impl BNK6_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK6_RETR::BNK6_RET_0 => false,
            BNK6_RETR::BNK6_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK6_RETR {
        match value {
            false => BNK6_RETR::BNK6_RET_0,
            true => BNK6_RETR::BNK6_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK6_RET_0`"]
    #[inline]
    pub fn is_bnk6_ret_0(&self) -> bool {
        *self == BNK6_RETR::BNK6_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK6_RET_1`"]
    #[inline]
    pub fn is_bnk6_ret_1(&self) -> bool {
        *self == BNK6_RETR::BNK6_RET_1
    }
}
#[doc = "Possible values of the field `BNK7_RET`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BNK7_RETR {
    #[doc = "Bank7 of the SRAM is not retained in LPM3 or LPM4"]
    BNK7_RET_0,
    #[doc = "Bank7 of the SRAM is retained in LPM3 and LPM4"]
    BNK7_RET_1,
}
impl BNK7_RETR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            BNK7_RETR::BNK7_RET_0 => false,
            BNK7_RETR::BNK7_RET_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> BNK7_RETR {
        match value {
            false => BNK7_RETR::BNK7_RET_0,
            true => BNK7_RETR::BNK7_RET_1,
        }
    }
    #[doc = "Checks if the value of the field is `BNK7_RET_0`"]
    #[inline]
    pub fn is_bnk7_ret_0(&self) -> bool {
        *self == BNK7_RETR::BNK7_RET_0
    }
    #[doc = "Checks if the value of the field is `BNK7_RET_1`"]
    #[inline]
    pub fn is_bnk7_ret_1(&self) -> bool {
        *self == BNK7_RETR::BNK7_RET_1
    }
}
#[doc = "Possible values of the field `SRAM_RDY`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SRAM_RDYR {
    #[doc = "SRAM banks are being set up for retention. Entry into LPM3, LPM4 should not be attempted until this bit is set to 1"]
    SRAM_RDY_0,
    #[doc = "SRAM is ready for accesses. All SRAM banks are enabled/disabled for retention according to values of bits 7:0 of this register"]
    SRAM_RDY_1,
}
impl SRAM_RDYR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SRAM_RDYR::SRAM_RDY_0 => false,
            SRAM_RDYR::SRAM_RDY_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SRAM_RDYR {
        match value {
            false => SRAM_RDYR::SRAM_RDY_0,
            true => SRAM_RDYR::SRAM_RDY_1,
        }
    }
    #[doc = "Checks if the value of the field is `SRAM_RDY_0`"]
    #[inline]
    pub fn is_sram_rdy_0(&self) -> bool {
        *self == SRAM_RDYR::SRAM_RDY_0
    }
    #[doc = "Checks if the value of the field is `SRAM_RDY_1`"]
    #[inline]
    pub fn is_sram_rdy_1(&self) -> bool {
        *self == SRAM_RDYR::SRAM_RDY_1
    }
}
#[doc = "Values that can be written to the field `BNK1_RET`"]
pub enum BNK1_RETW {
    #[doc = "Bank1 of the SRAM is not retained in LPM3 or LPM4"]
    BNK1_RET_0,
    #[doc = "Bank1 of the SRAM is retained in LPM3 and LPM4"]
    BNK1_RET_1,
}
impl BNK1_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK1_RETW::BNK1_RET_0 => false,
            BNK1_RETW::BNK1_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK1_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK1_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK1_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank1 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk1_ret_0(self) -> &'a mut W {
        self.variant(BNK1_RETW::BNK1_RET_0)
    }
    #[doc = "Bank1 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk1_ret_1(self) -> &'a mut W {
        self.variant(BNK1_RETW::BNK1_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK2_RET`"]
pub enum BNK2_RETW {
    #[doc = "Bank2 of the SRAM is not retained in LPM3 or LPM4"]
    BNK2_RET_0,
    #[doc = "Bank2 of the SRAM is retained in LPM3 and LPM4"]
    BNK2_RET_1,
}
impl BNK2_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK2_RETW::BNK2_RET_0 => false,
            BNK2_RETW::BNK2_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK2_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK2_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK2_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank2 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk2_ret_0(self) -> &'a mut W {
        self.variant(BNK2_RETW::BNK2_RET_0)
    }
    #[doc = "Bank2 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk2_ret_1(self) -> &'a mut W {
        self.variant(BNK2_RETW::BNK2_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK3_RET`"]
pub enum BNK3_RETW {
    #[doc = "Bank3 of the SRAM is not retained in LPM3 or LPM4"]
    BNK3_RET_0,
    #[doc = "Bank3 of the SRAM is retained in LPM3 and LPM4"]
    BNK3_RET_1,
}
impl BNK3_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK3_RETW::BNK3_RET_0 => false,
            BNK3_RETW::BNK3_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK3_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK3_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK3_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank3 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk3_ret_0(self) -> &'a mut W {
        self.variant(BNK3_RETW::BNK3_RET_0)
    }
    #[doc = "Bank3 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk3_ret_1(self) -> &'a mut W {
        self.variant(BNK3_RETW::BNK3_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK4_RET`"]
pub enum BNK4_RETW {
    #[doc = "Bank4 of the SRAM is not retained in LPM3 or LPM4"]
    BNK4_RET_0,
    #[doc = "Bank4 of the SRAM is retained in LPM3 and LPM4"]
    BNK4_RET_1,
}
impl BNK4_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK4_RETW::BNK4_RET_0 => false,
            BNK4_RETW::BNK4_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK4_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK4_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK4_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank4 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk4_ret_0(self) -> &'a mut W {
        self.variant(BNK4_RETW::BNK4_RET_0)
    }
    #[doc = "Bank4 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk4_ret_1(self) -> &'a mut W {
        self.variant(BNK4_RETW::BNK4_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK5_RET`"]
pub enum BNK5_RETW {
    #[doc = "Bank5 of the SRAM is not retained in LPM3 or LPM4"]
    BNK5_RET_0,
    #[doc = "Bank5 of the SRAM is retained in LPM3 and LPM4"]
    BNK5_RET_1,
}
impl BNK5_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK5_RETW::BNK5_RET_0 => false,
            BNK5_RETW::BNK5_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK5_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK5_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK5_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank5 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk5_ret_0(self) -> &'a mut W {
        self.variant(BNK5_RETW::BNK5_RET_0)
    }
    #[doc = "Bank5 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk5_ret_1(self) -> &'a mut W {
        self.variant(BNK5_RETW::BNK5_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK6_RET`"]
pub enum BNK6_RETW {
    #[doc = "Bank6 of the SRAM is not retained in LPM3 or LPM4"]
    BNK6_RET_0,
    #[doc = "Bank6 of the SRAM is retained in LPM3 and LPM4"]
    BNK6_RET_1,
}
impl BNK6_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK6_RETW::BNK6_RET_0 => false,
            BNK6_RETW::BNK6_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK6_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK6_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK6_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank6 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk6_ret_0(self) -> &'a mut W {
        self.variant(BNK6_RETW::BNK6_RET_0)
    }
    #[doc = "Bank6 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk6_ret_1(self) -> &'a mut W {
        self.variant(BNK6_RETW::BNK6_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `BNK7_RET`"]
pub enum BNK7_RETW {
    #[doc = "Bank7 of the SRAM is not retained in LPM3 or LPM4"]
    BNK7_RET_0,
    #[doc = "Bank7 of the SRAM is retained in LPM3 and LPM4"]
    BNK7_RET_1,
}
impl BNK7_RETW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            BNK7_RETW::BNK7_RET_0 => false,
            BNK7_RETW::BNK7_RET_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _BNK7_RETW<'a> {
    w: &'a mut W,
}
impl<'a> _BNK7_RETW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: BNK7_RETW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Bank7 of the SRAM is not retained in LPM3 or LPM4"]
    #[inline]
    pub fn bnk7_ret_0(self) -> &'a mut W {
        self.variant(BNK7_RETW::BNK7_RET_0)
    }
    #[doc = "Bank7 of the SRAM is retained in LPM3 and LPM4"]
    #[inline]
    pub fn bnk7_ret_1(self) -> &'a mut W {
        self.variant(BNK7_RETW::BNK7_RET_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Bank0 retention"]
    #[inline]
    pub fn bnk0_ret(&self) -> BNK0_RETR {
        let bits = {
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        };
        BNK0_RETR { bits }
    }
    #[doc = "Bit 1 - Bank1 retention"]
    #[inline]
    pub fn bnk1_ret(&self) -> BNK1_RETR {
        BNK1_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Bank2 retention"]
    #[inline]
    pub fn bnk2_ret(&self) -> BNK2_RETR {
        BNK2_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - Bank3 retention"]
    #[inline]
    pub fn bnk3_ret(&self) -> BNK3_RETR {
        BNK3_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - Bank4 retention"]
    #[inline]
    pub fn bnk4_ret(&self) -> BNK4_RETR {
        BNK4_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - Bank5 retention"]
    #[inline]
    pub fn bnk5_ret(&self) -> BNK5_RETR {
        BNK5_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - Bank6 retention"]
    #[inline]
    pub fn bnk6_ret(&self) -> BNK6_RETR {
        BNK6_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Bank7 retention"]
    #[inline]
    pub fn bnk7_ret(&self) -> BNK7_RETR {
        BNK7_RETR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 16 - SRAM ready"]
    #[inline]
    pub fn sram_rdy(&self) -> SRAM_RDYR {
        SRAM_RDYR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 255 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 1 - Bank1 retention"]
    #[inline]
    pub fn bnk1_ret(&mut self) -> _BNK1_RETW {
        _BNK1_RETW { w: self }
    }
    #[doc = "Bit 2 - Bank2 retention"]
    #[inline]
    pub fn bnk2_ret(&mut self) -> _BNK2_RETW {
        _BNK2_RETW { w: self }
    }
    #[doc = "Bit 3 - Bank3 retention"]
    #[inline]
    pub fn bnk3_ret(&mut self) -> _BNK3_RETW {
        _BNK3_RETW { w: self }
    }
    #[doc = "Bit 4 - Bank4 retention"]
    #[inline]
    pub fn bnk4_ret(&mut self) -> _BNK4_RETW {
        _BNK4_RETW { w: self }
    }
    #[doc = "Bit 5 - Bank5 retention"]
    #[inline]
    pub fn bnk5_ret(&mut self) -> _BNK5_RETW {
        _BNK5_RETW { w: self }
    }
    #[doc = "Bit 6 - Bank6 retention"]
    #[inline]
    pub fn bnk6_ret(&mut self) -> _BNK6_RETW {
        _BNK6_RETW { w: self }
    }
    #[doc = "Bit 7 - Bank7 retention"]
    #[inline]
    pub fn bnk7_ret(&mut self) -> _BNK7_RETW {
        _BNK7_RETW { w: self }
    }
}
