#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SYS_WDTRESET_CTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `TIMEOUT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIMEOUTR {
    #[doc = "WDT timeout event generates Soft reset"]
    TIMEOUT_0,
    #[doc = "WDT timeout event generates Hard reset"]
    TIMEOUT_1,
}
impl TIMEOUTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TIMEOUTR::TIMEOUT_0 => false,
            TIMEOUTR::TIMEOUT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TIMEOUTR {
        match value {
            false => TIMEOUTR::TIMEOUT_0,
            true => TIMEOUTR::TIMEOUT_1,
        }
    }
    #[doc = "Checks if the value of the field is `TIMEOUT_0`"]
    #[inline]
    pub fn is_timeout_0(&self) -> bool {
        *self == TIMEOUTR::TIMEOUT_0
    }
    #[doc = "Checks if the value of the field is `TIMEOUT_1`"]
    #[inline]
    pub fn is_timeout_1(&self) -> bool {
        *self == TIMEOUTR::TIMEOUT_1
    }
}
#[doc = "Possible values of the field `VIOLATION`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VIOLATIONR {
    #[doc = "WDT password violation event generates Soft reset"]
    VIOLATION_0,
    #[doc = "WDT password violation event generates Hard reset"]
    VIOLATION_1,
}
impl VIOLATIONR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            VIOLATIONR::VIOLATION_0 => false,
            VIOLATIONR::VIOLATION_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> VIOLATIONR {
        match value {
            false => VIOLATIONR::VIOLATION_0,
            true => VIOLATIONR::VIOLATION_1,
        }
    }
    #[doc = "Checks if the value of the field is `VIOLATION_0`"]
    #[inline]
    pub fn is_violation_0(&self) -> bool {
        *self == VIOLATIONR::VIOLATION_0
    }
    #[doc = "Checks if the value of the field is `VIOLATION_1`"]
    #[inline]
    pub fn is_violation_1(&self) -> bool {
        *self == VIOLATIONR::VIOLATION_1
    }
}
#[doc = "Values that can be written to the field `TIMEOUT`"]
pub enum TIMEOUTW {
    #[doc = "WDT timeout event generates Soft reset"]
    TIMEOUT_0,
    #[doc = "WDT timeout event generates Hard reset"]
    TIMEOUT_1,
}
impl TIMEOUTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            TIMEOUTW::TIMEOUT_0 => false,
            TIMEOUTW::TIMEOUT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TIMEOUTW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMEOUTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TIMEOUTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "WDT timeout event generates Soft reset"]
    #[inline]
    pub fn timeout_0(self) -> &'a mut W {
        self.variant(TIMEOUTW::TIMEOUT_0)
    }
    #[doc = "WDT timeout event generates Hard reset"]
    #[inline]
    pub fn timeout_1(self) -> &'a mut W {
        self.variant(TIMEOUTW::TIMEOUT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `VIOLATION`"]
pub enum VIOLATIONW {
    #[doc = "WDT password violation event generates Soft reset"]
    VIOLATION_0,
    #[doc = "WDT password violation event generates Hard reset"]
    VIOLATION_1,
}
impl VIOLATIONW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            VIOLATIONW::VIOLATION_0 => false,
            VIOLATIONW::VIOLATION_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _VIOLATIONW<'a> {
    w: &'a mut W,
}
impl<'a> _VIOLATIONW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: VIOLATIONW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "WDT password violation event generates Soft reset"]
    #[inline]
    pub fn violation_0(self) -> &'a mut W {
        self.variant(VIOLATIONW::VIOLATION_0)
    }
    #[doc = "WDT password violation event generates Hard reset"]
    #[inline]
    pub fn violation_1(self) -> &'a mut W {
        self.variant(VIOLATIONW::VIOLATION_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - WDT timeout reset type"]
    #[inline]
    pub fn timeout(&self) -> TIMEOUTR {
        TIMEOUTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - WDT password violation reset type"]
    #[inline]
    pub fn violation(&self) -> VIOLATIONR {
        VIOLATIONR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 3 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - WDT timeout reset type"]
    #[inline]
    pub fn timeout(&mut self) -> _TIMEOUTW {
        _TIMEOUTW { w: self }
    }
    #[doc = "Bit 1 - WDT password violation reset type"]
    #[inline]
    pub fn violation(&mut self) -> _VIOLATIONW {
        _VIOLATIONW { w: self }
    }
}
