#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Timer 1 Load Register"]
    pub t32load1: T32LOAD1,
    #[doc = "0x04 - Timer 1 Current Value Register"]
    pub t32value1: T32VALUE1,
    #[doc = "0x08 - Timer 1 Timer Control Register"]
    pub t32control1: T32CONTROL1,
    #[doc = "0x0c - Timer 1 Interrupt Clear Register"]
    pub t32intclr1: T32INTCLR1,
    #[doc = "0x10 - Timer 1 Raw Interrupt Status Register"]
    pub t32ris1: T32RIS1,
    #[doc = "0x14 - Timer 1 Interrupt Status Register"]
    pub t32mis1: T32MIS1,
    #[doc = "0x18 - Timer 1 Background Load Register"]
    pub t32bgload1: T32BGLOAD1,
    _reserved0: [u8; 4usize],
    #[doc = "0x20 - Timer 2 Load Register"]
    pub t32load2: T32LOAD2,
    #[doc = "0x24 - Timer 2 Current Value Register"]
    pub t32value2: T32VALUE2,
    #[doc = "0x28 - Timer 2 Timer Control Register"]
    pub t32control2: T32CONTROL2,
    #[doc = "0x2c - Timer 2 Interrupt Clear Register"]
    pub t32intclr2: T32INTCLR2,
    #[doc = "0x30 - Timer 2 Raw Interrupt Status Register"]
    pub t32ris2: T32RIS2,
    #[doc = "0x34 - Timer 2 Interrupt Status Register"]
    pub t32mis2: T32MIS2,
    #[doc = "0x38 - Timer 2 Background Load Register"]
    pub t32bgload2: T32BGLOAD2,
}
#[doc = "Timer 1 Load Register"]
pub struct T32LOAD1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Load Register"]
pub mod t32load1;
#[doc = "Timer 1 Current Value Register"]
pub struct T32VALUE1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Current Value Register"]
pub mod t32value1;
#[doc = "Timer 1 Timer Control Register"]
pub struct T32CONTROL1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Timer Control Register"]
pub mod t32control1;
#[doc = "Timer 1 Interrupt Clear Register"]
pub struct T32INTCLR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Interrupt Clear Register"]
pub mod t32intclr1;
#[doc = "Timer 1 Raw Interrupt Status Register"]
pub struct T32RIS1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Raw Interrupt Status Register"]
pub mod t32ris1;
#[doc = "Timer 1 Interrupt Status Register"]
pub struct T32MIS1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Interrupt Status Register"]
pub mod t32mis1;
#[doc = "Timer 1 Background Load Register"]
pub struct T32BGLOAD1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 1 Background Load Register"]
pub mod t32bgload1;
#[doc = "Timer 2 Load Register"]
pub struct T32LOAD2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Load Register"]
pub mod t32load2;
#[doc = "Timer 2 Current Value Register"]
pub struct T32VALUE2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Current Value Register"]
pub mod t32value2;
#[doc = "Timer 2 Timer Control Register"]
pub struct T32CONTROL2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Timer Control Register"]
pub mod t32control2;
#[doc = "Timer 2 Interrupt Clear Register"]
pub struct T32INTCLR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Interrupt Clear Register"]
pub mod t32intclr2;
#[doc = "Timer 2 Raw Interrupt Status Register"]
pub struct T32RIS2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Raw Interrupt Status Register"]
pub mod t32ris2;
#[doc = "Timer 2 Interrupt Status Register"]
pub struct T32MIS2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Interrupt Status Register"]
pub mod t32mis2;
#[doc = "Timer 2 Background Load Register"]
pub struct T32BGLOAD2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Timer 2 Background Load Register"]
pub mod t32bgload2;
