#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::T32CONTROL1 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `ONESHOT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ONESHOTR {
    #[doc = "wrapping mode"]
    ONESHOT_0,
    #[doc = "one-shot mode"]
    ONESHOT_1,
}
impl ONESHOTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            ONESHOTR::ONESHOT_0 => false,
            ONESHOTR::ONESHOT_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> ONESHOTR {
        match value {
            false => ONESHOTR::ONESHOT_0,
            true => ONESHOTR::ONESHOT_1,
        }
    }
    #[doc = "Checks if the value of the field is `ONESHOT_0`"]
    #[inline]
    pub fn is_oneshot_0(&self) -> bool {
        *self == ONESHOTR::ONESHOT_0
    }
    #[doc = "Checks if the value of the field is `ONESHOT_1`"]
    #[inline]
    pub fn is_oneshot_1(&self) -> bool {
        *self == ONESHOTR::ONESHOT_1
    }
}
#[doc = "Possible values of the field `SIZE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SIZER {
    #[doc = "16-bit counter"]
    SIZE_0,
    #[doc = "32-bit counter"]
    SIZE_1,
}
impl SIZER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SIZER::SIZE_0 => false,
            SIZER::SIZE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SIZER {
        match value {
            false => SIZER::SIZE_0,
            true => SIZER::SIZE_1,
        }
    }
    #[doc = "Checks if the value of the field is `SIZE_0`"]
    #[inline]
    pub fn is_size_0(&self) -> bool {
        *self == SIZER::SIZE_0
    }
    #[doc = "Checks if the value of the field is `SIZE_1`"]
    #[inline]
    pub fn is_size_1(&self) -> bool {
        *self == SIZER::SIZE_1
    }
}
#[doc = "Possible values of the field `PRESCALE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PRESCALER {
    #[doc = "0 stages of prescale, clock is divided by 1"]
    PRESCALE_0,
    #[doc = "4 stages of prescale, clock is divided by 16"]
    PRESCALE_1,
    #[doc = "8 stages of prescale, clock is divided by 256"]
    PRESCALE_2,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl PRESCALER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PRESCALER::PRESCALE_0 => 0,
            PRESCALER::PRESCALE_1 => 1,
            PRESCALER::PRESCALE_2 => 2,
            PRESCALER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PRESCALER {
        match value {
            0 => PRESCALER::PRESCALE_0,
            1 => PRESCALER::PRESCALE_1,
            2 => PRESCALER::PRESCALE_2,
            i => PRESCALER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PRESCALE_0`"]
    #[inline]
    pub fn is_prescale_0(&self) -> bool {
        *self == PRESCALER::PRESCALE_0
    }
    #[doc = "Checks if the value of the field is `PRESCALE_1`"]
    #[inline]
    pub fn is_prescale_1(&self) -> bool {
        *self == PRESCALER::PRESCALE_1
    }
    #[doc = "Checks if the value of the field is `PRESCALE_2`"]
    #[inline]
    pub fn is_prescale_2(&self) -> bool {
        *self == PRESCALER::PRESCALE_2
    }
}
#[doc = "Possible values of the field `IE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IER {
    #[doc = "Timer interrupt disabled"]
    IE_0,
    #[doc = "Timer interrupt enabled"]
    IE_1,
}
impl IER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            IER::IE_0 => false,
            IER::IE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> IER {
        match value {
            false => IER::IE_0,
            true => IER::IE_1,
        }
    }
    #[doc = "Checks if the value of the field is `IE_0`"]
    #[inline]
    pub fn is_ie_0(&self) -> bool {
        *self == IER::IE_0
    }
    #[doc = "Checks if the value of the field is `IE_1`"]
    #[inline]
    pub fn is_ie_1(&self) -> bool {
        *self == IER::IE_1
    }
}
#[doc = "Possible values of the field `MODE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MODER {
    #[doc = "Timer is in free-running mode"]
    MODE_0,
    #[doc = "Timer is in periodic mode"]
    MODE_1,
}
impl MODER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            MODER::MODE_0 => false,
            MODER::MODE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> MODER {
        match value {
            false => MODER::MODE_0,
            true => MODER::MODE_1,
        }
    }
    #[doc = "Checks if the value of the field is `MODE_0`"]
    #[inline]
    pub fn is_mode_0(&self) -> bool {
        *self == MODER::MODE_0
    }
    #[doc = "Checks if the value of the field is `MODE_1`"]
    #[inline]
    pub fn is_mode_1(&self) -> bool {
        *self == MODER::MODE_1
    }
}
#[doc = "Possible values of the field `ENABLE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ENABLER {
    #[doc = "Timer disabled"]
    ENABLE_0,
    #[doc = "Timer enabled"]
    ENABLE_1,
}
impl ENABLER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            ENABLER::ENABLE_0 => false,
            ENABLER::ENABLE_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> ENABLER {
        match value {
            false => ENABLER::ENABLE_0,
            true => ENABLER::ENABLE_1,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_0`"]
    #[inline]
    pub fn is_enable_0(&self) -> bool {
        *self == ENABLER::ENABLE_0
    }
    #[doc = "Checks if the value of the field is `ENABLE_1`"]
    #[inline]
    pub fn is_enable_1(&self) -> bool {
        *self == ENABLER::ENABLE_1
    }
}
#[doc = "Values that can be written to the field `ONESHOT`"]
pub enum ONESHOTW {
    #[doc = "wrapping mode"]
    ONESHOT_0,
    #[doc = "one-shot mode"]
    ONESHOT_1,
}
impl ONESHOTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            ONESHOTW::ONESHOT_0 => false,
            ONESHOTW::ONESHOT_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ONESHOTW<'a> {
    w: &'a mut W,
}
impl<'a> _ONESHOTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ONESHOTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "wrapping mode"]
    #[inline]
    pub fn oneshot_0(self) -> &'a mut W {
        self.variant(ONESHOTW::ONESHOT_0)
    }
    #[doc = "one-shot mode"]
    #[inline]
    pub fn oneshot_1(self) -> &'a mut W {
        self.variant(ONESHOTW::ONESHOT_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SIZE`"]
pub enum SIZEW {
    #[doc = "16-bit counter"]
    SIZE_0,
    #[doc = "32-bit counter"]
    SIZE_1,
}
impl SIZEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SIZEW::SIZE_0 => false,
            SIZEW::SIZE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SIZEW<'a> {
    w: &'a mut W,
}
impl<'a> _SIZEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SIZEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "16-bit counter"]
    #[inline]
    pub fn size_0(self) -> &'a mut W {
        self.variant(SIZEW::SIZE_0)
    }
    #[doc = "32-bit counter"]
    #[inline]
    pub fn size_1(self) -> &'a mut W {
        self.variant(SIZEW::SIZE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PRESCALE`"]
pub enum PRESCALEW {
    #[doc = "0 stages of prescale, clock is divided by 1"]
    PRESCALE_0,
    #[doc = "4 stages of prescale, clock is divided by 16"]
    PRESCALE_1,
    #[doc = "8 stages of prescale, clock is divided by 256"]
    PRESCALE_2,
}
impl PRESCALEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PRESCALEW::PRESCALE_0 => 0,
            PRESCALEW::PRESCALE_1 => 1,
            PRESCALEW::PRESCALE_2 => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PRESCALEW<'a> {
    w: &'a mut W,
}
impl<'a> _PRESCALEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PRESCALEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "0 stages of prescale, clock is divided by 1"]
    #[inline]
    pub fn prescale_0(self) -> &'a mut W {
        self.variant(PRESCALEW::PRESCALE_0)
    }
    #[doc = "4 stages of prescale, clock is divided by 16"]
    #[inline]
    pub fn prescale_1(self) -> &'a mut W {
        self.variant(PRESCALEW::PRESCALE_1)
    }
    #[doc = "8 stages of prescale, clock is divided by 256"]
    #[inline]
    pub fn prescale_2(self) -> &'a mut W {
        self.variant(PRESCALEW::PRESCALE_2)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IE`"]
pub enum IEW {
    #[doc = "Timer interrupt disabled"]
    IE_0,
    #[doc = "Timer interrupt enabled"]
    IE_1,
}
impl IEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            IEW::IE_0 => false,
            IEW::IE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _IEW<'a> {
    w: &'a mut W,
}
impl<'a> _IEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Timer interrupt disabled"]
    #[inline]
    pub fn ie_0(self) -> &'a mut W {
        self.variant(IEW::IE_0)
    }
    #[doc = "Timer interrupt enabled"]
    #[inline]
    pub fn ie_1(self) -> &'a mut W {
        self.variant(IEW::IE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `MODE`"]
pub enum MODEW {
    #[doc = "Timer is in free-running mode"]
    MODE_0,
    #[doc = "Timer is in periodic mode"]
    MODE_1,
}
impl MODEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            MODEW::MODE_0 => false,
            MODEW::MODE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _MODEW<'a> {
    w: &'a mut W,
}
impl<'a> _MODEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: MODEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Timer is in free-running mode"]
    #[inline]
    pub fn mode_0(self) -> &'a mut W {
        self.variant(MODEW::MODE_0)
    }
    #[doc = "Timer is in periodic mode"]
    #[inline]
    pub fn mode_1(self) -> &'a mut W {
        self.variant(MODEW::MODE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `ENABLE`"]
pub enum ENABLEW {
    #[doc = "Timer disabled"]
    ENABLE_0,
    #[doc = "Timer enabled"]
    ENABLE_1,
}
impl ENABLEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            ENABLEW::ENABLE_0 => false,
            ENABLEW::ENABLE_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ENABLEW<'a> {
    w: &'a mut W,
}
impl<'a> _ENABLEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ENABLEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Timer disabled"]
    #[inline]
    pub fn enable_0(self) -> &'a mut W {
        self.variant(ENABLEW::ENABLE_0)
    }
    #[doc = "Timer enabled"]
    #[inline]
    pub fn enable_1(self) -> &'a mut W {
        self.variant(ENABLEW::ENABLE_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Selects one-shot or wrapping counter mode"]
    #[inline]
    pub fn oneshot(&self) -> ONESHOTR {
        ONESHOTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - Selects 16 or 32 bit counter operation"]
    #[inline]
    pub fn size(&self) -> SIZER {
        SIZER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 2:3 - Prescale bits"]
    #[inline]
    pub fn prescale(&self) -> PRESCALER {
        PRESCALER::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 5 - Interrupt enable bit"]
    #[inline]
    pub fn ie(&self) -> IER {
        IER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - Mode bit"]
    #[inline]
    pub fn mode(&self) -> MODER {
        MODER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Enable bit"]
    #[inline]
    pub fn enable(&self) -> ENABLER {
        ENABLER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 32 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Selects one-shot or wrapping counter mode"]
    #[inline]
    pub fn oneshot(&mut self) -> _ONESHOTW {
        _ONESHOTW { w: self }
    }
    #[doc = "Bit 1 - Selects 16 or 32 bit counter operation"]
    #[inline]
    pub fn size(&mut self) -> _SIZEW {
        _SIZEW { w: self }
    }
    #[doc = "Bits 2:3 - Prescale bits"]
    #[inline]
    pub fn prescale(&mut self) -> _PRESCALEW {
        _PRESCALEW { w: self }
    }
    #[doc = "Bit 5 - Interrupt enable bit"]
    #[inline]
    pub fn ie(&mut self) -> _IEW {
        _IEW { w: self }
    }
    #[doc = "Bit 6 - Mode bit"]
    #[inline]
    pub fn mode(&mut self) -> _MODEW {
        _MODEW { w: self }
    }
    #[doc = "Bit 7 - Enable bit"]
    #[inline]
    pub fn enable(&mut self) -> _ENABLEW {
        _ENABLEW { w: self }
    }
}
