#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - TimerAx Control Register"]
    pub tax_ctl: TAXCTL,
    #[doc = "0x02 - Timer_A Capture/Compare Control Register"]
    pub tax_cctl: [TAXCCTL; 5],
    _reserved0: [u8; 4usize],
    #[doc = "0x10 - TimerA register"]
    pub tax_r: TAXR,
    #[doc = "0x12 - Timer_A Capture/Compare Register"]
    pub tax_ccr: [TAXCCR; 5],
    _reserved1: [u8; 4usize],
    #[doc = "0x20 - TimerAx Expansion 0 Register"]
    pub tax_ex0: TAXEX0,
    _reserved2: [u8; 12usize],
    #[doc = "0x2e - TimerAx Interrupt Vector Register"]
    pub tax_iv: TAXIV,
}
#[doc = "TimerAx Control Register"]
pub struct TAXCTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "TimerAx Control Register"]
pub mod tax_ctl;
#[doc = "Timer_A Capture/Compare Control Register"]
pub struct TAXCCTL {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Timer_A Capture/Compare Control Register"]
pub mod tax_cctl;
#[doc = "TimerA register"]
pub struct TAXR {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "TimerA register"]
pub mod tax_r;
#[doc = "Timer_A Capture/Compare Register"]
pub struct TAXCCR {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "Timer_A Capture/Compare Register"]
pub mod tax_ccr;
#[doc = "TimerAx Expansion 0 Register"]
pub struct TAXEX0 {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "TimerAx Expansion 0 Register"]
pub mod tax_ex0;
#[doc = "TimerAx Interrupt Vector Register"]
pub struct TAXIV {
    register: ::vcell::VolatileCell<u16>,
}
#[doc = "TimerAx Interrupt Vector Register"]
pub mod tax_iv;
