#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
impl super::TAXIV {
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `TAIV`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TAIVR {
    #[doc = "No interrupt pending"]
    TAIV_0,
    #[doc = "Interrupt Source: Capture/compare 1; Interrupt Flag: TAxCCR1 CCIFG; Interrupt Priority: Highest"]
    TAIV_2,
    #[doc = "Interrupt Source: Capture/compare 2; Interrupt Flag: TAxCCR2 CCIFG"]
    TAIV_4,
    #[doc = "Interrupt Source: Capture/compare 3; Interrupt Flag: TAxCCR3 CCIFG"]
    TAIV_6,
    #[doc = "Interrupt Source: Capture/compare 4; Interrupt Flag: TAxCCR4 CCIFG"]
    TAIV_8,
    #[doc = "Interrupt Source: Capture/compare 5; Interrupt Flag: TAxCCR5 CCIFG"]
    TAIV_10,
    #[doc = "Interrupt Source: Capture/compare 6; Interrupt Flag: TAxCCR6 CCIFG"]
    TAIV_12,
    #[doc = "Interrupt Source: Timer overflow; Interrupt Flag: TAxCTL TAIFG; Interrupt Priority: Lowest"]
    TAIV_14,
    #[doc = r" Reserved"]
    _Reserved(u16),
}
impl TAIVR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        match *self {
            TAIVR::TAIV_0 => 0,
            TAIVR::TAIV_2 => 2,
            TAIVR::TAIV_4 => 4,
            TAIVR::TAIV_6 => 6,
            TAIVR::TAIV_8 => 8,
            TAIVR::TAIV_10 => 10,
            TAIVR::TAIV_12 => 12,
            TAIVR::TAIV_14 => 14,
            TAIVR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u16) -> TAIVR {
        match value {
            0 => TAIVR::TAIV_0,
            2 => TAIVR::TAIV_2,
            4 => TAIVR::TAIV_4,
            6 => TAIVR::TAIV_6,
            8 => TAIVR::TAIV_8,
            10 => TAIVR::TAIV_10,
            12 => TAIVR::TAIV_12,
            14 => TAIVR::TAIV_14,
            i => TAIVR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `TAIV_0`"]
    #[inline]
    pub fn is_taiv_0(&self) -> bool {
        *self == TAIVR::TAIV_0
    }
    #[doc = "Checks if the value of the field is `TAIV_2`"]
    #[inline]
    pub fn is_taiv_2(&self) -> bool {
        *self == TAIVR::TAIV_2
    }
    #[doc = "Checks if the value of the field is `TAIV_4`"]
    #[inline]
    pub fn is_taiv_4(&self) -> bool {
        *self == TAIVR::TAIV_4
    }
    #[doc = "Checks if the value of the field is `TAIV_6`"]
    #[inline]
    pub fn is_taiv_6(&self) -> bool {
        *self == TAIVR::TAIV_6
    }
    #[doc = "Checks if the value of the field is `TAIV_8`"]
    #[inline]
    pub fn is_taiv_8(&self) -> bool {
        *self == TAIVR::TAIV_8
    }
    #[doc = "Checks if the value of the field is `TAIV_10`"]
    #[inline]
    pub fn is_taiv_10(&self) -> bool {
        *self == TAIVR::TAIV_10
    }
    #[doc = "Checks if the value of the field is `TAIV_12`"]
    #[inline]
    pub fn is_taiv_12(&self) -> bool {
        *self == TAIVR::TAIV_12
    }
    #[doc = "Checks if the value of the field is `TAIV_14`"]
    #[inline]
    pub fn is_taiv_14(&self) -> bool {
        *self == TAIVR::TAIV_14
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:15 - TimerA interrupt vector value"]
    #[inline]
    pub fn taiv(&self) -> TAIVR {
        TAIVR::_from({
            const MASK: u16 = 65535;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        })
    }
}
