#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - TLV Checksum"]
    pub tlv_checksum: TLV_CHECKSUM,
    #[doc = "0x04 - Device Info Tag"]
    pub device_info_tag: DEVICE_INFO_TAG,
    #[doc = "0x08 - Device Info Length"]
    pub device_info_len: DEVICE_INFO_LEN,
    #[doc = "0x0c - Device ID"]
    pub device_id: DEVICE_ID,
    #[doc = "0x10 - HW Revision"]
    pub hwrev: HWREV,
    #[doc = "0x14 - Boot Code Revision"]
    pub bcrev: BCREV,
    #[doc = "0x18 - ROM Driver Library Revision"]
    pub rom_drvlib_rev: ROM_DRVLIB_REV,
    #[doc = "0x1c - Die Record Tag"]
    pub die_rec_tag: DIE_REC_TAG,
    #[doc = "0x20 - Die Record Length"]
    pub die_rec_len: DIE_REC_LEN,
    #[doc = "0x24 - Die X-Position"]
    pub die_xpos: DIE_XPOS,
    #[doc = "0x28 - Die Y-Position"]
    pub die_ypos: DIE_YPOS,
    #[doc = "0x2c - Wafer ID"]
    pub wafer_id: WAFER_ID,
    #[doc = "0x30 - Lot ID"]
    pub lot_id: LOT_ID,
    #[doc = "0x34 - Reserved"]
    pub reserved0: RESERVED0,
    #[doc = "0x38 - Reserved"]
    pub reserved1: RESERVED1,
    #[doc = "0x3c - Reserved"]
    pub reserved2: RESERVED2,
    #[doc = "0x40 - Test Results"]
    pub test_results: TEST_RESULTS,
    #[doc = "0x44 - Clock System Calibration Tag"]
    pub cs_cal_tag: CS_CAL_TAG,
    #[doc = "0x48 - Clock System Calibration Length"]
    pub cs_cal_len: CS_CAL_LEN,
    #[doc = "0x4c - DCO IR mode: Frequency calibration for DCORSEL 0 to 4"]
    pub dcoir_fcal_rsel04: DCOIR_FCAL_RSEL04,
    #[doc = "0x50 - DCO IR mode: Frequency calibration for DCORSEL 5"]
    pub dcoir_fcal_rsel5: DCOIR_FCAL_RSEL5,
    #[doc = "0x54 - Reserved"]
    pub reserved3: RESERVED3,
    #[doc = "0x58 - Reserved"]
    pub reserved4: RESERVED4,
    #[doc = "0x5c - Reserved"]
    pub reserved5: RESERVED5,
    #[doc = "0x60 - Reserved"]
    pub reserved6: RESERVED6,
    #[doc = "0x64 - DCO IR mode: DCO Constant (K) for DCORSEL 0 to 4"]
    pub dcoir_constk_rsel04: DCOIR_CONSTK_RSEL04,
    #[doc = "0x68 - DCO IR mode: DCO Constant (K) for DCORSEL 5"]
    pub dcoir_constk_rsel5: DCOIR_CONSTK_RSEL5,
    #[doc = "0x6c - DCO ER mode: Frequency calibration for DCORSEL 0 to 4"]
    pub dcoer_fcal_rsel04: DCOER_FCAL_RSEL04,
    #[doc = "0x70 - DCO ER mode: Frequency calibration for DCORSEL 5"]
    pub dcoer_fcal_rsel5: DCOER_FCAL_RSEL5,
    #[doc = "0x74 - Reserved"]
    pub reserved7: RESERVED7,
    #[doc = "0x78 - Reserved"]
    pub reserved8: RESERVED8,
    #[doc = "0x7c - Reserved"]
    pub reserved9: RESERVED9,
    #[doc = "0x80 - Reserved"]
    pub reserved10: RESERVED10,
    #[doc = "0x84 - DCO ER mode: DCO Constant (K) for DCORSEL 0 to 4"]
    pub dcoer_constk_rsel04: DCOER_CONSTK_RSEL04,
    #[doc = "0x88 - DCO ER mode: DCO Constant (K) for DCORSEL 5"]
    pub dcoer_constk_rsel5: DCOER_CONSTK_RSEL5,
    #[doc = "0x8c - ADC14 Calibration Tag"]
    pub adc14_cal_tag: ADC14_CAL_TAG,
    #[doc = "0x90 - ADC14 Calibration Length"]
    pub adc14_cal_len: ADC14_CAL_LEN,
    #[doc = "0x94 - ADC Gain Factor"]
    pub adc_gain_factor: ADC_GAIN_FACTOR,
    #[doc = "0x98 - ADC Offset"]
    pub adc_offset: ADC_OFFSET,
    #[doc = "0x9c - Reserved"]
    pub reserved11: RESERVED11,
    #[doc = "0xa0 - Reserved"]
    pub reserved12: RESERVED12,
    #[doc = "0xa4 - Reserved"]
    pub reserved13: RESERVED13,
    #[doc = "0xa8 - Reserved"]
    pub reserved14: RESERVED14,
    #[doc = "0xac - Reserved"]
    pub reserved15: RESERVED15,
    #[doc = "0xb0 - Reserved"]
    pub reserved16: RESERVED16,
    #[doc = "0xb4 - Reserved"]
    pub reserved17: RESERVED17,
    #[doc = "0xb8 - Reserved"]
    pub reserved18: RESERVED18,
    #[doc = "0xbc - Reserved"]
    pub reserved19: RESERVED19,
    #[doc = "0xc0 - Reserved"]
    pub reserved20: RESERVED20,
    #[doc = "0xc4 - Reserved"]
    pub reserved21: RESERVED21,
    #[doc = "0xc8 - Reserved"]
    pub reserved22: RESERVED22,
    #[doc = "0xcc - Reserved"]
    pub reserved23: RESERVED23,
    #[doc = "0xd0 - Reserved"]
    pub reserved24: RESERVED24,
    #[doc = "0xd4 - Reserved"]
    pub reserved25: RESERVED25,
    #[doc = "0xd8 - Reserved"]
    pub reserved26: RESERVED26,
    #[doc = "0xdc - ADC14 1.2V Reference Temp. Sensor 30C"]
    pub adc14_ref1p2v_ts30c: ADC14_REF1P2V_TS30C,
    #[doc = "0xe0 - ADC14 1.2V Reference Temp. Sensor 85C"]
    pub adc14_ref1p2v_ts85c: ADC14_REF1P2V_TS85C,
    #[doc = "0xe4 - ADC14 1.45V Reference Temp. Sensor 30C"]
    pub adc14_ref1p45v_ts30c: ADC14_REF1P45V_TS30C,
    #[doc = "0xe8 - ADC14 1.45V Reference Temp. Sensor 85C"]
    pub adc14_ref1p45v_ts85c: ADC14_REF1P45V_TS85C,
    #[doc = "0xec - ADC14 2.5V Reference Temp. Sensor 30C"]
    pub adc14_ref2p5v_ts30c: ADC14_REF2P5V_TS30C,
    #[doc = "0xf0 - ADC14 2.5V Reference Temp. Sensor 85C"]
    pub adc14_ref2p5v_ts85c: ADC14_REF2P5V_TS85C,
    #[doc = "0xf4 - REF Calibration Tag"]
    pub ref_cal_tag: REF_CAL_TAG,
    #[doc = "0xf8 - REF Calibration Length"]
    pub ref_cal_len: REF_CAL_LEN,
    #[doc = "0xfc - REF 1.2V Reference"]
    pub ref_1p2v: REF_1P2V,
    #[doc = "0x100 - REF 1.45V Reference"]
    pub ref_1p45v: REF_1P45V,
    #[doc = "0x104 - REF 2.5V Reference"]
    pub ref_2p5v: REF_2P5V,
    #[doc = "0x108 - Flash Info Tag"]
    pub flash_info_tag: FLASH_INFO_TAG,
    #[doc = "0x10c - Flash Info Length"]
    pub flash_info_len: FLASH_INFO_LEN,
    #[doc = "0x110 - Flash Maximum Programming Pulses"]
    pub flash_max_prog_pulses: FLASH_MAX_PROG_PULSES,
    #[doc = "0x114 - Flash Maximum Erase Pulses"]
    pub flash_max_erase_pulses: FLASH_MAX_ERASE_PULSES,
    #[doc = "0x118 - 128-bit Random Number Tag"]
    pub random_num_tag: RANDOM_NUM_TAG,
    #[doc = "0x11c - 128-bit Random Number Length"]
    pub random_num_len: RANDOM_NUM_LEN,
    #[doc = "0x120 - 32-bit Random Number 1"]
    pub random_num_1: RANDOM_NUM_1,
    #[doc = "0x124 - 32-bit Random Number 2"]
    pub random_num_2: RANDOM_NUM_2,
    #[doc = "0x128 - 32-bit Random Number 3"]
    pub random_num_3: RANDOM_NUM_3,
    #[doc = "0x12c - 32-bit Random Number 4"]
    pub random_num_4: RANDOM_NUM_4,
    #[doc = "0x130 - BSL Configuration Tag"]
    pub bsl_cfg_tag: BSL_CFG_TAG,
    #[doc = "0x134 - BSL Configuration Length"]
    pub bsl_cfg_len: BSL_CFG_LEN,
    #[doc = "0x138 - BSL Peripheral Interface Selection"]
    pub bsl_periphif_sel: BSL_PERIPHIF_SEL,
    #[doc = "0x13c - BSL Port Interface Configuration for UART"]
    pub bsl_portif_cfg_uart: BSL_PORTIF_CFG_UART,
    #[doc = "0x140 - BSL Port Interface Configuration for SPI"]
    pub bsl_portif_cfg_spi: BSL_PORTIF_CFG_SPI,
    #[doc = "0x144 - BSL Port Interface Configuration for I2C"]
    pub bsl_portif_cfg_i2c: BSL_PORTIF_CFG_I2C,
    #[doc = "0x148 - TLV End Word"]
    pub tlv_end: TLV_END,
}
#[doc = "TLV Checksum"]
pub struct TLV_CHECKSUM {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "TLV Checksum"]
pub mod tlv_checksum;
#[doc = "Device Info Tag"]
pub struct DEVICE_INFO_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Device Info Tag"]
pub mod device_info_tag;
#[doc = "Device Info Length"]
pub struct DEVICE_INFO_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Device Info Length"]
pub mod device_info_len;
#[doc = "Device ID"]
pub struct DEVICE_ID {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Device ID"]
pub mod device_id;
#[doc = "HW Revision"]
pub struct HWREV {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "HW Revision"]
pub mod hwrev;
#[doc = "Boot Code Revision"]
pub struct BCREV {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Boot Code Revision"]
pub mod bcrev;
#[doc = "ROM Driver Library Revision"]
pub struct ROM_DRVLIB_REV {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ROM Driver Library Revision"]
pub mod rom_drvlib_rev;
#[doc = "Die Record Tag"]
pub struct DIE_REC_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Die Record Tag"]
pub mod die_rec_tag;
#[doc = "Die Record Length"]
pub struct DIE_REC_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Die Record Length"]
pub mod die_rec_len;
#[doc = "Die X-Position"]
pub struct DIE_XPOS {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Die X-Position"]
pub mod die_xpos;
#[doc = "Die Y-Position"]
pub struct DIE_YPOS {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Die Y-Position"]
pub mod die_ypos;
#[doc = "Wafer ID"]
pub struct WAFER_ID {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Wafer ID"]
pub mod wafer_id;
#[doc = "Lot ID"]
pub struct LOT_ID {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Lot ID"]
pub mod lot_id;
#[doc = "Reserved"]
pub struct RESERVED0 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved0;
#[doc = "Reserved"]
pub struct RESERVED1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved1;
#[doc = "Reserved"]
pub struct RESERVED2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved2;
#[doc = "Test Results"]
pub struct TEST_RESULTS {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Test Results"]
pub mod test_results;
#[doc = "Clock System Calibration Tag"]
pub struct CS_CAL_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clock System Calibration Tag"]
pub mod cs_cal_tag;
#[doc = "Clock System Calibration Length"]
pub struct CS_CAL_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Clock System Calibration Length"]
pub mod cs_cal_len;
#[doc = "DCO IR mode: Frequency calibration for DCORSEL 0 to 4"]
pub struct DCOIR_FCAL_RSEL04 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO IR mode: Frequency calibration for DCORSEL 0 to 4"]
pub mod dcoir_fcal_rsel04;
#[doc = "DCO IR mode: Frequency calibration for DCORSEL 5"]
pub struct DCOIR_FCAL_RSEL5 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO IR mode: Frequency calibration for DCORSEL 5"]
pub mod dcoir_fcal_rsel5;
#[doc = "Reserved"]
pub struct RESERVED3 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved3;
#[doc = "Reserved"]
pub struct RESERVED4 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved4;
#[doc = "Reserved"]
pub struct RESERVED5 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved5;
#[doc = "Reserved"]
pub struct RESERVED6 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved6;
#[doc = "DCO IR mode: DCO Constant (K) for DCORSEL 0 to 4"]
pub struct DCOIR_CONSTK_RSEL04 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO IR mode: DCO Constant (K) for DCORSEL 0 to 4"]
pub mod dcoir_constk_rsel04;
#[doc = "DCO IR mode: DCO Constant (K) for DCORSEL 5"]
pub struct DCOIR_CONSTK_RSEL5 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO IR mode: DCO Constant (K) for DCORSEL 5"]
pub mod dcoir_constk_rsel5;
#[doc = "DCO ER mode: Frequency calibration for DCORSEL 0 to 4"]
pub struct DCOER_FCAL_RSEL04 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO ER mode: Frequency calibration for DCORSEL 0 to 4"]
pub mod dcoer_fcal_rsel04;
#[doc = "DCO ER mode: Frequency calibration for DCORSEL 5"]
pub struct DCOER_FCAL_RSEL5 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO ER mode: Frequency calibration for DCORSEL 5"]
pub mod dcoer_fcal_rsel5;
#[doc = "Reserved"]
pub struct RESERVED7 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved7;
#[doc = "Reserved"]
pub struct RESERVED8 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved8;
#[doc = "Reserved"]
pub struct RESERVED9 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved9;
#[doc = "Reserved"]
pub struct RESERVED10 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved10;
#[doc = "DCO ER mode: DCO Constant (K) for DCORSEL 0 to 4"]
pub struct DCOER_CONSTK_RSEL04 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO ER mode: DCO Constant (K) for DCORSEL 0 to 4"]
pub mod dcoer_constk_rsel04;
#[doc = "DCO ER mode: DCO Constant (K) for DCORSEL 5"]
pub struct DCOER_CONSTK_RSEL5 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "DCO ER mode: DCO Constant (K) for DCORSEL 5"]
pub mod dcoer_constk_rsel5;
#[doc = "ADC14 Calibration Tag"]
pub struct ADC14_CAL_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 Calibration Tag"]
pub mod adc14_cal_tag;
#[doc = "ADC14 Calibration Length"]
pub struct ADC14_CAL_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 Calibration Length"]
pub mod adc14_cal_len;
#[doc = "ADC Gain Factor"]
pub struct ADC_GAIN_FACTOR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC Gain Factor"]
pub mod adc_gain_factor;
#[doc = "ADC Offset"]
pub struct ADC_OFFSET {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC Offset"]
pub mod adc_offset;
#[doc = "Reserved"]
pub struct RESERVED11 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved11;
#[doc = "Reserved"]
pub struct RESERVED12 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved12;
#[doc = "Reserved"]
pub struct RESERVED13 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved13;
#[doc = "Reserved"]
pub struct RESERVED14 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved14;
#[doc = "Reserved"]
pub struct RESERVED15 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved15;
#[doc = "Reserved"]
pub struct RESERVED16 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved16;
#[doc = "Reserved"]
pub struct RESERVED17 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved17;
#[doc = "Reserved"]
pub struct RESERVED18 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved18;
#[doc = "Reserved"]
pub struct RESERVED19 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved19;
#[doc = "Reserved"]
pub struct RESERVED20 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved20;
#[doc = "Reserved"]
pub struct RESERVED21 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved21;
#[doc = "Reserved"]
pub struct RESERVED22 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved22;
#[doc = "Reserved"]
pub struct RESERVED23 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved23;
#[doc = "Reserved"]
pub struct RESERVED24 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved24;
#[doc = "Reserved"]
pub struct RESERVED25 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved25;
#[doc = "Reserved"]
pub struct RESERVED26 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Reserved"]
pub mod reserved26;
#[doc = "ADC14 1.2V Reference Temp. Sensor 30C"]
pub struct ADC14_REF1P2V_TS30C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 1.2V Reference Temp. Sensor 30C"]
pub mod adc14_ref1p2v_ts30c;
#[doc = "ADC14 1.2V Reference Temp. Sensor 85C"]
pub struct ADC14_REF1P2V_TS85C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 1.2V Reference Temp. Sensor 85C"]
pub mod adc14_ref1p2v_ts85c;
#[doc = "ADC14 1.45V Reference Temp. Sensor 30C"]
pub struct ADC14_REF1P45V_TS30C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 1.45V Reference Temp. Sensor 30C"]
pub mod adc14_ref1p45v_ts30c;
#[doc = "ADC14 1.45V Reference Temp. Sensor 85C"]
pub struct ADC14_REF1P45V_TS85C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 1.45V Reference Temp. Sensor 85C"]
pub mod adc14_ref1p45v_ts85c;
#[doc = "ADC14 2.5V Reference Temp. Sensor 30C"]
pub struct ADC14_REF2P5V_TS30C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 2.5V Reference Temp. Sensor 30C"]
pub mod adc14_ref2p5v_ts30c;
#[doc = "ADC14 2.5V Reference Temp. Sensor 85C"]
pub struct ADC14_REF2P5V_TS85C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC14 2.5V Reference Temp. Sensor 85C"]
pub mod adc14_ref2p5v_ts85c;
#[doc = "REF Calibration Tag"]
pub struct REF_CAL_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "REF Calibration Tag"]
pub mod ref_cal_tag;
#[doc = "REF Calibration Length"]
pub struct REF_CAL_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "REF Calibration Length"]
pub mod ref_cal_len;
#[doc = "REF 1.2V Reference"]
pub struct REF_1P2V {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "REF 1.2V Reference"]
pub mod ref_1p2v;
#[doc = "REF 1.45V Reference"]
pub struct REF_1P45V {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "REF 1.45V Reference"]
pub mod ref_1p45v;
#[doc = "REF 2.5V Reference"]
pub struct REF_2P5V {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "REF 2.5V Reference"]
pub mod ref_2p5v;
#[doc = "Flash Info Tag"]
pub struct FLASH_INFO_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Flash Info Tag"]
pub mod flash_info_tag;
#[doc = "Flash Info Length"]
pub struct FLASH_INFO_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Flash Info Length"]
pub mod flash_info_len;
#[doc = "Flash Maximum Programming Pulses"]
pub struct FLASH_MAX_PROG_PULSES {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Flash Maximum Programming Pulses"]
pub mod flash_max_prog_pulses;
#[doc = "Flash Maximum Erase Pulses"]
pub struct FLASH_MAX_ERASE_PULSES {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Flash Maximum Erase Pulses"]
pub mod flash_max_erase_pulses;
#[doc = "128-bit Random Number Tag"]
pub struct RANDOM_NUM_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "128-bit Random Number Tag"]
pub mod random_num_tag;
#[doc = "128-bit Random Number Length"]
pub struct RANDOM_NUM_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "128-bit Random Number Length"]
pub mod random_num_len;
#[doc = "32-bit Random Number 1"]
pub struct RANDOM_NUM_1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "32-bit Random Number 1"]
pub mod random_num_1;
#[doc = "32-bit Random Number 2"]
pub struct RANDOM_NUM_2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "32-bit Random Number 2"]
pub mod random_num_2;
#[doc = "32-bit Random Number 3"]
pub struct RANDOM_NUM_3 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "32-bit Random Number 3"]
pub mod random_num_3;
#[doc = "32-bit Random Number 4"]
pub struct RANDOM_NUM_4 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "32-bit Random Number 4"]
pub mod random_num_4;
#[doc = "BSL Configuration Tag"]
pub struct BSL_CFG_TAG {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Configuration Tag"]
pub mod bsl_cfg_tag;
#[doc = "BSL Configuration Length"]
pub struct BSL_CFG_LEN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Configuration Length"]
pub mod bsl_cfg_len;
#[doc = "BSL Peripheral Interface Selection"]
pub struct BSL_PERIPHIF_SEL {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Peripheral Interface Selection"]
pub mod bsl_periphif_sel;
#[doc = "BSL Port Interface Configuration for UART"]
pub struct BSL_PORTIF_CFG_UART {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Port Interface Configuration for UART"]
pub mod bsl_portif_cfg_uart;
#[doc = "BSL Port Interface Configuration for SPI"]
pub struct BSL_PORTIF_CFG_SPI {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Port Interface Configuration for SPI"]
pub mod bsl_portif_cfg_spi;
#[doc = "BSL Port Interface Configuration for I2C"]
pub struct BSL_PORTIF_CFG_I2C {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "BSL Port Interface Configuration for I2C"]
pub mod bsl_portif_cfg_i2c;
#[doc = "TLV End Word"]
pub struct TLV_END {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "TLV End Word"]
pub mod tlv_end;
