#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::WDTCTL {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `WDTIS`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WDTISR {
    #[doc = "Watchdog clock source / (2^(31)) (18:12:16 at 32.768 kHz)"]
    WDTIS_0,
    #[doc = "Watchdog clock source /(2^(27)) (01:08:16 at 32.768 kHz)"]
    WDTIS_1,
    #[doc = "Watchdog clock source /(2^(23)) (00:04:16 at 32.768 kHz)"]
    WDTIS_2,
    #[doc = "Watchdog clock source /(2^(19)) (00:00:16 at 32.768 kHz)"]
    WDTIS_3,
    #[doc = "Watchdog clock source /(2^(15)) (1 s at 32.768 kHz)"]
    WDTIS_4,
    #[doc = "Watchdog clock source / (2^(13)) (250 ms at 32.768 kHz)"]
    WDTIS_5,
    #[doc = "Watchdog clock source / (2^(9)) (15.625 ms at 32.768 kHz)"]
    WDTIS_6,
    #[doc = "Watchdog clock source / (2^(6)) (1.95 ms at 32.768 kHz)"]
    WDTIS_7,
}
impl WDTISR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            WDTISR::WDTIS_0 => 0,
            WDTISR::WDTIS_1 => 1,
            WDTISR::WDTIS_2 => 2,
            WDTISR::WDTIS_3 => 3,
            WDTISR::WDTIS_4 => 4,
            WDTISR::WDTIS_5 => 5,
            WDTISR::WDTIS_6 => 6,
            WDTISR::WDTIS_7 => 7,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> WDTISR {
        match value {
            0 => WDTISR::WDTIS_0,
            1 => WDTISR::WDTIS_1,
            2 => WDTISR::WDTIS_2,
            3 => WDTISR::WDTIS_3,
            4 => WDTISR::WDTIS_4,
            5 => WDTISR::WDTIS_5,
            6 => WDTISR::WDTIS_6,
            7 => WDTISR::WDTIS_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `WDTIS_0`"]
    #[inline]
    pub fn is_wdtis_0(&self) -> bool {
        *self == WDTISR::WDTIS_0
    }
    #[doc = "Checks if the value of the field is `WDTIS_1`"]
    #[inline]
    pub fn is_wdtis_1(&self) -> bool {
        *self == WDTISR::WDTIS_1
    }
    #[doc = "Checks if the value of the field is `WDTIS_2`"]
    #[inline]
    pub fn is_wdtis_2(&self) -> bool {
        *self == WDTISR::WDTIS_2
    }
    #[doc = "Checks if the value of the field is `WDTIS_3`"]
    #[inline]
    pub fn is_wdtis_3(&self) -> bool {
        *self == WDTISR::WDTIS_3
    }
    #[doc = "Checks if the value of the field is `WDTIS_4`"]
    #[inline]
    pub fn is_wdtis_4(&self) -> bool {
        *self == WDTISR::WDTIS_4
    }
    #[doc = "Checks if the value of the field is `WDTIS_5`"]
    #[inline]
    pub fn is_wdtis_5(&self) -> bool {
        *self == WDTISR::WDTIS_5
    }
    #[doc = "Checks if the value of the field is `WDTIS_6`"]
    #[inline]
    pub fn is_wdtis_6(&self) -> bool {
        *self == WDTISR::WDTIS_6
    }
    #[doc = "Checks if the value of the field is `WDTIS_7`"]
    #[inline]
    pub fn is_wdtis_7(&self) -> bool {
        *self == WDTISR::WDTIS_7
    }
}
#[doc = "Possible values of the field `WDTTMSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WDTTMSELR {
    #[doc = "Watchdog mode"]
    WDTTMSEL_0,
    #[doc = "Interval timer mode"]
    WDTTMSEL_1,
}
impl WDTTMSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            WDTTMSELR::WDTTMSEL_0 => false,
            WDTTMSELR::WDTTMSEL_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> WDTTMSELR {
        match value {
            false => WDTTMSELR::WDTTMSEL_0,
            true => WDTTMSELR::WDTTMSEL_1,
        }
    }
    #[doc = "Checks if the value of the field is `WDTTMSEL_0`"]
    #[inline]
    pub fn is_wdttmsel_0(&self) -> bool {
        *self == WDTTMSELR::WDTTMSEL_0
    }
    #[doc = "Checks if the value of the field is `WDTTMSEL_1`"]
    #[inline]
    pub fn is_wdttmsel_1(&self) -> bool {
        *self == WDTTMSELR::WDTTMSEL_1
    }
}
#[doc = "Possible values of the field `WDTSSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WDTSSELR {
    #[doc = "SMCLK"]
    WDTSSEL_0,
    #[doc = "ACLK"]
    WDTSSEL_1,
    #[doc = "VLOCLK"]
    WDTSSEL_2,
    #[doc = "BCLK"]
    WDTSSEL_3,
}
impl WDTSSELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            WDTSSELR::WDTSSEL_0 => 0,
            WDTSSELR::WDTSSEL_1 => 1,
            WDTSSELR::WDTSSEL_2 => 2,
            WDTSSELR::WDTSSEL_3 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> WDTSSELR {
        match value {
            0 => WDTSSELR::WDTSSEL_0,
            1 => WDTSSELR::WDTSSEL_1,
            2 => WDTSSELR::WDTSSEL_2,
            3 => WDTSSELR::WDTSSEL_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `WDTSSEL_0`"]
    #[inline]
    pub fn is_wdtssel_0(&self) -> bool {
        *self == WDTSSELR::WDTSSEL_0
    }
    #[doc = "Checks if the value of the field is `WDTSSEL_1`"]
    #[inline]
    pub fn is_wdtssel_1(&self) -> bool {
        *self == WDTSSELR::WDTSSEL_1
    }
    #[doc = "Checks if the value of the field is `WDTSSEL_2`"]
    #[inline]
    pub fn is_wdtssel_2(&self) -> bool {
        *self == WDTSSELR::WDTSSEL_2
    }
    #[doc = "Checks if the value of the field is `WDTSSEL_3`"]
    #[inline]
    pub fn is_wdtssel_3(&self) -> bool {
        *self == WDTSSELR::WDTSSEL_3
    }
}
#[doc = "Possible values of the field `WDTHOLD`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WDTHOLDR {
    #[doc = "Watchdog timer is not stopped"]
    WDTHOLD_0,
    #[doc = "Watchdog timer is stopped"]
    WDTHOLD_1,
}
impl WDTHOLDR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            WDTHOLDR::WDTHOLD_0 => false,
            WDTHOLDR::WDTHOLD_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> WDTHOLDR {
        match value {
            false => WDTHOLDR::WDTHOLD_0,
            true => WDTHOLDR::WDTHOLD_1,
        }
    }
    #[doc = "Checks if the value of the field is `WDTHOLD_0`"]
    #[inline]
    pub fn is_wdthold_0(&self) -> bool {
        *self == WDTHOLDR::WDTHOLD_0
    }
    #[doc = "Checks if the value of the field is `WDTHOLD_1`"]
    #[inline]
    pub fn is_wdthold_1(&self) -> bool {
        *self == WDTHOLDR::WDTHOLD_1
    }
}
#[doc = r" Value of the field"]
pub struct WDTPWR {
    bits: u8,
}
impl WDTPWR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `WDTIS`"]
pub enum WDTISW {
    #[doc = "Watchdog clock source / (2^(31)) (18:12:16 at 32.768 kHz)"]
    WDTIS_0,
    #[doc = "Watchdog clock source /(2^(27)) (01:08:16 at 32.768 kHz)"]
    WDTIS_1,
    #[doc = "Watchdog clock source /(2^(23)) (00:04:16 at 32.768 kHz)"]
    WDTIS_2,
    #[doc = "Watchdog clock source /(2^(19)) (00:00:16 at 32.768 kHz)"]
    WDTIS_3,
    #[doc = "Watchdog clock source /(2^(15)) (1 s at 32.768 kHz)"]
    WDTIS_4,
    #[doc = "Watchdog clock source / (2^(13)) (250 ms at 32.768 kHz)"]
    WDTIS_5,
    #[doc = "Watchdog clock source / (2^(9)) (15.625 ms at 32.768 kHz)"]
    WDTIS_6,
    #[doc = "Watchdog clock source / (2^(6)) (1.95 ms at 32.768 kHz)"]
    WDTIS_7,
}
impl WDTISW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            WDTISW::WDTIS_0 => 0,
            WDTISW::WDTIS_1 => 1,
            WDTISW::WDTIS_2 => 2,
            WDTISW::WDTIS_3 => 3,
            WDTISW::WDTIS_4 => 4,
            WDTISW::WDTIS_5 => 5,
            WDTISW::WDTIS_6 => 6,
            WDTISW::WDTIS_7 => 7,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WDTISW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTISW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WDTISW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "Watchdog clock source / (2^(31)) (18:12:16 at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_0(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_0)
    }
    #[doc = "Watchdog clock source /(2^(27)) (01:08:16 at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_1(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_1)
    }
    #[doc = "Watchdog clock source /(2^(23)) (00:04:16 at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_2(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_2)
    }
    #[doc = "Watchdog clock source /(2^(19)) (00:00:16 at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_3(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_3)
    }
    #[doc = "Watchdog clock source /(2^(15)) (1 s at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_4(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_4)
    }
    #[doc = "Watchdog clock source / (2^(13)) (250 ms at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_5(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_5)
    }
    #[doc = "Watchdog clock source / (2^(9)) (15.625 ms at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_6(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_6)
    }
    #[doc = "Watchdog clock source / (2^(6)) (1.95 ms at 32.768 kHz)"]
    #[inline]
    pub fn wdtis_7(self) -> &'a mut W {
        self.variant(WDTISW::WDTIS_7)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `WDTCNTCL`"]
pub enum WDTCNTCLW {
    #[doc = "No action"]
    WDTCNTCL_0,
    #[doc = "WDTCNT = 0000h"]
    WDTCNTCL_1,
}
impl WDTCNTCLW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            WDTCNTCLW::WDTCNTCL_0 => false,
            WDTCNTCLW::WDTCNTCL_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WDTCNTCLW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTCNTCLW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WDTCNTCLW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "No action"]
    #[inline]
    pub fn wdtcntcl_0(self) -> &'a mut W {
        self.variant(WDTCNTCLW::WDTCNTCL_0)
    }
    #[doc = "WDTCNT = 0000h"]
    #[inline]
    pub fn wdtcntcl_1(self) -> &'a mut W {
        self.variant(WDTCNTCLW::WDTCNTCL_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `WDTTMSEL`"]
pub enum WDTTMSELW {
    #[doc = "Watchdog mode"]
    WDTTMSEL_0,
    #[doc = "Interval timer mode"]
    WDTTMSEL_1,
}
impl WDTTMSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            WDTTMSELW::WDTTMSEL_0 => false,
            WDTTMSELW::WDTTMSEL_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WDTTMSELW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTTMSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WDTTMSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Watchdog mode"]
    #[inline]
    pub fn wdttmsel_0(self) -> &'a mut W {
        self.variant(WDTTMSELW::WDTTMSEL_0)
    }
    #[doc = "Interval timer mode"]
    #[inline]
    pub fn wdttmsel_1(self) -> &'a mut W {
        self.variant(WDTTMSELW::WDTTMSEL_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `WDTSSEL`"]
pub enum WDTSSELW {
    #[doc = "SMCLK"]
    WDTSSEL_0,
    #[doc = "ACLK"]
    WDTSSEL_1,
    #[doc = "VLOCLK"]
    WDTSSEL_2,
    #[doc = "BCLK"]
    WDTSSEL_3,
}
impl WDTSSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            WDTSSELW::WDTSSEL_0 => 0,
            WDTSSELW::WDTSSEL_1 => 1,
            WDTSSELW::WDTSSEL_2 => 2,
            WDTSSELW::WDTSSEL_3 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WDTSSELW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTSSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WDTSSELW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "SMCLK"]
    #[inline]
    pub fn wdtssel_0(self) -> &'a mut W {
        self.variant(WDTSSELW::WDTSSEL_0)
    }
    #[doc = "ACLK"]
    #[inline]
    pub fn wdtssel_1(self) -> &'a mut W {
        self.variant(WDTSSELW::WDTSSEL_1)
    }
    #[doc = "VLOCLK"]
    #[inline]
    pub fn wdtssel_2(self) -> &'a mut W {
        self.variant(WDTSSELW::WDTSSEL_2)
    }
    #[doc = "BCLK"]
    #[inline]
    pub fn wdtssel_3(self) -> &'a mut W {
        self.variant(WDTSSELW::WDTSSEL_3)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `WDTHOLD`"]
pub enum WDTHOLDW {
    #[doc = "Watchdog timer is not stopped"]
    WDTHOLD_0,
    #[doc = "Watchdog timer is stopped"]
    WDTHOLD_1,
}
impl WDTHOLDW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            WDTHOLDW::WDTHOLD_0 => false,
            WDTHOLDW::WDTHOLD_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _WDTHOLDW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTHOLDW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: WDTHOLDW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Watchdog timer is not stopped"]
    #[inline]
    pub fn wdthold_0(self) -> &'a mut W {
        self.variant(WDTHOLDW::WDTHOLD_0)
    }
    #[doc = "Watchdog timer is stopped"]
    #[inline]
    pub fn wdthold_1(self) -> &'a mut W {
        self.variant(WDTHOLDW::WDTHOLD_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _WDTPWW<'a> {
    w: &'a mut W,
}
impl<'a> _WDTPWW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 255;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:2 - Watchdog timer interval select"]
    #[inline]
    pub fn wdtis(&self) -> WDTISR {
        WDTISR::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 4 - Watchdog timer mode select"]
    #[inline]
    pub fn wdttmsel(&self) -> WDTTMSELR {
        WDTTMSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 5:6 - Watchdog timer clock source select"]
    #[inline]
    pub fn wdtssel(&self) -> WDTSSELR {
        WDTSSELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        })
    }
    #[doc = "Bit 7 - Watchdog timer hold"]
    #[inline]
    pub fn wdthold(&self) -> WDTHOLDR {
        WDTHOLDR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
    #[doc = "Bits 8:15 - Watchdog timer password"]
    #[inline]
    pub fn wdtpw(&self) -> WDTPWR {
        let bits = {
            const MASK: u8 = 255;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        WDTPWR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 26884 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:2 - Watchdog timer interval select"]
    #[inline]
    pub fn wdtis(&mut self) -> _WDTISW {
        _WDTISW { w: self }
    }
    #[doc = "Bit 3 - Watchdog timer counter clear"]
    #[inline]
    pub fn wdtcntcl(&mut self) -> _WDTCNTCLW {
        _WDTCNTCLW { w: self }
    }
    #[doc = "Bit 4 - Watchdog timer mode select"]
    #[inline]
    pub fn wdttmsel(&mut self) -> _WDTTMSELW {
        _WDTTMSELW { w: self }
    }
    #[doc = "Bits 5:6 - Watchdog timer clock source select"]
    #[inline]
    pub fn wdtssel(&mut self) -> _WDTSSELW {
        _WDTSSELW { w: self }
    }
    #[doc = "Bit 7 - Watchdog timer hold"]
    #[inline]
    pub fn wdthold(&mut self) -> _WDTHOLDW {
        _WDTHOLDW { w: self }
    }
    #[doc = "Bits 8:15 - Watchdog timer password"]
    #[inline]
    pub fn wdtpw(&mut self) -> _WDTPWW {
        _WDTPWW { w: self }
    }
}
